class
	PD_EYESCLASSPART

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	dummy: INTEGER_32 assign set_dummy

feature {ANY} -- field setters

	set_dummy (a_dummy: INTEGER_32)
		do
			dummy := a_dummy
			update_memory_field ("dummy")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			dummy := a_other.dummy
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				dummy = a_other.dummy
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("dummy")
				>>)
			init_structure_info
		end

end
