class
	P_INPUT_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	squeeze: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	chopline: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

feature {ANY} -- public routines

	forw_line (a_curr_pos: INTEGER_32): INTEGER_32
		local
			l_new_pos: INTEGER_32
			l_c: INTEGER_32
			l_blankline: INTEGER_32
			l_endline: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_curr_pos = -1 then
						(create {P_LINE_STATIC}).null_line
						Result := (-1).to_integer_32
						l_return := True
					end
					if not l_return then
						if (create {P_SCREEN_STATIC}).hilite_search.item.item = 2 then
							if ((create {P_CH_STATIC}).ignore_eoi.item).to_boolean then
								l_tmp := 1
							else
								l_tmp := -1
							end
							(create {P_SEARCH_STATIC}).prep_hilite (a_curr_pos, a_curr_pos + (3 * (create {P_LINE_STATIC}).size_linebuf.item).to_integer_32, l_tmp)
						end
						if ((create {P_CH_STATIC}).ch_seek (a_curr_pos)).to_boolean then
							(create {P_LINE_STATIC}).null_line
							Result := (-1).to_integer_32
							l_return := True
						end
					end
					if not l_return then
						(create {P_LINE_STATIC}).prewind;
						(create {P_LINE_STATIC}).plinenum (a_curr_pos);
						(create {P_CH_STATIC}).ch_seek (a_curr_pos).do_nothing
						l_c := (create {P_CH_STATIC}).ch_forw_get
						if l_c = -1 then
							(create {P_LINE_STATIC}).null_line
							Result := (-1).to_integer_32
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						if l_c = 10 then
							l_tmp___1 := 1
						elseif l_c = 13 then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
						l_blankline := l_tmp___1
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 16 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if (((create {P_CH_STATIC}).sigs.item).bit_and (3)).to_boolean then
							(create {P_LINE_STATIC}).null_line
							Result := (-1).to_integer_32
							l_return := True
						end
						if l_return then
							l_pos := -1 + 15 -- skip if block
						end
				when 4 then -- if:
						if l_c = 10 then
							l_new_pos := (create {P_CH_STATIC}).ch_tell
							l_endline := 1
							l_break := True
						elseif l_c = -1 then
							l_new_pos := (create {P_CH_STATIC}).ch_tell
							l_endline := 1
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if:
						if not (((create {P_LINE_STATIC}).pappend (l_c, ((create {P_CH_STATIC}).ch_tell) - 1)).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 6 then -- if:
						if not ((chopline.item.item).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if not ((create {P_COMMAND_STATIC}).hshift.item > 0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							(l_break)
						loop
							l_break := False
							l_c := (create {P_CH_STATIC}).ch_forw_get
							if l_c /= 10 then
								if l_c = -1 then
									l_break := True
								end
							else
								l_break := True
							end
						end
						l_break := False
						l_new_pos := (create {P_CH_STATIC}).ch_tell
						l_endline := 1;
						(create {P_COMMAND_STATIC}).quit_if_one_screen.item.item := 0
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_new_pos := ((create {P_CH_STATIC}).ch_tell) - 1
						l_endline := 0
				when 13 then -- if done
						l_break := True
				when 14 then -- if done | if done
						if not (l_return or l_break) then
							l_c := (create {P_CH_STATIC}).ch_forw_get
						end
				when 15 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 16 then -- loop done | if done
					if not l_return then
						l_break := False;
						(create {P_LINE_STATIC}).pdone (l_endline)
						if (squeeze.item.item).to_boolean then
							if l_blankline.to_boolean then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_c := (create {P_CH_STATIC}).ch_forw_get
									if l_c /= 10 then
										if l_c /= 13 then
											l_break := True
										end
									end
									if not (l_return or l_break) and then ((((create {P_CH_STATIC}).sigs.item).bit_and (3)).to_boolean) then
										(create {P_LINE_STATIC}).null_line
										Result := (-1).to_integer_32
										l_return := True
									end
								end
								if not l_return then
									l_break := False
									if l_c /= -1 then
										(create {P_CH_STATIC}).ch_back_get.do_nothing
									end
									l_new_pos := (create {P_CH_STATIC}).ch_tell
								end
							end
						end
					end
					if not l_return then
						Result := l_new_pos
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	back_line (a_curr_pos: INTEGER_32): INTEGER_32
		local
			l_new_pos: INTEGER_32
			l_begin_new_pos: INTEGER_32
			l_c: INTEGER_32
			l_endline: INTEGER_32
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_curr_pos = -1 then
						(create {P_LINE_STATIC}).null_line
						Result := (-1).to_integer_32
						l_return := True
					elseif a_curr_pos <= 0 then
						(create {P_LINE_STATIC}).null_line
						Result := (-1).to_integer_32
						l_return := True
					end
					if not l_return then
						if (create {P_SCREEN_STATIC}).hilite_search.item.item = 2 then
							if a_curr_pos < (3 * (create {P_LINE_STATIC}).size_linebuf.item).to_integer_32 then
								l_tmp := (0).to_integer_32
							else
								l_tmp := a_curr_pos - (3 * (create {P_LINE_STATIC}).size_linebuf.item).to_integer_32
							end
							(create {P_SEARCH_STATIC}).prep_hilite (l_tmp, a_curr_pos, -1)
						end
						if ((create {P_CH_STATIC}).ch_seek (a_curr_pos - 1)).to_boolean then
							(create {P_LINE_STATIC}).null_line
							Result := (-1).to_integer_32
							l_return := True
						end
					end
					if not (not l_return and then ((squeeze.item.item).to_boolean)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:;
						(create {P_CH_STATIC}).ch_forw_get.do_nothing
						l_c := (create {P_CH_STATIC}).ch_forw_get;
						(create {P_CH_STATIC}).ch_back_get.do_nothing;
						(create {P_CH_STATIC}).ch_back_get.do_nothing
						if l_c /= 10 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if l_c /= 13 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_c := (create {P_CH_STATIC}).ch_back_get
							if l_c /= 10 then
								if l_c /= 13 then
									l_break := True
								end
							end
							if not (l_return or l_break) and then ((((create {P_CH_STATIC}).sigs.item).bit_and (3)).to_boolean) then
								(create {P_LINE_STATIC}).null_line
								Result := (-1).to_integer_32
								l_return := True
							end
						end
						if not l_return then
							l_break := False
							if l_c = -1 then
								(create {P_LINE_STATIC}).null_line
								Result := (-1).to_integer_32
								l_return := True
							end
						end
						if not l_return then
							(create {P_CH_STATIC}).ch_forw_get.do_nothing
						end
				when 6 then -- if done | if done
					if not l_return then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if (((create {P_CH_STATIC}).sigs.item).bit_and (3)).to_boolean then
								(create {P_LINE_STATIC}).null_line
								Result := (-1).to_integer_32
								l_return := True
							end
							if not l_return then
								l_c := (create {P_CH_STATIC}).ch_back_get
								if l_c = 10 then
									l_new_pos := ((create {P_CH_STATIC}).ch_tell) + 1
									l_break := True
								end
								if not (l_return or l_break) and then (l_c = -1) then
									l_new_pos := (create {P_CH_STATIC}).ch_tell
									l_break := True
								end
							end
						end
					end
					if not l_return then
						l_break := False
						if ((create {P_CH_STATIC}).ch_seek (l_new_pos)).to_boolean then
							(create {P_LINE_STATIC}).null_line
							Result := (-1).to_integer_32
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 7 then -- if:
						l_endline := 0
				when 8 then -- loop:
						l_begin_new_pos := l_new_pos;
						(create {P_LINE_STATIC}).prewind;
						(create {P_LINE_STATIC}).plinenum (l_new_pos);
						(create {P_CH_STATIC}).ch_seek (l_new_pos).do_nothing
				when 9 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 14 -- skip loop
						end
				when 10 then -- loop body:
						l_break := False
						l_c := (create {P_CH_STATIC}).ch_forw_get
						if l_c = -1 then
							(create {P_LINE_STATIC}).null_line
							Result := (-1).to_integer_32
							l_return := True
						elseif (((create {P_CH_STATIC}).sigs.item).bit_and (3)).to_boolean then
							(create {P_LINE_STATIC}).null_line
							Result := (-1).to_integer_32
							l_return := True
						end
						if l_return then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_new_pos := l_new_pos + 1
						if l_c = 10 then
							l_endline := 1
							l_break := True
						end
						if not (l_return or l_break) then
							if ((create {P_LINE_STATIC}).pappend (l_c, ((create {P_CH_STATIC}).ch_tell) - 1)).to_boolean then
								if (chopline.item.item).to_boolean then
									l_endline := 1;
									(create {P_COMMAND_STATIC}).quit_if_one_screen.item.item := 0
									l_break := True
								elseif (create {P_COMMAND_STATIC}).hshift.item > 0 then
									l_endline := 1;
									(create {P_COMMAND_STATIC}).quit_if_one_screen.item.item := 0
									l_break := True
								end
								if not (l_return or l_break) then
									(create {P_LINE_STATIC}).pdone (0);
									(create {P_CH_STATIC}).ch_back_get.do_nothing
									l_new_pos := l_new_pos - 1
									l_pos := -1 + 8 -- goto loop
								end
							end
						end
				when 12 then
						if not (l_return or l_break) and then (not (l_new_pos < a_curr_pos)) then
							l_break := True
						end
				when 13 then -- if done
						l_pos := -1 + 9 -- back to loop condition
				when 14 then -- loop done | if done
					if not l_return then
						l_break := False;
						(create {P_LINE_STATIC}).pdone (l_endline)
						Result := l_begin_new_pos
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_attnpos (a_pos: INTEGER_32)
		local
			l_pos2: INTEGER_32
			l_c: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_pos2 := a_pos
			if l_pos2 /= -1 then
				if ((create {P_CH_STATIC}).ch_seek (l_pos2)).to_boolean then
					l_return := True
				end
				if not l_return then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_c := (create {P_CH_STATIC}).ch_forw_get
						if l_c = -1 then
							l_return := True
						end
						if not l_return then
							if l_c /= 10 then
								if l_c /= 13 then
									l_break := True
								end
							end
							if not (l_return or l_break) then
								l_pos2 := l_pos2 + 1
							end
						end
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				(create {P_MAIN_STATIC}).start_attnpos.item := l_pos2
				from
				until
					(l_break)
				loop
					l_break := False
					l_c := (create {P_CH_STATIC}).ch_forw_get
					l_pos2 := l_pos2 + 1
					if l_c = -1 then
						l_break := True
					elseif l_c = 10 then
						l_break := True
					elseif l_c = 13 then
						l_break := True
					end
				end
				l_break := False;
				(create {P_MAIN_STATIC}).end_attnpos.item := l_pos2
			end
		end

end
