class
	S_FCNTL_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	open (a_args: TUPLE [a___file: CE_POINTER [INTEGER_8]; a___oflag: INTEGER_32]): INTEGER_32
		require
			not a_args.a___file.is_void
		do
			Result := (create {CE_ROUTINE}.make_shared (c_open)).integer_32_item (a_args)
		end

	c_open: POINTER
		external
			"C inline use <less.h>"
		alias
			"return (EIF_POINTER)&open;"
		end

	creat (a___file: CE_POINTER [INTEGER_8]; a___mode: NATURAL_32): INTEGER_32
		require
			not a___file.is_void
		do
			Result := c_creat (a___file.c_pointer, a___mode)
		end

	c_creat (a___file: POINTER; a___mode: NATURAL_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return creat($a___file, $a___mode);"
		end

end
