class
	P_HTTP_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_STDLIB_STATIC

feature {ANY} -- public routines

	parse_http_header (a_head___0, a_item: CE_POINTER [NATURAL_8]; a_ptr: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [NATURAL_8]
		local
			l_i: CE_POINTER [NATURAL_8]
			l_f: CE_POINTER [NATURAL_8]
			l_g: CE_POINTER [NATURAL_8]
			l_h: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_8
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_POINTER} l_h.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_head___0.is_void then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						l_h := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_f := a_head___0
				when 2 then -- loop condition:
						if not (not (l_return or l_break) and then ((l_f.item).to_boolean)) then
							l_pos := -1 + 14 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						if (l_f.item).to_integer_32 /= 10 then
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						l_f := l_f + 1
						l_i := a_item
				when 5 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 10 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						if (l_i.item).to_boolean then
							if not (l_f.item).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_tmp := (create {P_LINKS_STATIC}).upcase (l_i.item)
						if l_tmp.to_integer_32 /= ((create {P_LINKS_STATIC}).upcase (l_f.item)).to_integer_32 then
							l_pos := -1 + 12 -- goto cont
						end
				when 8 then
						l_i := l_i + 1
						l_f := l_f + 1
				when 9 then -- if done
						l_pos := -1 + 5 -- back to loop condition
				when 10 then -- loop done
						l_break := False
						if not (l_f.item).to_boolean then
							l_break := True
						end
				when 11 then -- if done
						if not (l_return or l_break or l_continue) and then ((l_f[0]).to_integer_32 = 58) then
							from
							until
								(l_f[1]).to_integer_32 /= 32
							loop
								l_f := l_f + 1
							end
							l_f := l_f + 1
							l_g := l_f
							from
							until
								not ((l_g.item).to_integer_32 >= 32)
							loop
								l_g := l_g + 1
							end
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_g.c_pointer.to_integer_32).to_natural_32 > (l_f.c_pointer.to_integer_32).to_natural_32 then
									if (l_g[-1]).to_integer_32 /= 32 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_g := l_g - 1
								end
							end
							l_break := False
							if (not l_h.is_void) then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 27, create {CE_VOID_POINTER}.make_cast (l_h))
							end
							l_h := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 28, ((l_g.distance (l_f)) + 1).to_natural_32)))
							memcpy (create {CE_VOID_POINTER}.make_cast (l_h), create {CE_VOID_POINTER}.make_cast (l_f), (l_g.distance (l_f)).to_natural_32).do_nothing
							l_h[(l_g.distance (l_f))] := (0).to_natural_8
							if (not a_ptr.is_void) then
								a_ptr.item := l_f
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								Result := l_h
								l_return := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | cont:
						l_f := l_f - 1
				when 13 then -- if done
						if (not l_return and not l_break) then
							l_f := l_f + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 14 then -- loop done | if done
					if not l_return then
						l_break := False
						l_continue := False
						Result := l_h
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	parse_header_param (a_x, a_e: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_u: NATURAL_8
			l_le: NATURAL_32
			l_lp: INTEGER_32
			l_y: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_le := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_e)))
					l_y := a_x
				when 1 then -- a:
					l_y := create {CE_NATURAL_8_POINTER}.make_cast ((strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_y), (';').code)))
					if l_y.is_void then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_y.item).to_boolean then
								if (l_y.item).to_integer_32 /= 59 then
									if not ((l_y.item).to_integer_32 <= 32) then
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_y := l_y + 1
							end
						end
						l_break := False
						if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_y))) < l_le then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						if ((create {P_LINKS_STATIC}).casecmp (l_y, a_e, l_le)).to_boolean then
							l_pos := -1 + 1 -- goto a
						end
				when 3 then
						l_y := l_y + l_le.to_integer_32
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_y.item).to_boolean then
								if not ((l_y.item).to_integer_32 <= 32) then
									if (l_y.item).to_integer_32 /= 61 then
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_y := l_y + 1
							end
						end
						l_break := False
						l_u := ((';').code).to_natural_8
						if (l_y.item).to_integer_32 = 39 then
							l_tmp___3 := l_y
							l_y := l_y + 1
							l_u := l_tmp___3.item
						elseif (l_y.item).to_integer_32 = 34 then
							l_tmp___3 := l_y
							l_y := l_y + 1
							l_u := l_tmp___3.item
						end
						l_lp := 0
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if (l_y[l_lp]).to_integer_32 >= 32 then
								if (l_y[l_lp]).to_integer_32 = l_u.to_integer_32 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_lp := l_lp + 1
								if l_lp = 2_147_483_647 then
									from
									until
										False
									loop
										(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("http.c"), 61]);
										(create {P_KBD_STATIC}).fatal_tty_exit
										exit (4)
									end
								end
							end
						end
						l_break := False
						Result := ((create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 63, l_y, l_lp))
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_param (a_e, a_name: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_e.is_void
		local
			l_e: CE_POINTER [NATURAL_8]
			l_n: CE_POINTER [NATURAL_8]
			l_start: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_8
			l_tmp___2: NATURAL_8
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_uu: INTEGER_8
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_POINTER} l_start.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_e := a_e
					l_i := 0
				when 1 then -- again:
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_e.item).to_boolean then
							l_tmp := l_e
							l_e := l_e + 1
							l_tmp___0 := (create {P_LINKS_STATIC}).upcase (l_tmp.item)
							if l_tmp___0.to_integer_32 = ((create {P_LINKS_STATIC}).upcase (a_name.item)).to_integer_32 then
								l_break := True
							end
						else
							l_break := True
						end
					end
					l_break := False
					if not (l_e.item).to_boolean then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						l_n := a_name + 1
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_n.item).to_boolean then
								l_tmp___2 := (create {P_LINKS_STATIC}).upcase (l_e.item)
								if l_tmp___2.to_integer_32 /= ((create {P_LINKS_STATIC}).upcase (l_n.item)).to_integer_32 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_e := l_e + 1
								l_n := l_n + 1
							end
						end
						l_break := False
						if (l_n.item).to_boolean then
							l_pos := -1 + 1 -- goto again
						end
				when 3 then
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_e.item).to_integer_32 /= 9 then
								if (l_e.item).to_integer_32 /= 10 then
									if (l_e.item).to_integer_32 /= 12 then
										if (l_e.item).to_integer_32 /= 13 then
											if (l_e.item).to_integer_32 /= 32 then
												l_break := True
											end
										end
									end
								end
							end
							if not (l_break) then
								l_e := l_e + 1
							end
						end
						l_break := False
						l_tmp___4 := l_e
						l_e := l_e + 1
						if (l_tmp___4.item).to_integer_32 /= 61 then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
				when 4 then -- if done
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 5 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_e.item).to_integer_32 /= 9 then
								if (l_e.item).to_integer_32 /= 10 then
									if (l_e.item).to_integer_32 /= 12 then
										if (l_e.item).to_integer_32 /= 13 then
											if (l_e.item).to_integer_32 /= 32 then
												l_break := True
											end
										end
									end
								end
							end
							if not (l_break) then
								l_e := l_e + 1
							end
						end
						l_break := False
						l_start := l_e
						if (l_e.item).to_integer_32 /= 34 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if (l_e.item).to_integer_32 /= 39 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | _L:
						l_tmp___5 := l_e
						l_e := l_e + 1
						l_uu := (l_tmp___5.item).to_integer_8
						l_start := l_start + 1
						from
						until
							not (not (l_return) and then ((l_e.item).to_integer_32 /= l_uu.to_integer_32))
						loop
							if not (l_e.item).to_boolean then
								Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
								l_return := True
							end
							if not l_return then
								l_e := l_e + 1
							end
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_e.item).to_boolean then
								if (l_e.item).to_integer_32 = 9 then
									l_break := True
								elseif (l_e.item).to_integer_32 = 10 then
									l_break := True
								elseif (l_e.item).to_integer_32 = 12 then
									l_break := True
								elseif (l_e.item).to_integer_32 = 13 then
									l_break := True
								elseif (l_e.item).to_integer_32 = 32 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_e := l_e + 1
							end
						end
						l_break := False
				when 12 then -- if done | if done
					if not l_return then
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_start.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32 then
								if (l_start.item).to_integer_32 /= 32 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_start := l_start + 1
							end
						end
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_start.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32 then
								if (l_e[-1]).to_integer_32 /= 32 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_e := l_e - 1
							end
						end
						l_break := False
						if l_start.is_equal (l_e) then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
					end
					if not l_return then
						l_n := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 99, ((l_e.distance (l_start)) + 1).to_natural_32)))
						from
						until
							not ((l_start.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32)
						loop
							if (l_start.item).to_integer_32 < 32 then
								l_n[l_i] := (('.').code).to_natural_8
							else
								l_n[l_i] := l_start.item
							end
							l_i := l_i + 1
							l_start := l_start + 1
						end
						l_n[l_i] := (0).to_natural_8
						Result := l_n
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
