class
	S_TIME_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	time (a___timer: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := c_time (a___timer.c_pointer)
		end

	c_time (a___timer: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return time($a___timer);"
		end

	strftime (a___s: CE_POINTER [INTEGER_8]; a___maxsize: NATURAL_32; a___format: CE_POINTER [INTEGER_8]; a___tp: CE_POINTER [SD_TM]): NATURAL_32
		do
			Result := c_strftime (a___s.c_pointer, a___maxsize, a___format.c_pointer, a___tp.c_pointer)
		end

	c_strftime (a___s: POINTER; a___maxsize: NATURAL_32; a___format: POINTER; a___tp: POINTER): NATURAL_32
		external
			"C inline use <links.h>"
		alias
			"return strftime($a___s, $a___maxsize, $a___format, $a___tp);"
		end

	localtime (a___timer: CE_POINTER [INTEGER_32]): CE_POINTER [SD_TM]
		do
			create {CE_CLASS_POINTER [SD_TM]} Result.make_shared (c_localtime (a___timer.c_pointer))
		end

	c_localtime (a___timer: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return (EIF_POINTER)localtime($a___timer);"
		end

	mktime (a___tp: CE_POINTER [SD_TM]): INTEGER_32
		do
			Result := c_mktime (a___tp.c_pointer)
		end

	c_mktime (a___tp: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return mktime($a___tp);"
		end

end
