class
	PD_FROMTO_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} ft_from.make
			create {CE_NATURAL_8_POINTER} ft_to.make
		end

feature {ANY} -- fields

	ft_from: CE_POINTER [NATURAL_8] assign set_ft_from

	ft_to: CE_POINTER [NATURAL_8] assign set_ft_to

feature {ANY} -- field setters

	set_ft_from (a_ft_from: CE_POINTER [NATURAL_8])
		do
			ft_from := a_ft_from
			update_memory_field ("ft_from")
		end

	set_ft_to (a_ft_to: CE_POINTER [NATURAL_8])
		do
			ft_to := a_ft_to
			update_memory_field ("ft_to")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ft_from := a_other.ft_from
			ft_to := a_other.ft_to
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ft_from.is_equal (a_other.ft_from) and
				ft_to.is_equal (a_other.ft_to)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ft_from"),
					create {CE_STRUCTURE_FIELD}.make ("ft_to")
				>>)
			init_structure_info
		end

end
