class
	PD_MATCHINF_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_LANGP_S]} mi_lp.make
			create {CE_NATURAL_8_POINTER} mi_word.make
			create {CE_NATURAL_8_POINTER} mi_end.make
			create {CE_NATURAL_8_POINTER} mi_fend.make
			create {CE_NATURAL_8_POINTER} mi_cend.make
			create {CE_NATURAL_8_ARRAY} mi_fword.make (<<251>>)
			create {CE_NATURAL_8_ARRAY} mi_compflags.make (<<250>>)
			create {CE_CLASS_POINTER [PD_WINDOW_S]} mi_win.make
			create {CE_NATURAL_8_POINTER} mi_end2.make
			Precursor
		end

feature {ANY} -- fields

	mi_lp: CE_POINTER [PD_LANGP_S] assign set_mi_lp

	mi_word: CE_POINTER [NATURAL_8] assign set_mi_word

	mi_end: CE_POINTER [NATURAL_8] assign set_mi_end

	mi_fend: CE_POINTER [NATURAL_8] assign set_mi_fend

	mi_cend: CE_POINTER [NATURAL_8] assign set_mi_cend

	mi_fword: CE_ARRAY [NATURAL_8]

	mi_fwordlen: INTEGER_32 assign set_mi_fwordlen

	mi_prefarridx: INTEGER_32 assign set_mi_prefarridx

	mi_prefcnt: INTEGER_32 assign set_mi_prefcnt

	mi_prefixlen: INTEGER_32 assign set_mi_prefixlen

	mi_cprefixlen: INTEGER_32 assign set_mi_cprefixlen

	mi_compoff: INTEGER_32 assign set_mi_compoff

	mi_compflags: CE_ARRAY [NATURAL_8]

	mi_complen: INTEGER_32 assign set_mi_complen

	mi_compextra: INTEGER_32 assign set_mi_compextra

	mi_result: INTEGER_32 assign set_mi_result

	mi_capflags: INTEGER_32 assign set_mi_capflags

	mi_win: CE_POINTER [PD_WINDOW_S] assign set_mi_win

	mi_result2: INTEGER_32 assign set_mi_result2

	mi_end2: CE_POINTER [NATURAL_8] assign set_mi_end2

feature {ANY} -- field setters

	set_mi_lp (a_mi_lp: CE_POINTER [PD_LANGP_S])
		do
			mi_lp := a_mi_lp
			update_memory_field ("mi_lp")
		end

	set_mi_word (a_mi_word: CE_POINTER [NATURAL_8])
		do
			mi_word := a_mi_word
			update_memory_field ("mi_word")
		end

	set_mi_end (a_mi_end: CE_POINTER [NATURAL_8])
		do
			mi_end := a_mi_end
			update_memory_field ("mi_end")
		end

	set_mi_fend (a_mi_fend: CE_POINTER [NATURAL_8])
		do
			mi_fend := a_mi_fend
			update_memory_field ("mi_fend")
		end

	set_mi_cend (a_mi_cend: CE_POINTER [NATURAL_8])
		do
			mi_cend := a_mi_cend
			update_memory_field ("mi_cend")
		end

	set_mi_fwordlen (a_mi_fwordlen: INTEGER_32)
		do
			mi_fwordlen := a_mi_fwordlen
			update_memory_field ("mi_fwordlen")
		end

	set_mi_prefarridx (a_mi_prefarridx: INTEGER_32)
		do
			mi_prefarridx := a_mi_prefarridx
			update_memory_field ("mi_prefarridx")
		end

	set_mi_prefcnt (a_mi_prefcnt: INTEGER_32)
		do
			mi_prefcnt := a_mi_prefcnt
			update_memory_field ("mi_prefcnt")
		end

	set_mi_prefixlen (a_mi_prefixlen: INTEGER_32)
		do
			mi_prefixlen := a_mi_prefixlen
			update_memory_field ("mi_prefixlen")
		end

	set_mi_cprefixlen (a_mi_cprefixlen: INTEGER_32)
		do
			mi_cprefixlen := a_mi_cprefixlen
			update_memory_field ("mi_cprefixlen")
		end

	set_mi_compoff (a_mi_compoff: INTEGER_32)
		do
			mi_compoff := a_mi_compoff
			update_memory_field ("mi_compoff")
		end

	set_mi_complen (a_mi_complen: INTEGER_32)
		do
			mi_complen := a_mi_complen
			update_memory_field ("mi_complen")
		end

	set_mi_compextra (a_mi_compextra: INTEGER_32)
		do
			mi_compextra := a_mi_compextra
			update_memory_field ("mi_compextra")
		end

	set_mi_result (a_mi_result: INTEGER_32)
		do
			mi_result := a_mi_result
			update_memory_field ("mi_result")
		end

	set_mi_capflags (a_mi_capflags: INTEGER_32)
		do
			mi_capflags := a_mi_capflags
			update_memory_field ("mi_capflags")
		end

	set_mi_win (a_mi_win: CE_POINTER [PD_WINDOW_S])
		do
			mi_win := a_mi_win
			update_memory_field ("mi_win")
		end

	set_mi_result2 (a_mi_result2: INTEGER_32)
		do
			mi_result2 := a_mi_result2
			update_memory_field ("mi_result2")
		end

	set_mi_end2 (a_mi_end2: CE_POINTER [NATURAL_8])
		do
			mi_end2 := a_mi_end2
			update_memory_field ("mi_end2")
		end

feature {ANY} -- public routines

	find_word (a_mode: INTEGER_32)
		local
			l_arridx: INTEGER_32
			l_endlen: CE_ARRAY [INTEGER_32]
			l_endidx: CE_ARRAY [INTEGER_32]
			l_endidxcnt: INTEGER_32
			l_len: INTEGER_32
			l_wlen: INTEGER_32
			l_flen: INTEGER_32
			l_c: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_lo: INTEGER_32
			l_hi___1: INTEGER_32
			l_m: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_res: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
			l_flags___0: NATURAL_32
			l_byts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_word_ends: INTEGER_32
			l_prefix_found: INTEGER_32
			l_nobreak_result: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_capflags: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			l_tmp___25: INTEGER_32
			l_fword: CE_ARRAY [NATURAL_8]
			l_tmp___26: INTEGER_32
			l_tmp___27: INTEGER_32
			l_save_result: INTEGER_32
			l_save_end: CE_POINTER [NATURAL_8]
			l_save_lp: CE_POINTER [PD_LANGP_S]
			l_lpi: INTEGER_32
			l_tmp___28: INTEGER_32
			l_tmp___29: INTEGER_32
			l_tmp___30: INTEGER_32
			l_tmp___31: INTEGER_32
			l_tmp___32: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_endlen.make (<<250>>)
			create {CE_INTEGER_32_ARRAY} l_endidx.make (<<250>>)
			create {CE_NATURAL_8_ARRAY} l_fword.make (<<250>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arridx := 0
					l_endidxcnt := 0
					l_wlen := 0
					l_res := 3
					l_slang := mi_lp.item.lp_slang
					if a_mode /= 1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_mode /= 4 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_ptr := mi_word
						l_flen := 9_999
						l_byts := l_slang.item.sl_kbyts
						l_idxs := l_slang.item.sl_kidxs
						if a_mode = 4 then
							l_wlen := l_wlen + mi_compoff
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_ptr := mi_fword
						l_flen := mi_fwordlen
						l_byts := l_slang.item.sl_fbyts
						l_idxs := l_slang.item.sl_fidxs
						if a_mode = 2 then
							l_wlen := mi_prefixlen
							l_flen := l_flen - mi_prefixlen
						elseif a_mode = 3 then
							l_wlen := mi_compoff
							l_flen := l_flen - mi_compoff
						end
				when 7 then -- if done
					if l_byts.is_void then
						l_return := True
					end
					if not l_return then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_flen <= 0 then
								if (mi_fend.item).to_integer_32 /= 0 then
									l_flen := ((create {CE_CLASS_POINTER [PD_MATCHINF_S]}.make_shared (c_pointer))).item.fold_more
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							l_tmp := l_arridx
							l_arridx := l_arridx + 1
							l_len := (l_byts[l_tmp]).to_integer_32
							if (l_byts[l_arridx]).to_integer_32 = 0 then
								if l_endidxcnt = 250 then
									l_tmp___0 := gettext ((create {P_SPELL_STATIC}).e_format.item)
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0)).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									l_return := True
								end
								if not l_return then
									l_endlen[l_endidxcnt] := l_wlen
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___1 := l_endidxcnt
									l_endidxcnt := l_endidxcnt + 1
									l_tmp___2 := l_arridx
									l_arridx := l_arridx + 1
									l_endidx[l_tmp___1] := l_tmp___2
									update_class_fields -- Current might have been changed; synchronize
									l_len := l_len - 1
									from
									until
										(l_break)
									loop
										l_break := False
										if l_len > 0 then
											if (l_byts[l_arridx]).to_integer_32 /= 0 then
												l_break := True
											end
										else
											l_break := True
										end
										if not (l_break) then
											l_arridx := l_arridx + 1
											l_len := l_len - 1
										end
									end
									l_break := False
									if l_len = 0 then
										l_break := True
									end
								end
							end
							if not (l_return or l_break) and then ((l_ptr[l_wlen]).to_integer_32 = 0) then
								l_break := True
							end
							if not (l_return or l_break) then
								l_c := (l_ptr[l_wlen]).to_integer_32
								if l_c = 9 then
									l_c := (' ').code
								end
								l_lo := l_arridx
								l_hi___1 := (l_arridx + l_len) - 1
								from
								until
									not (not (l_break) and then (l_lo < l_hi___1))
								loop
									l_break := False
									l_m := (l_lo + l_hi___1) // 2
									if (l_byts[l_m]).to_integer_32 > l_c then
										l_hi___1 := l_m - 1
									elseif (l_byts[l_m]).to_integer_32 < l_c then
										l_lo := l_m + 1
									else
										l_hi___1 := l_m
										l_lo := l_hi___1
										l_break := True
									end
								end
								l_break := False
								if l_hi___1 < l_lo then
									l_break := True
								elseif (l_byts[l_lo]).to_integer_32 /= l_c then
									l_break := True
								end
							end
							if not (l_return or l_break) then
								l_arridx := l_idxs[l_lo]
								l_wlen := l_wlen + 1
								l_flen := l_flen - 1
								if l_c = 32 then
									from
									until
										(l_break)
									loop
										l_break := False
										if l_flen <= 0 then
											if (mi_fend.item).to_integer_32 /= 0 then
												l_flen := ((create {CE_CLASS_POINTER [PD_MATCHINF_S]}.make_shared (c_pointer))).item.fold_more
												update_class_fields -- Current might have been changed; synchronize
											end
										end
										if (l_ptr[l_wlen]).to_integer_32 /= 32 then
											if (l_ptr[l_wlen]).to_integer_32 /= 9 then
												l_break := True
											end
										end
										if not (l_break) then
											l_wlen := l_wlen + 1
											l_flen := l_flen - 1
										end
									end
									l_break := False
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 35 -- skip if block
					end
				when 8 then -- if:
						l_break := False
				when 9 then -- loop condition:
						if not (not (l_return or l_break) and then (l_endidxcnt > 0)) then
							l_pos := -1 + 34 -- skip loop
						end
				when 10 then -- loop body:
						l_break := False
						l_continue := False
						l_endidxcnt := l_endidxcnt - 1
						l_arridx := l_endidx[l_endidxcnt]
						l_wlen := l_endlen[l_endidxcnt]
						l_tmp___3 := (create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_ptr, l_ptr + l_wlen])
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___3 > 0 then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							l_tmp___4 := mi_win.item.spell_iswordp (l_ptr + l_wlen)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___4.to_boolean then
								if (l_slang.item.sl_compprog).is_void then
									if not (l_slang.item.sl_nobreak).to_boolean then
										l_continue := True
									end
								end
								if not (l_return or l_break or l_continue) then
									l_word_ends := 0
								end
							else
								l_word_ends := 1
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 33 -- skip if block
						end
				when 11 then -- if:
						l_prefix_found := 0
						if a_mode /= 1 then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_p___0 := mi_word
								l_tmp___9 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), l_wlen.to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___9 /= 0 then
									l_s := l_ptr
									from
									until
										not ((l_s.c_pointer.to_integer_32).to_natural_32 < ((l_ptr + l_wlen).c_pointer.to_integer_32).to_natural_32)
									loop
										if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
											l_tmp___7 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___8 := l_tmp___7
										else
											l_tmp___8 := 1
										end
										l_p___0 := l_p___0 + l_tmp___8
										if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
											l_tmp___5 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s])
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___6 := l_tmp___5
										else
											l_tmp___6 := 1
										end
										l_s := l_s + l_tmp___6
									end
									l_wlen := l_p___0.distance (mi_word)
								end
							end
						end
						l_res := 3
						l_len := (l_byts[(l_arridx - 1)]).to_integer_32
				when 12 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 32 -- skip loop
						end
				when 13 then -- loop body:
						l_break := False
						l_continue := False
						if l_len > 0 then
							if (l_byts[l_arridx]).to_integer_32 /= 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_flags___0 := (l_idxs[l_arridx]).to_natural_32
							if a_mode = 0 then
								if not mi_cend.is_equal (mi_word + l_wlen) then
									Current.mi_cend := mi_word + l_wlen
									update_class_fields -- Current might have been changed; synchronize
									Current.mi_capflags := (create {P_SPELL_STATIC}).captype (mi_word, mi_cend)
									update_class_fields -- Current might have been changed; synchronize
								end
								if mi_capflags = 128 then
									l_continue := True
								else
									l_tmp___10 := (create {P_SPELL_STATIC}).spell_valid_case (mi_capflags, l_flags___0.to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
									if not l_tmp___10.to_boolean then
										l_continue := True
									end
								end
							elseif a_mode = 2 then
								if not l_prefix_found.to_boolean then
									l_c := (create {P_SPELL_STATIC}).valid_word_prefix (mi_prefcnt, mi_prefarridx, l_flags___0.to_integer_32, mi_word + mi_cprefixlen, l_slang, 0)
									update_class_fields -- Current might have been changed; synchronize
									if l_c = 0 then
										l_continue := True
									end
									if not (l_return or l_break or l_continue) then
										if ((l_c).bit_and (((1).bit_shift_left (24)))).to_boolean then
											l_flags___0 := (l_flags___0).bit_or (({NATURAL_32} 8))
										end
										l_prefix_found := 1
									end
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 31 -- skip if block
						end
				when 14 then -- if:
						if not ((l_slang.item.sl_nobreak).to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 15 then -- if:
						if a_mode /= 3 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L___0
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 18 then -- else:
						if a_mode /= 4 then
							l_pos := -1 + 20 -- skip if block
						end
				when 19 then -- if: | _L___0:
						if ((l_flags___0).bit_and ({NATURAL_32} 16)) = {NATURAL_32} 0 then
							Current.mi_result := 0
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
				when 20 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 31
				when 21 then -- else:
						if a_mode /= 3 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 28 -- goto _L___1
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 24 then -- else:
						if a_mode /= 4 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L___1
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 27 then -- else:
						if l_word_ends.to_boolean then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if: | _L___1:
						if (l_flags___0).bit_shift_right (24) = {NATURAL_32} 0 then
							l_continue := True
						elseif l_wlen - mi_compoff < l_slang.item.sl_compminlen then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) and then (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							if l_slang.item.sl_compminlen > 0 then
								l_tmp___11 := mb_charlen_len (mi_word + mi_compoff, l_wlen - mi_compoff)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___11 < l_slang.item.sl_compminlen then
									l_continue := True
								end
							end
						end
						if not (l_return or l_break or l_continue) and then (not l_word_ends.to_boolean) then
							if (mi_complen + mi_compextra) + 2 > l_slang.item.sl_compmax then
								if l_slang.item.sl_compsylmax = 250 then
									l_continue := True
								end
							end
						end
						if not (l_return or l_break or l_continue) and then (mi_complen > 0) then
							if ((l_flags___0).bit_and ({NATURAL_32} 4_096)).to_boolean then
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) and then (not l_word_ends.to_boolean) then
							if ((l_flags___0).bit_and ({NATURAL_32} 8_192)).to_boolean then
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							if mi_complen = 0 then
								l_tmp___12 := l_slang.item.sl_compstartflags
							else
								l_tmp___12 := l_slang.item.sl_compallflags
							end
							l_tmp___13 := (create {P_SPELL_STATIC}).byte_in_str (l_tmp___12, ((l_flags___0).bit_shift_right (24)).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___13.to_boolean then
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							l_tmp___14 := (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_comppat"))).item.match_checkcompoundpattern (l_ptr, l_wlen)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___14.to_boolean then
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) and then (a_mode = 3) then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___19 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr), create {CE_INTEGER_8_POINTER}.make_cast (mi_word), mi_compoff.to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___19 /= 0 then
									l_p___0 := mi_word
									l_s := l_ptr
									from
									until
										not ((l_s.c_pointer.to_integer_32).to_natural_32 < ((l_ptr + mi_compoff).c_pointer.to_integer_32).to_natural_32)
									loop
										if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
											l_tmp___17 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___18 := l_tmp___17
										else
											l_tmp___18 := 1
										end
										l_p___0 := l_p___0 + l_tmp___18
										if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
											l_tmp___15 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s])
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___16 := l_tmp___15
										else
											l_tmp___16 := 1
										end
										l_s := l_s + l_tmp___16
									end
								else
									l_p___0 := mi_word + mi_compoff
								end
							else
								l_p___0 := mi_word + mi_compoff
							end
							l_capflags := (create {P_SPELL_STATIC}).captype (l_p___0, mi_word + l_wlen)
							update_class_fields -- Current might have been changed; synchronize
							if l_capflags = 128 then
								l_continue := True
							elseif l_capflags = 4 then
								if ((l_flags___0).bit_and ({NATURAL_32} 64)) /= {NATURAL_32} 0 then
									l_continue := True
								end
							end
							if not (l_return or l_break or l_continue) and then (l_capflags /= 4) then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___20 := (create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([mi_word, l_p___0 - 1])
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___21 := l_tmp___20 + 1
								else
									l_tmp___21 := 1
								end
								l_p___0 := l_p___0 - l_tmp___21
								l_tmp___25 := (create {P_SPELL_STATIC}).spell_iswordp_nmw (l_p___0)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___25.to_boolean then
									l_tmp___24 := (l_capflags = 2).to_integer
								else
									if ((l_flags___0).bit_and ({NATURAL_32} 2)) /= {NATURAL_32} 0 then
										if l_capflags /= 2 then
											l_tmp___23 := 1
										else
											l_tmp___23 := 0
										end
									else
										l_tmp___23 := 0
									end
									l_tmp___24 := l_tmp___23
								end
								if l_tmp___24.to_boolean then
									l_continue := True
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							mi_compflags[mi_complen] := ((l_flags___0).bit_shift_right (24)).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
							mi_compflags[mi_complen + 1] := (('%/0/').code).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
							if l_word_ends.to_boolean then
								if l_slang.item.sl_compsylmax < 250 then
									if l_ptr.is_equal (mi_word) then
										(create {P_SPELL_STATIC}).spell_casefold (l_ptr, l_wlen, l_fword, 250).do_nothing
										update_class_fields -- Current might have been changed; synchronize
									else
										(create {P_MISC2_STATIC}).vim_strncpy (l_fword, l_ptr, (l_endlen[l_endidxcnt]).to_natural_32)
										update_class_fields -- Current might have been changed; synchronize
									end
								end
								l_tmp___26 := l_slang.item.can_compound (l_fword, mi_compflags)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___26.to_boolean then
									l_continue := True
								end
							elseif not (l_slang.item.sl_comprules).is_void then
								l_tmp___27 := l_slang.item.match_compoundrule (mi_compflags)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___27.to_boolean then
									l_continue := True
								end
							end
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else:
						if ((l_flags___0).bit_and ({NATURAL_32} 512)).to_boolean then
							l_continue := True
						end
				when 31 then -- if done | if done | if done | if done
						if not (l_return or l_break or l_continue) then
							l_nobreak_result := 0
							if not l_word_ends.to_boolean then
								l_save_result := mi_result
								l_save_end := mi_end
								l_save_lp := mi_lp
								if (l_slang.item.sl_nobreak).to_boolean then
									Current.mi_result := 3
									update_class_fields -- Current might have been changed; synchronize
								end
								Current.mi_compoff := l_endlen[l_endidxcnt]
								update_class_fields -- Current might have been changed; synchronize
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									if a_mode = 1 then
										l_p___0 := mi_fword
										l_tmp___32 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), l_wlen.to_natural_32)
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___32 /= 0 then
											l_s := l_ptr
											from
											until
												not ((l_s.c_pointer.to_integer_32).to_natural_32 < ((l_ptr + l_wlen).c_pointer.to_integer_32).to_natural_32)
											loop
												if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
													l_tmp___30 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
													update_class_fields -- Current might have been changed; synchronize
													l_tmp___31 := l_tmp___30
												else
													l_tmp___31 := 1
												end
												l_p___0 := l_p___0 + l_tmp___31
												if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
													l_tmp___28 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s])
													update_class_fields -- Current might have been changed; synchronize
													l_tmp___29 := l_tmp___28
												else
													l_tmp___29 := 1
												end
												l_s := l_s + l_tmp___29
											end
											Current.mi_compoff := l_p___0.distance (mi_fword)
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								end
								l_c := mi_compoff
								Current.mi_complen := mi_complen + 1
								update_class_fields -- Current might have been changed; synchronize
								if ((l_flags___0).bit_and ({NATURAL_32} 2_048)).to_boolean then
									Current.mi_compextra := mi_compextra + 1
									update_class_fields -- Current might have been changed; synchronize
								end
								l_lpi := 0
								from
								until
									not (not (l_break) and then (l_lpi < (mi_win.item.w_s).item.b_langp.ga_len))
								loop
									l_break := False
									l_continue := False
									if (l_slang.item.sl_nobreak).to_boolean then
										Current.mi_lp := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast ((mi_win.item.w_s).item.b_langp.ga_data) + l_lpi
										update_class_fields -- Current might have been changed; synchronize
										if ((mi_lp.item.lp_slang).item.sl_fidxs).is_void then
											l_continue := True
										elseif not ((mi_lp.item.lp_slang).item.sl_nobreak).to_boolean then
											l_continue := True
										end
									end
									if not (l_return or l_break or l_continue) then
										((create {CE_CLASS_POINTER [PD_MATCHINF_S]}.make_shared (c_pointer))).item.find_word (3)
										update_class_fields -- Current might have been changed; synchronize
										if not (l_slang.item.sl_nobreak).to_boolean then
											Current.mi_compoff := l_wlen
											update_class_fields; -- Current might have been changed; synchronize
											((create {CE_CLASS_POINTER [PD_MATCHINF_S]}.make_shared (c_pointer))).item.find_word (4)
											update_class_fields -- Current might have been changed; synchronize
										elseif mi_result = 3 then
											Current.mi_compoff := l_wlen
											update_class_fields; -- Current might have been changed; synchronize
											((create {CE_CLASS_POINTER [PD_MATCHINF_S]}.make_shared (c_pointer))).item.find_word (4)
											update_class_fields -- Current might have been changed; synchronize
										end
										if not (l_slang.item.sl_nobreak).to_boolean then
											l_break := True
										end
									end
									if (not l_break) then
										l_lpi := l_lpi + 1
									end
								end
								l_break := False
								l_continue := False
								Current.mi_complen := mi_complen - 1
								update_class_fields -- Current might have been changed; synchronize
								if ((l_flags___0).bit_and ({NATURAL_32} 2_048)).to_boolean then
									Current.mi_compextra := mi_compextra - 1
									update_class_fields -- Current might have been changed; synchronize
								end
								Current.mi_lp := l_save_lp
								update_class_fields -- Current might have been changed; synchronize
								if (l_slang.item.sl_nobreak).to_boolean then
									l_nobreak_result := mi_result
									Current.mi_result := l_save_result
									update_class_fields -- Current might have been changed; synchronize
									Current.mi_end := l_save_end
									update_class_fields -- Current might have been changed; synchronize
								else
									if mi_result = 0 then
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										l_continue := True
									end
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							if ((l_flags___0).bit_and ({NATURAL_32} 16)).to_boolean then
								l_res := -1
							elseif ((l_flags___0).bit_and ({NATURAL_32} 1)).to_boolean then
								if (((mi_lp.item.lp_region).to_natural_32).bit_and (((l_flags___0).bit_shift_right (16)))) /= {NATURAL_32} 0 then
									l_res := 0
								else
									l_res := 2
								end
							elseif ((l_flags___0).bit_and ({NATURAL_32} 8)).to_boolean then
								l_res := 1
							else
								l_res := 0
							end
							if l_nobreak_result = 3 then
								if mi_result2 > l_res then
									Current.mi_result2 := l_res
									update_class_fields -- Current might have been changed; synchronize
									Current.mi_end2 := mi_word + l_wlen
									update_class_fields -- Current might have been changed; synchronize
								elseif mi_result2 = l_res then
									if (mi_end2.c_pointer.to_integer_32).to_natural_32 < ((mi_word + l_wlen).c_pointer.to_integer_32).to_natural_32 then
										Current.mi_end2 := mi_word + l_wlen
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							elseif mi_result > l_res then
								Current.mi_result := l_res
								update_class_fields -- Current might have been changed; synchronize
								Current.mi_end := mi_word + l_wlen
								update_class_fields -- Current might have been changed; synchronize
							elseif mi_result = l_res then
								if (mi_end.c_pointer.to_integer_32).to_natural_32 < ((mi_word + l_wlen).c_pointer.to_integer_32).to_natural_32 then
									Current.mi_end := mi_word + l_wlen
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							if mi_result = 0 then
								l_break := True
							end
						end
						if (not l_return and not l_break) then
							l_len := l_len - 1
							l_arridx := l_arridx + 1
						end
						l_pos := -1 + 12 -- back to loop condition
				when 32 then -- loop done
						l_break := False
						l_continue := False
						if mi_result = 0 then
							l_break := True
						end
				when 33 then -- if done
						l_pos := -1 + 9 -- back to loop condition
				when 34 then -- loop done
						l_break := False
						l_continue := False
				when 35 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	fold_more: INTEGER_32
		local
			l_flen: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: NATURAL_32
			l_break: BOOLEAN
		do
			l_p___0 := mi_fend
			from
			until
				(l_break)
			loop
				l_break := False
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					l_tmp := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([mi_fend])
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := l_tmp
				else
					l_tmp___0 := 1
				end
				Current.mi_fend := mi_fend + l_tmp___0
				update_class_fields -- Current might have been changed; synchronize
				if (mi_fend.item).to_integer_32 /= 0 then
					l_tmp___1 := mi_win.item.spell_iswordp (mi_fend)
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp___1.to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
			end
			l_break := False
			if (mi_fend.item).to_integer_32 /= 0 then
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					l_tmp___2 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([mi_fend])
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___3 := l_tmp___2
				else
					l_tmp___3 := 1
				end
				Current.mi_fend := mi_fend + l_tmp___3
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_SPELL_STATIC}).spell_casefold (l_p___0, mi_fend.distance (l_p___0), mi_fword + mi_fwordlen, 250 - mi_fwordlen).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___4 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((mi_fword + mi_fwordlen)))
			update_class_fields -- Current might have been changed; synchronize
			l_flen := l_tmp___4.to_integer_32
			Current.mi_fwordlen := mi_fwordlen + l_flen
			update_class_fields -- Current might have been changed; synchronize
			Result := l_flen
		end

feature {PD_MATCHINF_S} -- private routines

	mb_charlen_len (a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		require
			not a_str___1.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_count___2: INTEGER_32
			l_break: BOOLEAN
		do
			l_p___0 := a_str___1
			l_count___2 := 0
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_p___0.item).to_integer_32 /= 0 then
					if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((a_str___1 + a_len).c_pointer.to_integer_32).to_natural_32) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_p___0 := l_p___0 + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
					l_count___2 := l_count___2 + 1
				end
			end
			l_break := False
			Result := l_count___2
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mi_lp := a_other.mi_lp
			mi_word := a_other.mi_word
			mi_end := a_other.mi_end
			mi_fend := a_other.mi_fend
			mi_cend := a_other.mi_cend
			mi_fword := a_other.mi_fword.twin
			mi_fwordlen := a_other.mi_fwordlen
			mi_prefarridx := a_other.mi_prefarridx
			mi_prefcnt := a_other.mi_prefcnt
			mi_prefixlen := a_other.mi_prefixlen
			mi_cprefixlen := a_other.mi_cprefixlen
			mi_compoff := a_other.mi_compoff
			mi_compflags := a_other.mi_compflags.twin
			mi_complen := a_other.mi_complen
			mi_compextra := a_other.mi_compextra
			mi_result := a_other.mi_result
			mi_capflags := a_other.mi_capflags
			mi_win := a_other.mi_win
			mi_result2 := a_other.mi_result2
			mi_end2 := a_other.mi_end2
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mi_lp.is_equal (a_other.mi_lp) and
				mi_word.is_equal (a_other.mi_word) and
				mi_end.is_equal (a_other.mi_end) and
				mi_fend.is_equal (a_other.mi_fend) and
				mi_cend.is_equal (a_other.mi_cend) and
				mi_fword.is_equal (a_other.mi_fword) and
				mi_fwordlen = a_other.mi_fwordlen and
				mi_prefarridx = a_other.mi_prefarridx and
				mi_prefcnt = a_other.mi_prefcnt and
				mi_prefixlen = a_other.mi_prefixlen and
				mi_cprefixlen = a_other.mi_cprefixlen and
				mi_compoff = a_other.mi_compoff and
				mi_compflags.is_equal (a_other.mi_compflags) and
				mi_complen = a_other.mi_complen and
				mi_compextra = a_other.mi_compextra and
				mi_result = a_other.mi_result and
				mi_capflags = a_other.mi_capflags and
				mi_win.is_equal (a_other.mi_win) and
				mi_result2 = a_other.mi_result2 and
				mi_end2.is_equal (a_other.mi_end2)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("mi_lp"),
					create {CE_STRUCTURE_FIELD}.make ("mi_word"),
					create {CE_STRUCTURE_FIELD}.make ("mi_end"),
					create {CE_STRUCTURE_FIELD}.make ("mi_fend"),
					create {CE_STRUCTURE_FIELD}.make ("mi_cend"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mi_fword", <<251>>),
					create {CE_STRUCTURE_FIELD}.make ("mi_fwordlen"),
					create {CE_STRUCTURE_FIELD}.make ("mi_prefarridx"),
					create {CE_STRUCTURE_FIELD}.make ("mi_prefcnt"),
					create {CE_STRUCTURE_FIELD}.make ("mi_prefixlen"),
					create {CE_STRUCTURE_FIELD}.make ("mi_cprefixlen"),
					create {CE_STRUCTURE_FIELD}.make ("mi_compoff"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mi_compflags", <<250>>),
					create {CE_STRUCTURE_FIELD}.make ("mi_complen"),
					create {CE_STRUCTURE_FIELD}.make ("mi_compextra"),
					create {CE_STRUCTURE_FIELD}.make ("mi_result"),
					create {CE_STRUCTURE_FIELD}.make ("mi_capflags"),
					create {CE_STRUCTURE_FIELD}.make ("mi_win"),
					create {CE_STRUCTURE_FIELD}.make ("mi_result2"),
					create {CE_STRUCTURE_FIELD}.make ("mi_end2")
				>>)
			init_structure_info
		end

end
