class
	PD_SPELLOAD_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_ARRAY} sl_lang.make (<<251>>)
			create {CE_CLASS_POINTER [PD_SLANG_S]} sl_slang.make
		end

feature {ANY} -- fields

	sl_lang: CE_ARRAY [NATURAL_8]

	sl_slang: CE_POINTER [PD_SLANG_S] assign set_sl_slang

	sl_nobreak: INTEGER_32 assign set_sl_nobreak

feature {ANY} -- field setters

	set_sl_slang (a_sl_slang: CE_POINTER [PD_SLANG_S])
		do
			sl_slang := a_sl_slang
			update_memory_field ("sl_slang")
		end

	set_sl_nobreak (a_sl_nobreak: INTEGER_32)
		do
			sl_nobreak := a_sl_nobreak
			update_memory_field ("sl_nobreak")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sl_lang := a_other.sl_lang.twin
			sl_slang := a_other.sl_slang
			sl_nobreak := a_other.sl_nobreak
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sl_lang.is_equal (a_other.sl_lang) and
				sl_slang.is_equal (a_other.sl_slang) and
				sl_nobreak = a_other.sl_nobreak
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sl_lang", <<251>>),
					create {CE_STRUCTURE_FIELD}.make ("sl_slang"),
					create {CE_STRUCTURE_FIELD}.make ("sl_nobreak")
				>>)
			init_structure_info
		end

end
