class
	PD_SPELLTAB_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_ARRAY} st_isw.make (<<256>>)
			create {CE_NATURAL_8_ARRAY} st_isu.make (<<256>>)
			create {CE_NATURAL_8_ARRAY} st_fold.make (<<256>>)
			create {CE_NATURAL_8_ARRAY} st_upper.make (<<256>>)
			Precursor
		end

feature {ANY} -- fields

	st_isw: CE_ARRAY [NATURAL_8]

	st_isu: CE_ARRAY [NATURAL_8]

	st_fold: CE_ARRAY [NATURAL_8]

	st_upper: CE_ARRAY [NATURAL_8]

feature {ANY} -- public routines

	clear_spell_chartab
		local
			l_i___0: INTEGER_32
		do
			memset (create {CE_VOID_POINTER}.make_cast (st_isw), 0, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (256).to_natural_32)).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			memset (create {CE_VOID_POINTER}.make_cast (st_isu), 0, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (256).to_natural_32)).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_i___0 := 0
			from
			until
				not (l_i___0 < 256)
			loop
				st_fold[l_i___0] := l_i___0.to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				st_upper[l_i___0] := l_i___0.to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := l_i___0 + 1
			end
			l_i___0 := ('0').code
			from
			until
				not (l_i___0 <= 57)
			loop
				st_isw[l_i___0] := (1).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := l_i___0 + 1
			end
			l_i___0 := ('A').code
			from
			until
				not (l_i___0 <= 90)
			loop
				st_isw[l_i___0] := (1).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				st_isu[l_i___0] := (1).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				st_fold[l_i___0] := (l_i___0 + 32).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := l_i___0 + 1
			end
			l_i___0 := ('a').code
			from
			until
				not (l_i___0 <= 122)
			loop
				st_isw[l_i___0] := (1).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				st_upper[l_i___0] := (l_i___0 - 32).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := l_i___0 + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			st_isw := a_other.st_isw.twin
			st_isu := a_other.st_isu.twin
			st_fold := a_other.st_fold.twin
			st_upper := a_other.st_upper.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				st_isw.is_equal (a_other.st_isw) and
				st_isu.is_equal (a_other.st_isu) and
				st_fold.is_equal (a_other.st_fold) and
				st_upper.is_equal (a_other.st_upper)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("st_isw", <<256>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("st_isu", <<256>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("st_fold", <<256>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("st_upper", <<256>>)
				>>)
			init_structure_info
		end

end
