class
	S_DLFCN_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	dlopen (a___file: CE_POINTER [INTEGER_8]; a___mode: INTEGER_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_dlopen (a___file.c_pointer, a___mode))
		end

	c_dlopen (a___file: POINTER; a___mode: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)dlopen($a___file, $a___mode);"
		end

	dlclose (a___handle: CE_POINTER [ANY]): INTEGER_32
		require
			not a___handle.is_void
		do
			Result := c_dlclose (a___handle.c_pointer)
		end

	c_dlclose (a___handle: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return dlclose($a___handle);"
		end

	dlsym (a___handle: CE_POINTER [ANY]; a___name: CE_POINTER [INTEGER_8]): CE_POINTER [ANY]
		require
			not a___name.is_void
		do
			create {CE_VOID_POINTER} Result.make_shared (c_dlsym (a___handle.c_pointer, a___name.c_pointer))
		end

	c_dlsym (a___handle: POINTER; a___name: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)dlsym($a___handle, $a___name);"
		end

	dlerror: CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_dlerror)
		end

	c_dlerror: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)dlerror();"
		end

end
