class
	S_GLIB_OBJECT_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	g_type_check_instance_cast (a_instance: CE_POINTER [SD_GTYPEINSTANCE]; a_iface_type: NATURAL_32): CE_POINTER [SD_GTYPEINSTANCE]
		do
			create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]} Result.make_shared (c_g_type_check_instance_cast (a_instance.c_pointer, a_iface_type))
		end

	c_g_type_check_instance_cast (a_instance: POINTER; a_iface_type: NATURAL_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)g_type_check_instance_cast($a_instance, $a_iface_type);"
		end

	g_signal_connect_data (a_instance: CE_POINTER [ANY]; a_detailed_signal: CE_POINTER [INTEGER_8]; a_c_handler: CE_ROUTINE; a_data: CE_POINTER [ANY]; a_destroy_data: CE_ROUTINE; a_connect_flags: NATURAL_32): NATURAL_32
		do
			Result := c_g_signal_connect_data (a_instance.c_pointer, a_detailed_signal.c_pointer, a_c_handler.c_pointer, a_data.c_pointer, a_destroy_data.c_pointer, a_connect_flags)
		end

	c_g_signal_connect_data (a_instance: POINTER; a_detailed_signal: POINTER; a_c_handler: POINTER; a_data: POINTER; a_destroy_data: POINTER; a_connect_flags: NATURAL_32): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return g_signal_connect_data($a_instance, $a_detailed_signal, $a_c_handler, $a_data, $a_destroy_data, $a_connect_flags);"
		end

	g_signal_handler_block (a_instance: CE_POINTER [ANY]; a_handler_id: NATURAL_32)
		do
			c_g_signal_handler_block (a_instance.c_pointer, a_handler_id)
		end

	c_g_signal_handler_block (a_instance: POINTER; a_handler_id: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"g_signal_handler_block($a_instance, $a_handler_id);"
		end

	g_signal_handler_unblock (a_instance: CE_POINTER [ANY]; a_handler_id: NATURAL_32)
		do
			c_g_signal_handler_unblock (a_instance.c_pointer, a_handler_id)
		end

	c_g_signal_handler_unblock (a_instance: POINTER; a_handler_id: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"g_signal_handler_unblock($a_instance, $a_handler_id);"
		end

	g_object_ref (a_object: CE_POINTER [ANY]): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_g_object_ref (a_object.c_pointer))
		end

	c_g_object_ref (a_object: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)g_object_ref($a_object);"
		end

	g_object_unref (a_object: CE_POINTER [ANY])
		do
			c_g_object_unref (a_object.c_pointer)
		end

	c_g_object_unref (a_object: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"g_object_unref($a_object);"
		end

	g_type_check_instance_is_a (a_instance: CE_POINTER [SD_GTYPEINSTANCE]; a_iface_type: NATURAL_32): INTEGER_32
		do
			Result := c_g_type_check_instance_is_a (a_instance.c_pointer, a_iface_type)
		end

	c_g_type_check_instance_is_a (a_instance: POINTER; a_iface_type: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return g_type_check_instance_is_a($a_instance, $a_iface_type);"
		end

	g_object_get_data (a_object: CE_POINTER [SD_GOBJECT]; a_key: CE_POINTER [INTEGER_8]): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_g_object_get_data (a_object.c_pointer, a_key.c_pointer))
		end

	c_g_object_get_data (a_object: POINTER; a_key: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)g_object_get_data($a_object, $a_key);"
		end

	g_object_set_data (a_object: CE_POINTER [SD_GOBJECT]; a_key: CE_POINTER [INTEGER_8]; a_data: CE_POINTER [ANY])
		do
			c_g_object_set_data (a_object.c_pointer, a_key.c_pointer, a_data.c_pointer)
		end

	c_g_object_set_data (a_object: POINTER; a_key: POINTER; a_data: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"g_object_set_data($a_object, $a_key, $a_data);"
		end

	g_object_set (a_args: TUPLE [a_object: CE_POINTER [ANY]; a_first_property_name: CE_POINTER [INTEGER_8]])
		do
			(create {CE_ROUTINE}.make_shared (c_g_object_set)).call (a_args)
		end

	c_g_object_set: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)&g_object_set;"
		end

	g_type_check_class_cast (a_g_class: CE_POINTER [SD_GTYPECLASS]; a_is_a_type: NATURAL_32): CE_POINTER [SD_GTYPECLASS]
		do
			create {CE_CLASS_POINTER [SD_GTYPECLASS]} Result.make_shared (c_g_type_check_class_cast (a_g_class.c_pointer, a_is_a_type))
		end

	c_g_type_check_class_cast (a_g_class: POINTER; a_is_a_type: NATURAL_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)g_type_check_class_cast($a_g_class, $a_is_a_type);"
		end

feature {ANY} -- routine addresses

	g_object_unref_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent g_object_unref)
		end

end
