class
	S_ICONV_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	iconv (a___cd: CE_POINTER [ANY]; a___inbuf: CE_POINTER [CE_POINTER [INTEGER_8]]; a___inbytesleft: CE_POINTER [NATURAL_32]; a___outbuf: CE_POINTER [CE_POINTER [INTEGER_8]]; a___outbytesleft: CE_POINTER [NATURAL_32]): NATURAL_32
		do
			Result := c_iconv (a___cd.c_pointer, a___inbuf.c_pointer, a___inbytesleft.c_pointer, a___outbuf.c_pointer, a___outbytesleft.c_pointer)
		end

	c_iconv (a___cd: POINTER; a___inbuf: POINTER; a___inbytesleft: POINTER; a___outbuf: POINTER; a___outbytesleft: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return iconv($a___cd, $a___inbuf, $a___inbytesleft, $a___outbuf, $a___outbytesleft);"
		end

	iconv_close (a___cd: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_iconv_close (a___cd.c_pointer)
		end

	c_iconv_close (a___cd: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return iconv_close($a___cd);"
		end

	iconv_open (a___tocode, a___fromcode: CE_POINTER [INTEGER_8]): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_iconv_open (a___tocode.c_pointer, a___fromcode.c_pointer))
		end

	c_iconv_open (a___tocode: POINTER; a___fromcode: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)iconv_open($a___tocode, $a___fromcode);"
		end

end
