class
	SD_GDKFONT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	type: NATURAL_32 assign set_type

	ascent: INTEGER_32 assign set_ascent

	descent: INTEGER_32 assign set_descent

feature {ANY} -- field setters

	set_type (a_type: NATURAL_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_ascent (a_ascent: INTEGER_32)
		do
			ascent := a_ascent
			update_memory_field ("ascent")
		end

	set_descent (a_descent: INTEGER_32)
		do
			descent := a_descent
			update_memory_field ("descent")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			ascent := a_other.ascent
			descent := a_other.descent
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				ascent = a_other.ascent and
				descent = a_other.descent
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("ascent"),
					create {CE_STRUCTURE_FIELD}.make ("descent")
				>>)
			init_structure_info
		end

end
