class
	SD_GTYPECLASS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	g_type: NATURAL_32 assign set_g_type

feature {ANY} -- field setters

	set_g_type (a_g_type: NATURAL_32)
		do
			g_type := a_g_type
			update_memory_field ("g_type")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			g_type := a_other.g_type
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				g_type = a_other.g_type
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("g_type")
				>>)
			init_structure_info
		end

end
