class
	SD_GTYPEINSTANCE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_GTYPECLASS]} g_class.make
		end

feature {ANY} -- fields

	g_class: CE_POINTER [SD_GTYPECLASS] assign set_g_class

feature {ANY} -- field setters

	set_g_class (a_g_class: CE_POINTER [SD_GTYPECLASS])
		do
			g_class := a_g_class
			update_memory_field ("g_class")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			g_class := a_other.g_class
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				g_class.is_equal (a_other.g_class)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("g_class")
				>>)
			init_structure_info
		end

end
