class
	SD_UTIMBUF

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	actime: INTEGER_32 assign set_actime

	modtime: INTEGER_32 assign set_modtime

feature {ANY} -- field setters

	set_actime (a_actime: INTEGER_32)
		do
			actime := a_actime
			update_memory_field ("actime")
		end

	set_modtime (a_modtime: INTEGER_32)
		do
			modtime := a_modtime
			update_memory_field ("modtime")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			actime := a_other.actime
			modtime := a_other.modtime
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				actime = a_other.actime and
				modtime = a_other.modtime
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("actime"),
					create {CE_STRUCTURE_FIELD}.make ("modtime")
				>>)
			init_structure_info
		end

end
