class
	P_DCPI1_BDIV_QR_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_dcpi1_bdiv_qr_n_itch (a_n: INTEGER_32): INTEGER_32
		do
			Result := a_n
		end

	gmpn_dcpi1_bdiv_qr_n (a_qp, a_np, a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_dinv: NATURAL_32; a_tp: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_tp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_lo: CE_ARRAY [INTEGER_32]
			l_hi: CE_ARRAY [INTEGER_32]
			l_cy: CE_ARRAY [NATURAL_32]
			l_rh: NATURAL_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_tp.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_lo.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_hi.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)

			l_tp.item := a_tp
			l_lo.item := (a_n).bit_shift_right (1)
			l_hi.item := a_n - l_lo.item
			if 60 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_lo.item >= 60 then
					l_cy.item := gmpn_dcpi1_bdiv_qr_n (a_qp, a_np, a_dp, l_lo.item, a_dinv, l_tp.item)
				else
					l_cy.item := (create {P_SBPI1_BDIV_QR_STATIC}).gmpn_sbpi1_bdiv_qr (a_qp, a_np, 2 * l_lo.item, a_dp, l_lo.item, a_dinv)
				end
			else
				l_cy.item := (create {P_SBPI1_BDIV_QR_STATIC}).gmpn_sbpi1_bdiv_qr (a_qp, a_np, 2 * l_lo.item, a_dp, l_lo.item, a_dinv)
			end
			(create {P_MUL_STATIC}).gmpn_mul (l_tp.item, a_dp + l_lo.item, l_hi.item, a_qp, l_lo.item).do_nothing
			from
			until
				(l_break)
			loop
				l_break := False
				asm323 (l___ptr_dummy, l_tp, l_lo, l_cy)
				l_break := True
			end
			l_break := False
			l_rh := (create {P_GMP_STATIC}).gmpn_sub (a_np + l_lo.item, (a_np + l_lo.item), a_n + l_hi.item, l_tp.item, a_n)
			if 60 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_hi.item >= 60 then
					l_cy.item := gmpn_dcpi1_bdiv_qr_n (a_qp + l_lo.item, a_np + l_lo.item, a_dp, l_hi.item, a_dinv, l_tp.item)
				else
					l_cy.item := (create {P_SBPI1_BDIV_QR_STATIC}).gmpn_sbpi1_bdiv_qr (a_qp + l_lo.item, a_np + l_lo.item, 2 * l_hi.item, a_dp, l_hi.item, a_dinv)
				end
			else
				l_cy.item := (create {P_SBPI1_BDIV_QR_STATIC}).gmpn_sbpi1_bdiv_qr (a_qp + l_lo.item, a_np + l_lo.item, 2 * l_hi.item, a_dp, l_hi.item, a_dinv)
			end
			(create {P_MUL_STATIC}).gmpn_mul (l_tp.item, (a_qp + l_lo.item), l_hi.item, a_dp + l_hi.item, l_lo.item).do_nothing
			from
			until
				(l_break)
			loop
				l_break := False
				asm324 (l___ptr_dummy___0, l_tp, l_hi, l_cy)
				l_break := True
			end
			l_break := False
			l_rh := l_rh + ((create {P_GMP_STATIC}).gmpn_sub_n (a_np + a_n, (a_np + a_n), l_tp.item, a_n))
			Result := l_rh
		end

	gmpn_dcpi1_bdiv_qr (a_qp, a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_dinv: NATURAL_32): NATURAL_32
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_qn: CE_ARRAY [INTEGER_32]
			l_rr: NATURAL_32
			l_cy: CE_ARRAY [NATURAL_32]
			l_tp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_INTEGER_32_ARRAY} l_qn.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_tp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)

			l_qp := a_qp
			l_np := a_np
			l___tmp_marker := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			l_tp.item := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new ((a_dn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_qn.item := a_nn - a_dn
			if l_qn.item > a_dn then
				from
				until
					(l_break)
				loop
					l_break := False
					l_qn.item := l_qn.item - a_dn
					if not (l_qn.item > a_dn) then
						l_break := True
					end
				end
				l_break := False
				if 60 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_qn.item >= 60 then
						l_cy.item := gmpn_dcpi1_bdiv_qr_n (l_qp, l_np, a_dp, l_qn.item, a_dinv, l_tp.item)
					else
						l_cy.item := (create {P_SBPI1_BDIV_QR_STATIC}).gmpn_sbpi1_bdiv_qr (l_qp, l_np, 2 * l_qn.item, a_dp, l_qn.item, a_dinv)
					end
				else
					l_cy.item := (create {P_SBPI1_BDIV_QR_STATIC}).gmpn_sbpi1_bdiv_qr (l_qp, l_np, 2 * l_qn.item, a_dp, l_qn.item, a_dinv)
				end
				l_rr := (0).to_natural_32
				if l_qn.item /= a_dn then
					if l_qn.item > a_dn - l_qn.item then
						(create {P_MUL_STATIC}).gmpn_mul (l_tp.item, l_qp, l_qn.item, a_dp + l_qn.item, a_dn - l_qn.item).do_nothing
					else
						(create {P_MUL_STATIC}).gmpn_mul (l_tp.item, a_dp + l_qn.item, a_dn - l_qn.item, l_qp, l_qn.item).do_nothing
					end
					from
					until
						(l_break)
					loop
						l_break := False
						asm325 (l___ptr_dummy, l_tp, l_qn, l_cy)
						l_break := True
					end
					l_break := False
					l_rr := (create {P_GMP_STATIC}).gmpn_sub (l_np + l_qn.item, (l_np + l_qn.item), a_nn - l_qn.item, l_tp.item, a_dn)
					l_cy.item := (0).to_natural_32
				end
				l_np := l_np + (l_qn.item)
				l_qp := l_qp + (l_qn.item)
				l_qn.item := (a_nn - a_dn) - l_qn.item
				from
				until
					(l_break)
				loop
					l_break := False
					l_rr := l_rr + ((create {P_GMP_STATIC}).gmpn_sub_1 (l_np + a_dn, (l_np + a_dn), l_qn.item, l_cy.item))
					l_cy.item := gmpn_dcpi1_bdiv_qr_n (l_qp, l_np, a_dp, a_dn, a_dinv, l_tp.item)
					l_qp := l_qp + a_dn
					l_np := l_np + a_dn
					l_qn.item := l_qn.item - a_dn
					if not (l_qn.item > 0) then
						l_break := True
					end
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not l___tmp_marker.is_void).to_integer, 0)).to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker)
					end
					l_break := True
				end
				l_break := False
				Result := (l_rr + l_cy.item)
				l_return := True
			end
			if not l_return then
				if 60 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_qn.item >= 60 then
						l_cy.item := gmpn_dcpi1_bdiv_qr_n (l_qp, l_np, a_dp, l_qn.item, a_dinv, l_tp.item)
					else
						l_cy.item := (create {P_SBPI1_BDIV_QR_STATIC}).gmpn_sbpi1_bdiv_qr (l_qp, l_np, 2 * l_qn.item, a_dp, l_qn.item, a_dinv)
					end
				else
					l_cy.item := (create {P_SBPI1_BDIV_QR_STATIC}).gmpn_sbpi1_bdiv_qr (l_qp, l_np, 2 * l_qn.item, a_dp, l_qn.item, a_dinv)
				end
				l_rr := (0).to_natural_32
				if l_qn.item /= a_dn then
					if l_qn.item > a_dn - l_qn.item then
						(create {P_MUL_STATIC}).gmpn_mul (l_tp.item, l_qp, l_qn.item, a_dp + l_qn.item, a_dn - l_qn.item).do_nothing
					else
						(create {P_MUL_STATIC}).gmpn_mul (l_tp.item, a_dp + l_qn.item, a_dn - l_qn.item, l_qp, l_qn.item).do_nothing
					end
					from
					until
						(l_break)
					loop
						l_break := False
						asm326 (l___ptr_dummy___0, l_tp, l_qn, l_cy)
						l_break := True
					end
					l_break := False
					l_rr := (create {P_GMP_STATIC}).gmpn_sub (l_np + l_qn.item, (l_np + l_qn.item), a_nn - l_qn.item, l_tp.item, a_dn)
					l_cy.item := (0).to_natural_32
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not l___tmp_marker.is_void).to_integer, 0)).to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker)
					end
					l_break := True
				end
				l_break := False
				Result := (l_rr + l_cy.item)
			end
		end

end
