class
	P_MUL_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpq_mul (a_prod, a_op1, a_op2: CE_POINTER [PD_MPQ_STRUCT])
		local
			l_gcd1: CE_ARRAY [PD_MPZ_STRUCT]
			l_gcd2: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp1: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp2: CE_ARRAY [PD_MPZ_STRUCT]
			l_op1_num_size: INTEGER_32
			l_op1_den_size: INTEGER_32
			l_op2_num_size: INTEGER_32
			l_op2_den_size: INTEGER_32
			l_alloc: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___2: CE_POINTER [ANY]
			l___x___0: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___7: CE_POINTER [ANY]
			l___x___1: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___12: CE_POINTER [ANY]
			l___x___2: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___17: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_gcd1.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_gcd2.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_tmp1.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_tmp2.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			if a_op1.is_equal (a_op2) then
				(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_prod.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))).item.gmpz_mul (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")));
				(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_prod.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))).item.gmpz_mul (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))
				l_return := True
			end
			if not l_return then
				if a_op1.item.mp_num.mp_size >= 0 then
					l_op1_num_size := (a_op1.item.mp_num.mp_size).to_integer_32
				else
					l_op1_num_size := (-a_op1.item.mp_num.mp_size).to_integer_32
				end
				l_op1_den_size := (a_op1.item.mp_den.mp_size).to_integer_32
				if a_op2.item.mp_num.mp_size >= 0 then
					l_op2_num_size := (a_op2.item.mp_num.mp_size).to_integer_32
				else
					l_op2_num_size := (-a_op2.item.mp_num.mp_size).to_integer_32
				end
				l_op2_den_size := (a_op2.item.mp_den.mp_size).to_integer_32
				if l_op1_num_size = 0 then
					a_prod.item.mp_num.mp_size := 0
					a_prod.item.mp_den.mp_d[0] := (1).to_natural_32
					a_prod.item.mp_den.mp_size := 1
					l_return := True
				elseif l_op2_num_size = 0 then
					a_prod.item.mp_num.mp_size := 0
					a_prod.item.mp_den.mp_d[0] := (1).to_natural_32
					a_prod.item.mp_den.mp_size := 1
					l_return := True
				end
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				if l_op1_num_size < l_op2_den_size then
					l_alloc := l_op1_num_size
				else
					l_alloc := l_op2_den_size
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___x := l_gcd1
					l___x.item.mp_alloc := l_alloc.to_integer_32
					if (builtin_expect ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___2 := (l_aaf.new ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___2 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l___x.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
					l_break := True
				end
				l_break := False
				if l_op2_num_size < l_op1_den_size then
					l_alloc := l_op2_num_size
				else
					l_alloc := l_op1_den_size
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___x___0 := l_gcd2
					l___x___0.item.mp_alloc := l_alloc.to_integer_32
					if (builtin_expect ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___7 := (l_aaf.new ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___7 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l___x___0.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___7)
					l_break := True
				end
				l_break := False
				if l_op1_num_size > l_op2_den_size then
					l_alloc := l_op1_num_size
				else
					l_alloc := l_op2_den_size
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___x___1 := l_tmp1
					l___x___1.item.mp_alloc := l_alloc.to_integer_32
					if (builtin_expect ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___12 := (l_aaf.new ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___12 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l___x___1.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___12)
					l_break := True
				end
				l_break := False
				if l_op2_num_size > l_op1_den_size then
					l_alloc := l_op2_num_size
				else
					l_alloc := l_op1_den_size
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___x___2 := l_tmp2
					l___x___2.item.mp_alloc := l_alloc.to_integer_32
					if (builtin_expect ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___17 := (l_aaf.new ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___17 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l___x___2.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___17)
					l_break := True
				end
				l_break := False
				l_gcd1.item.gmpz_gcd (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))
				l_gcd2.item.gmpz_gcd (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")));
				(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (l_tmp1, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd1));
				(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (l_tmp2, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd2));
				(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_prod.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))).item.gmpz_mul (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2));
				(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (l_tmp1, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd1));
				(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (l_tmp2, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd2));
				(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_prod.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))).item.gmpz_mul (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2))
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpn_mul (a_prodp, a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_vp: CE_POINTER [NATURAL_32]; a_vn: INTEGER_32): NATURAL_32
		local
			l_vn: CE_ARRAY [INTEGER_32]
			l_prodp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_up: CE_POINTER [NATURAL_32]
			l_un: INTEGER_32
			l_tp: CE_ARRAY [NATURAL_32]
			l_cy: CE_ARRAY [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_scratch: CE_POINTER [NATURAL_32]
			l_cy___0: CE_ARRAY [NATURAL_32]
			l_ws: CE_POINTER [NATURAL_32]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_scratch___0: CE_POINTER [NATURAL_32]
			l_cy___1: CE_ARRAY [NATURAL_32]
			l_ws___0: CE_POINTER [NATURAL_32]
			l___ptr_dummy___3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___4: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_scratch___1: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___6: CE_POINTER [ANY]
			l_tmp___14: CE_POINTER [ANY]
			l_tmp___23: CE_POINTER [ANY]
			l_cy___2: CE_ARRAY [NATURAL_32]
			l_ws___1: CE_POINTER [NATURAL_32]
			l___tmp_marker___0: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___ptr_dummy___5: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___6: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_INTEGER_32_ARRAY} l_vn.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_prodp.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_tp.make (<<20>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___2.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy___1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___3.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___4.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy___2.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___5.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___6.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_vn.item := a_vn
					l_prodp.item := a_prodp
					l_up := a_up
					l_un := a_un
					if l_un /= l_vn.item then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_up.is_equal (a_vp) then
							(create {P_SQR_STATIC}).gmpn_sqr (l_prodp.item, l_up, l_un)
						else
							(create {P_MUL_N_STATIC}).gmpn_mul_n (l_prodp.item, l_up, a_vp, l_un)
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 3 then -- else:
						if not (l_vn.item < 20) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_un <= 500 then
							(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (l_prodp.item, l_up, l_un, a_vp, l_vn.item)
						elseif l_vn.item = 1 then
							(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (l_prodp.item, l_up, l_un, a_vp, l_vn.item)
						else
							(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (l_prodp.item, l_up, (500).to_integer_32, a_vp, l_vn.item)
							l_prodp.item := l_prodp.item + (500)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_prodp.item, l_vn.item)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							l_up := l_up + (500)
							l_un := l_un - (500)
							from
							until
								not (not (l_return) and then (l_un > 500))
							loop
								(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (l_prodp.item, l_up, (500).to_integer_32, a_vp, l_vn.item)
								l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_prodp.item, l_prodp.item, create {CE_NATURAL_32_POINTER}.make_cast (l_tp), l_vn.item)
								from
								until
									(l_break)
								loop
									l_break := False
									asm87 (l___ptr_dummy, l_prodp, l_vn, l_cy)
									l_break := True
								end
								l_break := False
								l_prodp.item := l_prodp.item + (500)
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_prodp.item, l_vn.item)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								l_up := l_up + (500)
								l_un := l_un - (500)
							end
							if l_un > l_vn.item then
								(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (l_prodp.item, l_up, l_un, a_vp, l_vn.item)
							else
								(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (l_prodp.item, a_vp, l_vn.item, l_up, l_un)
							end
							l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_prodp.item, l_prodp.item, create {CE_NATURAL_32_POINTER}.make_cast (l_tp), l_vn.item)
							from
							until
								(l_break)
							loop
								l_break := False
								asm88 (l___ptr_dummy___0, l_prodp, l_vn, l_cy)
								l_break := True
							end
							l_break := False
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 6 then -- else:
						if 77 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 40 -- skip if block
						end
				when 7 then -- if:
						if not (l_vn.item >= 77) then
							l_pos := -1 + 38 -- skip if block
						end
				when 8 then -- if:
						if 6_784 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 36 -- skip if block
						end
				when 9 then -- if:
						if not (((l_un + l_vn.item)).bit_shift_right (1) >= 6_784) then
							l_pos := -1 + 34 -- skip if block
						end
				when 10 then -- if:
						if 6_784 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if 3 * l_vn.item >= 6_784 then
							if l_un >= 8 * l_vn.item then
								l___tmp_marker___0.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
								l_ws___1 := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker___0, (((9 * l_vn.item).bit_shift_right (1)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)));
								(create {P_NUSSBAUMER_MUL_STATIC}).gmpn_nussbaumer_mul (l_prodp.item, l_up, 3 * l_vn.item, a_vp, l_vn.item)
								l_un := l_un - (3 * l_vn.item)
								l_up := l_up + (3 * l_vn.item)
								l_prodp.item := l_prodp.item + (3 * l_vn.item)
								from
								until
									not (not (l_return) and then (2 * l_un >= 7 * l_vn.item))
								loop
									(create {P_NUSSBAUMER_MUL_STATIC}).gmpn_nussbaumer_mul (l_ws___1, l_up, 3 * l_vn.item, a_vp, l_vn.item)
									l_un := l_un - (3 * l_vn.item)
									l_up := l_up + (3 * l_vn.item)
									l_cy___2.item := (create {P_GMP_STATIC}).gmpn_add_n (l_prodp.item, l_prodp.item, l_ws___1, l_vn.item)
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											(l_return or l_break)
										loop
											l_break := False;
											(create {P_GMP_STATIC}).gmpn_copyi (l_prodp.item + l_vn.item, (l_ws___1 + l_vn.item), 3 * l_vn.item)
											l_break := True
										end
										l_break := False
										l_break := True
									end
									l_break := False
									from
									until
										(l_break)
									loop
										l_break := False
										asm89 (l___ptr_dummy___5, l_prodp, l_vn, l_cy___2)
										l_break := True
									end
									l_break := False
									l_prodp.item := l_prodp.item + (3 * l_vn.item)
								end
								if l_un < l_vn.item then
									gmpn_mul (l_ws___1, a_vp, l_vn.item, l_up, l_un).do_nothing
								else
									gmpn_mul (l_ws___1, l_up, l_un, a_vp, l_vn.item).do_nothing
								end
								l_cy___2.item := (create {P_GMP_STATIC}).gmpn_add_n (l_prodp.item, l_prodp.item, l_ws___1, l_vn.item)
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_prodp.item + l_vn.item, (l_ws___1 + l_vn.item), l_un)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									asm90 (l___ptr_dummy___6, l_prodp, l_vn, l_cy___2)
									l_break := True
								end
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									if (builtin_expect ((not (l___tmp_marker___0.item).is_void).to_integer, 0)).to_boolean then
										(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker___0.item)
									end
									l_break := True
								end
								l_break := False
							else
								(create {P_NUSSBAUMER_MUL_STATIC}).gmpn_nussbaumer_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item)
							end
						else
							l_pos := -1 + 13 -- goto _L___3
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 13 then -- else: | _L___3:
						if 182 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 32 -- skip if block
						end
				when 14 then -- if:
						if not (l_vn.item >= 182) then
							l_pos := -1 + 30 -- skip if block
						end
				when 15 then -- if:
						if (12 + 3 * l_un < 4 * l_vn.item) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if: | _L___1:
						l_scratch___0 := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((16 * l_vn.item + 100).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						if 2 * l_un >= 5 * l_vn.item then
							l_ws___0 := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new ((((7 * l_vn.item).bit_shift_right (1)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							if 79 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_vn.item >= 79 then
									(create {P_TOOM63_MUL_STATIC}).gmpn_toom63_mul (l_prodp.item, l_up, 2 * l_vn.item, a_vp, l_vn.item, l_scratch___0)
								else
									(create {P_TOOM42_MUL_STATIC}).gmpn_toom42_mul (l_prodp.item, l_up, 2 * l_vn.item, a_vp, l_vn.item, l_scratch___0)
								end
							else
								(create {P_TOOM42_MUL_STATIC}).gmpn_toom42_mul (l_prodp.item, l_up, 2 * l_vn.item, a_vp, l_vn.item, l_scratch___0)
							end
							l_un := l_un - (2 * l_vn.item)
							l_up := l_up + (2 * l_vn.item)
							l_prodp.item := l_prodp.item + (2 * l_vn.item)
							from
							until
								not (not (l_return) and then (2 * l_un >= 5 * l_vn.item))
							loop
								if 79 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_vn.item >= 79 then
										(create {P_TOOM63_MUL_STATIC}).gmpn_toom63_mul (l_ws___0, l_up, 2 * l_vn.item, a_vp, l_vn.item, l_scratch___0)
									else
										(create {P_TOOM42_MUL_STATIC}).gmpn_toom42_mul (l_ws___0, l_up, 2 * l_vn.item, a_vp, l_vn.item, l_scratch___0)
									end
								else
									(create {P_TOOM42_MUL_STATIC}).gmpn_toom42_mul (l_ws___0, l_up, 2 * l_vn.item, a_vp, l_vn.item, l_scratch___0)
								end
								l_un := l_un - (2 * l_vn.item)
								l_up := l_up + (2 * l_vn.item)
								l_cy___1.item := (create {P_GMP_STATIC}).gmpn_add_n (l_prodp.item, l_prodp.item, l_ws___0, l_vn.item)
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_prodp.item + l_vn.item, (l_ws___0 + l_vn.item), 2 * l_vn.item)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									asm91 (l___ptr_dummy___3, l_prodp, l_vn, l_cy___1)
									l_break := True
								end
								l_break := False
								l_prodp.item := l_prodp.item + (2 * l_vn.item)
							end
							if l_un < l_vn.item then
								gmpn_mul (l_ws___0, a_vp, l_vn.item, l_up, l_un).do_nothing
							else
								gmpn_mul (l_ws___0, l_up, l_un, a_vp, l_vn.item).do_nothing
							end
							l_cy___1.item := (create {P_GMP_STATIC}).gmpn_add_n (l_prodp.item, l_prodp.item, l_ws___0, l_vn.item)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_prodp.item + l_vn.item, (l_ws___0 + l_vn.item), l_un)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								asm92 (l___ptr_dummy___4, l_prodp, l_vn, l_cy___1)
								l_break := True
							end
							l_break := False
						elseif 6 * l_un < 7 * l_vn.item then
							(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
						elseif 2 * l_un < 3 * l_vn.item then
							if 75 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_vn.item >= 75 then
									(create {P_TOOM43_MUL_STATIC}).gmpn_toom43_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
								else
									(create {P_TOOM32_MUL_STATIC}).gmpn_toom32_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
								end
							else
								(create {P_TOOM32_MUL_STATIC}).gmpn_toom32_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
							end
						elseif 6 * l_un < 11 * l_vn.item then
							if 4 * l_un < 7 * l_vn.item then
								if 122 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_vn.item >= 122 then
										(create {P_TOOM53_MUL_STATIC}).gmpn_toom53_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
									else
										(create {P_TOOM32_MUL_STATIC}).gmpn_toom32_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
									end
								else
									(create {P_TOOM32_MUL_STATIC}).gmpn_toom32_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
								end
							elseif 115 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_vn.item >= 115 then
									(create {P_TOOM53_MUL_STATIC}).gmpn_toom53_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
								else
									(create {P_TOOM42_MUL_STATIC}).gmpn_toom42_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
								end
							else
								(create {P_TOOM42_MUL_STATIC}).gmpn_toom42_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
							end
						elseif 79 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_vn.item >= 79 then
								(create {P_TOOM63_MUL_STATIC}).gmpn_toom63_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
							else
								(create {P_TOOM42_MUL_STATIC}).gmpn_toom42_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
							end
						else
							(create {P_TOOM42_MUL_STATIC}).gmpn_toom42_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___0)
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 18 then -- else:
						l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						if 252 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 27 -- skip if block
						end
				when 19 then -- if:
						if not (l_vn.item >= 252) then
							l_pos := -1 + 25 -- skip if block
						end
				when 20 then -- if:
						if 381 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if l_vn.item >= 381 then
							if (builtin_expect ((((create {P_GMP_IMPL_STATIC}).mpn_toom8h_mul_itch (l_un, l_vn.item)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___23 := (l_aaf.new ((((create {P_GMP_IMPL_STATIC}).mpn_toom8h_mul_itch (l_un, l_vn.item)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___23 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (((create {P_GMP_IMPL_STATIC}).mpn_toom8h_mul_itch (l_un, l_vn.item)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_scratch___1 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___23);
							(create {P_TOOM8H_MUL_STATIC}).gmpn_toom8h_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___1)
						else
							l_pos := -1 + 23 -- goto _L
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else: | _L:
						if (builtin_expect ((((create {P_GMP_IMPL_STATIC}).mpn_toom6h_mul_itch (l_un, l_vn.item)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___14 := (l_aaf.new ((((create {P_GMP_IMPL_STATIC}).mpn_toom6h_mul_itch (l_un, l_vn.item)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___14 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (((create {P_GMP_IMPL_STATIC}).mpn_toom6h_mul_itch (l_un, l_vn.item)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_scratch___1 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___14);
						(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___1)
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						l_pos := -1 + 27 -- goto _L___0
				when 26 then -- if done | if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else: | _L___0:
						if (builtin_expect (((3 * l_un + 32).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___6 := (l_aaf.new (((3 * l_un + 32).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___6 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((3 * l_un + 32).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_scratch___1 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___6);
						(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch___1)
				when 28 then
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
				when 29 then -- if done | if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else:
						l_pos := -1 + 16 -- goto _L___1
				when 31 then -- if done | if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else:
						l_pos := -1 + 16 -- goto _L___1
				when 33 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else:
						l_pos := -1 + 13 -- goto _L___3
				when 35 then -- if done | if block done, skip else block:
						l_pos := -1 + 37
				when 36 then -- else:
						l_pos := -1 + 13 -- goto _L___3
				when 37 then -- if done | if block done, skip else block:
						l_pos := -1 + 39
				when 38 then -- else:
						l_pos := -1 + 40 -- goto _L___4
				when 39 then -- if done | if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else: | _L___4:
						l_scratch := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((16 * l_vn.item + 100).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						if l_un >= 3 * l_vn.item then
							l_ws := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((4 * l_vn.item).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)));
							(create {P_TOOM42_MUL_STATIC}).gmpn_toom42_mul (l_prodp.item, l_up, 2 * l_vn.item, a_vp, l_vn.item, l_scratch)
							l_un := l_un - (2 * l_vn.item)
							l_up := l_up + (2 * l_vn.item)
							l_prodp.item := l_prodp.item + (2 * l_vn.item)
							from
							until
								not (not (l_return) and then (l_un >= 3 * l_vn.item))
							loop
								(create {P_TOOM42_MUL_STATIC}).gmpn_toom42_mul (l_ws, l_up, 2 * l_vn.item, a_vp, l_vn.item, l_scratch)
								l_un := l_un - (2 * l_vn.item)
								l_up := l_up + (2 * l_vn.item)
								l_cy___0.item := (create {P_GMP_STATIC}).gmpn_add_n (l_prodp.item, l_prodp.item, l_ws, l_vn.item)
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_prodp.item + l_vn.item, (l_ws + l_vn.item), 2 * l_vn.item)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									asm93 (l___ptr_dummy___1, l_prodp, l_vn, l_cy___0)
									l_break := True
								end
								l_break := False
								l_prodp.item := l_prodp.item + (2 * l_vn.item)
							end
							if 4 * l_un < 5 * l_vn.item then
								(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (l_ws, l_up, l_un, a_vp, l_vn.item, l_scratch)
							elseif 4 * l_un < 7 * l_vn.item then
								(create {P_TOOM32_MUL_STATIC}).gmpn_toom32_mul (l_ws, l_up, l_un, a_vp, l_vn.item, l_scratch)
							else
								(create {P_TOOM42_MUL_STATIC}).gmpn_toom42_mul (l_ws, l_up, l_un, a_vp, l_vn.item, l_scratch)
							end
							l_cy___0.item := (create {P_GMP_STATIC}).gmpn_add_n (l_prodp.item, l_prodp.item, l_ws, l_vn.item)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_prodp.item + l_vn.item, (l_ws + l_vn.item), l_un)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								asm94 (l___ptr_dummy___2, l_prodp, l_vn, l_cy___0)
								l_break := True
							end
							l_break := False
						elseif 4 * l_un < 5 * l_vn.item then
							(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch)
						elseif 4 * l_un < 7 * l_vn.item then
							(create {P_TOOM32_MUL_STATIC}).gmpn_toom32_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch)
						else
							(create {P_TOOM42_MUL_STATIC}).gmpn_toom42_mul (l_prodp.item, l_up, l_un, a_vp, l_vn.item, l_scratch)
						end
				when 41 then -- if done | if done
					Result := (l_prodp.item[((l_un + l_vn.item) - 1)])
				when 42 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
