class
	P_POW_UI_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_pow_ui (a_r, a_b: CE_POINTER [PD_MPZ_STRUCT]; a_e: NATURAL_32)
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_e.to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 0
					a_r.item.gmpz_set_ui ({NATURAL_32} 1)
					l_pos := -1 + 5 -- switch 1; break
				when 2 then -- switch 1, case 1
					a_r.item.gmpz_set (a_b)
					l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 2
					a_r.item.gmpz_mul (a_b, a_b)
					l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:;
					(create {P_N_POW_UI_STATIC}).gmpz_n_pow_ui (a_r, a_b.item.mp_d, (a_b.item.mp_size).to_integer_32, a_e)
				when 5 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
