class
	P_RANDOM2_STATIC

inherit
	CE_UTILITIES
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_random2 (a_rp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32)
		local
			l_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_bit_pos: INTEGER_32
			l_ran: NATURAL_32
			l_ranm: CE_ARRAY [NATURAL_32]
			l___rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_ranm.make (<<1>>)

			if not ((create {P_RANDS_STATIC}).gmp_rands_initialized.item).to_boolean then
				(create {P_RANDS_STATIC}).gmp_rands_initialized.item := (1).to_integer_8;
				(create {CE_CLASS_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (((create {P_GMP_IMPL_STATIC}).gmp_rands.item))).item.gmp_randinit_mt_noseed
			end
			l_rstate := (create {P_GMP_IMPL_STATIC}).gmp_rands.item
			from
			until
				(l_break)
			loop
				l_break := False
				l___rstate := l_rstate;
				((create {CE_CLASS_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l___rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l___rstate, l_ranm, {NATURAL_32} 32])
				l_break := True
			end
			l_break := False
			l_ran := l_ranm.item
			l_bit_pos := (l_ran \\ {NATURAL_32} 32).to_integer_32
			gmp_rrandomb___0 (a_rp, l_rstate, (a_n * 32 - l_bit_pos.to_integer_32).to_natural_32)
		end

	gmp_rrandomb___0 (a_rp: CE_POINTER [NATURAL_32]; a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_nbits: NATURAL_32)
		require
			not a_rstate.is_void
		local
			l_rp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_bi: CE_ARRAY [NATURAL_32]
			l_ranm: CE_ARRAY [NATURAL_32]
			l_cap_chunksize: NATURAL_32
			l_chunksize: NATURAL_32
			l_i: INTEGER_32
			l___rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l___rstate___0: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l___rstate___1: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_rp.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_bi.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_ranm.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)

			l_rp.item := a_rp
			l_i := (((a_nbits + {NATURAL_32} 32) - {NATURAL_32} 1) // {NATURAL_32} 32 - {NATURAL_32} 1).to_integer_32
			l_rp.item[l_i] := ({NATURAL_32} 4_294_967_295).bit_shift_right ((({NATURAL_32} 32 - a_nbits \\ {NATURAL_32} 32) \\ {NATURAL_32} 32).to_integer_32)
			l_i := l_i - 1
			from
			until
				not (l_i >= 0)
			loop
				l_rp.item[l_i] := {NATURAL_32} 4_294_967_295
				l_i := l_i - 1
			end
			from
			until
				(l_break)
			loop
				l_break := False
				l___rstate := a_rstate;
				((create {CE_CLASS_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l___rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l___rstate, l_ranm, {NATURAL_32} 32])
				l_break := True
			end
			l_break := False
			l_cap_chunksize := (a_nbits // (l_ranm.item \\ {NATURAL_32} 4 + {NATURAL_32} 1)).to_natural_32
			l_cap_chunksize := l_cap_chunksize + (l_cap_chunksize = {NATURAL_32} 0).to_integer.to_natural_32
			l_bi.item := a_nbits
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l___rstate___0 := a_rstate;
					((create {CE_CLASS_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l___rstate___0.item.mp_algdata.mp_lc)).item.randget_fn).call ([l___rstate___0, l_ranm, {NATURAL_32} 32])
					l_break := True
				end
				l_break := False
				l_chunksize := ({NATURAL_32} 1 + l_ranm.item \\ l_cap_chunksize.to_natural_32).to_natural_32
				if l_bi.item < l_chunksize.to_natural_32 then
					l_bi.item := (0).to_natural_32
				else
					l_bi.item := l_bi.item - l_chunksize.to_natural_32
				end
				if l_bi.item = {NATURAL_32} 0 then
					l_break := True
				end
				if not (l_return or l_break) then
					l_rp.item[(l_bi.item // {NATURAL_32} 32).to_integer_32] := (l_rp.item[(l_bi.item // {NATURAL_32} 32).to_integer_32]).bit_xor ((({NATURAL_32} 1).bit_shift_left ((l_bi.item \\ {NATURAL_32} 32).to_integer_32)))
					from
					until
						(l_break)
					loop
						l_break := False
						l___rstate___1 := a_rstate;
						((create {CE_CLASS_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l___rstate___1.item.mp_algdata.mp_lc)).item.randget_fn).call ([l___rstate___1, l_ranm, {NATURAL_32} 32])
						l_break := True
					end
					l_break := False
					l_chunksize := ({NATURAL_32} 1 + l_ranm.item \\ l_cap_chunksize.to_natural_32).to_natural_32
					if l_bi.item < l_chunksize.to_natural_32 then
						l_bi.item := (0).to_natural_32
					else
						l_bi.item := l_bi.item - l_chunksize.to_natural_32
					end
					from
					until
						(l_break)
					loop
						l_break := False
						asm100 (l___ptr_dummy, l_rp, l_bi)
						l_break := True
					end
					l_break := False
					if l_bi.item = {NATURAL_32} 0 then
						l_break := True
					end
				end
			end
			l_break := False
		end

end
