class
	P_SBPI1_DIVAPPR_Q_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_sbpi1_divappr_q (a_qp, a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_dinv: NATURAL_32): NATURAL_32
		local
			l_dinv: CE_ARRAY [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_dp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_dn: INTEGER_32
			l_qh: NATURAL_32
			l_qn: INTEGER_32
			l_i: INTEGER_32
			l_n1: CE_ARRAY [NATURAL_32]
			l_n0: CE_ARRAY [NATURAL_32]
			l_d1: CE_ARRAY [NATURAL_32]
			l_d0: CE_ARRAY [NATURAL_32]
			l_cy: NATURAL_32
			l_cy1: NATURAL_32
			l_q: CE_ARRAY [NATURAL_32]
			l_flag: NATURAL_32
			l__q0: CE_ARRAY [NATURAL_32]
			l__t1: CE_ARRAY [NATURAL_32]
			l__t0: CE_ARRAY [NATURAL_32]
			l__mask: CE_ARRAY [NATURAL_32]
			l__q0___0: CE_ARRAY [NATURAL_32]
			l__t1___0: CE_ARRAY [NATURAL_32]
			l__t0___0: CE_ARRAY [NATURAL_32]
			l__mask___0: CE_ARRAY [NATURAL_32]
			l__q0___1: CE_ARRAY [NATURAL_32]
			l__t1___1: CE_ARRAY [NATURAL_32]
			l__t0___1: CE_ARRAY [NATURAL_32]
			l__mask___1: CE_ARRAY [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_ARRAY} l_dinv.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_np.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_dp.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_n1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_n0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_d1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_d0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_q.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__q0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__t1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__t0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__mask.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__q0___0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__t1___0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__t0___0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__mask___0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__q0___1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__t1___1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__t0___1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__mask___1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dinv.item := a_dinv
					l_qp := a_qp
					l_np.item := a_np
					l_dp.item := a_dp
					l_dn := a_dn
					l_np.item := l_np.item + a_nn
					l_qn := a_nn - l_dn
					if l_qn + 1 < l_dn then
						l_dp.item := l_dp.item + (l_dn - (l_qn + 1))
						l_dn := l_qn + 1
					end
					l_qh := (((create {P_GMP_STATIC}).gmpn_cmp ((l_np.item - l_dn), l_dp.item, l_dn)) >= 0).to_integer.to_natural_32
					if l_qh /= {NATURAL_32} 0 then
						(create {P_GMP_STATIC}).gmpn_sub_n (l_np.item - l_dn, (l_np.item - l_dn), l_dp.item, l_dn).do_nothing
					end
					l_qp := l_qp + l_qn
					l_dn := l_dn - (2)
					l_d1.item := l_dp.item[(l_dn + 1)]
					l_d0.item := l_dp.item[l_dn]
					l_np.item := l_np.item - (2)
					l_n1.item := l_np.item[1]
					l_i := l_qn - (l_dn + 2)
				when 1 then -- loop condition:
					if not (not (l_return) and then (l_i >= 0)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						l_np.item := l_np.item - 1
						if not ((builtin_expect ((l_n1.item = l_d1.item).to_integer, 0)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_np.item[1] = l_d0.item then
							l_q.item := {NATURAL_32} 4_294_967_295;
							(create {P_GMP_STATIC}).gmpn_submul_1 (l_np.item - l_dn, l_dp.item, l_dn + 2, l_q.item).do_nothing
							l_n1.item := l_np.item[1]
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						from
						until
							(l_break)
						loop
							l_break := False
							asm273 (l__q0, l_q, l_n1, l_dinv)
							asm274 (l_q, l__q0, l_n1, l_np)
							l_n1.item := l_np.item[1] - l_d1.item * l_q.item
							l_n0.item := l_np.item[0]
							asm275 (l_n1, l_n0, l_d1, l_d0)
							asm276 (l__t0, l__t1, l_d0, l_q)
							asm277 (l_n1, l_n0, l__t1, l__t0)
							l_q.item := l_q.item + 1
							l__mask.item := (-((l_n1.item >= l__q0.item).to_integer.to_natural_32).to_integer_32).to_natural_32
							l_q.item := l_q.item + (l__mask.item)
							asm278 (l_n1, l_n0, l__mask, l_d1, l_d0)
							if (builtin_expect ((l_n1.item >= l_d1.item).to_integer, 0)).to_boolean then
								if l_n1.item > l_d1.item then
									l_q.item := l_q.item + 1
									asm279 (l_n1, l_n0, l_d1, l_d0)
								elseif l_n0.item >= l_d0.item then
									l_q.item := l_q.item + 1
									asm280 (l_n1, l_n0, l_d1, l_d0)
								end
							end
							l_break := True
						end
						l_break := False
						l_cy := (create {P_GMP_STATIC}).gmpn_submul_1 (l_np.item - l_dn, l_dp.item, l_dn, l_q.item)
						l_cy1 := (l_n0.item < l_cy).to_integer.to_natural_32
						l_n0.item := ((l_n0.item - l_cy)).bit_and ({NATURAL_32} 4_294_967_295)
						l_cy := (l_n1.item < l_cy1).to_integer.to_natural_32
						l_n1.item := l_n1.item - l_cy1
						l_np.item[0] := l_n0.item
						if (builtin_expect ((l_cy /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
							l_n1.item := l_n1.item + (l_d1.item + ((create {P_GMP_STATIC}).gmpn_add_n (l_np.item - l_dn, (l_np.item - l_dn), l_dp.item, l_dn + 1)))
							l_q.item := l_q.item - 1
						end
				when 6 then
						l_qp := l_qp - 1
						l_qp.item := l_q.item
						l_i := l_i - 1
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					l_flag := ((0).to_natural_32).bit_not
					if l_dn >= 0 then
						l_i := l_dn
						from
						until
							not (not (l_return) and then (l_i > 0))
						loop
							l_np.item := l_np.item - 1
							if (builtin_expect ((l_n1.item >= ((l_d1.item).bit_and (l_flag))).to_integer, 0)).to_boolean then
								l_q.item := {NATURAL_32} 4_294_967_295
								l_cy := (create {P_GMP_STATIC}).gmpn_submul_1 (l_np.item - l_dn, l_dp.item, l_dn + 2, l_q.item)
								if (builtin_expect ((l_n1.item /= l_cy).to_integer, 0)).to_boolean then
									if l_n1.item < ((l_cy).bit_and (l_flag)) then
										l_q.item := l_q.item - 1;
										(create {P_GMP_STATIC}).gmpn_add_n (l_np.item - l_dn, (l_np.item - l_dn), l_dp.item, l_dn + 2).do_nothing
									else
										l_flag := (0).to_natural_32
									end
								end
								l_n1.item := l_np.item[1]
							else
								from
								until
									(l_break)
								loop
									l_break := False
									asm281 (l__q0___0, l_q, l_n1, l_dinv)
									asm282 (l_q, l__q0___0, l_n1, l_np)
									l_n1.item := l_np.item[1] - l_d1.item * l_q.item
									l_n0.item := l_np.item[0]
									asm283 (l_n1, l_n0, l_d1, l_d0)
									asm284 (l__t0___0, l__t1___0, l_d0, l_q)
									asm285 (l_n1, l_n0, l__t1___0, l__t0___0)
									l_q.item := l_q.item + 1
									l__mask___0.item := (-((l_n1.item >= l__q0___0.item).to_integer.to_natural_32).to_integer_32).to_natural_32
									l_q.item := l_q.item + (l__mask___0.item)
									asm286 (l_n1, l_n0, l__mask___0, l_d1, l_d0)
									if (builtin_expect ((l_n1.item >= l_d1.item).to_integer, 0)).to_boolean then
										if l_n1.item > l_d1.item then
											l_q.item := l_q.item + 1
											asm287 (l_n1, l_n0, l_d1, l_d0)
										elseif l_n0.item >= l_d0.item then
											l_q.item := l_q.item + 1
											asm288 (l_n1, l_n0, l_d1, l_d0)
										end
									end
									l_break := True
								end
								l_break := False
								l_cy := (create {P_GMP_STATIC}).gmpn_submul_1 (l_np.item - l_dn, l_dp.item, l_dn, l_q.item)
								l_cy1 := (l_n0.item < l_cy).to_integer.to_natural_32
								l_n0.item := ((l_n0.item - l_cy)).bit_and ({NATURAL_32} 4_294_967_295)
								l_cy := (l_n1.item < l_cy1).to_integer.to_natural_32
								l_n1.item := l_n1.item - l_cy1
								l_np.item[0] := l_n0.item
								if (builtin_expect ((l_cy /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
									l_n1.item := l_n1.item + (l_d1.item + ((create {P_GMP_STATIC}).gmpn_add_n (l_np.item - l_dn, (l_np.item - l_dn), l_dp.item, l_dn + 1)))
									l_q.item := l_q.item - 1
								end
							end
							l_qp := l_qp - 1
							l_qp.item := l_q.item
							l_dn := l_dn - 1
							l_dp.item := l_dp.item + 1
							l_i := l_i - 1
						end
						l_np.item := l_np.item - 1
						if (builtin_expect ((l_n1.item >= ((l_d1.item).bit_and (l_flag))).to_integer, 0)).to_boolean then
							l_q.item := {NATURAL_32} 4_294_967_295
							l_cy := (create {P_GMP_STATIC}).gmpn_submul_1 (l_np.item, l_dp.item, (2).to_integer_32, l_q.item)
							if (builtin_expect ((l_n1.item /= l_cy).to_integer, 0)).to_boolean then
								if l_n1.item < ((l_cy).bit_and (l_flag)) then
									l_q.item := l_q.item - 1
									asm289 (l_np, l_dp)
								else
									l_flag := (0).to_natural_32
								end
							end
							l_n1.item := l_np.item[1]
						else
							from
							until
								(l_break)
							loop
								l_break := False
								asm290 (l__q0___1, l_q, l_n1, l_dinv)
								asm291 (l_q, l__q0___1, l_n1, l_np)
								l_n1.item := l_np.item[1] - l_d1.item * l_q.item
								l_n0.item := l_np.item[0]
								asm292 (l_n1, l_n0, l_d1, l_d0)
								asm293 (l__t0___1, l__t1___1, l_d0, l_q)
								asm294 (l_n1, l_n0, l__t1___1, l__t0___1)
								l_q.item := l_q.item + 1
								l__mask___1.item := (-((l_n1.item >= l__q0___1.item).to_integer.to_natural_32).to_integer_32).to_natural_32
								l_q.item := l_q.item + (l__mask___1.item)
								asm295 (l_n1, l_n0, l__mask___1, l_d1, l_d0)
								if (builtin_expect ((l_n1.item >= l_d1.item).to_integer, 0)).to_boolean then
									if l_n1.item > l_d1.item then
										l_q.item := l_q.item + 1
										asm296 (l_n1, l_n0, l_d1, l_d0)
									elseif l_n0.item >= l_d0.item then
										l_q.item := l_q.item + 1
										asm297 (l_n1, l_n0, l_d1, l_d0)
									end
								end
								l_break := True
							end
							l_break := False
							l_np.item[1] := l_n1.item
							l_np.item[0] := l_n0.item
						end
						l_qp := l_qp - 1
						l_qp.item := l_q.item
					end
					from
					until
						(l_break)
					loop
						l_break := False
						if l_np.item[1] /= l_n1.item then
							(create {P_ASSERT_STATIC}).gmp_assert_fail (ce_string ("sbpi1_divappr_q.c"), 185, ce_string ("np[1] == n1"))
						end
						l_break := True
					end
					l_break := False
					Result := l_qh
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
