class
	P_SUB_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpf_sub (a_r, a_u, a_v: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_u.is_void
			not a_v.is_void
		local
			l_u: CE_POINTER [PD_MPF_STRUCT]
			l_v: CE_POINTER [PD_MPF_STRUCT]
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_rsize: INTEGER_32
			l_prec: INTEGER_32
			l_exp: INTEGER_32
			l_ediff: INTEGER_32
			l_negate: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_v_negated: CE_ARRAY [PD_MPF_STRUCT]
			l_t: CE_POINTER [PD_MPF_STRUCT]
			l___mp_srcptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp: INTEGER_32
			l_tmp___2: CE_POINTER [ANY]
			l_cy_limb: NATURAL_32
			l_size: INTEGER_32
			l_i: INTEGER_32
			l_size___0: INTEGER_32
			l_i___0: INTEGER_32
			l_size___1: INTEGER_32
			l_size___2: INTEGER_32
			l_i___1: INTEGER_32
			l_tmp___10: CE_POINTER [ANY]
			l_size___3: INTEGER_32
			l_size___4: INTEGER_32
			l_i___2: INTEGER_32
			l_size___5: INTEGER_32
			l_size___6: INTEGER_32
			l_i___3: INTEGER_32
			l_size___7: INTEGER_32
			l_i___4: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPF_STRUCT]} l_v_negated.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_u := a_u
					l_v := a_v
					l_usize := (l_u.item.mp_size).to_integer_32
					l_vsize := (l_v.item.mp_size).to_integer_32
					if l_usize = 0 then
						a_r.item.gmpf_neg (l_v)
						l_return := True
					end
					if not l_return and then (l_vsize = 0) then
						if not a_r.is_equal (l_u) then
							a_r.item.gmpf_set (l_u)
						end
						l_return := True
					end
					if not l_return and then (((l_usize).bit_xor (l_vsize)) < 0) then
						l_v_negated.item.mp_size := (-l_vsize).to_integer_32
						l_v_negated.item.mp_exp := l_v.item.mp_exp
						l_v_negated.item.mp_d := l_v.item.mp_d;
						(create {P_ADD_STATIC}).gmpf_add (a_r, l_u, l_v_negated)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 32 -- skip if block
					end
				when 1 then -- if:
						l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						l_negate := (l_usize < 0).to_integer
						if l_u.item.mp_exp < l_v.item.mp_exp then
							l_t := l_u
							l_u := l_v
							l_v := l_t
							l_negate := (l_negate).bit_xor ((1))
							l_usize := (l_u.item.mp_size).to_integer_32
							l_vsize := (l_v.item.mp_size).to_integer_32
						end
						if l_usize >= 0 then
							l_usize := l_usize
						else
							l_usize := -l_usize
						end
						if l_vsize >= 0 then
							l_vsize := l_vsize
						else
							l_vsize := -l_vsize
						end
						l_up := l_u.item.mp_d
						l_vp := l_v.item.mp_d
						l_rp := a_r.item.mp_d
						l_prec := (a_r.item.mp_prec + 1).to_integer_32
						l_exp := l_u.item.mp_exp
						l_ediff := (l_u.item.mp_exp - l_v.item.mp_exp)
						if not (l_ediff <= 1) then
							l_pos := -1 + 19 -- skip if block
						end
				when 2 then -- if:
						if l_ediff /= 0 then
							l_pos := -1 + 14 -- skip if block
						end
				when 3 then -- if:
						if l_up[(l_usize - 1)] /= l_vp[(l_vsize - 1)] then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 10 -- skip loop
						end
				when 5 then -- loop body:
						l_break := False
						l_usize := l_usize - 1
						l_vsize := l_vsize - 1
						l_exp := l_exp - 1
						if l_usize /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_negate := (l_negate).bit_xor ((1))
				when 7 then -- cancellation:
						from
						until
							(l_break)
						loop
							l_break := False
							if l_vsize /= 0 then
								if l_vp[(l_vsize - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_vsize := l_vsize - 1
								l_exp := l_exp - 1
							end
						end
						l_break := False
						if l_vsize > l_prec then
							l_vp := l_vp + (l_vsize - l_prec)
							l_vsize := l_prec
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_vp, l_vsize)
							l_break := True
						end
						l_break := False
						l_rsize := l_vsize
						l_pos := -1 + 31 -- goto done
				when 8 then
						if l_vsize = 0 then
							l_vp := l_up
							l_vsize := l_usize
							l_pos := -1 + 7 -- goto cancellation
						end
				when 9 then
						if l_up[(l_usize - 1)] /= l_vp[(l_vsize - 1)] then
							l_break := True
						end
						l_pos := -1 + 4 -- back to loop condition
				when 10 then -- loop done
						l_break := False
				when 11 then -- if done
						if l_up[(l_usize - 1)] < l_vp[(l_vsize - 1)] then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_srcptr_swap__tmp := l_up
									l_up := l_vp
									l_vp := l___mp_srcptr_swap__tmp
									l_break := True
								end
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_size_t_swap__tmp := l_usize
									l_usize := l_vsize
									l_vsize := l___mp_size_t_swap__tmp
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							l_negate := (l_negate).bit_xor ((1))
						end
						if l_up[(l_usize - 1)] /= l_vp[(l_vsize - 1)] + {NATURAL_32} 1 then
							l_pos := -1 + 19 -- goto general_case
						end
				when 12 then
						l_usize := l_usize - 1
						l_vsize := l_vsize - 1
						l_exp := l_exp - 1
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else:
						if l_up[(l_usize - 1)] /= {NATURAL_32} 1 then
							l_pos := -1 + 19 -- goto general_case
						elseif l_vp[(l_vsize - 1)] /= {NATURAL_32} 4_294_967_295 then
							l_pos := -1 + 19 -- goto general_case
						elseif l_usize >= 2 then
							if l_up[(l_usize - 2)] /= {NATURAL_32} 0 then
								l_pos := -1 + 19 -- goto general_case
							end
						end
				when 15 then
						l_usize := l_usize - 1
						l_exp := l_exp - 1
				when 16 then -- if done
						from
						until
							(l_break)
						loop
							l_break := False
							if l_vsize /= 0 then
								if l_usize /= 0 then
									if l_up[(l_usize - 1)] = {NATURAL_32} 0 then
										if l_vp[(l_vsize - 1)] /= {NATURAL_32} 4_294_967_295 then
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_usize := l_usize - 1
								l_vsize := l_vsize - 1
								l_exp := l_exp - 1
							end
						end
						l_break := False
						if l_usize = 0 then
							from
							until
								(l_break)
							loop
								l_break := False
								if l_vsize /= 0 then
									if l_vp[(l_vsize - 1)] /= {NATURAL_32} 4_294_967_295 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									l_vsize := l_vsize - 1
									l_exp := l_exp - 1
								end
							end
							l_break := False
						end
						if l_usize > l_prec - 1 then
							l_up := l_up + (l_usize - (l_prec - 1))
							l_usize := l_prec - 1
						end
						if l_vsize > l_prec - 1 then
							l_vp := l_vp + (l_vsize - (l_prec - 1))
							l_vsize := l_prec - 1
						end
						if (builtin_expect ((l_prec.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___2 := (l_aaf.new ((l_prec.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___2 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_prec.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
						if l_vsize = 0 then
							l_size := l_usize
							l_i := (0).to_integer_32
							from
							until
								not (l_i < l_size)
							loop
								l_tp[l_i] := l_up[l_i]
								l_i := l_i + 1
							end
							l_tp[l_size] := (1).to_natural_32
							l_rsize := l_size + 1
							l_exp := l_exp + 1
							l_pos := -1 + 30 -- goto normalize
						end
				when 17 then
						if l_usize = 0 then
							l_size___0 := l_vsize
							l_i___0 := (0).to_integer_32
							from
							until
								not (l_i___0 < l_size___0)
							loop
								l_tp[l_i___0] := (((l_vp[l_i___0]).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
								l_i___0 := l_i___0 + 1
							end
							l_cy_limb := {NATURAL_32} 1 - ((create {P_GMP_STATIC}).gmpn_add_1 (l_tp, l_tp, l_vsize, (1).to_natural_32))
							l_rsize := l_vsize
							if l_cy_limb = {NATURAL_32} 0 then
								l_tp[l_rsize] := (1).to_natural_32
								l_rsize := l_rsize + 1
								l_exp := l_exp + 1
							end
							l_pos := -1 + 30 -- goto normalize
						end
				when 18 then
						if l_usize >= l_vsize then
							l_size___1 := l_usize - l_vsize
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_up, l_size___1)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							l_cy_limb := (create {P_GMP_STATIC}).gmpn_sub_n (l_tp + l_size___1, l_up + l_size___1, l_vp, l_vsize)
							l_rsize := l_usize
						else
							l_size___2 := l_vsize - l_usize
							l_i___1 := (0).to_integer_32
							from
							until
								not (l_i___1 < l_size___2)
							loop
								l_tp[l_i___1] := (((l_vp[l_i___1]).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
								l_i___1 := l_i___1 + 1
							end
							l_cy_limb := (create {P_GMP_STATIC}).gmpn_sub_n (l_tp + l_size___2, l_up, l_vp + l_size___2, l_usize)
							l_cy_limb := l_cy_limb + ((create {P_GMP_STATIC}).gmpn_sub_1 (l_tp + l_size___2, (l_tp + l_size___2), l_usize, (1).to_natural_32))
							l_cy_limb := l_cy_limb - ((create {P_GMP_STATIC}).gmpn_add_1 (l_tp, l_tp, l_vsize, (1).to_natural_32))
							l_rsize := l_vsize
						end
						if l_cy_limb = {NATURAL_32} 0 then
							l_tp[l_rsize] := (1).to_natural_32
							l_rsize := l_rsize + 1
							l_exp := l_exp + 1
						end
						l_pos := -1 + 30 -- goto normalize
				when 19 then -- general_case:
						if l_usize > l_prec then
							l_up := l_up + (l_usize - l_prec)
							l_usize := l_prec
						end
						if l_vsize + l_ediff > l_prec then
							l_vp := l_vp + ((l_vsize + l_ediff) - l_prec)
							l_vsize := l_prec - l_ediff
						end
						if (builtin_expect ((l_prec.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___10 := (l_aaf.new ((l_prec.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___10 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_prec.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___10)
						if not (l_ediff >= l_prec) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if not l_tp.is_equal (l_up) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_up, l_usize)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
						end
						l_rsize := l_usize
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 22 then -- else: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 25 -- skip loop
						end
				when 23 then -- loop body:
						l_break := False
						if l_vsize = 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_up, l_usize)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							l_rsize := l_usize
							l_pos := -1 + 31 -- goto done
						end
				when 24 then
						if l_vp[0] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_vp := l_vp + 1
							l_vsize := l_vsize - 1
						end
						l_pos := -1 + 22 -- back to loop condition
				when 25 then -- loop done
						l_break := False
				when 26 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 29 -- skip loop
						end
				when 27 then -- loop body:
						l_break := False
						if l_usize = 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_vp, l_vsize)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							l_rsize := l_vsize
							l_negate := (l_negate).bit_xor ((1))
							l_pos := -1 + 31 -- goto done
						end
				when 28 then
						if l_up[0] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_up := l_up + 1
							l_usize := l_usize - 1
						end
						l_pos := -1 + 26 -- back to loop condition
				when 29 then -- loop done
						l_break := False
						if l_usize > l_ediff then
							if l_ediff = 0 then
								if l_usize >= l_vsize then
									l_size___3 := l_usize - l_vsize
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											(l_return or l_break)
										loop
											l_break := False;
											(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_up, l_size___3)
											l_break := True
										end
										l_break := False
										l_break := True
									end
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_sub_n (l_tp + l_size___3, l_up + l_size___3, l_vp, l_vsize).do_nothing
									l_rsize := l_usize
								else
									l_size___4 := l_vsize - l_usize
									l_tp[0] := (((-(l_vp[0]).to_integer_32).to_natural_32).bit_and ({NATURAL_32} 4_294_967_295))
									l_i___2 := (1).to_integer_32
									from
									until
										not (l_i___2 < l_size___4)
									loop
										l_tp[l_i___2] := (((l_vp[l_i___2]).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
										l_i___2 := l_i___2 + 1
									end
									(create {P_GMP_STATIC}).gmpn_sub_n (l_tp + l_size___4, l_up, l_vp + l_size___4, l_usize).do_nothing;
									(create {P_GMP_STATIC}).gmpn_sub_1 (l_tp + l_size___4, (l_tp + l_size___4), l_usize, (1).to_natural_32).do_nothing
									l_rsize := l_vsize
								end
							elseif l_vsize + l_ediff <= l_usize then
								l_size___5 := (l_usize - l_ediff) - l_vsize
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_up, l_size___5)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_sub (l_tp + l_size___5, l_up + l_size___5, l_usize - l_size___5, l_vp, l_vsize).do_nothing
								l_rsize := l_usize
							else
								l_size___6 := (l_vsize + l_ediff) - l_usize
								l_tp[0] := (((-(l_vp[0]).to_integer_32).to_natural_32).bit_and ({NATURAL_32} 4_294_967_295))
								l_i___3 := (1).to_integer_32
								from
								until
									not (l_i___3 < l_size___6)
								loop
									l_tp[l_i___3] := (((l_vp[l_i___3]).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
									l_i___3 := l_i___3 + 1
								end
								(create {P_GMP_STATIC}).gmpn_sub (l_tp + l_size___6, l_up, l_usize, l_vp + l_size___6, l_usize - l_ediff).do_nothing;
								(create {P_GMP_STATIC}).gmpn_sub_1 (l_tp + l_size___6, (l_tp + l_size___6), l_usize, (1).to_natural_32).do_nothing
								l_rsize := l_vsize + l_ediff
							end
						else
							l_size___7 := (l_vsize + l_ediff) - l_usize
							l_tp[0] := (((-(l_vp[0]).to_integer_32).to_natural_32).bit_and ({NATURAL_32} 4_294_967_295))
							l_i___4 := (1).to_integer_32
							from
							until
								not (l_i___4 < l_vsize)
							loop
								l_tp[l_i___4] := (((l_vp[l_i___4]).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
								l_i___4 := l_i___4 + 1
							end
							l_i___4 := l_vsize
							from
							until
								not (l_i___4 < l_size___7)
							loop
								l_tp[l_i___4] := {NATURAL_32} 4_294_967_295
								l_i___4 := l_i___4 + 1
							end
							(create {P_GMP_STATIC}).gmpn_sub_1 (l_tp + l_size___7, l_up, l_usize, (1).to_natural_32).do_nothing
							l_rsize := l_size___7 + l_usize
						end
				when 30 then -- normalize:
						from
						until
							(l_break)
						loop
							l_break := False
							if l_rsize /= 0 then
								if l_tp[(l_rsize - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_rsize := l_rsize - 1
								l_exp := l_exp - 1
							end
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_tp, l_rsize)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
				when 31 then -- done:
						if l_negate.to_boolean then
							a_r.item.mp_size := (-l_rsize).to_integer_32
						else
							a_r.item.mp_size := l_rsize.to_integer_32
						end
						if l_rsize = 0 then
							l_exp := (0).to_integer_32
						end
						a_r.item.mp_exp := l_exp
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
				when 32 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
