class
	P_TOOM22_MUL_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_toom22_mul (a_pp, a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_pp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_n: CE_ARRAY [INTEGER_32]
			l_s: INTEGER_32
			l_t: INTEGER_32
			l_vm1_neg: INTEGER_32
			l_cy: CE_ARRAY [NATURAL_32]
			l_cy2: CE_ARRAY [NATURAL_32]
			l_asm1: CE_POINTER [NATURAL_32]
			l_bsm1: CE_POINTER [NATURAL_32]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_32]
			l___dst___0: CE_POINTER [NATURAL_32]
			l___n___0: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_pp.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_n.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy2.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___1.make (<<1>>)

			l_pp.item := a_pp
			l_s := (a_an).bit_shift_right (1)
			l_n.item := a_an - l_s
			l_t := a_bn - l_n.item
			l_asm1 := l_pp.item
			l_bsm1 := l_pp.item + l_n.item
			l_vm1_neg := 0
			if l_s = l_n.item then
				if ((create {P_GMP_STATIC}).gmpn_cmp (a_ap, a_ap + l_n.item, l_n.item)) < 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n (l_asm1, a_ap + l_n.item, a_ap, l_n.item).do_nothing
					l_vm1_neg := 1
				else
					(create {P_GMP_STATIC}).gmpn_sub_n (l_asm1, a_ap, a_ap + l_n.item, l_n.item).do_nothing
				end
			elseif ((create {P_GMP_IMPL_STATIC}).mpn_zero_p (a_ap + l_s, l_n.item - l_s)).to_boolean then
				if ((create {P_GMP_STATIC}).gmpn_cmp (a_ap, a_ap + l_n.item, l_s)) < 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n (l_asm1, a_ap + l_n.item, a_ap, l_s).do_nothing
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_n.item - l_s /= 0 then
							l___dst := l_asm1 + l_s
							l___n := l_n.item - l_s
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___0 := l___dst
								l___dst := l___dst + 1
								l_tmp___0.item := (0).to_natural_32
								l___n := l___n - 1
								if not l___n.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
					l_vm1_neg := 1
				else
					(create {P_GMP_STATIC}).gmpn_sub (l_asm1, a_ap, l_n.item, a_ap + l_n.item, l_s).do_nothing
				end
			else
				(create {P_GMP_STATIC}).gmpn_sub (l_asm1, a_ap, l_n.item, a_ap + l_n.item, l_s).do_nothing
			end
			if l_t = l_n.item then
				if ((create {P_GMP_STATIC}).gmpn_cmp (a_bp, a_bp + l_n.item, l_n.item)) < 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n (l_bsm1, a_bp + l_n.item, a_bp, l_n.item).do_nothing
					l_vm1_neg := (l_vm1_neg).bit_xor ((1))
				else
					(create {P_GMP_STATIC}).gmpn_sub_n (l_bsm1, a_bp, a_bp + l_n.item, l_n.item).do_nothing
				end
			elseif ((create {P_GMP_IMPL_STATIC}).mpn_zero_p (a_bp + l_t, l_n.item - l_t)).to_boolean then
				if ((create {P_GMP_STATIC}).gmpn_cmp (a_bp, a_bp + l_n.item, l_t)) < 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n (l_bsm1, a_bp + l_n.item, a_bp, l_t).do_nothing
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_n.item - l_t /= 0 then
							l___dst___0 := l_bsm1 + l_t
							l___n___0 := l_n.item - l_t
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___4 := l___dst___0
								l___dst___0 := l___dst___0 + 1
								l_tmp___4.item := (0).to_natural_32
								l___n___0 := l___n___0 - 1
								if not l___n___0.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
					l_vm1_neg := (l_vm1_neg).bit_xor ((1))
				else
					(create {P_GMP_STATIC}).gmpn_sub (l_bsm1, a_bp, l_n.item, a_bp + l_n.item, l_t).do_nothing
				end
			else
				(create {P_GMP_STATIC}).gmpn_sub (l_bsm1, a_bp, l_n.item, a_bp + l_n.item, l_t).do_nothing
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if 20 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n.item >= 20 then
						gmpn_toom22_mul (a_scratch, l_asm1, l_n.item, l_bsm1, l_n.item, a_scratch + 2 * l_n.item)
					else
						(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (a_scratch, l_asm1, l_n.item, l_bsm1, l_n.item)
					end
				else
					(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (a_scratch, l_asm1, l_n.item, l_bsm1, l_n.item)
				end
				l_break := True
			end
			l_break := False
			if l_s > l_t then
				from
				until
					(l_break)
				loop
					l_break := False
					if 20 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if l_t >= 20 then
							if 4 * l_s < 5 * l_t then
								gmpn_toom22_mul (l_pp.item + 2 * l_n.item, a_ap + l_n.item, l_s, a_bp + l_n.item, l_t, a_scratch + 2 * l_n.item)
							else
								(create {P_TOOM32_MUL_STATIC}).gmpn_toom32_mul (l_pp.item + 2 * l_n.item, a_ap + l_n.item, l_s, a_bp + l_n.item, l_t, a_scratch + 2 * l_n.item)
							end
						else
							(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (l_pp.item + 2 * l_n.item, a_ap + l_n.item, l_s, a_bp + l_n.item, l_t)
						end
					else
						(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (l_pp.item + 2 * l_n.item, a_ap + l_n.item, l_s, a_bp + l_n.item, l_t)
					end
					l_break := True
				end
				l_break := False
			else
				from
				until
					(l_break)
				loop
					l_break := False
					if 20 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if l_s >= 20 then
							gmpn_toom22_mul (l_pp.item + 2 * l_n.item, a_ap + l_n.item, l_s, a_bp + l_n.item, l_s, a_scratch + 2 * l_n.item)
						else
							(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (l_pp.item + 2 * l_n.item, a_ap + l_n.item, l_s, a_bp + l_n.item, l_s)
						end
					else
						(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (l_pp.item + 2 * l_n.item, a_ap + l_n.item, l_s, a_bp + l_n.item, l_s)
					end
					l_break := True
				end
				l_break := False
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if 20 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n.item >= 20 then
						gmpn_toom22_mul (l_pp.item, a_ap, l_n.item, a_bp, l_n.item, a_scratch + 2 * l_n.item)
					else
						(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (l_pp.item, a_ap, l_n.item, a_bp, l_n.item)
					end
				else
					(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (l_pp.item, a_ap, l_n.item, a_bp, l_n.item)
				end
				l_break := True
			end
			l_break := False
			l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + 2 * l_n.item, (l_pp.item + l_n.item), (l_pp.item + 2 * l_n.item), l_n.item)
			l_cy2.item := l_cy.item + ((create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + l_n.item, (l_pp.item + 2 * l_n.item), l_pp.item, l_n.item))
			l_cy.item := l_cy.item + ((create {P_GMP_STATIC}).gmpn_add (l_pp.item + 2 * l_n.item, (l_pp.item + 2 * l_n.item), l_n.item, ((l_pp.item + 2 * l_n.item) + l_n.item), (l_s + l_t) - l_n.item))
			if l_vm1_neg.to_boolean then
				l_cy.item := l_cy.item + ((create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + l_n.item, (l_pp.item + l_n.item), a_scratch, 2 * l_n.item))
			else
				l_cy.item := l_cy.item - ((create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + l_n.item, (l_pp.item + l_n.item), a_scratch, 2 * l_n.item))
			end
			from
			until
				(l_break)
			loop
				l_break := False
				asm131 (l___ptr_dummy, l_pp, l_n, l_cy2)
				l_break := True
			end
			l_break := False
			if (builtin_expect ((l_cy.item <= {NATURAL_32} 2).to_integer, 1)).to_boolean then
				from
				until
					(l_break)
				loop
					l_break := False
					asm132 (l___ptr_dummy___0, l_pp, l_n, l_cy)
					l_break := True
				end
				l_break := False
			else
				from
				until
					(l_break)
				loop
					l_break := False
					asm133 (l___ptr_dummy___1, l_pp, l_n)
					l_break := True
				end
				l_break := False
			end
		end

end
