class
	P_TOOM2_SQR_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_toom2_sqr (a_pp, a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_pp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_n: CE_ARRAY [INTEGER_32]
			l_s: INTEGER_32
			l_cy: CE_ARRAY [NATURAL_32]
			l_cy2: CE_ARRAY [NATURAL_32]
			l_asm1: CE_POINTER [NATURAL_32]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_pp.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_n.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy2.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___1.make (<<1>>)

			l_pp.item := a_pp
			l_s := (a_an).bit_shift_right (1)
			l_n.item := a_an - l_s
			l_asm1 := l_pp.item
			if l_s = l_n.item then
				if ((create {P_GMP_STATIC}).gmpn_cmp (a_ap, a_ap + l_n.item, l_n.item)) < 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n (l_asm1, a_ap + l_n.item, a_ap, l_n.item).do_nothing
				else
					(create {P_GMP_STATIC}).gmpn_sub_n (l_asm1, a_ap, a_ap + l_n.item, l_n.item).do_nothing
				end
			elseif ((create {P_GMP_IMPL_STATIC}).mpn_zero_p (a_ap + l_s, l_n.item - l_s)).to_boolean then
				if ((create {P_GMP_STATIC}).gmpn_cmp (a_ap, a_ap + l_n.item, l_s)) < 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n (l_asm1, a_ap + l_n.item, a_ap, l_s).do_nothing
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_n.item - l_s /= 0 then
							l___dst := l_asm1 + l_s
							l___n := l_n.item - l_s
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___0 := l___dst
								l___dst := l___dst + 1
								l_tmp___0.item := (0).to_natural_32
								l___n := l___n - 1
								if not l___n.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
				else
					(create {P_GMP_STATIC}).gmpn_sub (l_asm1, a_ap, l_n.item, a_ap + l_n.item, l_s).do_nothing
				end
			else
				(create {P_GMP_STATIC}).gmpn_sub (l_asm1, a_ap, l_n.item, a_ap + l_n.item, l_s).do_nothing
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if 30 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n.item >= 30 then
						gmpn_toom2_sqr (a_scratch, l_asm1, l_n.item, a_scratch + 2 * l_n.item)
					else
						(create {P_GMP_IMPL_STATIC}).gmpn_sqr_basecase (a_scratch, l_asm1, l_n.item)
					end
				else
					(create {P_GMP_IMPL_STATIC}).gmpn_sqr_basecase (a_scratch, l_asm1, l_n.item)
				end
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False
				if 30 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_s >= 30 then
						gmpn_toom2_sqr (l_pp.item + 2 * l_n.item, a_ap + l_n.item, l_s, a_scratch + 2 * l_n.item)
					else
						(create {P_GMP_IMPL_STATIC}).gmpn_sqr_basecase (l_pp.item + 2 * l_n.item, a_ap + l_n.item, l_s)
					end
				else
					(create {P_GMP_IMPL_STATIC}).gmpn_sqr_basecase (l_pp.item + 2 * l_n.item, a_ap + l_n.item, l_s)
				end
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False
				if 30 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n.item >= 30 then
						gmpn_toom2_sqr (l_pp.item, a_ap, l_n.item, a_scratch + 2 * l_n.item)
					else
						(create {P_GMP_IMPL_STATIC}).gmpn_sqr_basecase (l_pp.item, a_ap, l_n.item)
					end
				else
					(create {P_GMP_IMPL_STATIC}).gmpn_sqr_basecase (l_pp.item, a_ap, l_n.item)
				end
				l_break := True
			end
			l_break := False
			l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + 2 * l_n.item, (l_pp.item + l_n.item), (l_pp.item + 2 * l_n.item), l_n.item)
			l_cy2.item := l_cy.item + ((create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + l_n.item, (l_pp.item + 2 * l_n.item), l_pp.item, l_n.item))
			l_cy.item := l_cy.item + ((create {P_GMP_STATIC}).gmpn_add (l_pp.item + 2 * l_n.item, (l_pp.item + 2 * l_n.item), l_n.item, ((l_pp.item + 2 * l_n.item) + l_n.item), (l_s + l_s) - l_n.item))
			l_cy.item := l_cy.item - ((create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + l_n.item, (l_pp.item + l_n.item), a_scratch, 2 * l_n.item))
			from
			until
				(l_break)
			loop
				l_break := False
				asm140 (l___ptr_dummy, l_pp, l_n, l_cy2)
				l_break := True
			end
			l_break := False
			if (builtin_expect ((l_cy.item <= {NATURAL_32} 2).to_integer, 1)).to_boolean then
				from
				until
					(l_break)
				loop
					l_break := False
					asm141 (l___ptr_dummy___0, l_pp, l_n, l_cy)
					l_break := True
				end
				l_break := False
			else
				from
				until
					(l_break)
				loop
					l_break := False
					asm142 (l___ptr_dummy___1, l_pp, l_n)
					l_break := True
				end
				l_break := False
			end
		end

end
