class
	P_TOOM32_MUL_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_toom32_mul (a_pp, a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_scratch: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_pp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_n: CE_ARRAY [INTEGER_32]
			l_s: INTEGER_32
			l_t: INTEGER_32
			l_vm1_neg: INTEGER_32
			l_cy: CE_ARRAY [NATURAL_32]
			l_hi: CE_ARRAY [INTEGER_32]
			l_ap1_hi: NATURAL_32
			l_bp1_hi: NATURAL_32
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_scratch.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_pp.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_n.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_hi.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___2.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___3.make (<<1>>)

			l_scratch.item := a_scratch
			l_pp.item := a_pp
			if 2 * a_an >= 3 * a_bn then
				l_tmp := (a_an - 1).to_natural_32 // {NATURAL_32} 3
			else
				l_tmp := (((a_bn - 1)).bit_shift_right (1)).to_natural_32
			end
			l_n.item := ({NATURAL_32} 1 + l_tmp).to_integer_32
			l_s := a_an - 2 * l_n.item
			l_t := a_bn - l_n.item
			l_ap1_hi := (create {P_GMP_STATIC}).gmpn_add (l_pp.item, a_ap, l_n.item, a_ap + 2 * l_n.item, l_s)
			if l_ap1_hi = {NATURAL_32} 0 then
				if ((create {P_GMP_STATIC}).gmpn_cmp (l_pp.item, a_ap + l_n.item, l_n.item)) < 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + 2 * l_n.item, a_ap + l_n.item, l_pp.item, l_n.item).do_nothing
					l_hi.item := 0
					l_vm1_neg := 1
				else
					l_tmp___0 := (create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + 2 * l_n.item, l_pp.item, a_ap + l_n.item, l_n.item)
					l_hi.item := (l_ap1_hi - l_tmp___0).to_integer_32
					l_vm1_neg := 0
				end
			else
				l_tmp___0 := (create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + 2 * l_n.item, l_pp.item, a_ap + l_n.item, l_n.item)
				l_hi.item := (l_ap1_hi - l_tmp___0).to_integer_32
				l_vm1_neg := 0
			end
			l_ap1_hi := l_ap1_hi + ((create {P_GMP_STATIC}).gmpn_add_n (l_pp.item, l_pp.item, a_ap + l_n.item, l_n.item))
			if l_t = l_n.item then
				l_bp1_hi := (create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + l_n.item, a_bp, a_bp + l_n.item, l_n.item)
				if ((create {P_GMP_STATIC}).gmpn_cmp (a_bp, a_bp + l_n.item, l_n.item)) < 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + 3 * l_n.item, a_bp + l_n.item, a_bp, l_n.item).do_nothing
					l_vm1_neg := (l_vm1_neg).bit_xor ((1))
				else
					(create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + 3 * l_n.item, a_bp, a_bp + l_n.item, l_n.item).do_nothing
				end
			else
				l_bp1_hi := (create {P_GMP_STATIC}).gmpn_add (l_pp.item + l_n.item, a_bp, l_n.item, a_bp + l_n.item, l_t)
				if ((create {P_GMP_IMPL_STATIC}).mpn_zero_p (a_bp + l_t, l_n.item - l_t)).to_boolean then
					if ((create {P_GMP_STATIC}).gmpn_cmp (a_bp, a_bp + l_n.item, l_t)) < 0 then
						(create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + 3 * l_n.item, a_bp + l_n.item, a_bp, l_t).do_nothing
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_n.item - l_t /= 0 then
								l___dst := (l_pp.item + 3 * l_n.item) + l_t
								l___n := l_n.item - l_t
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___4 := l___dst
									l___dst := l___dst + 1
									l_tmp___4.item := (0).to_natural_32
									l___n := l___n - 1
									if not l___n.to_boolean then
										l_break := True
									end
								end
								l_break := False
							end
							l_break := True
						end
						l_break := False
						l_vm1_neg := (l_vm1_neg).bit_xor ((1))
					else
						(create {P_GMP_STATIC}).gmpn_sub (l_pp.item + 3 * l_n.item, a_bp, l_n.item, a_bp + l_n.item, l_t).do_nothing
					end
				else
					(create {P_GMP_STATIC}).gmpn_sub (l_pp.item + 3 * l_n.item, a_bp, l_n.item, a_bp + l_n.item, l_t).do_nothing
				end
			end
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_MUL_N_STATIC}).gmpn_mul_n (l_scratch.item, l_pp.item, (l_pp.item + l_n.item), l_n.item)
				l_break := True
			end
			l_break := False
			if l_ap1_hi = {NATURAL_32} 1 then
				l_cy.item := l_bp1_hi + ((create {P_GMP_STATIC}).gmpn_add_n (l_scratch.item + l_n.item, (l_scratch.item + l_n.item), (l_pp.item + l_n.item), l_n.item))
			elseif l_ap1_hi = {NATURAL_32} 2 then
				l_cy.item := {NATURAL_32} 2 * l_bp1_hi + ((create {P_GMP_STATIC}).gmpn_addmul_1 (l_scratch.item + l_n.item, (l_pp.item + l_n.item), l_n.item, (2).to_natural_32))
			else
				l_cy.item := (0).to_natural_32
			end
			if l_bp1_hi /= {NATURAL_32} 0 then
				l_cy.item := l_cy.item + ((create {P_GMP_STATIC}).gmpn_add_n (l_scratch.item + l_n.item, (l_scratch.item + l_n.item), l_pp.item, l_n.item))
			end
			l_scratch.item[2 * l_n.item] := l_cy.item
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_MUL_N_STATIC}).gmpn_mul_n (l_pp.item, (l_pp.item + 2 * l_n.item), (l_pp.item + 3 * l_n.item), l_n.item)
				l_break := True
			end
			l_break := False
			if (l_hi.item).to_boolean then
				l_hi.item := ((create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + l_n.item, (l_pp.item + l_n.item), (l_pp.item + 3 * l_n.item), l_n.item)).to_integer_32
			end
			l_pp.item[2 * l_n.item] := (l_hi.item).to_natural_32
			if l_vm1_neg.to_boolean then
				(create {P_GMP_STATIC}).gmpn_sub_n (l_scratch.item, l_scratch.item, l_pp.item, 2 * l_n.item + 1).do_nothing;
				(create {P_GMP_STATIC}).gmpn_rshift (l_scratch.item, l_scratch.item, 2 * l_n.item + 1, {NATURAL_32} 1).do_nothing
			else
				(create {P_GMP_STATIC}).gmpn_add_n (l_scratch.item, l_scratch.item, l_pp.item, 2 * l_n.item + 1).do_nothing;
				(create {P_GMP_STATIC}).gmpn_rshift (l_scratch.item, l_scratch.item, 2 * l_n.item + 1, {NATURAL_32} 1).do_nothing
			end
			l_hi.item := (l_pp.item[2 * l_n.item]).to_integer_32
			l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + 2 * l_n.item, l_scratch.item, (l_scratch.item + l_n.item), l_n.item)
			from
			until
				(l_break)
			loop
				l_break := False
				asm134 (l___ptr_dummy, l_scratch, l_n, l_cy)
				l_break := True
			end
			l_break := False
			if l_vm1_neg.to_boolean then
				l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_scratch.item, l_scratch.item, l_pp.item, l_n.item)
				l_hi.item := ((l_hi.item).to_natural_32 + ((create {P_GMP_IMPL_STATIC}).gmpn_add_nc (l_pp.item + 2 * l_n.item, (l_pp.item + 2 * l_n.item), (l_pp.item + l_n.item), l_n.item, l_cy.item))).to_integer_32
				from
				until
					(l_break)
				loop
					l_break := False
					asm135 (l___ptr_dummy___0, l_scratch, l_n, l_hi)
					l_break := True
				end
				l_break := False
			else
				l_cy.item := (create {P_GMP_STATIC}).gmpn_sub_n (l_scratch.item, l_scratch.item, l_pp.item, l_n.item)
				l_hi.item := ((l_hi.item).to_natural_32 + ((create {P_GMP_IMPL_STATIC}).gmpn_sub_nc (l_pp.item + 2 * l_n.item, (l_pp.item + 2 * l_n.item), (l_pp.item + l_n.item), l_n.item, l_cy.item))).to_integer_32
				from
				until
					(l_break)
				loop
					l_break := False
					asm136 (l___ptr_dummy___1, l_scratch, l_n, l_hi)
					l_break := True
				end
				l_break := False
			end
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_MUL_N_STATIC}).gmpn_mul_n (l_pp.item, a_ap, a_bp, l_n.item)
				l_break := True
			end
			l_break := False
			if l_s > l_t then
				(create {P_MUL_STATIC}).gmpn_mul (l_pp.item + 3 * l_n.item, a_ap + 2 * l_n.item, l_s, a_bp + l_n.item, l_t).do_nothing
			else
				(create {P_MUL_STATIC}).gmpn_mul (l_pp.item + 3 * l_n.item, a_bp + l_n.item, l_t, a_ap + 2 * l_n.item, l_s).do_nothing
			end
			l_cy.item := (create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + l_n.item, (l_pp.item + l_n.item), (l_pp.item + 3 * l_n.item), l_n.item)
			l_hi.item := (l_scratch.item[2 * l_n.item] + l_cy.item).to_integer_32
			l_cy.item := (create {P_GMP_IMPL_STATIC}).gmpn_sub_nc (l_pp.item + 2 * l_n.item, (l_pp.item + 2 * l_n.item), l_pp.item, l_n.item, l_cy.item)
			l_hi.item := ((l_hi.item).to_natural_32 - ((create {P_GMP_IMPL_STATIC}).gmpn_sub_nc (l_pp.item + 3 * l_n.item, (l_scratch.item + l_n.item), (l_pp.item + l_n.item), l_n.item, l_cy.item))).to_integer_32
			l_hi.item := ((l_hi.item).to_natural_32 + ((create {P_GMP_STATIC}).gmpn_add (l_pp.item + l_n.item, (l_pp.item + l_n.item), 3 * l_n.item, l_scratch.item, l_n.item))).to_integer_32
			if (builtin_expect ((l_s + l_t > l_n.item).to_integer, 1)).to_boolean then
				l_hi.item := ((l_hi.item).to_natural_32 - ((create {P_GMP_STATIC}).gmpn_sub (l_pp.item + 2 * l_n.item, (l_pp.item + 2 * l_n.item), 2 * l_n.item, (l_pp.item + 4 * l_n.item), (l_s + l_t) - l_n.item))).to_integer_32
				if l_hi.item < 0 then
					from
					until
						(l_break)
					loop
						l_break := False
						asm137 (l___ptr_dummy___2, l_pp, l_n, l_hi)
						l_break := True
					end
					l_break := False
				else
					from
					until
						(l_break)
					loop
						l_break := False
						asm138 (l___ptr_dummy___3, l_pp, l_n, l_hi)
						l_break := True
					end
					l_break := False
				end
			else
			end
		end

end
