class
	P_TOOM53_MUL_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_toom53_mul (a_pp, a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		require
			not a_pp.is_void
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_t: CE_ARRAY [INTEGER_32]
			l_cy: CE_ARRAY [NATURAL_32]
			l_gp: CE_POINTER [NATURAL_32]
			l_as1: CE_POINTER [NATURAL_32]
			l_asm1: CE_POINTER [NATURAL_32]
			l_as2: CE_POINTER [NATURAL_32]
			l_asm2: CE_POINTER [NATURAL_32]
			l_ash: CE_POINTER [NATURAL_32]
			l_bs1: CE_POINTER [NATURAL_32]
			l_bsm1: CE_POINTER [NATURAL_32]
			l_bs2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_bsm2: CE_POINTER [NATURAL_32]
			l_bsh: CE_POINTER [NATURAL_32]
			l_flags: NATURAL_32
			l___tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp: NATURAL_32
			l_tmp___19: NATURAL_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_INTEGER_32_ARRAY} l_t.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_bs2.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)

			if 3 * a_an >= 5 * a_bn then
				l_tmp := (a_an - 1).to_natural_32 // {NATURAL_32} 5
			else
				l_tmp := (a_bn - 1).to_natural_32 // {NATURAL_32} 3
			end
			l_n := ({NATURAL_32} 1 + l_tmp).to_integer_32
			l_s := a_an - 4 * l_n
			l_t.item := a_bn - 2 * l_n
			l___tmp_marker := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			l_as1 := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_asm1 := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_as2 := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_asm2 := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_ash := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_bs1 := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_bsm1 := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_bs2.item := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_bsm2 := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_bsh := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_gp := a_pp
			l_flags := ((2).bit_and (((create {P_TOOM_EVAL_PM1_STATIC}).gmpn_toom_eval_pm1 (l_as1, l_asm1, {NATURAL_32} 4, a_ap, l_n, l_s, l_gp)))).to_natural_32
			l_flags := ((l_flags).bit_or (((1).bit_and (((create {P_TOOM_EVAL_PM2_STATIC}).gmpn_toom_eval_pm2 (l_as2, l_asm2, {NATURAL_32} 4, a_ap, l_n, l_s, l_gp)))).to_natural_32))
			l_cy.item := (create {P_GMP_STATIC}).gmpn_lshift (l_ash, a_ap, l_n, {NATURAL_32} 1)
			l_cy.item := l_cy.item + ((create {P_GMP_STATIC}).gmpn_add_n (l_ash, l_ash, a_ap + l_n, l_n))
			l_cy.item := {NATURAL_32} 2 * l_cy.item + ((create {P_GMP_STATIC}).gmpn_lshift (l_ash, l_ash, l_n, {NATURAL_32} 1))
			l_cy.item := l_cy.item + ((create {P_GMP_STATIC}).gmpn_add_n (l_ash, l_ash, a_ap + 2 * l_n, l_n))
			l_cy.item := {NATURAL_32} 2 * l_cy.item + ((create {P_GMP_STATIC}).gmpn_lshift (l_ash, l_ash, l_n, {NATURAL_32} 1))
			l_cy.item := l_cy.item + ((create {P_GMP_STATIC}).gmpn_add_n (l_ash, l_ash, a_ap + 3 * l_n, l_n))
			l_cy.item := {NATURAL_32} 2 * l_cy.item + ((create {P_GMP_STATIC}).gmpn_lshift (l_ash, l_ash, l_n, {NATURAL_32} 1))
			l_ash[l_n] := l_cy.item + ((create {P_GMP_STATIC}).gmpn_add (l_ash, l_ash, l_n, a_ap + 4 * l_n, l_s))
			l_bs1[l_n] := (create {P_GMP_STATIC}).gmpn_add (l_bs1, a_bp, l_n, a_bp + 2 * l_n, l_t.item)
			if l_bs1[l_n] = {NATURAL_32} 0 then
				if ((create {P_GMP_STATIC}).gmpn_cmp (l_bs1, a_bp + l_n, l_n)) < 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n (l_bsm1, a_bp + l_n, l_bs1, l_n).do_nothing
					l_bsm1[l_n] := (0).to_natural_32
					l_flags := ((l_flags).bit_xor ({NATURAL_32} 2))
				else
					l_tmp___19 := (create {P_GMP_STATIC}).gmpn_sub_n (l_bsm1, l_bs1, a_bp + l_n, l_n)
					l_bsm1[l_n] := l_bs1[l_n] - l_tmp___19
				end
			else
				l_tmp___19 := (create {P_GMP_STATIC}).gmpn_sub_n (l_bsm1, l_bs1, a_bp + l_n, l_n)
				l_bsm1[l_n] := l_bs1[l_n] - l_tmp___19
			end
			l_bs1[l_n] := l_bs1[l_n] + ((create {P_GMP_STATIC}).gmpn_add_n (l_bs1, l_bs1, a_bp + l_n, l_n))
			l_cy.item := (create {P_GMP_STATIC}).gmpn_lshift (l_gp, a_bp + 2 * l_n, l_t.item, {NATURAL_32} 2)
			l_bs2.item[l_n] := (create {P_GMP_STATIC}).gmpn_add (l_bs2.item, a_bp, l_n, l_gp, l_t.item)
			from
			until
				(l_break)
			loop
				l_break := False
				asm139 (l___ptr_dummy, l_bs2, l_t, l_cy)
				l_break := True
			end
			l_break := False
			l_gp[l_n] := (create {P_GMP_STATIC}).gmpn_lshift (l_gp, a_bp + l_n, l_n, {NATURAL_32} 1)
			if ((create {P_GMP_STATIC}).gmpn_cmp (l_bs2.item, l_gp, l_n + 1)) < 0 then
				(create {P_GMP_STATIC}).gmpn_sub_n (l_bsm2, l_gp, l_bs2.item, l_n + 1).do_nothing
				l_flags := ((l_flags).bit_xor ({NATURAL_32} 1))
			else
				(create {P_GMP_STATIC}).gmpn_sub_n (l_bsm2, l_bs2.item, l_gp, l_n + 1).do_nothing
			end
			(create {P_GMP_STATIC}).gmpn_add_n (l_bs2.item, l_bs2.item, l_gp, l_n + 1).do_nothing
			l_cy.item := (create {P_GMP_STATIC}).gmpn_lshift (l_bsh, a_bp, l_n, {NATURAL_32} 1)
			l_cy.item := l_cy.item + ((create {P_GMP_STATIC}).gmpn_add_n (l_bsh, l_bsh, a_bp + l_n, l_n))
			l_cy.item := {NATURAL_32} 2 * l_cy.item + ((create {P_GMP_STATIC}).gmpn_lshift (l_bsh, l_bsh, l_n, {NATURAL_32} 1))
			l_bsh[l_n] := l_cy.item + ((create {P_GMP_STATIC}).gmpn_add (l_bsh, l_bsh, l_n, a_bp + 2 * l_n, l_t.item));
			(create {P_MUL_N_STATIC}).gmpn_mul_n (a_scratch, l_as2, l_bs2.item, l_n + 1);
			(create {P_MUL_N_STATIC}).gmpn_mul_n ((a_scratch + 2 * l_n) + 1, l_asm2, l_bsm2, l_n + 1);
			(create {P_MUL_N_STATIC}).gmpn_mul_n ((a_scratch + 4 * l_n) + 2, l_ash, l_bsh, l_n + 1);
			((a_scratch + 6 * l_n) + 3)[2 * l_n] := (0).to_natural_32;
			(create {P_MUL_N_STATIC}).gmpn_mul_n ((a_scratch + 6 * l_n) + 3, l_asm1, l_bsm1, l_n + (((l_asm1[l_n]).bit_or (l_bsm1[l_n])) /= {NATURAL_32} 0).to_integer);
			(a_pp + 2 * l_n)[2 * l_n] := (0).to_natural_32;
			(create {P_MUL_N_STATIC}).gmpn_mul_n (a_pp + 2 * l_n, l_as1, l_bs1, l_n + (((l_as1[l_n]).bit_or (l_bs1[l_n])) /= {NATURAL_32} 0).to_integer);
			(create {P_MUL_N_STATIC}).gmpn_mul_n (a_pp, a_ap, a_bp, l_n)
			if l_s > l_t.item then
				(create {P_MUL_STATIC}).gmpn_mul (a_pp + 6 * l_n, a_ap + 4 * l_n, l_s, a_bp + 2 * l_n, l_t.item).do_nothing
			else
				(create {P_MUL_STATIC}).gmpn_mul (a_pp + 6 * l_n, a_bp + 2 * l_n, l_t.item, a_ap + 4 * l_n, l_s).do_nothing
			end
			(create {P_TOOM_INTERPOLATE_7PTS_STATIC}).gmpn_toom_interpolate_7pts (a_pp, l_n, l_flags, (a_scratch + 2 * l_n) + 1, (a_scratch + 6 * l_n) + 3, a_scratch, (a_scratch + 4 * l_n) + 2, l_s + l_t.item, (a_scratch + 8 * l_n) + 4)
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect ((not l___tmp_marker.is_void).to_integer, 0)).to_boolean then
					(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker)
				end
				l_break := True
			end
			l_break := False
		end

end
