class
	P_TOOM6_SQR_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpn_toom6_sqr (a_pp, a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_break: BOOLEAN
		do
			l_n := ({NATURAL_32} 1 + (a_an - 1).to_natural_32 // {NATURAL_32} 6).to_integer_32
			l_s := a_an - 5 * l_n;
			(create {P_TOOM_EVAL_PM2REXP_STATIC}).gmpn_toom_eval_pm2rexp ((a_pp + 9 * l_n) + 2, a_pp + 7 * l_n, {NATURAL_32} 5, a_ap, l_n, l_s, {NATURAL_32} 1, a_pp).do_nothing
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_TOOM2_SQR_STATIC}).gmpn_toom2_sqr (a_pp, (a_pp + 7 * l_n), l_n + 1, (a_scratch + 9 * l_n) + 3)
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_TOOM2_SQR_STATIC}).gmpn_toom2_sqr (a_scratch, ((a_pp + 9 * l_n) + 2), l_n + 1, (a_scratch + 9 * l_n) + 3)
				l_break := True
			end
			l_break := False;
			(create {P_TOOM_COUPLE_HANDLING_STATIC}).gmpn_toom_couple_handling (a_scratch, 2 * l_n + 1, a_pp, 0, l_n, 1, 0);
			(create {P_TOOM_EVAL_PM1_STATIC}).gmpn_toom_eval_pm1 ((a_pp + 9 * l_n) + 2, a_pp + 7 * l_n, {NATURAL_32} 5, a_ap, l_n, l_s, a_pp).do_nothing
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_TOOM2_SQR_STATIC}).gmpn_toom2_sqr (a_pp, (a_pp + 7 * l_n), l_n + 1, (a_scratch + 9 * l_n) + 3)
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_TOOM2_SQR_STATIC}).gmpn_toom2_sqr ((a_scratch + 3 * l_n) + 1, ((a_pp + 9 * l_n) + 2), l_n + 1, (a_scratch + 9 * l_n) + 3)
				l_break := True
			end
			l_break := False;
			(create {P_TOOM_COUPLE_HANDLING_STATIC}).gmpn_toom_couple_handling ((a_scratch + 3 * l_n) + 1, 2 * l_n + 1, a_pp, 0, l_n, 0, 0);
			(create {P_TOOM_EVAL_PM2EXP_STATIC}).gmpn_toom_eval_pm2exp ((a_pp + 9 * l_n) + 2, a_pp + 7 * l_n, {NATURAL_32} 5, a_ap, l_n, l_s, {NATURAL_32} 2, a_pp).do_nothing
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_TOOM2_SQR_STATIC}).gmpn_toom2_sqr (a_pp, (a_pp + 7 * l_n), l_n + 1, (a_scratch + 9 * l_n) + 3)
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_TOOM2_SQR_STATIC}).gmpn_toom2_sqr ((a_scratch + 6 * l_n) + 2, ((a_pp + 9 * l_n) + 2), l_n + 1, (a_scratch + 9 * l_n) + 3)
				l_break := True
			end
			l_break := False;
			(create {P_TOOM_COUPLE_HANDLING_STATIC}).gmpn_toom_couple_handling ((a_scratch + 6 * l_n) + 2, 2 * l_n + 1, a_pp, 0, l_n, 2, 4);
			(create {P_TOOM_EVAL_PM2REXP_STATIC}).gmpn_toom_eval_pm2rexp ((a_pp + 9 * l_n) + 2, a_pp + 7 * l_n, {NATURAL_32} 5, a_ap, l_n, l_s, {NATURAL_32} 2, a_pp).do_nothing
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_TOOM2_SQR_STATIC}).gmpn_toom2_sqr (a_pp, (a_pp + 7 * l_n), l_n + 1, (a_scratch + 9 * l_n) + 3)
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_TOOM2_SQR_STATIC}).gmpn_toom2_sqr (a_pp + 3 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, (a_scratch + 9 * l_n) + 3)
				l_break := True
			end
			l_break := False;
			(create {P_TOOM_COUPLE_HANDLING_STATIC}).gmpn_toom_couple_handling (a_pp + 3 * l_n, 2 * l_n + 1, a_pp, 0, l_n, 2, 0);
			(create {P_TOOM_EVAL_PM2_STATIC}).gmpn_toom_eval_pm2 ((a_pp + 9 * l_n) + 2, a_pp + 7 * l_n, {NATURAL_32} 5, a_ap, l_n, l_s, a_pp).do_nothing
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_TOOM2_SQR_STATIC}).gmpn_toom2_sqr (a_pp, (a_pp + 7 * l_n), l_n + 1, (a_scratch + 9 * l_n) + 3)
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_TOOM2_SQR_STATIC}).gmpn_toom2_sqr (a_pp + 7 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, (a_scratch + 9 * l_n) + 3)
				l_break := True
			end
			l_break := False;
			(create {P_TOOM_COUPLE_HANDLING_STATIC}).gmpn_toom_couple_handling (a_pp + 7 * l_n, 2 * l_n + 1, a_pp, 0, l_n, 1, 2)
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_TOOM2_SQR_STATIC}).gmpn_toom2_sqr (a_pp, a_ap, l_n, (a_scratch + 9 * l_n) + 3)
				l_break := True
			end
			l_break := False;
			(create {P_TOOM_INTERPOLATE_12PTS_STATIC}).gmpn_toom_interpolate_12pts (a_pp, (a_scratch + 6 * l_n) + 2, (a_scratch + 3 * l_n) + 1, a_scratch, l_n, 2 * l_s, 0, (a_scratch + 9 * l_n) + 3)
		end

end
