class
	P_TOOM_INTERPOLATE_5PTS_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_toom_interpolate_5pts (a_c, a_v2, a_vm1: CE_POINTER [NATURAL_32]; a_k, a_twor: INTEGER_32; a_sa: INTEGER_32; a_vinf0: NATURAL_32)
		local
			l_twor: CE_ARRAY [INTEGER_32]
			l_v2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_vinf0: CE_ARRAY [NATURAL_32]
			l_cy: CE_ARRAY [NATURAL_32]
			l_saved: NATURAL_32
			l_twok: INTEGER_32
			l_kk1: CE_ARRAY [INTEGER_32]
			l_c1: CE_POINTER [NATURAL_32]
			l_v1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_c3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_vinf: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_tmp: NATURAL_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___4: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_twor.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_v2.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_vinf0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_kk1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_v1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_c3.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_vinf.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___2.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___3.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___4.make (<<1>>)

			l_twor.item := a_twor
			l_v2.item := a_v2
			l_vinf0.item := a_vinf0
			l_twok := a_k + a_k
			l_kk1.item := l_twok + 1
			l_c1 := a_c + a_k
			l_v1.item := l_c1 + a_k
			l_c3.item := l_v1.item + a_k
			l_vinf.item := l_c3.item + a_k
			if a_sa.to_boolean then
				(create {P_GMP_STATIC}).gmpn_add_n (l_v2.item, l_v2.item, a_vm1, l_kk1.item).do_nothing
			else
				(create {P_GMP_STATIC}).gmpn_sub_n (l_v2.item, l_v2.item, a_vm1, l_kk1.item).do_nothing
			end
			l_tmp := (create {P_GMP_IMPL_STATIC}).gmpn_bdiv_dbm1c (l_v2.item, l_v2.item, l_kk1.item, {NATURAL_32} 1_431_655_765, (0).to_natural_32)
			if a_sa.to_boolean then
				(create {P_GMP_STATIC}).gmpn_add_n (a_vm1, l_v1.item, a_vm1, l_kk1.item).do_nothing;
				(create {P_GMP_STATIC}).gmpn_rshift (a_vm1, a_vm1, l_kk1.item, {NATURAL_32} 1).do_nothing
			else
				(create {P_GMP_STATIC}).gmpn_sub_n (a_vm1, l_v1.item, a_vm1, l_kk1.item).do_nothing;
				(create {P_GMP_STATIC}).gmpn_rshift (a_vm1, a_vm1, l_kk1.item, {NATURAL_32} 1).do_nothing
			end
			l_vinf.item[0] := l_vinf.item[0] - ((create {P_GMP_STATIC}).gmpn_sub_n (l_v1.item, l_v1.item, a_c, l_twok));
			(create {P_GMP_STATIC}).gmpn_sub_n (l_v2.item, l_v2.item, l_v1.item, l_kk1.item).do_nothing;
			(create {P_GMP_STATIC}).gmpn_rshift (l_v2.item, l_v2.item, l_kk1.item, {NATURAL_32} 1).do_nothing;
			(create {P_GMP_STATIC}).gmpn_sub_n (l_v1.item, l_v1.item, a_vm1, l_kk1.item).do_nothing
			l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_c1, l_c1, a_vm1, l_kk1.item)
			from
			until
				(l_break)
			loop
				l_break := False
				asm143 (l___ptr_dummy, l_c3, l_cy)
				l_break := True
			end
			l_break := False
			l_saved := l_vinf.item[0]
			l_vinf.item[0] := l_vinf0.item
			l_cy.item := (create {P_GMP_STATIC}).gmpn_lshift (a_vm1, l_vinf.item, l_twor.item, {NATURAL_32} 1)
			l_cy.item := l_cy.item + ((create {P_GMP_STATIC}).gmpn_sub_n (l_v2.item, l_v2.item, a_vm1, l_twor.item))
			from
			until
				(l_break)
			loop
				l_break := False
				asm144 (l___ptr_dummy___0, l_v2, l_twor, l_cy)
				l_break := True
			end
			l_break := False
			if (builtin_expect ((l_twor.item > a_k + 1).to_integer, 1)).to_boolean then
				l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_vinf.item, l_vinf.item, (l_v2.item + a_k), a_k + 1)
				from
				until
					(l_break)
				loop
					l_break := False
					asm145 (l___ptr_dummy___1, l_c3, l_kk1, l_cy)
					l_break := True
				end
				l_break := False
			else
				(create {P_GMP_STATIC}).gmpn_add_n (l_vinf.item, l_vinf.item, (l_v2.item + a_k), l_twor.item).do_nothing
			end
			l_cy.item := (create {P_GMP_STATIC}).gmpn_sub_n (l_v1.item, l_v1.item, l_vinf.item, l_twor.item)
			l_vinf0.item := l_vinf.item[0]
			l_vinf.item[0] := l_saved
			from
			until
				(l_break)
			loop
				l_break := False
				asm146 (l___ptr_dummy___2, l_v1, l_twor, l_cy)
				l_break := True
			end
			l_break := False
			l_cy.item := (create {P_GMP_STATIC}).gmpn_sub_n (l_c1, l_c1, l_v2.item, a_k)
			from
			until
				(l_break)
			loop
				l_break := False
				asm147 (l___ptr_dummy___3, l_v1, l_cy)
				l_break := True
			end
			l_break := False
			l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_c3.item, l_c3.item, l_v2.item, a_k)
			l_vinf.item[0] := l_vinf.item[0] + (l_cy.item)
			from
			until
				(l_break)
			loop
				l_break := False
				asm148 (l___ptr_dummy___4, l_vinf, l_vinf0)
				l_break := True
			end
			l_break := False
		end

end
