class
	P_UI_SUB_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpf_ui_sub (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: NATURAL_32; a_v: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_v.is_void
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_rsize: INTEGER_32
			l_prec: INTEGER_32
			l_uexp: INTEGER_32
			l_ediff: INTEGER_32
			l_negate: INTEGER_32
			l_ulimb: CE_ARRAY [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_v_negated: CE_ARRAY [PD_MPF_STRUCT]
			l_tmp___2: CE_POINTER [ANY]
			l_cmp: INTEGER_32
			l_size: INTEGER_32
			l_size___0: INTEGER_32
			l_i: INTEGER_32
			l_cmp___0: INTEGER_32
			l_size___1: INTEGER_32
			l_i___0: INTEGER_32
			l_size___2: INTEGER_32
			l_cmp___1: INTEGER_32
			l_size___3: INTEGER_32
			l_size___4: INTEGER_32
			l_i___1: INTEGER_32
			l_size___5: INTEGER_32
			l_i___2: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_NATURAL_32_ARRAY} l_ulimb.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPF_STRUCT]} l_v_negated.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_vsize := (a_v.item.mp_size).to_integer_32
					if a_u = {NATURAL_32} 0 then
						a_r.item.gmpf_neg (a_v)
						l_return := True
					end
					if not l_return and then (l_vsize = 0) then
						a_r.item.gmpf_set_ui (a_u)
						l_return := True
					end
					if not l_return and then (l_vsize < 0) then
						l_v_negated.item.mp_size := (-l_vsize).to_integer_32
						l_v_negated.item.mp_exp := a_v.item.mp_exp
						l_v_negated.item.mp_d := a_v.item.mp_d
						a_r.item.gmpf_add_ui (l_v_negated, a_u)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 23 -- skip if block
					end
				when 1 then -- if:
						l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						l_ulimb.item := a_u
						if 1 < a_v.item.mp_exp then
							l_negate := 1
							if l_vsize >= 0 then
								l_usize := l_vsize
							else
								l_usize := -l_vsize
							end
							l_vsize := (1).to_integer_32
							l_up := a_v.item.mp_d
							l_vp := l_ulimb
							l_rp := a_r.item.mp_d
							l_prec := (a_r.item.mp_prec + 1).to_integer_32
							l_uexp := a_v.item.mp_exp
							l_ediff := l_uexp - 1
						else
							l_negate := 0
							l_usize := (1).to_integer_32
							if l_vsize >= 0 then
								l_vsize := l_vsize
							else
								l_vsize := -l_vsize
							end
							l_up := l_ulimb
							l_vp := a_v.item.mp_d
							l_rp := a_r.item.mp_d
							l_prec := (a_r.item.mp_prec).to_integer_32
							l_uexp := (1).to_integer_32
							l_ediff := (1 - a_v.item.mp_exp)
						end
						if l_ediff /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 2 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 7 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_usize := l_usize - 1
						l_vsize := l_vsize - 1
						if l_up[l_usize] /= l_vp[l_vsize] then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_uexp := l_uexp - 1
						if l_usize = 0 then
							l_pos := -1 + 10 -- goto Lu0
						end
				when 5 then
						if l_vsize = 0 then
							l_pos := -1 + 8 -- goto Lv0
						end
				when 6 then
						l_pos := -1 + 2 -- back to loop condition
				when 7 then -- loop done
						l_break := False
						l_usize := l_usize + 1
						l_vsize := l_vsize + 1
						if l_vsize /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | Lv0:
						from
						until
							(l_break)
						loop
							l_break := False
							if l_usize /= 0 then
								if l_up[(l_usize - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_usize := l_usize - 1
								l_uexp := l_uexp - 1
							end
						end
						l_break := False
				when 9 then -- if done
						if l_usize /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | Lu0:
						from
						until
							(l_break)
						loop
							l_break := False
							if l_vsize /= 0 then
								if l_vp[(l_vsize - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_vsize := l_vsize - 1
								l_uexp := l_uexp - 1
							end
						end
						l_break := False
				when 11 then -- if done | if done
						if l_usize > l_prec then
							l_up := l_up + (l_usize - l_prec)
							l_usize := l_prec
						end
						if l_vsize + l_ediff > l_prec then
							l_vp := l_vp + ((l_vsize + l_ediff) - l_prec)
							l_vsize := l_prec - l_ediff
						end
						if (builtin_expect ((l_prec.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___2 := (l_aaf.new ((l_prec.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___2 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_prec.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
						if not (l_ediff >= l_prec) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if not l_tp.is_equal (l_up) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_up, l_usize)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
						end
						l_rsize := l_usize
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 14 then -- else: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 17 -- skip loop
						end
				when 15 then -- loop body:
						l_break := False
						if l_vsize = 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_up, l_usize)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							l_rsize := l_usize
							l_pos := -1 + 22 -- goto done
						end
				when 16 then
						if l_vp[0] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_vp := l_vp + 1
							l_vsize := l_vsize - 1
						end
						l_pos := -1 + 14 -- back to loop condition
				when 17 then -- loop done
						l_break := False
				when 18 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 21 -- skip loop
						end
				when 19 then -- loop body:
						l_break := False
						if l_usize = 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_vp, l_vsize)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							l_rsize := l_vsize
							l_negate := (l_negate).bit_xor ((1))
							l_pos := -1 + 22 -- goto done
						end
				when 20 then
						if l_up[0] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_up := l_up + 1
							l_usize := l_usize - 1
						end
						l_pos := -1 + 18 -- back to loop condition
				when 21 then -- loop done
						l_break := False
						if l_usize > l_ediff then
							if l_ediff = 0 then
								if l_usize > l_vsize then
									l_cmp := (create {P_GMP_STATIC}).gmpn_cmp ((l_up + l_usize) - l_vsize, l_vp, l_vsize)
									if l_cmp >= 0 then
										l_size := l_usize - l_vsize
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											from
											until
												(l_return or l_break)
											loop
												l_break := False;
												(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_up, l_size)
												l_break := True
											end
											l_break := False
											l_break := True
										end
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_sub_n (l_tp + l_size, l_up + l_size, l_vp, l_vsize).do_nothing
										l_rsize := l_usize
									else
										l_size___0 := l_usize - l_vsize
										l_tp[0] := (((-(l_up[0]).to_integer_32).to_natural_32).bit_and ({NATURAL_32} 4_294_967_295))
										l_i := (1).to_integer_32
										from
										until
											not (l_i < l_size___0)
										loop
											l_tp[l_i] := (((l_up[l_i]).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
											l_i := l_i + 1
										end
										(create {P_GMP_STATIC}).gmpn_sub_n (l_tp + l_size___0, l_vp, l_up + l_size___0, l_vsize).do_nothing;
										(create {P_GMP_STATIC}).gmpn_sub_1 (l_tp + l_size___0, (l_tp + l_size___0), l_vsize, (1).to_natural_32).do_nothing
										l_negate := (l_negate).bit_xor ((1))
										l_rsize := l_usize
									end
								elseif l_usize < l_vsize then
									l_cmp___0 := (create {P_GMP_STATIC}).gmpn_cmp (l_up, (l_vp + l_vsize) - l_usize, l_usize)
									if l_cmp___0 > 0 then
										l_size___1 := l_vsize - l_usize
										l_tp[0] := (((-(l_vp[0]).to_integer_32).to_natural_32).bit_and ({NATURAL_32} 4_294_967_295))
										l_i___0 := (1).to_integer_32
										from
										until
											not (l_i___0 < l_size___1)
										loop
											l_tp[l_i___0] := (((l_vp[l_i___0]).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
											l_i___0 := l_i___0 + 1
										end
										(create {P_GMP_STATIC}).gmpn_sub_n (l_tp + l_size___1, l_up, l_vp + l_size___1, l_usize).do_nothing;
										(create {P_GMP_STATIC}).gmpn_sub_1 (l_tp + l_size___1, (l_tp + l_size___1), l_usize, (1).to_natural_32).do_nothing
										l_rsize := l_vsize
									else
										l_size___2 := l_vsize - l_usize
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											from
											until
												(l_return or l_break)
											loop
												l_break := False;
												(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_vp, l_size___2)
												l_break := True
											end
											l_break := False
											l_break := True
										end
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_sub_n (l_tp + l_size___2, l_vp + l_size___2, l_up, l_usize).do_nothing
										l_negate := (l_negate).bit_xor ((1))
										l_rsize := l_vsize
									end
								else
									l_cmp___1 := (create {P_GMP_STATIC}).gmpn_cmp (l_up, (l_vp + l_vsize) - l_usize, l_usize)
									if l_cmp___1 > 0 then
										(create {P_GMP_STATIC}).gmpn_sub_n (l_tp, l_up, l_vp, l_usize).do_nothing
										l_rsize := l_usize
									else
										(create {P_GMP_STATIC}).gmpn_sub_n (l_tp, l_vp, l_up, l_usize).do_nothing
										l_negate := (l_negate).bit_xor ((1))
										l_rsize := l_usize
									end
								end
							elseif l_vsize + l_ediff <= l_usize then
								l_size___3 := (l_usize - l_ediff) - l_vsize
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_up, l_size___3)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_sub (l_tp + l_size___3, l_up + l_size___3, l_usize - l_size___3, l_vp, l_vsize).do_nothing
								l_rsize := l_usize
							else
								l_size___4 := (l_vsize + l_ediff) - l_usize
								l_tp[0] := (((-(l_vp[0]).to_integer_32).to_natural_32).bit_and ({NATURAL_32} 4_294_967_295))
								l_i___1 := (1).to_integer_32
								from
								until
									not (l_i___1 < l_size___4)
								loop
									l_tp[l_i___1] := (((l_vp[l_i___1]).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
									l_i___1 := l_i___1 + 1
								end
								(create {P_GMP_STATIC}).gmpn_sub (l_tp + l_size___4, l_up, l_usize, l_vp + l_size___4, l_usize - l_ediff).do_nothing;
								(create {P_GMP_STATIC}).gmpn_sub_1 (l_tp + l_size___4, (l_tp + l_size___4), l_usize, (1).to_natural_32).do_nothing
								l_rsize := l_vsize + l_ediff
							end
						else
							l_size___5 := (l_vsize + l_ediff) - l_usize
							l_tp[0] := (((-(l_vp[0]).to_integer_32).to_natural_32).bit_and ({NATURAL_32} 4_294_967_295))
							l_i___2 := (1).to_integer_32
							from
							until
								not (l_i___2 < l_vsize)
							loop
								l_tp[l_i___2] := (((l_vp[l_i___2]).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
								l_i___2 := l_i___2 + 1
							end
							l_i___2 := l_vsize
							from
							until
								not (l_i___2 < l_size___5)
							loop
								l_tp[l_i___2] := {NATURAL_32} 4_294_967_295
								l_i___2 := l_i___2 + 1
							end
							(create {P_GMP_STATIC}).gmpn_sub_1 (l_tp + l_size___5, l_up, l_usize, (1).to_natural_32).do_nothing
							l_rsize := l_size___5 + l_usize
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if l_rsize /= 0 then
								if l_tp[(l_rsize - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_rsize := l_rsize - 1
								l_uexp := l_uexp - 1
							end
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_tp, l_rsize)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
				when 22 then -- done:
						if l_negate.to_boolean then
							a_r.item.mp_size := (-l_rsize).to_integer_32
						else
							a_r.item.mp_size := l_rsize.to_integer_32
						end
						a_r.item.mp_exp := l_uexp
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
				when 23 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
