class
	PD_GMP_RANDSTATE_STRUCT_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- routine addresses

	randget_lc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_rp: CE_POINTER [NATURAL_32]; a_nbits: NATURAL_32)
				do
					a_rstate.item.randget_lc (a_rp, a_nbits)
				end)
		end

	randseed_lc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_seed: CE_POINTER [PD_MPZ_STRUCT])
				do
					a_rstate.item.randseed_lc (a_seed)
				end)
		end

	randclear_lc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT])
				do
					a_rstate.item.randclear_lc
				end)
		end

	randiset_lc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dst, a_src: CE_POINTER [PD_GMP_RANDSTATE_STRUCT])
				do
					a_dst.item.randiset_lc (a_src)
				end)
		end

	gmp_randget_mt_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_dest: CE_POINTER [NATURAL_32]; a_nbits: NATURAL_32)
				do
					a_rstate.item.gmp_randget_mt (a_dest, a_nbits)
				end)
		end

	gmp_randclear_mt_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT])
				do
					a_rstate.item.gmp_randclear_mt
				end)
		end

	gmp_randiset_mt_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_dst, a_src: CE_POINTER [PD_GMP_RANDSTATE_STRUCT])
				do
					a_dst.item.gmp_randiset_mt (a_src)
				end)
		end

	randseed_mt_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_seed: CE_POINTER [PD_MPZ_STRUCT])
				do
					a_rstate.item.randseed_mt (a_seed)
				end)
		end

end
