class
	PD_GMP_SNPRINTF_T_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- routine addresses

	gmp_snprintf_format_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_d: CE_POINTER [PD_GMP_SNPRINTF_T]; a_fmt: CE_POINTER [INTEGER_8]; a_orig_ap: CE_VA_LIST): INTEGER_32
				do
					Result := a_d.item.gmp_snprintf_format (a_fmt, a_orig_ap)
				end)
		end

	gmp_snprintf_memory_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_d: CE_POINTER [PD_GMP_SNPRINTF_T]; a_str: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): INTEGER_32
				do
					Result := a_d.item.gmp_snprintf_memory (a_str, a_len)
				end)
		end

	gmp_snprintf_reps_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_d: CE_POINTER [PD_GMP_SNPRINTF_T]; a_c, a_reps: INTEGER_32): INTEGER_32
				do
					Result := a_d.item.gmp_snprintf_reps (a_c, a_reps)
				end)
		end

	gmp_snprintf_final_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_d: CE_POINTER [PD_GMP_SNPRINTF_T]): INTEGER_32
				do
					Result := a_d.item.gmp_snprintf_final
				end)
		end

end
