class
	P_BIGAUSS_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_bivariate_gaussian_pdf (a_x, a_y, a_sigma_x, a_sigma_y, a_rho: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_v: REAL_64
			l_c___1: REAL_64
			l_p: REAL_64
			l_tmp: REAL_64
		do
			l_u := a_x / a_sigma_x
			l_v := a_y / a_sigma_y
			l_c___1 := (1).to_double - a_rho * a_rho
			l_tmp := sqrt (l_c___1)
			l_p := ((1).to_double / (((((2).to_double * 3.14159265358979323846) * a_sigma_x) * a_sigma_y) * l_tmp)) * (exp (-((l_u * l_u - (((2).to_double * a_rho) * l_u) * l_v) + l_v * l_v) / ((2).to_double * l_c___1)))
			Result := l_p
		end

end
