class
	P_EXPONENTIALINV_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_cdf_exponential_Pinv (a_P___2, a_mu: REAL_64): REAL_64
		local
			l_x: REAL_64
		do
			l_x := -a_mu * (log1p (-a_P___2))
			Result := l_x
		end

	gsl_cdf_exponential_Qinv (a_Q___1, a_mu: REAL_64): REAL_64
		local
			l_x: REAL_64
		do
			l_x := -a_mu * (log (a_Q___1))
			Result := l_x
		end

end
