class
	P_FISHMAN20_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	m___1: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (2_147_483_647).to_integer_32
		end

	a___2: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (48_271).to_integer_32
		end

	q___1: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (44_488).to_integer_32
		end

	r___1: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (3_399).to_integer_32
		end

	ran_type___7: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("fishman20"), {NATURAL_32} 2_147_483_646, {NATURAL_32} 1, (create {PD_RAN_STATE_T}.make).structure_size.to_natural_32, ran_set___7_address, ran_get___7_address, ran_get_double___7_address])
				>>)
		end

	gsl_rng_fishman20: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ran_type___7.item
		end

feature {ANY} -- public routines

	ran_get___7 (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
			l_x: NATURAL_32
			l_h: INTEGER_32
			l_t: INTEGER_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			l_x := l_state.item.x
			l_h := (l_x // q___1.item.to_natural_32).to_integer_32
			l_t := (a___2.item.to_natural_32 * (l_x - (l_h * q___1.item).to_natural_32) - (l_h * r___1.item).to_natural_32).to_integer_32
			if l_t < 0 then
				l_state.item.x := (l_t + m___1.item).to_natural_32
			else
				l_state.item.x := l_t.to_natural_32
			end
			Result := (l_state.item.x)
		end

	ran_get_double___7 (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			Result := ((ran_get___7 (create {CE_VOID_POINTER}.make_cast (l_state))).to_real_64 / 2147483647.0)
		end

	ran_set___7 (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			if l_s \\ m___1.item.to_natural_32 = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := (l_s).bit_and (m___1.item.to_natural_32)
		end

feature {ANY} -- routine addresses

	ran_get___7_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_get___7)
		end

	ran_get_double___7_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_get_double___7)
		end

	ran_set___7_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_set___7)
		end

end
