class
	P_GEAR2_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	gear2_type: CE_STATIC [CE_ARRAY [PD_GSL_ODEIV_STEP_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_ODEIV_STEP_TYPE]}.make_initialized (<<
					create {PD_GSL_ODEIV_STEP_TYPE}.make_initialized ([ce_string ("gear2"), 1, 0, gear2_alloc_address, gear2_apply_address, gear2_reset_address, gear2_order_address, gear2_free_address])
				>>)
		end

	gsl_odeiv_step_gear2: CE_STATIC [CE_POINTER [PD_GSL_ODEIV_STEP_TYPE]]
		once ("PROCESS")
			Result.item := gear2_type.item
		end

feature {ANY} -- public routines

	gear2_alloc (a_dim: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_GEAR2_STATE_T]
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_GEAR2_STATE_T]}.make_cast ((malloc ((create {PD_GEAR2_STATE_T}.make).structure_size.to_natural_32)))
			if l_state.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for gear2_state"), ce_string ("gear2.c"), 56, 8)
					Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.yim1 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.yim1).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for yim1"), ce_string ("gear2.c"), 64, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.k := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.yim1))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for k"), ce_string ("gear2.c"), 73, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.y0 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.yim1))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for y0"), ce_string ("gear2.c"), 83, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.y0_orig := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0_orig).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.yim1))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for y0_orig"), ce_string ("gear2.c"), 94, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.y_onestep := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y_onestep).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0_orig))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.yim1))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for y0_orig"), ce_string ("gear2.c"), 106, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.primed := 0
				l_state.item.primer := (create {P_STEP_STATIC}).gsl_odeiv_step_alloc ((create {P_RK4IMP_STATIC}).gsl_odeiv_step_rk4imp.item, a_dim)
				if (l_state.item.primer).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y_onestep))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0_orig))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.yim1))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for primer"), ce_string ("gear2.c"), 120, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.last_h := 0.0
				Result := (create {CE_VOID_POINTER}.make_cast (l_state))
			end
		end

	gear2_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t, a_h: REAL_64; a_y, a_yerr, a_dydt_in, a_dydt_out: CE_POINTER [REAL_64]; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_state: CE_POINTER [PD_GEAR2_STATE_T]
			l_status: INTEGER_32
			l_k: CE_POINTER [REAL_64]
			l_y0___0: CE_POINTER [REAL_64]
			l_y0_orig: CE_POINTER [REAL_64]
			l_yim1: CE_POINTER [REAL_64]
			l_y_onestep: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_i: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state := create {CE_CLASS_POINTER [PD_GEAR2_STATE_T]}.make_cast (a_vstate)
					l_state.item.stutter := 0
					if l_state.item.primed /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if a_t /= l_state.item.t_primed then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if a_h = l_state.item.last_h then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						memcpy (create {CE_VOID_POINTER}.make_cast (l_state.item.yim1), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
						l_status := (l_state.item.primer).item.gsl_odeiv_step_apply (a_t, a_h, a_y, a_yerr, a_dydt_in, a_dydt_out, a_sys)
						l_state.item.primed := 1
						l_state.item.t_primed := a_t
						l_state.item.last_h := a_h
						l_state.item.stutter := 1
						Result := l_status
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_k := l_state.item.k
						l_y0___0 := l_state.item.y0
						l_y0_orig := l_state.item.y0_orig
						l_yim1 := l_state.item.yim1
						l_y_onestep := l_state.item.y_onestep
						memcpy (create {CE_VOID_POINTER}.make_cast (l_y0___0), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
						memcpy (create {CE_VOID_POINTER}.make_cast (l_y0_orig), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
						if not a_dydt_out.is_void then
							memcpy (create {CE_VOID_POINTER}.make_cast (l_k), create {CE_VOID_POINTER}.make_cast (a_dydt_out), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
						end
						memcpy (create {CE_VOID_POINTER}.make_cast (l_y_onestep), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
						l_s := l_state.item.gear2_step (l_y_onestep, a_h, a_t, a_dim, a_sys)
						if l_s /= 0 then
							Result := l_s
							l_return := True
						end
						if not l_return then
							l_s := l_state.item.gear2_step (a_y, a_h / 2.0, a_t, a_dim, a_sys)
							if l_s /= 0 then
								memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
								Result := l_s
								l_return := True
							end
						end
						if not l_return then
							memcpy (create {CE_VOID_POINTER}.make_cast (l_y0___0), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
							l_s := l_state.item.gear2_step (a_y, a_h / 2.0, a_t + a_h / 2.0, a_dim, a_sys)
							if l_s /= 0 then
								memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
								Result := l_s
								l_return := True
							end
						end
						if not l_return and then (not a_dydt_out.is_void) then
							l_s := (a_sys.item.function).integer_32_item ([a_t + a_h, a_y, a_dydt_out, a_sys.item.params])
							if l_s /= 0 then
								memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
								Result := l_s
								l_return := True
							end
						end
						if not l_return then
							l_i := (0).to_natural_32
							from
							until
								not (l_i < a_dim)
							loop
								a_yerr[l_i.to_integer_32] := 4.0 * (a_y[l_i.to_integer_32] - l_y_onestep[l_i.to_integer_32])
								l_yim1[l_i.to_integer_32] := l_y0___0[l_i.to_integer_32]
								l_i := l_i + 1
							end
							l_state.item.last_h := a_h
							Result := 0
						end
				when 10 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gear2_reset (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_GEAR2_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_GEAR2_STATE_T]}.make_cast (a_vstate)
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.yim1), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.k), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.y0), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			l_state.item.primed := 0
			l_state.item.last_h := 0.0
			Result := 0
		end

	gear2_order (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_GEAR2_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_GEAR2_STATE_T]}.make_cast (a_vstate)
			l_state := create {CE_CLASS_POINTER [PD_GEAR2_STATE_T]}.make_shared (default_pointer)
			Result := {NATURAL_32} 3
		end

	gear2_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_GEAR2_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_GEAR2_STATE_T]}.make_cast (a_vstate)
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.yim1))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.k))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0_orig))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.y_onestep));
			(create {P_STEP_STATIC}).gsl_odeiv_step_free (l_state.item.primer)
			free (create {CE_VOID_POINTER}.make_cast (l_state))
		end

feature {ANY} -- routine addresses

	gear2_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gear2_alloc)
		end

	gear2_apply_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gear2_apply)
		end

	gear2_reset_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gear2_reset)
		end

	gear2_order_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gear2_order)
		end

	gear2_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gear2_free)
		end

end
