class
	P_GSL_GSL_INTERP_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_interp_bsearch (a_x_array: CE_POINTER [REAL_64]; a_x: REAL_64; a_index_lo, a_index_hi: NATURAL_32): NATURAL_32
		local
			l_ilo: NATURAL_32
			l_ihi: NATURAL_32
			l_i: NATURAL_32
		do
			l_ilo := a_index_lo
			l_ihi := a_index_hi
			from
			until
				not (l_ihi > l_ilo + {NATURAL_32} 1)
			loop
				l_i := (l_ihi + l_ilo) // {NATURAL_32} 2
				if a_x_array[l_i.to_integer_32] > a_x then
					l_ihi := l_i
				else
					l_ilo := l_i
				end
			end
			Result := l_ilo
		end

end
