class
	P_KNUTHRAN2_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	ran_type___1: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("knuthran2"), {NATURAL_32} 2_147_483_646, {NATURAL_32} 0, (create {PD_RAN_STATE_T_26__}.make).structure_size.to_natural_32, ran_set___1_address, ran_get___1_address, ran_get_double___1_address])
				>>)
		end

	gsl_rng_knuthran2: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ran_type___1.item
		end

feature {ANY} -- public routines

	ran_get___1 (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN_STATE_T_26__]
			l_xtmp: NATURAL_32
			l_tmp: NATURAL_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T_26__]}.make_cast (a_vstate)
			l_xtmp := l_state.item.x1
			l_tmp := (create {P_SCHRAGE_STATIC}).schrage_mult ({NATURAL_32} 271_828_183, l_state.item.x1, {NATURAL_32} 2_147_483_647, {NATURAL_32} 46_341)
			l_state.item.x1 := l_tmp + ((create {P_SCHRAGE_STATIC}).schrage_mult ({NATURAL_32} 1_833_324_378, l_state.item.x0, {NATURAL_32} 2_147_483_647, {NATURAL_32} 46_341))
			if l_state.item.x1 >= {NATURAL_32} 2_147_483_647 then
				l_state.item.x1 := l_state.item.x1 - ({NATURAL_32} 2_147_483_647)
			end
			l_state.item.x0 := l_xtmp
			Result := (l_state.item.x1)
		end

	ran_get_double___1 (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RAN_STATE_T_26__]
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T_26__]}.make_cast (a_vstate)
			Result := ((ran_get___1 (create {CE_VOID_POINTER}.make_cast (l_state))).to_real_64 / 2147483647.0)
		end

	ran_set___1 (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RAN_STATE_T_26__]
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T_26__]}.make_cast (a_vstate)
			if l_s \\ {NATURAL_32} 2_147_483_647 = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x0 := l_s \\ {NATURAL_32} 2_147_483_647
			l_state.item.x1 := l_s \\ {NATURAL_32} 2_147_483_647
		end

feature {ANY} -- routine addresses

	ran_get___1_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_get___1)
		end

	ran_get_double___1_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_get_double___1)
		end

	ran_set___1_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_set___1)
		end

end
