class
	P_LECUYER21_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	ran_type___4: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("lecuyer21"), {NATURAL_32} 2_147_483_398, {NATURAL_32} 1, (create {PD_RAN_STATE_T}.make).structure_size.to_natural_32, ran_set___4_address, ran_get___4_address, ran_get_double___4_address])
				>>)
		end

	gsl_rng_lecuyer21: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ran_type___4.item
		end

feature {ANY} -- public routines

	ran_get___4 (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
			l_y: INTEGER_32
			l_r___3: INTEGER_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			l_y := (l_state.item.x).to_integer_32
			l_r___3 := 3_791 * (l_y // 52_774)
			l_y := 40_692 * (l_y \\ 52_774) - l_r___3
			if l_y < 0 then
				l_y := (l_y.to_natural_32 + {NATURAL_32} 2_147_483_399).to_integer_32
			end
			l_state.item.x := l_y.to_natural_32
			Result := (l_state.item.x)
		end

	ran_get_double___4 (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			Result := ((ran_get___4 (create {CE_VOID_POINTER}.make_cast (l_state))).to_real_64 / 2147483399.0)
		end

	ran_set___4 (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			if l_s \\ {NATURAL_32} 2_147_483_399 = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := l_s \\ {NATURAL_32} 2_147_483_399
		end

feature {ANY} -- routine addresses

	ran_get___4_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_get___4)
		end

	ran_get_double___4_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_get_double___4)
		end

	ran_set___4_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_set___4)
		end

end
