class
	P_PASCAL_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_ran_pascal_pdf (a_k: NATURAL_32; a_p: REAL_64; a_n: NATURAL_32): REAL_64
		local
			l_P___2: REAL_64
		do
			l_P___2 := ((create {P_NBINOMIAL_STATIC}).gsl_ran_negative_binomial_pdf (a_k, a_p, a_n.to_real_64))
			Result := l_P___2
		end

	gsl_cdf_pascal_P (a_k: NATURAL_32; a_p: REAL_64; a_n: NATURAL_32): REAL_64
		local
			l_P___2: REAL_64
		do
			l_P___2 := ((create {P_NBINOMIAL_STATIC}).gsl_cdf_negative_binomial_P (a_k, a_p, a_n.to_real_64))
			Result := l_P___2
		end

	gsl_cdf_pascal_Q (a_k: NATURAL_32; a_p: REAL_64; a_n: NATURAL_32): REAL_64
		local
			l_Q___1: REAL_64
		do
			l_Q___1 := ((create {P_NBINOMIAL_STATIC}).gsl_cdf_negative_binomial_Q (a_k, a_p, a_n.to_real_64))
			Result := l_Q___1
		end

end
