class
	P_RNG_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC

feature {ANY} -- public routines

	gsl_rng_alloc (a_T: CE_POINTER [PD_GSL_RNG_TYPE]): CE_POINTER [PD_GSL_RNG]
		local
			l_r___3: CE_POINTER [PD_GSL_RNG]
			l_return, l_break: BOOLEAN
		do
			l_r___3 := create {CE_CLASS_POINTER [PD_GSL_RNG]}.make_cast ((malloc ((create {PD_GSL_RNG}.make).structure_size.to_natural_32)))
			if l_r___3.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for rng struct"), ce_string ("rng.c"), 36, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_RNG]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_r___3.item.state := malloc (a_T.item.size)
				if (l_r___3.item.state).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_r___3))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for rng state"), ce_string ("rng.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_RNG]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_r___3.item.type := a_T
				l_r___3.item.gsl_rng_set ((create {P_MT_STATIC}).gsl_rng_default_seed.item)
				Result := l_r___3
			end
		end

	gsl_rng_clone (a_q___3: CE_POINTER [PD_GSL_RNG]): CE_POINTER [PD_GSL_RNG]
		local
			l_r___3: CE_POINTER [PD_GSL_RNG]
			l_return, l_break: BOOLEAN
		do
			l_r___3 := create {CE_CLASS_POINTER [PD_GSL_RNG]}.make_cast ((malloc ((create {PD_GSL_RNG}.make).structure_size.to_natural_32)))
			if l_r___3.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for rng struct"), ce_string ("rng.c"), 77, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_RNG]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_r___3.item.state := malloc ((a_q___3.item.type).item.size)
				if (l_r___3.item.state).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_r___3))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for rng state"), ce_string ("rng.c"), 87, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_RNG]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_r___3.item.type := a_q___3.item.type
				memcpy (l_r___3.item.state, a_q___3.item.state, (a_q___3.item.type).item.size).do_nothing
				Result := l_r___3
			end
		end

	gsl_rng_free (a_r___3: CE_POINTER [PD_GSL_RNG])
		local
			l_return: BOOLEAN
		do
			if a_r___3.is_void then
				l_return := True
			end
			if not l_return then
				free (a_r___3.item.state)
				free (create {CE_VOID_POINTER}.make_cast (a_r___3))
			end
		end

end
