class
	P_SORTIND_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	downheap (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [ANY]; a_size, a_N, a_k: NATURAL_32; a_compare: CE_ROUTINE)
		require
			not a_p.is_void
		local
			l_k: NATURAL_32
			l_pki: NATURAL_32
			l_j: NATURAL_32
			l_break: BOOLEAN
		do
			l_k := a_k
			l_pki := a_p[l_k.to_integer_32]
			from
			until
				not (not (l_break) and then (l_k <= a_N // {NATURAL_32} 2))
			loop
				l_break := False
				l_j := {NATURAL_32} 2 * l_k
				if l_j < a_N then
					if (a_compare.integer_32_item ([create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (a_data) + (a_size * a_p[l_j.to_integer_32]).to_integer_32)), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (a_data) + (a_size * a_p[(l_j + {NATURAL_32} 1).to_integer_32]).to_integer_32))])) < 0 then
						l_j := l_j + 1
					end
				end
				if (a_compare.integer_32_item ([create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (a_data) + (a_size * l_pki).to_integer_32)), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (a_data) + (a_size * a_p[l_j.to_integer_32]).to_integer_32))])) >= 0 then
					l_break := True
				end
				if not (l_break) then
					a_p[l_k.to_integer_32] := a_p[l_j.to_integer_32]
					l_k := l_j
				end
			end
			l_break := False
			a_p[l_k.to_integer_32] := l_pki
		end

	gsl_heapsort_index (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [ANY]; a_count, a_size: NATURAL_32; a_compare: CE_ROUTINE): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_N: NATURAL_32
			l_tmp: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_count = {NATURAL_32} 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_count)
				loop
					a_p[l_i.to_integer_32] := l_i
					l_i := l_i + 1
				end
				l_N := a_count - {NATURAL_32} 1
				l_k := l_N // {NATURAL_32} 2
				l_k := l_k + 1
				from
				until
					(l_break)
				loop
					l_break := False
					l_k := l_k - 1
					downheap (a_p, a_data, a_size, l_N, l_k, a_compare)
					if not (l_k > {NATURAL_32} 0) then
						l_break := True
					end
				end
				l_break := False
				from
				until
					not (l_N > {NATURAL_32} 0)
				loop
					l_tmp := a_p[0]
					a_p[0] := a_p[l_N.to_integer_32]
					a_p[l_N.to_integer_32] := l_tmp
					l_N := l_N - 1
					downheap (a_p, a_data, a_size, l_N, (0).to_natural_32, a_compare)
				end
				Result := 0
			end
		end

end
