class
	P_SROTG_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	cblas_srotg (a_a___5, a_b___0, a_c___1, a_s: CE_POINTER [REAL_32])
		require
			not a_a___5.is_void
			not a_b___0.is_void
			not a_c___1.is_void
			not a_s.is_void
		local
			l_roe: REAL_32
			l_tmp___1: REAL_32
			l_tmp___2: REAL_64
			l_scale: REAL_32
			l_tmp___4: REAL_64
			l_r___3: REAL_32
			l_z: REAL_32
			l_aos: REAL_32
			l_bos: REAL_32
			l_tmp___7: INTEGER_32
			l_tmp___8: REAL_64
			l_tmp___10: REAL_64
		do
			l_tmp___2 := fabs ((a_a___5.item).to_double)
			if l_tmp___2 > (fabs ((a_b___0.item).to_double)) then
				l_tmp___1 := a_a___5.item
			else
				l_tmp___1 := a_b___0.item
			end
			l_roe := l_tmp___1
			l_tmp___4 := fabs ((a_a___5.item).to_double)
			l_scale := (l_tmp___4 + (fabs ((a_b___0.item).to_double))).truncated_to_real
			if l_scale.to_double /= 0.0 then
				l_aos := a_a___5.item / l_scale
				l_bos := a_b___0.item / l_scale
				l_r___3 := (l_scale.to_double * (sqrt ((l_aos * l_aos + l_bos * l_bos).to_double))).truncated_to_real
				if l_roe.to_double >= 0.0 then
					l_tmp___7 := 1
				else
					l_tmp___7 := -1
				end
				l_r___3 := l_tmp___7.to_real * l_r___3
				a_c___1.item := a_a___5.item / l_r___3
				a_s.item := a_b___0.item / l_r___3
				l_z := (1.0).truncated_to_real
				l_tmp___8 := fabs ((a_a___5.item).to_double)
				if l_tmp___8 > (fabs ((a_b___0.item).to_double)) then
					l_z := a_s.item
				end
				l_tmp___10 := fabs ((a_b___0.item).to_double)
				if l_tmp___10 >= (fabs ((a_a___5.item).to_double)) then
					if (a_c___1.item).to_double /= 0.0 then
						l_z := (1.0 / (a_c___1.item).to_double).truncated_to_real
					end
				end
			else
				a_c___1.item := (1.0).truncated_to_real
				a_s.item := (0.0).truncated_to_real
				l_r___3 := (0.0).truncated_to_real
				l_z := (0.0).truncated_to_real
			end
			a_a___5.item := l_r___3
			a_b___0.item := l_z
		end

end
