class
	P_TAUS113_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	taus113_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("taus113"), {NATURAL_32} 4_294_967_295, {NATURAL_32} 0, (create {PD_TAUS113_STATE_T}.make).structure_size.to_natural_32, taus113_set_address, taus113_get_address, taus113_get_double_address])
				>>)
		end

	gsl_rng_taus113: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := taus113_type.item
		end

feature {ANY} -- public routines

	taus113_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_TAUS113_STATE_T]
			l_b1___0: NATURAL_32
			l_b2: NATURAL_32
			l_b3___3: NATURAL_32
			l_b4___2: NATURAL_32
		do
			l_state := create {CE_CLASS_POINTER [PD_TAUS113_STATE_T]}.make_cast (a_vstate)
			l_b1___0 := (((((((l_state.item.z1).bit_shift_left (({NATURAL_32} 6).to_integer_32))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (l_state.item.z1))).bit_shift_right (({NATURAL_32} 13).to_integer_32)
			l_state.item.z1 := (((((((l_state.item.z1).bit_and ({NATURAL_32} 4_294_967_294))).bit_shift_left (({NATURAL_32} 18).to_integer_32))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (l_b1___0)
			l_b2 := (((((((l_state.item.z2).bit_shift_left (({NATURAL_32} 2).to_integer_32))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (l_state.item.z2))).bit_shift_right (({NATURAL_32} 27).to_integer_32)
			l_state.item.z2 := (((((((l_state.item.z2).bit_and ({NATURAL_32} 4_294_967_288))).bit_shift_left (({NATURAL_32} 2).to_integer_32))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (l_b2)
			l_b3___3 := (((((((l_state.item.z3).bit_shift_left (({NATURAL_32} 13).to_integer_32))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (l_state.item.z3))).bit_shift_right (({NATURAL_32} 21).to_integer_32)
			l_state.item.z3 := (((((((l_state.item.z3).bit_and ({NATURAL_32} 4_294_967_280))).bit_shift_left (({NATURAL_32} 7).to_integer_32))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (l_b3___3)
			l_b4___2 := (((((((l_state.item.z4).bit_shift_left (({NATURAL_32} 3).to_integer_32))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (l_state.item.z4))).bit_shift_right (({NATURAL_32} 12).to_integer_32)
			l_state.item.z4 := (((((((l_state.item.z4).bit_and ({NATURAL_32} 4_294_967_168))).bit_shift_left (({NATURAL_32} 13).to_integer_32))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (l_b4___2)
			Result := ((((((l_state.item.z1).bit_xor (l_state.item.z2))).bit_xor (l_state.item.z3))).bit_xor (l_state.item.z4))
		end

	taus113_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((taus113_get (a_vstate)).to_real_64 / 4294967296.0)
		end

	taus113_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_TAUS113_STATE_T]
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_TAUS113_STATE_T]}.make_cast (a_vstate)
			if not l_s.to_boolean then
				l_s := {NATURAL_32} 1
			end
			l_state.item.z1 := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			if l_state.item.z1 < {NATURAL_32} 2 then
				l_state.item.z1 := l_state.item.z1 + ({NATURAL_32} 2)
			end
			l_state.item.z2 := ({NATURAL_32} 69_069 * l_state.item.z1).bit_and ({NATURAL_32} 4_294_967_295)
			if l_state.item.z2 < {NATURAL_32} 8 then
				l_state.item.z2 := l_state.item.z2 + ({NATURAL_32} 8)
			end
			l_state.item.z3 := ({NATURAL_32} 69_069 * l_state.item.z2).bit_and ({NATURAL_32} 4_294_967_295)
			if l_state.item.z3 < {NATURAL_32} 16 then
				l_state.item.z3 := l_state.item.z3 + ({NATURAL_32} 16)
			end
			l_state.item.z4 := ({NATURAL_32} 69_069 * l_state.item.z3).bit_and ({NATURAL_32} 4_294_967_295)
			if l_state.item.z4 < {NATURAL_32} 128 then
				l_state.item.z4 := l_state.item.z4 + ({NATURAL_32} 128)
			end
			taus113_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
		end

feature {ANY} -- routine addresses

	taus113_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent taus113_get)
		end

	taus113_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent taus113_get_double)
		end

	taus113_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent taus113_set)
		end

end
