class
	P_VECTOR_BFGS2_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public attributes

	vector_bfgs2_type: CE_STATIC [CE_ARRAY [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE]}.make_initialized (<<
					create {PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE}.make_initialized ([ce_string ("vector_bfgs2"), (create {PD_VECTOR_BFGS2_STATE_T}.make).structure_size.to_natural_32, vector_bfgs2_alloc_address, (create {PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT_STATIC}).vector_bfgs2_set_address, vector_bfgs2_iterate_address, vector_bfgs2_restart_address, vector_bfgs2_free_address])
				>>)
		end

	gsl_multimin_fdfminimizer_vector_bfgs2: CE_STATIC [CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE]]
		once ("PROCESS")
			Result.item := vector_bfgs2_type.item
		end

feature {ANY} -- public routines

	vector_bfgs2_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_VECTOR_BFGS2_STATE_T]
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_VECTOR_BFGS2_STATE_T]}.make_cast (a_vstate)
			l_state.item.p := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
			if (l_state.item.p).is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for p"), ce_string ("vector_bfgs2.c"), 73, 8)
					Result := 8
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.x0 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_state.item.x0).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.p)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for g0"), ce_string ("vector_bfgs2.c"), 81, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.g0 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_state.item.g0).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x0);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.p)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for g0"), ce_string ("vector_bfgs2.c"), 90, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.dx0 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_state.item.dx0).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.g0);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x0);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.p)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for g0"), ce_string ("vector_bfgs2.c"), 100, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.dg0 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_state.item.dg0).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.dx0);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.g0);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x0);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.p)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for g0"), ce_string ("vector_bfgs2.c"), 111, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.x_alpha := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_state.item.x_alpha).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.dg0);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.dx0);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.g0);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x0);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.p)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for g0"), ce_string ("vector_bfgs2.c"), 123, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.g_alpha := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_state.item.g_alpha).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x_alpha);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.dg0);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.dx0);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.g0);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x0);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.p)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for g0"), ce_string ("vector_bfgs2.c"), 136, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	vector_bfgs2_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_VECTOR_BFGS2_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_VECTOR_BFGS2_STATE_T]}.make_cast (a_vstate);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x_alpha);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.g_alpha);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.dg0);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.dx0);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.g0);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x0);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.p)
		end

	vector_bfgs2_restart (a_vstate: CE_POINTER [ANY]): INTEGER_32
		local
			l_state: CE_POINTER [PD_VECTOR_BFGS2_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_VECTOR_BFGS2_STATE_T]}.make_cast (a_vstate)
			l_state.item.iter := 0
			Result := 0
		end

	vector_bfgs2_iterate (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_gradient, a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		require
			not a_f.is_void
		local
			l_state: CE_POINTER [PD_VECTOR_BFGS2_STATE_T]
			l_alpha: CE_ARRAY [REAL_64]
			l_alpha1: REAL_64
			l_x0: CE_POINTER [PD_GSL_VECTOR]
			l_g0: CE_POINTER [PD_GSL_VECTOR]
			l_p: CE_POINTER [PD_GSL_VECTOR]
			l_g0norm: REAL_64
			l_pnorm: REAL_64
			l_delta_f: REAL_64
			l_pg: CE_ARRAY [REAL_64]
			l_dir: REAL_64
			l_status: INTEGER_32
			l_f0: REAL_64
			l_del: REAL_64
			l_dx0: CE_POINTER [PD_GSL_VECTOR]
			l_dg0: CE_POINTER [PD_GSL_VECTOR]
			l_dxg: CE_ARRAY [REAL_64]
			l_dgg: CE_ARRAY [REAL_64]
			l_dxdg: CE_ARRAY [REAL_64]
			l_dgnorm: REAL_64
			l_A___0: REAL_64
			l_B: REAL_64
			l_return: BOOLEAN
		do
			create {CE_REAL_64_ARRAY} l_alpha.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_pg.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_dxg.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_dgg.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_dxdg.make (<<1>>)

			l_state := create {CE_CLASS_POINTER [PD_VECTOR_BFGS2_STATE_T]}.make_cast (a_vstate)
			l_alpha.item := 0.0
			l_x0 := l_state.item.x0
			l_g0 := l_state.item.g0
			l_p := l_state.item.p
			l_g0norm := l_state.item.g0norm
			l_pnorm := l_state.item.pnorm
			l_delta_f := l_state.item.delta_f
			l_f0 := a_f.item
			if l_pnorm = 0.0 then
				a_dx.item.gsl_vector_set_zero
				Result := 27
				l_return := True
			elseif l_g0norm = 0.0 then
				a_dx.item.gsl_vector_set_zero
				Result := 27
				l_return := True
			elseif l_state.item.fp0 = (0).to_double then
				a_dx.item.gsl_vector_set_zero
				Result := 27
				l_return := True
			end
			if not l_return then
				if l_delta_f < (0).to_double then
					l_del := ((create {P_GSL_GSL_MINMAX_STATIC}).GSL_MAX_DBL (-l_delta_f, ((10).to_double * 2.2204460492503131e-16) * (fabs (l_f0))))
					l_alpha1 := (create {P_GSL_GSL_MINMAX_STATIC}).GSL_MIN_DBL (1.0, (2.0 * l_del) / -l_state.item.fp0)
				else
					l_alpha1 := fabs (l_state.item.step)
				end
				l_status := (create {CE_CLASS_POINTER [PD_GSL_FUNCTION_FDF_STRUCT]}.make_shared (l_state.c_pointer + (create {PD_VECTOR_BFGS2_STATE_T}.make).offset_of ("wrap") + (create {PD_WRAPPER_T}.make).offset_of ("fdf_linear"))).item.minimize___2 (l_state.item.rho, l_state.item.sigma, l_state.item.tau1, l_state.item.tau2, l_state.item.tau3, l_state.item.order, l_alpha1, l_alpha)
				if l_status /= 0 then
					Result := l_status
					l_return := True
				end
			end
			if not l_return then
				(create {CE_CLASS_POINTER [PD_WRAPPER_T]}.make_shared (l_state.c_pointer + (create {PD_VECTOR_BFGS2_STATE_T}.make).offset_of ("wrap"))).item.update_position (l_alpha.item, a_x, a_f, a_gradient)
				l_state.item.delta_f := a_f.item - l_f0
				l_dx0 := l_state.item.dx0
				l_dg0 := l_state.item.dg0
				l_dx0.item.gsl_vector_memcpy (a_x).do_nothing
				l_x0.item.gsl_blas_daxpy (-1.0, l_dx0).do_nothing
				a_dx.item.gsl_vector_memcpy (l_dx0).do_nothing
				l_dg0.item.gsl_vector_memcpy (a_gradient).do_nothing
				l_g0.item.gsl_blas_daxpy (-1.0, l_dg0).do_nothing
				l_dx0.item.gsl_blas_ddot (a_gradient, l_dxg).do_nothing
				l_dg0.item.gsl_blas_ddot (a_gradient, l_dgg).do_nothing
				l_dx0.item.gsl_blas_ddot (l_dg0, l_dxdg).do_nothing
				l_dgnorm := l_dg0.item.gsl_blas_dnrm2
				if l_dxdg.item /= (0).to_double then
					l_B := l_dxg.item / l_dxdg.item
					l_A___0 := -(1.0 + (l_dgnorm * l_dgnorm) / l_dxdg.item) * l_B + l_dgg.item / l_dxdg.item
				else
					l_B := (0).to_double
					l_A___0 := (0).to_double
				end
				l_p.item.gsl_vector_memcpy (a_gradient).do_nothing
				l_dx0.item.gsl_blas_daxpy (-l_A___0, l_p).do_nothing
				l_dg0.item.gsl_blas_daxpy (-l_B, l_p).do_nothing
				l_g0.item.gsl_vector_memcpy (a_gradient).do_nothing
				l_x0.item.gsl_vector_memcpy (a_x).do_nothing
				l_state.item.g0norm := l_g0.item.gsl_blas_dnrm2
				l_state.item.pnorm := l_p.item.gsl_blas_dnrm2
				l_p.item.gsl_blas_ddot (a_gradient, l_pg).do_nothing
				if l_pg.item >= 0.0 then
					l_dir := -1.0
				else
					l_dir := 1.0
				end
				l_p.item.gsl_blas_dscal (l_dir / l_state.item.pnorm)
				l_state.item.pnorm := l_p.item.gsl_blas_dnrm2
				l_p.item.gsl_blas_ddot (l_g0, create {CE_REAL_64_POINTER}.make_shared (l_state.c_pointer + (create {PD_VECTOR_BFGS2_STATE_T}.make).offset_of ("fp0"))).do_nothing;
				(create {CE_CLASS_POINTER [PD_WRAPPER_T]}.make_shared (l_state.c_pointer + (create {PD_VECTOR_BFGS2_STATE_T}.make).offset_of ("wrap"))).item.change_direction
				Result := 0
			end
		end

feature {ANY} -- routine addresses

	vector_bfgs2_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent vector_bfgs2_alloc)
		end

	vector_bfgs2_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent vector_bfgs2_free)
		end

	vector_bfgs2_restart_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent vector_bfgs2_restart)
		end

	vector_bfgs2_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent vector_bfgs2_iterate)
		end

end
