class
	PD_IL_PARAMS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_FUNCTION_STRUCT]} f.make
		end

feature {ANY} -- fields

	b: REAL_64 assign set_b

	f: CE_POINTER [PD_GSL_FUNCTION_STRUCT] assign set_f

feature {ANY} -- field setters

	set_b (a_b: REAL_64)
		do
			b := a_b
			update_memory_field ("b")
		end

	set_f (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT])
		do
			f := a_f
			update_memory_field ("f")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			b := a_other.b
			f := a_other.f
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				b = a_other.b and
				f.is_equal (a_other.f)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("b"),
					create {CE_STRUCTURE_FIELD}.make ("f")
				>>)
			init_structure_info
		end

end
