class
	S_SYS_STAT_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	stat (a___file: CE_POINTER [INTEGER_8]; a___buf: CE_POINTER [SD_STAT]): INTEGER_32
		require
			not a___file.is_void
			not a___buf.is_void
		do
			Result := c_stat (a___file.c_pointer, a___buf.c_pointer)
		end

	c_stat (a___file: POINTER; a___buf: POINTER): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return stat($a___file, $a___buf);"
		end

	lstat (a___file: CE_POINTER [INTEGER_8]; a___buf: CE_POINTER [SD_STAT]): INTEGER_32
		require
			not a___file.is_void
			not a___buf.is_void
		do
			Result := c_lstat (a___file.c_pointer, a___buf.c_pointer)
		end

	c_lstat (a___file: POINTER; a___buf: POINTER): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return lstat($a___file, $a___buf);"
		end

end
