class
	SD_WIDGETREC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create core.make
		end

feature {ANY} -- fields

	core: SD_COREPART assign set_core

feature {ANY} -- field setters

	set_core (a_core: SD_COREPART)
		do
			core := a_core
			update_memory_field ("core")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			core := a_other.core.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				core.is_equal (a_other.core)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("core")
				>>)
			init_structure_info
		end

end
