class
	SD_XTACTIONSREC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} string.make
			create proc.make
		end

feature {ANY} -- fields

	string: CE_POINTER [INTEGER_8] assign set_string

	proc: CE_ROUTINE assign set_proc

feature {ANY} -- field setters

	set_string (a_string: CE_POINTER [INTEGER_8])
		do
			string := a_string
			update_memory_field ("string")
		end

	set_proc (a_proc: CE_ROUTINE)
		do
			proc := a_proc
			update_memory_field ("proc")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			string := a_other.string
			proc := a_other.proc
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				string.is_equal (a_other.string) and
				proc.is_equal (a_other.proc)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("string"),
					create {CE_STRUCTURE_FIELD}.make ("proc")
				>>)
			init_structure_info
		end

end
