class
	SD_SIGSET_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_32_ARRAY} val.make (<<({NATURAL_32} 1_024 // ({NATURAL_32} 8 * {PLATFORM}.Natural_32_bytes.to_natural_32)).to_integer_32>>)
		end

feature {ANY} -- fields

	val: CE_ARRAY [NATURAL_32]

feature {ANY}

	copy (a_other: like Current)
		do
			val := a_other.val.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				val.is_equal (a_other.val)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("val", <<({NATURAL_32} 1_024 // ({NATURAL_32} 8 * {PLATFORM}.Natural_32_bytes.to_natural_32)).to_integer_32>>)
				>>)
			init_structure_info
		end

end
