class
	P_C_CTYPE_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	c2_isalnum (a_c: INTEGER_32): BOOLEAN
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_c >= 48) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_c <= 57 then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if ((a_c).bit_and (-33)) >= 65 then
							if ((a_c).bit_and (-33)) <= 90 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 4 then
					Result := l_tmp.to_boolean
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	c2_isblank (a_c: INTEGER_32): BOOLEAN
		local
			l_tmp: INTEGER_32
		do
			if a_c = 32 then
				l_tmp := 1
			elseif a_c = 9 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp.to_boolean
		end

	c2_iscntrl (a_c: INTEGER_32): BOOLEAN
		local
			l_tmp: INTEGER_32
		do
			if ((a_c).bit_and (-32)) = 0 then
				l_tmp := 1
			elseif a_c = 127 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp.to_boolean
		end

	c2_isdigit (a_c: INTEGER_32): BOOLEAN
		local
			l_tmp: INTEGER_32
		do
			if a_c >= 48 then
				if a_c <= 57 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp.to_boolean
		end

	c2_islower (a_c: INTEGER_32): BOOLEAN
		local
			l_tmp: INTEGER_32
		do
			if a_c >= 97 then
				if a_c <= 122 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp.to_boolean
		end

	c2_isgraph (a_c: INTEGER_32): BOOLEAN
		local
			l_tmp: INTEGER_32
		do
			if a_c >= 33 then
				if a_c <= 126 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp.to_boolean
		end

	c2_isprint (a_c: INTEGER_32): BOOLEAN
		local
			l_tmp: INTEGER_32
		do
			if a_c >= 32 then
				if a_c <= 126 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp.to_boolean
		end

	c2_ispunct (a_c: INTEGER_32): BOOLEAN
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_c >= 33) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (a_c <= 126) then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if not (a_c >= 48) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if a_c <= 57 then
							l_tmp := 0
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if ((a_c).bit_and (-33)) >= 65 then
							if ((a_c).bit_and (-33)) <= 90 then
								l_tmp := 0
							else
								l_tmp := 1
							end
						else
							l_tmp := 1
						end
				when 6 then -- if done | if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_tmp := 0
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_tmp := 0
				when 10 then
					Result := l_tmp.to_boolean
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	c2_isspace (a_c: INTEGER_32): BOOLEAN
		local
			l_tmp: INTEGER_32
		do
			if a_c = 32 then
				l_tmp := 1
			elseif a_c = 9 then
				l_tmp := 1
			elseif a_c = 10 then
				l_tmp := 1
			elseif a_c = 11 then
				l_tmp := 1
			elseif a_c = 12 then
				l_tmp := 1
			elseif a_c = 13 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp.to_boolean
		end

	c2_isupper (a_c: INTEGER_32): BOOLEAN
		local
			l_tmp: INTEGER_32
		do
			if a_c >= 65 then
				if a_c <= 90 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp.to_boolean
		end

	c2_isxdigit (a_c: INTEGER_32): BOOLEAN
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_c >= 48) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_c <= 57 then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if ((a_c).bit_and (-33)) >= 65 then
							if ((a_c).bit_and (-33)) <= 70 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 4 then
					Result := l_tmp.to_boolean
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	c2_tolower (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_c >= 65 then
				if a_c <= 90 then
					l_tmp := (a_c - 65) + 97
				else
					l_tmp := a_c
				end
			else
				l_tmp := a_c
			end
			Result := l_tmp
		end

	c2_toupper (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_c >= 97 then
				if a_c <= 122 then
					l_tmp := (a_c - 97) + 65
				else
					l_tmp := a_c
				end
			else
				l_tmp := a_c
			end
			Result := l_tmp
		end

end
