class
	P_MAIN_STATIC

inherit
	CE_UTILITIES
	S_LOCALE_STATIC
	S_LIBINTL_STATIC
	S_STRING_STATIC
	S_STDLIB_STATIC
	S_ASSERT_STATIC
	S_STDIO_STATIC
	S_GETOPT_STATIC
	S_GCC_BUILTIN_STATIC
	S_SYS_STAT_STATIC
	S_SIGNAL_STATIC
	S_UNISTD_STATIC
	S_BITS_ERRNO_STATIC
	S_TIME_STATIC

feature {ANY} -- public attributes

	numurls: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	option_data: CE_STATIC [CE_ARRAY [PD_CMDLINE_OPTION]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CMDLINE_OPTION]}.make_initialized (<<
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("accept"), (('A').code).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("accept")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("adjust-extension"), (('E').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("adjustextension")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("append-output"), (('a').code).to_integer_8, {PC_TYPE}.OPT__APPEND_OUTPUT, create {CE_VOID_POINTER}.make_shared (default_pointer), 1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("ask-password"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("askpassword")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("auth-no-challenge"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("authnochallenge")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("background"), (('b').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("background")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("backup-converted"), (('K').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("backupconverted")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("backups"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("backups")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("base"), (('B').code).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("base")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("bind-address"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("bindaddress")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("cacertificate")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("cadirectory")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("cache"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("cache")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("certificate")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("certificatetype")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("checkcertificate")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("clobber"), (0).to_integer_8, {PC_TYPE}.OPT__CLOBBER, create {CE_VOID_POINTER}.make_shared (default_pointer), 2]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("connect-timeout"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("connecttimeout")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("continue"), (('c').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("continue")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("convert-links"), (('k').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("convertlinks")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("content-disposition"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("contentdisposition")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("cookies"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("cookies")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("cut-dirs"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("cutdirs")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("debug"), (('d').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("debug")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("default-page"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("defaultpage")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("delete-after"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("deleteafter")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("directories"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("dirstruct")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("directory-prefix"), (('P').code).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("dirprefix")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("dns-cache"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("dnscache")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("dns-timeout"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("dnstimeout")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("domains"), (('D').code).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("domains")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("dont-remove-listing"), (0).to_integer_8, {PC_TYPE}.OPT__DONT_REMOVE_LISTING, create {CE_VOID_POINTER}.make_shared (default_pointer), 0]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("dot-style"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("dotstyle")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("egd-file"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("egdfile")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("exclude-directories"), (('X').code).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("excludedirectories")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("exclude-domains"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("excludedomains")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("execute"), (('e').code).to_integer_8, {PC_TYPE}.OPT__EXECUTE, create {CE_VOID_POINTER}.make_shared (default_pointer), 1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("follow-ftp"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("followftp")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("follow-tags"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("followtags")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("force-directories"), (('x').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("dirstruct")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("force-html"), (('F').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("forcehtml")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("ftp-password"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("ftppassword")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("ftp-user"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("ftpuser")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("glob"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("glob")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("header"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("header")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("help"), (('h').code).to_integer_8, {PC_TYPE}.OPT_FUNCALL, create {CE_VOID_POINTER}.make_cast ((print_help_address)), 0]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("host-directories"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("addhostdir")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("html-extension"), (('E').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("adjustextension")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("htmlify"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("htmlify")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("http-keep-alive"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("httpkeepalive")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("http-passwd"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("httppassword")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("http-password"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("httppassword")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("http-user"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("httpuser")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("ignore-case"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("ignorecase")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("ignore-length"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("ignorelength")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("ignore-tags"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("ignoretags")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("include-directories"), (('I').code).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("includedirectories")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("inet4-only"), (('4').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("inet4only")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("inet6-only"), (('6').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("inet6only")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("input-file"), (('i').code).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("input")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("iri"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("iri")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("keep-session-cookies"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("keepsessioncookies")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("level"), (('l').code).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("reclevel")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("limit-rate"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("limitrate")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("load-cookies"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("loadcookies")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("local-encoding"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("localencoding")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("max-redirect"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("maxredirect")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("mirror"), (('m').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("mirror")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("no"), (('n').code).to_integer_8, {PC_TYPE}.OPT__NO, create {CE_VOID_POINTER}.make_shared (default_pointer), 1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("no-clobber"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("noclobber")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("no-parent"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("noparent")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("output-document"), (('O').code).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("outputdocument")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("output-file"), (('o').code).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("logfile")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("page-requisites"), (('p').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("pagerequisites")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("parent"), (0).to_integer_8, {PC_TYPE}.OPT__PARENT, create {CE_VOID_POINTER}.make_shared (default_pointer), 2]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("passive-ftp"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("passiveftp")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("password"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("password")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("post-data"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("postdata")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("post-file"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("postfile")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("prefer-family"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("preferfamily")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("preserve-permissions"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("preservepermissions")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("privatekey")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("privatekeytype")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("progress"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("progress")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("protocol-directories"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("protocoldirectories")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("proxy"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("useproxy")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("proxy__compat"), (('Y').code).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("useproxy")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("proxy-passwd"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("proxypassword")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("proxy-password"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("proxypassword")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("proxy-user"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("proxyuser")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("quiet"), (('q').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("quiet")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("quota"), (('Q').code).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("quota")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("random-file"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("randomfile")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("random-wait"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("randomwait")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("read-timeout"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("readtimeout")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("recursive"), (('r').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("recursive")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("referer"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("referer")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("reject"), (('R').code).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("reject")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("relative"), (('L').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("relativeonly")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("remote-encoding"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("remoteencoding")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("remove-listing"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("removelisting")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("restrict-file-names"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("restrictfilenames")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("retr-symlinks"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("retrsymlinks")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("retry-connrefused"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("retryconnrefused")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("save-cookies"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("savecookies")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("save-headers"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("saveheaders")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("secureprotocol")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("server-response"), (('S').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("serverresponse")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("span-hosts"), (('H').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("spanhosts")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("spider"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("spider")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("strict-comments"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("strictcomments")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("timeout"), (('T').code).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("timeout")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("timestamping"), (('N').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("timestamping")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("tries"), (('t').code).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("tries")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("user"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("user")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("user-agent"), (('U').code).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("useragent")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("verbose"), (('v').code).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("verbose")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("verbose"), (0).to_integer_8, {PC_TYPE}.OPT_BOOLEAN, create {CE_VOID_POINTER}.make_cast (ce_string ("verbose")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("version"), (('V').code).to_integer_8, {PC_TYPE}.OPT_FUNCALL, create {CE_VOID_POINTER}.make_cast ((print_version_address)), 0]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("wait"), (('w').code).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("wait")), -1]),
					create {PD_CMDLINE_OPTION}.make_initialized ([ce_string ("waitretry"), (0).to_integer_8, {PC_TYPE}.OPT_VALUE, create {CE_VOID_POINTER}.make_cast (ce_string ("waitretry")), -1])
				>>)
		end

	buffer: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<1_024>>)
		end

	p: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := buffer.item
		end

	long_options: CE_STATIC [CE_ARRAY [SD_OPTION]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [SD_OPTION]}.make (<<({NATURAL_32} 2 * (((create {PD_CMDLINE_OPTION}.make).structure_size.to_natural_32 * (121).to_natural_32) // (create {PD_CMDLINE_OPTION}.make).structure_size.to_natural_32) + {NATURAL_32} 1).to_integer_32>>)
		end

	short_options: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<128>>)
		end

	optmap: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<96>>)
		end

	help: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("%N"),
					ce_string ("Mandatory arguments to long options are mandatory for short options too.%N%N"),
					ce_string ("Startup:%N"),
					ce_string ("  -V,  --version           display the version of Wget and exit.%N"),
					ce_string ("  -h,  --help              print this help.%N"),
					ce_string ("  -b,  --background        go to background after startup.%N"),
					ce_string ("  -e,  --execute=COMMAND   execute a `.wgetrc%'-style command.%N"),
					ce_string ("%N"),
					ce_string ("Logging and input file:%N"),
					ce_string ("  -o,  --output-file=FILE    log messages to FILE.%N"),
					ce_string ("  -a,  --append-output=FILE  append messages to FILE.%N"),
					ce_string ("  -d,  --debug               print lots of debugging information.%N"),
					ce_string ("  -q,  --quiet               quiet (no output).%N"),
					ce_string ("  -v,  --verbose             be verbose (this is the default).%N"),
					ce_string ("  -nv, --no-verbose          turn off verboseness, without being quiet.%N"),
					ce_string ("  -i,  --input-file=FILE     download URLs found in local or external FILE.%N"),
					ce_string ("  -F,  --force-html          treat input file as HTML.%N"),
					ce_string ("  -B,  --base=URL            resolves HTML input-file links (-i -F)%N                             relative to URL.%N"),
					ce_string ("%N"),
					ce_string ("Download:%N"),
					ce_string ("  -t,  --tries=NUMBER            set number of retries to NUMBER (0 unlimits).%N"),
					ce_string ("       --retry-connrefused       retry even if connection is refused.%N"),
					ce_string ("  -O,  --output-document=FILE    write documents to FILE.%N"),
					ce_string ("  -nc, --no-clobber              skip downloads that would download to%N                                 existing files.%N"),
					ce_string ("  -c,  --continue                resume getting a partially-downloaded file.%N"),
					ce_string ("       --progress=TYPE           select progress gauge type.%N"),
					ce_string ("  -N,  --timestamping            don%'t re-retrieve files unless newer than%N                                 local.%N"),
					ce_string ("  -S,  --server-response         print server response.%N"),
					ce_string ("       --spider                  don%'t download anything.%N"),
					ce_string ("  -T,  --timeout=SECONDS         set all timeout values to SECONDS.%N"),
					ce_string ("       --dns-timeout=SECS        set the DNS lookup timeout to SECS.%N"),
					ce_string ("       --connect-timeout=SECS    set the connect timeout to SECS.%N"),
					ce_string ("       --read-timeout=SECS       set the read timeout to SECS.%N"),
					ce_string ("  -w,  --wait=SECONDS            wait SECONDS between retrievals.%N"),
					ce_string ("       --waitretry=SECONDS       wait 1..SECONDS between retries of a retrieval.%N"),
					ce_string ("       --random-wait             wait from 0...2*WAIT secs between retrievals.%N"),
					ce_string ("       --no-proxy                explicitly turn off proxy.%N"),
					ce_string ("  -Q,  --quota=NUMBER            set retrieval quota to NUMBER.%N"),
					ce_string ("       --bind-address=ADDRESS    bind to ADDRESS (hostname or IP) on local host.%N"),
					ce_string ("       --limit-rate=RATE         limit download rate to RATE.%N"),
					ce_string ("       --no-dns-cache            disable caching DNS lookups.%N"),
					ce_string ("       --restrict-file-names=OS  restrict chars in file names to ones OS allows.%N"),
					ce_string ("       --ignore-case             ignore case when matching files/directories.%N"),
					ce_string ("  -4,  --inet4-only              connect only to IPv4 addresses.%N"),
					ce_string ("  -6,  --inet6-only              connect only to IPv6 addresses.%N"),
					ce_string ("       --prefer-family=FAMILY    connect first to addresses of specified family,%N                                 one of IPv6, IPv4, or none.%N"),
					ce_string ("       --user=USER               set both ftp and http user to USER.%N"),
					ce_string ("       --password=PASS           set both ftp and http password to PASS.%N"),
					ce_string ("       --ask-password            prompt for passwords.%N"),
					ce_string ("       --no-iri                  turn off IRI support.%N"),
					ce_string ("       --local-encoding=ENC      use ENC as the local encoding for IRIs.%N"),
					ce_string ("       --remote-encoding=ENC     use ENC as the default remote encoding.%N"),
					ce_string ("%N"),
					ce_string ("Directories:%N"),
					ce_string ("  -nd, --no-directories           don%'t create directories.%N"),
					ce_string ("  -x,  --force-directories        force creation of directories.%N"),
					ce_string ("  -nH, --no-host-directories      don%'t create host directories.%N"),
					ce_string ("       --protocol-directories     use protocol name in directories.%N"),
					ce_string ("  -P,  --directory-prefix=PREFIX  save files to PREFIX/...%N"),
					ce_string ("       --cut-dirs=NUMBER          ignore NUMBER remote directory components.%N"),
					ce_string ("%N"),
					ce_string ("HTTP options:%N"),
					ce_string ("       --http-user=USER        set http user to USER.%N"),
					ce_string ("       --http-password=PASS    set http password to PASS.%N"),
					ce_string ("       --no-cache              disallow server-cached data.%N"),
					ce_string ("       --default-page=NAME     Change the default page name (normally%N                               this is `index.html%'.).%N"),
					ce_string ("  -E,  --adjust-extension      save HTML/CSS documents with proper extensions.%N"),
					ce_string ("       --ignore-length         ignore `Content-Length%' header field.%N"),
					ce_string ("       --header=STRING         insert STRING among the headers.%N"),
					ce_string ("       --max-redirect          maximum redirections allowed per page.%N"),
					ce_string ("       --proxy-user=USER       set USER as proxy username.%N"),
					ce_string ("       --proxy-password=PASS   set PASS as proxy password.%N"),
					ce_string ("       --referer=URL           include `Referer: URL%' header in HTTP request.%N"),
					ce_string ("       --save-headers          save the HTTP headers to file.%N"),
					ce_string ("  -U,  --user-agent=AGENT      identify as AGENT instead of Wget/VERSION.%N"),
					ce_string ("       --no-http-keep-alive    disable HTTP keep-alive (persistent connections).%N"),
					ce_string ("       --no-cookies            don%'t use cookies.%N"),
					ce_string ("       --load-cookies=FILE     load cookies from FILE before session.%N"),
					ce_string ("       --save-cookies=FILE     save cookies to FILE after session.%N"),
					ce_string ("       --keep-session-cookies  load and save session (non-permanent) cookies.%N"),
					ce_string ("       --post-data=STRING      use the POST method; send STRING as the data.%N"),
					ce_string ("       --post-file=FILE        use the POST method; send contents of FILE.%N"),
					ce_string ("       --content-disposition   honor the Content-Disposition header when%N                               choosing local file names (EXPERIMENTAL).%N"),
					ce_string ("       --auth-no-challenge     send Basic HTTP authentication information%N                               without first waiting for the server%'s%N                               challenge.%N"),
					ce_string ("%N"),
					ce_string ("FTP options:%N"),
					ce_string ("       --ftp-user=USER         set ftp user to USER.%N"),
					ce_string ("       --ftp-password=PASS     set ftp password to PASS.%N"),
					ce_string ("       --no-remove-listing     don%'t remove `.listing%' files.%N"),
					ce_string ("       --no-glob               turn off FTP file name globbing.%N"),
					ce_string ("       --no-passive-ftp        disable the %"passive%" transfer mode.%N"),
					ce_string ("       --retr-symlinks         when recursing, get linked-to files (not dir).%N"),
					ce_string ("%N"),
					ce_string ("Recursive download:%N"),
					ce_string ("  -r,  --recursive          specify recursive download.%N"),
					ce_string ("  -l,  --level=NUMBER       maximum recursion depth (inf or 0 for infinite).%N"),
					ce_string ("       --delete-after       delete files locally after downloading them.%N"),
					ce_string ("  -k,  --convert-links      make links in downloaded HTML or CSS point to%N                            local files.%N"),
					ce_string ("  -K,  --backup-converted   before converting file X, back up as X.orig.%N"),
					ce_string ("  -m,  --mirror             shortcut for -N -r -l inf --no-remove-listing.%N"),
					ce_string ("  -p,  --page-requisites    get all images, etc. needed to display HTML page.%N"),
					ce_string ("       --strict-comments    turn on strict (SGML) handling of HTML comments.%N"),
					ce_string ("%N"),
					ce_string ("Recursive accept/reject:%N"),
					ce_string ("  -A,  --accept=LIST               comma-separated list of accepted extensions.%N"),
					ce_string ("  -R,  --reject=LIST               comma-separated list of rejected extensions.%N"),
					ce_string ("  -D,  --domains=LIST              comma-separated list of accepted domains.%N"),
					ce_string ("       --exclude-domains=LIST      comma-separated list of rejected domains.%N"),
					ce_string ("       --follow-ftp                follow FTP links from HTML documents.%N"),
					ce_string ("       --follow-tags=LIST          comma-separated list of followed HTML tags.%N"),
					ce_string ("       --ignore-tags=LIST          comma-separated list of ignored HTML tags.%N"),
					ce_string ("  -H,  --span-hosts                go to foreign hosts when recursive.%N"),
					ce_string ("  -L,  --relative                  follow relative links only.%N"),
					ce_string ("  -I,  --include-directories=LIST  list of allowed directories.%N"),
					ce_string ("  -X,  --exclude-directories=LIST  list of excluded directories.%N"),
					ce_string ("  -np, --no-parent                 don%'t ascend to the parent directory.%N"),
					ce_string ("%N"),
					ce_string ("Mail bug reports and suggestions to <bug-wget@gnu.org>.%N")
				>>)
		end

	buf___1: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<32>>)
		end

	program_name: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

feature {ANY} -- public routines

	i18n_initialize
		do
			setlocale (6, ce_string ("")).do_nothing
			bindtextdomain (ce_string ("wget"), ce_string ("/usr/local/share/locale")).do_nothing
			textdomain (ce_string ("wget")).do_nothing
		end

	no_prefix (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_s.is_void
		local
			l_cp: CE_POINTER [INTEGER_8]
			l_size: INTEGER_32
		do
			l_cp := p.item
			l_size := (({NATURAL_32} 3 + (strlen (a_s))) + {NATURAL_32} 1).to_integer_32
			if ((p.item + l_size).c_pointer.to_integer_32).to_natural_32 >= ((buffer.item + ({PLATFORM}.Integer_8_bytes.to_natural_32 * (1_024).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
				abort
			end
			l_cp[0] := (('n').code).to_integer_8
			l_cp[1] := (('o').code).to_integer_8
			l_cp[2] := (('-').code).to_integer_8
			strcpy ((l_cp + 3), a_s).do_nothing
			p.item := p.item + l_size
			Result := l_cp
		end

	init_switches
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_i: NATURAL_32
			l_o: NATURAL_32
			l_opt___0: CE_POINTER [PD_CMDLINE_OPTION]
			l_longopt: CE_POINTER [SD_OPTION]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: NATURAL_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := short_options.item
					l_o := (0).to_natural_32
					l_i := (0).to_natural_32
				when 1 then -- loop condition:
					if not (l_i < ((create {PD_CMDLINE_OPTION}.make).structure_size.to_natural_32 * (121).to_natural_32) // (create {PD_CMDLINE_OPTION}.make).structure_size.to_natural_32) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						l_continue := False
						l_opt___0 := option_data.item + l_i.to_integer_32
						if (l_opt___0.item.long_name).is_void then
							l_continue := True
						end
						if (l_continue) then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						l_tmp := l_o
						l_o := l_o + 1
						l_longopt := long_options.item + l_tmp.to_integer_32
						l_longopt.item.name := l_opt___0.item.long_name
						l_longopt.item.val := l_i.to_integer_32
						if (l_opt___0.item.short_name).to_boolean then
							l_tmp___0 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___0[0] := l_opt___0.item.short_name
							optmap.item[(l_opt___0.item.short_name).to_integer_32 - 32] := (l_longopt.distance (long_options.item)).to_natural_8
						end
						inspect (l_opt___0.item.type).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 4
						when 1 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 4 then -- switch 1, case 0
						l_longopt.item.has_arg := 1
						if (l_opt___0.item.short_name).to_boolean then
							l_tmp___1 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___1[0] := ((':').code).to_integer_8
						end
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 1
						l_longopt.item.has_arg := 2
						l_tmp___2 := l_o
						l_o := l_o + 1
						l_longopt := long_options.item + l_tmp___2.to_integer_32
						l_longopt.item.name := (no_prefix (l_opt___0.item.long_name))
						l_longopt.item.has_arg := 0
						l_longopt.item.val := ((l_i).bit_or ({NATURAL_32} 1_024)).to_integer_32
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
						if l_opt___0.item.argtype = -1 then
							assert_fail (ce_string ("opt->argtype != -1"), ce_string ("main.c"), {NATURAL_32} 365, ce_string ("init_switches"))
						end
						l_longopt.item.has_arg := l_opt___0.item.argtype
						if (l_opt___0.item.short_name).to_boolean then
							if l_longopt.item.has_arg = 1 then
								l_tmp___4 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___4[0] := ((':').code).to_integer_8
							end
						end
				when 7 then -- switch 1, done: | if done
						l_i := l_i + 1
						l_pos := -1 + 1 -- back to loop condition
				when 8 then -- loop done
					l_continue := False
					l_p___0[0] := (('%/0/').code).to_integer_8
					if not (l_o <= ((create {SD_OPTION}.make).structure_size.to_natural_32 * {NATURAL_32} 2 * (((create {PD_CMDLINE_OPTION}.make).structure_size.to_natural_32 * (121).to_natural_32) // (create {PD_CMDLINE_OPTION}.make).structure_size.to_natural_32) + {NATURAL_32} 1) // (create {SD_OPTION}.make).structure_size.to_natural_32) then
						assert_fail (ce_string ("o <= (sizeof (long_options) / sizeof ((long_options)[0]))"), ce_string ("main.c"), {NATURAL_32} 379, ce_string ("init_switches"))
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	print_usage
		do
			printf ([(gettext (ce_string ("Usage: %%s [OPTION]... [URL]...%N"))), (create {P_WGET_STATIC}).exec_name.item]).do_nothing
		end

	print_help
		local
			l_i: NATURAL_32
		do
			printf ([(gettext (ce_string ("GNU Wget %%s, a non-interactive network retriever.%N"))), (create {P_VERSION_STATIC}).version_string.item]).do_nothing
			print_usage
			l_i := (0).to_natural_32
			from
			until
				not (l_i < ({PLATFORM}.Pointer_bytes.to_natural_32 * (118).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32)
			loop
				fputs ((gettext (help.item[l_i.to_integer_32])), (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
				l_i := l_i + 1
			end
			exit (0)
		end

	secs_to_human_time (a_interval: REAL_64): CE_POINTER [INTEGER_8]
		local
			l_secs: INTEGER_32
			l_hours: INTEGER_32
			l_mins: INTEGER_32
			l_days: INTEGER_32
		do
			l_secs := (a_interval + 0.5).truncated_to_integer
			l_days := l_secs // 86_400
			l_secs := l_secs \\ (86_400)
			l_hours := l_secs // 3_600
			l_secs := l_secs \\ (3_600)
			l_mins := l_secs // 60
			l_secs := l_secs \\ (60)
			if l_days.to_boolean then
				sprintf ([buf___1.item, ce_string ("%%dd %%dh %%dm %%ds"), l_days, l_hours, l_mins, l_secs]).do_nothing
			elseif l_hours.to_boolean then
				sprintf ([buf___1.item, ce_string ("%%dh %%dm %%ds"), l_hours, l_mins, l_secs]).do_nothing
			elseif l_mins.to_boolean then
				sprintf ([buf___1.item, ce_string ("%%dm %%ds"), l_mins, l_secs]).do_nothing
			else
				sprintf ([buf___1.item, ce_string ("%%ss"), ((create {P_UTILS_STATIC}).print_decimal (a_interval))]).do_nothing
			end
			Result := buf___1.item
		end

	prompt_for_password: CE_POINTER [INTEGER_8]
		local
			l_tmp: CE_POINTER [INTEGER_8]
		do
			if (not ((create {P_OPTIONS_STATIC}).opt.item.item.user).is_void) then
				l_tmp := (create {P_QUOTE_STATIC}).quote ((create {P_OPTIONS_STATIC}).opt.item.item.user)
				printf ([(gettext (ce_string ("Password for user %%s: "))), l_tmp]).do_nothing
			else
				Io.put_string (eif_string ((gettext (ce_string ("Password: ")))))
			end
			Result := ((create {P_GETPASS_STATIC}).gnu_getpass (ce_string ("")))
		end

	format_and_print_line (a_prefix, a_line: CE_POINTER [INTEGER_8]; a_line_length: INTEGER_32)
		require
			not a_prefix.is_void
		local
			l_line_length: INTEGER_32
			l_remaining_chars: INTEGER_32
			l_line_dup: CE_POINTER [INTEGER_8]
			l_token: CE_POINTER [INTEGER_8]
		do
			l_line_length := a_line_length
			if a_prefix.is_void then
				assert_fail (ce_string ("prefix != ((void *)0)"), ce_string ("main.c"), {NATURAL_32} 745, ce_string ("format_and_print_line"))
			end
			if a_line.is_void then
				assert_fail (ce_string ("line != ((void *)0)"), ce_string ("main.c"), {NATURAL_32} 746, ce_string ("format_and_print_line"))
			end
			l_line_dup := (create {P_XMALLOC_STATIC}).xstrdup (a_line)
			if l_line_length <= 0 then
				l_line_length := 68
			end
			Io.put_string (eif_string (a_prefix))
			l_remaining_chars := l_line_length
			l_token := strtok (l_line_dup, ce_string (" "))
			from
			until
				l_token.is_void
			loop
				if l_remaining_chars.to_natural_32 <= (strlen (l_token)) then
					printf ([ce_string ("%N%%*c"), 4, (' ').code]).do_nothing
					l_remaining_chars := l_line_length - 4
				end
				Io.put_string (eif_string (l_token) + " ")
				l_remaining_chars := (l_remaining_chars.to_natural_32 - ((strlen (l_token)) + {NATURAL_32} 1)).to_integer_32
				l_token := strtok (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string (" "))
			end
			Io.put_string ("%N")
			free (create {CE_VOID_POINTER}.make_cast (l_line_dup))
		end

	print_version
		local
			l_wgetrc_title: CE_POINTER [INTEGER_8]
			l_locale_title: CE_POINTER [INTEGER_8]
			l_compile_title: CE_POINTER [INTEGER_8]
			l_link_title: CE_POINTER [INTEGER_8]
			l_env_wgetrc: CE_POINTER [INTEGER_8]
			l_user_wgetrc: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_line_length: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_wgetrc_title := (gettext (ce_string ("Wgetrc: ")))
			l_locale_title := (gettext (ce_string ("Locale: ")))
			l_compile_title := (gettext (ce_string ("Compile: ")))
			l_link_title := (gettext (ce_string ("Link: ")))
			printf ([(gettext (ce_string ("GNU Wget %%s built on %%s.%N%N"))), (create {P_VERSION_STATIC}).version_string.item, ce_string ("linux-gnu")]).do_nothing
			l_i := 0
			from
			until
				not (not (l_return) and then (not ((create {P_BUILD_INFO_STATIC}).compiled_features.item[l_i]).is_void))
			loop
				l_line_length := 72
				from
				until
					(l_break)
				loop
					l_break := False
					if l_line_length > 0 then
						if ((create {P_BUILD_INFO_STATIC}).compiled_features.item[l_i]).is_void then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						Io.put_string (eif_string ((create {P_BUILD_INFO_STATIC}).compiled_features.item[l_i]) + " ")
						l_line_length := (l_line_length.to_natural_32 - ((strlen ((create {P_BUILD_INFO_STATIC}).compiled_features.item[l_i])) + {NATURAL_32} 2)).to_integer_32
						l_i := l_i + 1
					end
				end
				l_break := False
				Io.put_string ("%N")
			end
			Io.put_string ("%N")
			Io.put_string (eif_string (l_wgetrc_title) + "%N")
			l_env_wgetrc := (create {P_INIT_STATIC}).wgetrc_env_file_name
			if (not l_env_wgetrc.is_void) then
				if (l_env_wgetrc[0]).to_boolean then
					printf ([(gettext (ce_string ("    %%s (env)%N"))), l_env_wgetrc]).do_nothing
					free (create {CE_VOID_POINTER}.make_cast (l_env_wgetrc))
				end
			end
			l_user_wgetrc := (create {P_INIT_STATIC}).wgetrc_user_file_name
			if (not l_user_wgetrc.is_void) then
				printf ([(gettext (ce_string ("    %%s (user)%N"))), l_user_wgetrc]).do_nothing
				free (create {CE_VOID_POINTER}.make_cast (l_user_wgetrc))
			end
			printf ([(gettext (ce_string ("    %%s (system)%N"))), ce_string ("/usr/local/etc/wgetrc")]).do_nothing
			format_and_print_line (l_locale_title, ce_string ("/usr/local/share/locale"), 72)
			format_and_print_line (l_compile_title, (create {P_VERSION_STATIC}).compilation_string.item, 72)
			format_and_print_line (l_link_title, (create {P_VERSION_STATIC}).link_string.item, 72)
			Io.put_string ("%N")
			fputs ((gettext (ce_string ("Copyright (C) 2009 Free Software Foundation, Inc.%N"))), (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
			fputs ((gettext (ce_string ("License GPLv3+: GNU GPL version 3 or later%N<http://www.gnu.org/licenses/gpl.html>.%NThis is free software: you are free to change and redistribute it.%NThere is NO WARRANTY, to the extent permitted by law.%N"))), (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
			fputs ((gettext (ce_string ("%NOriginally written by Hrvoje Niksic <hniksic@xemacs.org>.%N"))), (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
			fputs ((gettext (ce_string ("Currently maintained by Micah Cowan <micah@cowan.name>.%N"))), (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
			fputs ((gettext (ce_string ("Please send bug reports and questions to <bug-wget@gnu.org>.%N"))), (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
			exit (0)
		end

	main (a_argc: INTEGER_32; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		require
			not a_argv.is_void
		local
			l_url: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_t: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_i: INTEGER_32
			l_ret: INTEGER_32
			l_longindex: CE_ARRAY [INTEGER_32]
			l_nurl: INTEGER_32
			l_status: INTEGER_32
			l_append_to_log: BOOLEAN
			l_val: INTEGER_32
			l_opt___0: CE_POINTER [PD_CMDLINE_OPTION]
			l_neg: BOOLEAN
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_func: CE_ROUTINE
			l_p___0: CE_POINTER [INTEGER_8]
			l_flag: BOOLEAN
			l_tmp___7: INTEGER_32
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___21: CE_POINTER [INTEGER_8]
			l_rewritten: CE_POINTER [INTEGER_8]
			l_st: CE_ARRAY [SD_STAT]
			l_tmp___25: CE_POINTER [INTEGER_8]
			l_filename: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_redirected_URL: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_dt: CE_ARRAY [INTEGER_32]
			l_url_err: CE_ARRAY [INTEGER_32]
			l_iri: CE_POINTER [PD_IRI]
			l_url_parsed: CE_POINTER [PD_URL]
			l_error___0: CE_POINTER [INTEGER_8]
			l_old_follow_ftp: INTEGER_32
			l_tmp___32: NATURAL_32
			l_count: CE_ARRAY [INTEGER_32]
			l_tmp___43: CE_POINTER [INTEGER_8]
			l_tmp___44: CE_POINTER [INTEGER_8]
			l_tmp___45: CE_POINTER [INTEGER_8]
			l_tmp___47: CE_POINTER [INTEGER_8]
			l_tmp___49: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_INTEGER_32_ARRAY} l_longindex.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_filename.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_redirected_URL.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_dt.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_url_err.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_count.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_append_to_log := (0).to_boolean
					program_name.item := a_argv[0]
					i18n_initialize;
					(create {P_WGET_STATIC}).exec_name.item := (strrchr (a_argv[0], ('/').code))
					if ((create {P_WGET_STATIC}).exec_name.item).is_void then
						(create {P_WGET_STATIC}).exec_name.item := a_argv[0]
					else
						(create {P_WGET_STATIC}).exec_name.item := (create {P_WGET_STATIC}).exec_name.item + 1
					end
					(create {P_INIT_STATIC}).initialize
					init_switches
					l_longindex.item := -1
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 24 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_ret := getopt_long (a_argc, a_argv, short_options.item, create {CE_CLASS_POINTER [SD_OPTION]}.make_cast (long_options.item), l_longindex)
						if l_ret = -1 then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 23 -- skip if block
						end
				when 3 then -- if:
						if l_longindex.item = -1 then
							if l_ret = 63 then
								print_usage
								Io.put_string ("%N")
								printf ([(gettext (ce_string ("Try `%%s --help%' for more options.%N"))), (create {P_WGET_STATIC}).exec_name.item]).do_nothing
								exit (2)
							end
							l_longindex.item := (optmap.item[l_ret - 32]).to_integer_32
						end
						l_val := long_options.item[l_longindex.item].val
						l_opt___0 := option_data.item + (l_val).bit_and (-1_025)
						inspect (l_opt___0.item.type).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 4
						when 1 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 6
						when 3 then l_pos := -1 + 7
						when 6 then l_pos := -1 + 8
						when 7 then l_pos := -1 + 9
						when 8 then l_pos := -1 + 20
						when 4 then l_pos := -1 + 20
						when 5 then l_pos := -1 + 21
						else l_pos := -1 + 22
						end
				when 4 then -- switch 1, case 0;
						(create {P_INIT_STATIC}).setoptval (create {CE_INTEGER_8_POINTER}.make_cast (l_opt___0.item.data), optarg, l_opt___0.item.long_name)
						l_pos := -1 + 22 -- switch 1; break
				when 5 then -- switch 1, case 1
						if (not optarg.is_void) then
							(create {P_INIT_STATIC}).setoptval (create {CE_INTEGER_8_POINTER}.make_cast (l_opt___0.item.data), optarg, l_opt___0.item.long_name)
						else
							l_neg := (((l_val).bit_and (1_024)).to_boolean)
							if l_neg then
								l_tmp___1 := ce_string ("0")
							else
								l_tmp___1 := ce_string ("1")
							end
							(create {P_INIT_STATIC}).setoptval (create {CE_INTEGER_8_POINTER}.make_cast (l_opt___0.item.data), l_tmp___1, l_opt___0.item.long_name)
						end
						l_pos := -1 + 22 -- switch 1; break
				when 6 then -- switch 1, case 2
						l_func := create {CE_ROUTINE}.make_cast (l_opt___0.item.data)
						l_func.call ([])
						l_pos := -1 + 22 -- switch 1; break
				when 7 then -- switch 1, case 3;
						(create {P_INIT_STATIC}).setoptval (ce_string ("logfile"), optarg, l_opt___0.item.long_name)
						l_append_to_log := (1).to_boolean
						l_pos := -1 + 22 -- switch 1; break
				when 8 then -- switch 1, case 6;
						(create {P_INIT_STATIC}).run_command (optarg)
						l_pos := -1 + 22 -- switch 1; break
				when 9 then -- switch 1, case 7
						l_p___0 := optarg
				when 10 then -- loop condition:
						if not ((l_p___0[0]).to_boolean) then
							l_pos := -1 + 19 -- skip loop
						end
				when 11 then -- loop body:
						inspect (l_p___0[0]).to_integer_32 -- switch 2 head
						when 118 then l_pos := -1 + 12
						when 72 then l_pos := -1 + 13
						when 100 then l_pos := -1 + 14
						when 99 then l_pos := -1 + 15
						when 112 then l_pos := -1 + 16
						else l_pos := -1 + 17
						end
				when 12 then -- switch 2, case 118;
						(create {P_INIT_STATIC}).setoptval (ce_string ("verbose"), ce_string ("0"), l_opt___0.item.long_name)
						l_pos := -1 + 18 -- switch 2; break
				when 13 then -- switch 2, case 72;
						(create {P_INIT_STATIC}).setoptval (ce_string ("addhostdir"), ce_string ("0"), l_opt___0.item.long_name)
						l_pos := -1 + 18 -- switch 2; break
				when 14 then -- switch 2, case 100;
						(create {P_INIT_STATIC}).setoptval (ce_string ("dirstruct"), ce_string ("0"), l_opt___0.item.long_name)
						l_pos := -1 + 18 -- switch 2; break
				when 15 then -- switch 2, case 99;
						(create {P_INIT_STATIC}).setoptval (ce_string ("noclobber"), ce_string ("1"), l_opt___0.item.long_name)
						l_pos := -1 + 18 -- switch 2; break
				when 16 then -- switch 2, case 112;
						(create {P_INIT_STATIC}).setoptval (ce_string ("noparent"), ce_string ("1"), l_opt___0.item.long_name)
						l_pos := -1 + 18 -- switch 2; break
				when 17 then -- switch 2, default:
						printf ([(gettext (ce_string ("%%s: illegal option -- `-n%%c%'%N"))), (create {P_WGET_STATIC}).exec_name.item, (l_p___0[0]).to_integer_32]).do_nothing
						print_usage
						Io.put_string ("%N")
						printf ([(gettext (ce_string ("Try `%%s --help%' for more options.%N"))), (create {P_WGET_STATIC}).exec_name.item]).do_nothing
						exit (1)
				when 18 then -- switch 2, done:
						l_p___0 := l_p___0 + 1
						l_pos := -1 + 10 -- back to loop condition
				when 19 then -- loop done
						l_pos := -1 + 22 -- switch 1; break
				when 20 then -- switch 1, case 8 | switch 1, case 4
						l_flag := (1).to_boolean
						if (not optarg.is_void) then
							if (optarg[0]).to_integer_32 = 49 then
								l_tmp___7 := 1
							elseif ((create {P_C_CTYPE_STATIC}).c2_tolower ((optarg[0]).to_integer_32)) = 121 then
								l_tmp___7 := 1
							elseif ((create {P_C_CTYPE_STATIC}).c2_tolower ((optarg[0]).to_integer_32)) = 111 then
								if ((create {P_C_CTYPE_STATIC}).c2_tolower ((optarg[1]).to_integer_32)) = 110 then
									l_tmp___7 := 1
								else
									l_tmp___7 := 0
								end
							else
								l_tmp___7 := 0
							end
							l_flag := l_tmp___7.to_boolean
						end
						if l_flag then
							l_tmp___8 := ce_string ("0")
						else
							l_tmp___8 := ce_string ("1")
						end
						if l_opt___0.item.type = {NATURAL_32} 8 then
							l_tmp___9 := ce_string ("noparent")
						else
							l_tmp___9 := ce_string ("noclobber")
						end
						(create {P_INIT_STATIC}).setoptval (l_tmp___9, l_tmp___8, l_opt___0.item.long_name)
						l_pos := -1 + 22 -- switch 1; break
				when 21 then -- switch 1, case 5;
						(create {P_INIT_STATIC}).setoptval (ce_string ("removelisting"), ce_string ("0"), l_opt___0.item.long_name)
						l_pos := -1 + 22 -- switch 1; break
				when 22 then -- switch 1, done:
						l_longindex.item := -1
				when 23 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 24 then -- loop done
					l_break := False
					l_nurl := a_argc - optind
					if (create {P_OPTIONS_STATIC}).opt.item.item.reclevel = 0 then
						(create {P_OPTIONS_STATIC}).opt.item.item.reclevel := -1
					end
					if (create {P_OPTIONS_STATIC}).opt.item.item.spider then
						(create {P_OPTIONS_STATIC}).opt.item.item.no_dirstruct := (1).to_boolean
					elseif (create {P_OPTIONS_STATIC}).opt.item.item.delete_after then
						(create {P_OPTIONS_STATIC}).opt.item.item.no_dirstruct := (1).to_boolean
					end
					if (create {P_OPTIONS_STATIC}).opt.item.item.page_requisites then
						if not (create {P_OPTIONS_STATIC}).opt.item.item.recursive then
							(create {P_OPTIONS_STATIC}).opt.item.item.reclevel := 0
							if not (create {P_OPTIONS_STATIC}).opt.item.item.no_dirstruct then
								(create {P_OPTIONS_STATIC}).opt.item.item.dirstruct := (1).to_boolean
							end
						end
					end
					if (create {P_OPTIONS_STATIC}).opt.item.item.verbose = -1 then
						(create {P_OPTIONS_STATIC}).opt.item.item.verbose := (not (create {P_OPTIONS_STATIC}).opt.item.item.quiet).to_integer
					end
					if ((create {P_OPTIONS_STATIC}).opt.item.item.verbose).to_boolean then
						if (create {P_OPTIONS_STATIC}).opt.item.item.quiet then
							Io.put_string (eif_string ((gettext (ce_string ("Can%'t be verbose and quiet at the same time.%N")))))
							print_usage
							exit (1)
						end
					end
					if (create {P_OPTIONS_STATIC}).opt.item.item.timestamping then
						if (create {P_OPTIONS_STATIC}).opt.item.item.noclobber then
							Io.put_string (eif_string ((gettext (ce_string ("Can%'t timestamp and not clobber old files at the same time.%N")))))
							print_usage
							exit (1)
						end
					end
					if (create {P_OPTIONS_STATIC}).opt.item.item.ipv4_only then
						if (create {P_OPTIONS_STATIC}).opt.item.item.ipv6_only then
							Io.put_string (eif_string ((gettext (ce_string ("Cannot specify both --inet4-only and --inet6-only.%N")))))
							print_usage
							exit (1)
						end
					end
					if (not ((create {P_OPTIONS_STATIC}).opt.item.item.output_document).is_void) then
						if (create {P_OPTIONS_STATIC}).opt.item.item.convert_links then
							if l_nurl > 1 then
								l_tmp___13 := gettext (ce_string ("Cannot specify both -k and -O if multiple URLs are given, or in combination%Nwith -p or -r. See the manual for details.%N%N"))
								fputs (l_tmp___13, (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
								print_usage
								exit (1)
							elseif (create {P_OPTIONS_STATIC}).opt.item.item.page_requisites then
								l_tmp___13 := gettext (ce_string ("Cannot specify both -k and -O if multiple URLs are given, or in combination%Nwith -p or -r. See the manual for details.%N%N"))
								fputs (l_tmp___13, (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
								print_usage
								exit (1)
							elseif (create {P_OPTIONS_STATIC}).opt.item.item.recursive then
								l_tmp___13 := gettext (ce_string ("Cannot specify both -k and -O if multiple URLs are given, or in combination%Nwith -p or -r. See the manual for details.%N%N"))
								fputs (l_tmp___13, (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
								print_usage
								exit (1)
							end
						end
						if (create {P_OPTIONS_STATIC}).opt.item.item.page_requisites then
							l_tmp___14 := gettext (ce_string ("WARNING: combining -O with -r or -p will mean that all downloaded content%Nwill be placed in the single file you specified.%N%N"));
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s"), l_tmp___14])
						elseif (create {P_OPTIONS_STATIC}).opt.item.item.recursive then
							l_tmp___14 := gettext (ce_string ("WARNING: combining -O with -r or -p will mean that all downloaded content%Nwill be placed in the single file you specified.%N%N"));
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s"), l_tmp___14])
						end
						if (create {P_OPTIONS_STATIC}).opt.item.item.timestamping then
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s"), (gettext (ce_string ("WARNING: timestamping does nothing in combination with -O. See the manual%Nfor details.%N%N")))]);
							(create {P_OPTIONS_STATIC}).opt.item.item.timestamping := (0).to_boolean
						end
						if (create {P_OPTIONS_STATIC}).opt.item.item.noclobber then
							if ((create {P_UTILS_STATIC}).file_exists_p ((create {P_OPTIONS_STATIC}).opt.item.item.output_document)) then
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("File `%%s%' already there; not retrieving.%N"))), (create {P_OPTIONS_STATIC}).opt.item.item.output_document])
								exit (1)
							end
						end
					end
					if (create {P_OPTIONS_STATIC}).opt.item.item.ask_passwd then
						if (not ((create {P_OPTIONS_STATIC}).opt.item.item.passwd).is_void) then
							Io.put_string (eif_string ((gettext (ce_string ("Cannot specify both --ask-password and --password.%N")))))
							print_usage
							exit (1)
						end
					end
					if not l_nurl.to_boolean then
						if ((create {P_OPTIONS_STATIC}).opt.item.item.input_filename).is_void then
							printf ([(gettext (ce_string ("%%s: missing URL%N"))), (create {P_WGET_STATIC}).exec_name.item]).do_nothing
							print_usage
							Io.put_string ("%N")
							printf ([(gettext (ce_string ("Try `%%s --help%' for more options.%N"))), (create {P_WGET_STATIC}).exec_name.item]).do_nothing
							exit (1)
						end
					end
					if (create {P_OPTIONS_STATIC}).opt.item.item.enable_iri then
						l_tmp___21 := gettext (ce_string ("This version does not have support for IRIs%N"))
						Io.put_string (eif_string (l_tmp___21))
						exit (1)
					elseif (not ((create {P_OPTIONS_STATIC}).opt.item.item.locale).is_void) then
						l_tmp___21 := gettext (ce_string ("This version does not have support for IRIs%N"))
						Io.put_string (eif_string (l_tmp___21))
						exit (1)
					elseif (not ((create {P_OPTIONS_STATIC}).opt.item.item.encoding_remote).is_void) then
						l_tmp___21 := gettext (ce_string ("This version does not have support for IRIs%N"))
						Io.put_string (eif_string (l_tmp___21))
						exit (1)
					end
					if (create {P_OPTIONS_STATIC}).opt.item.item.ask_passwd then
						(create {P_OPTIONS_STATIC}).opt.item.item.passwd := prompt_for_password
						if ((create {P_OPTIONS_STATIC}).opt.item.item.passwd).is_void then
							exit (1)
						elseif ((create {P_OPTIONS_STATIC}).opt.item.item.passwd[0]).to_integer_32 = 0 then
							exit (1)
						end
					end
					if (create {P_OPTIONS_STATIC}).opt.item.item.background then
						(create {P_UTILS_STATIC}).fork_to_background
					end
					if ((create {P_OPTIONS_STATIC}).opt.item.item.verbose).to_boolean then
						(create {P_PROGRESS_STATIC}).set_progress_implementation ((create {P_OPTIONS_STATIC}).opt.item.item.progress_type)
					end
					l_url := create {CE_POINTER_POINTER [INTEGER_8]}.make_cast ((l_aaf.new ((l_nurl + 1).to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
					l_i := 0
					from
					until
						not (l_i < l_nurl)
					loop
						l_rewritten := ((create {P_URL_STATIC}).rewrite_shorthand_url (a_argv[optind]))
						if (not l_rewritten.is_void) then
							l_url[l_i] := l_rewritten
						else
							l_url[l_i] := (create {P_XMALLOC_STATIC}).xstrdup (a_argv[optind])
						end
						l_i := l_i + 1
						Current.optind := optind + 1
					end
					l_url[l_i] := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer);
					(create {P_LOG_STATIC}).log_init ((create {P_OPTIONS_STATIC}).opt.item.item.lfilename, l_append_to_log)
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
							(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("DEBUG output created by Wget %%s on %%s.%N%N"), (create {P_VERSION_STATIC}).version_string.item, ce_string ("linux-gnu")])
						end
						l_break := True
					end
					l_break := False
					if ((create {P_OPTIONS_STATIC}).opt.item.item.output_document).is_void then
						l_pos := -1 + 29 -- skip if block
					end
				when 25 then -- if:
						if (((create {P_OPTIONS_STATIC}).opt.item.item.output_document).item).to_integer_32 /= 45 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.output_document[1]).to_boolean then
							(create {P_RETR_STATIC}).output_stream.item := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))
						else
							l_pos := -1 + 28 -- goto _L
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else: | _L:
						if (create {P_OPTIONS_STATIC}).opt.item.item.always_rest then
							l_tmp___25 := ce_string ("ab")
						else
							l_tmp___25 := ce_string ("wb")
						end
						(create {P_RETR_STATIC}).output_stream.item := fopen ((create {P_OPTIONS_STATIC}).opt.item.item.output_document, l_tmp___25)
						if ((create {P_RETR_STATIC}).output_stream.item).is_void then
							perror ((create {P_OPTIONS_STATIC}).opt.item.item.output_document)
							exit (1)
						end
						if (fstat ((fileno ((create {P_RETR_STATIC}).output_stream.item)), l_st)) = 0 then
							if ((l_st.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 32_768 then
								(create {P_RETR_STATIC}).output_stream_regular.item := (1).to_boolean
							end
						end
				when 29 then -- if done
					if ((signal (1, create {CE_ROUTINE}.make_shared (default_pointer + 1))).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_ROUTINE}.make_shared (default_pointer + 1)).c_pointer.to_integer_32).to_natural_32 then
						signal (1, redirect_output_signal_address).do_nothing
					end
					signal (10, redirect_output_signal_address).do_nothing
					signal (13, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
					signal (28, (create {P_PROGRESS_STATIC}).progress_handle_sigwinch_address).do_nothing
					l_status := 31
					l_t := l_url
				when 30 then -- loop condition:
					if not (not (l_return) and then (not (l_t.item).is_void)) then
						l_pos := -1 + 49 -- skip loop
					end
				when 31 then -- loop body:
						l_filename.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						l_redirected_URL.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						l_iri := (create {P_IRI_STATIC}).dummy_iri.item
						l_url_parsed := (create {P_URL_STATIC}).url_parse (l_t.item, l_url_err, l_iri, (1).to_boolean)
						if (not l_url_parsed.is_void) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_error___0 := ((create {P_URL_STATIC}).url_error (l_t.item, l_url_err.item));
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s.%N"), l_t.item, l_error___0])
						free (create {CE_VOID_POINTER}.make_cast (l_error___0))
						l_status := 23
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 34 then -- else:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.recursive) then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_pos := -1 + 38 -- goto _L___1
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 37 then -- else:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.page_requisites) then
							l_pos := -1 + 46 -- skip if block
						end
				when 38 then -- if: | _L___1:
						if ((create {P_URL_STATIC}).url_scheme (l_t.item)) = {NATURAL_32} 1 then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						l_pos := -1 + 42 -- goto _L___0
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 41 then -- else:
						if not ((create {P_RETR_STATIC}).url_uses_proxy (l_url_parsed)) then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if: | _L___0:
						l_old_follow_ftp := ((create {P_OPTIONS_STATIC}).opt.item.item.follow_ftp).to_integer
						if ((create {P_URL_STATIC}).url_scheme (l_t.item)) = {NATURAL_32} 1 then
							(create {P_OPTIONS_STATIC}).opt.item.item.follow_ftp := (1).to_boolean
						end
						l_status := (l_url_parsed.item.retrieve_tree (create {CE_CLASS_POINTER [PD_IRI]}.make_shared (default_pointer))).to_integer_32;
						(create {P_OPTIONS_STATIC}).opt.item.item.follow_ftp := l_old_follow_ftp.to_boolean
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else:
						l_tmp___32 := (create {P_RETR_STATIC}).retrieve_url (l_url_parsed, l_t.item, l_filename, l_redirected_URL, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), l_dt, (create {P_OPTIONS_STATIC}).opt.item.item.recursive, l_iri, (1).to_boolean)
						l_status := l_tmp___32.to_integer_32
				when 45 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else:
						l_tmp___32 := (create {P_RETR_STATIC}).retrieve_url (l_url_parsed, l_t.item, l_filename, l_redirected_URL, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), l_dt, (create {P_OPTIONS_STATIC}).opt.item.item.recursive, l_iri, (1).to_boolean)
						l_status := l_tmp___32.to_integer_32
				when 47 then -- if done
						if (create {P_OPTIONS_STATIC}).opt.item.item.delete_after then
							if ((create {P_UTILS_STATIC}).file_exists_p (l_filename.item)) then
								from
								until
									(l_break)
								loop
									l_break := False
									if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
										(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Removing file due to --delete-after in main():%N")])
									end
									l_break := True
								end
								l_break := False;
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Removing %%s.%N"))), l_filename.item])
								if (unlink (l_filename.item)).to_boolean then
									(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("unlink: %%s%N"), (strerror ((errno_location).item))])
								end
							end
						end
						if (not (l_redirected_URL.item).is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_redirected_URL.item))
						end
						if (not (l_filename.item).is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_filename.item))
						end
						l_url_parsed.item.url_free
				when 48 then -- if done
						l_t := l_t + 1
						l_pos := -1 + 30 -- back to loop condition
				when 49 then -- loop done
					if (not ((create {P_OPTIONS_STATIC}).opt.item.item.input_filename).is_void) then
						l_status := ((create {P_RETR_STATIC}).retrieve_from_file ((create {P_OPTIONS_STATIC}).opt.item.item.input_filename, (create {P_OPTIONS_STATIC}).opt.item.item.force_html, l_count)).to_integer_32
						if not (l_count.item).to_boolean then
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("No URLs found in %%s.%N"))), (create {P_OPTIONS_STATIC}).opt.item.item.input_filename])
						end
					end
					if (create {P_OPTIONS_STATIC}).opt.item.item.recursive then
						if (create {P_OPTIONS_STATIC}).opt.item.item.spider then
							(create {P_SPIDER_STATIC}).print_broken_links
						end
					end
					if not ((create {P_OPTIONS_STATIC}).opt.item.item.recursive) then
						l_pos := -1 + 52 -- skip if block
					end
				when 50 then -- if:
						l_pos := -1 + 60 -- goto _L___2
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 52 then -- else:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.page_requisites) then
							l_pos := -1 + 55 -- skip if block
						end
				when 53 then -- if:
						l_pos := -1 + 60 -- goto _L___2
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 55 then -- else:
						if not (l_nurl > 1) then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						l_pos := -1 + 60 -- goto _L___2
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 58 then -- else:
						if ((create {P_OPTIONS_STATIC}).opt.item.item.input_filename).is_void then
							l_pos := -1 + 61 -- skip if block
						end
				when 59 then -- if:
						if (create {P_RETR_STATIC}).total_downloaded_bytes.item = {INTEGER_64} 0 then
							l_pos := -1 + 61 -- skip if block
						end
				when 60 then -- if: | _L___2:
						if (create {P_RETR_STATIC}).total_downloaded_bytes.item /= {INTEGER_64} 0 then
							l_tmp___43 := (create {P_RETR_STATIC}).retr_rate ((create {P_RETR_STATIC}).total_downloaded_bytes.item, (create {P_RETR_STATIC}).total_download_time.item)
							l_tmp___44 := secs_to_human_time ((create {P_RETR_STATIC}).total_download_time.item)
							l_tmp___45 := (create {P_UTILS_STATIC}).human_readable ((create {P_RETR_STATIC}).total_downloaded_bytes.item)
							l_tmp___47 := (create {P_UTILS_STATIC}).datetime_str ((time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))));
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("FINISHED --%%s--%NDownloaded: %%d files, %%s in %%s (%%s)%N"))), l_tmp___47, numurls.item, l_tmp___45, l_tmp___44, l_tmp___43])
							if ((create {P_OPTIONS_STATIC}).opt.item.item.quota).to_boolean then
								if (create {P_RETR_STATIC}).total_downloaded_bytes.item > (create {P_OPTIONS_STATIC}).opt.item.item.quota then
									l_tmp___49 := (create {P_UTILS_STATIC}).human_readable ((create {P_OPTIONS_STATIC}).opt.item.item.quota);
									(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Download quota of %%s EXCEEDED!%N"))), l_tmp___49])
								end
							end
						end
				when 61 then -- if done | if done | if done | if done
					if (not ((create {P_OPTIONS_STATIC}).opt.item.item.cookies_output).is_void) then
						(create {P_HTTP_STATIC}).save_cookies
					end
					if (create {P_OPTIONS_STATIC}).opt.item.item.convert_links then
						if not (create {P_OPTIONS_STATIC}).opt.item.item.delete_after then
							(create {P_CONVERT_STATIC}).convert_all_links
						end
					end
					(create {P_LOG_STATIC}).log_close
					l_i := 0
					from
					until
						not (l_i < l_nurl)
					loop
						free (create {CE_VOID_POINTER}.make_cast (l_url[l_i]))
						l_i := l_i + 1
					end
					(create {P_INIT_STATIC}).cleanup
					Result := ((create {P_EXITS_STATIC}).get_exit_status)
				when 62 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	redirect_output_signal (a_sig: INTEGER_32)
		local
			l_signal_name: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			if a_sig = 1 then
				l_tmp___0 := ce_string ("SIGHUP")
			else
				if a_sig = 10 then
					l_tmp := ce_string ("SIGUSR1")
				else
					l_tmp := ce_string ("WTF?!")
				end
				l_tmp___0 := l_tmp
			end
			l_signal_name := l_tmp___0;
			(create {P_LOG_STATIC}).log_request_redirect_output (l_signal_name);
			(create {P_PROGRESS_STATIC}).progress_schedule_redirect
			signal (a_sig, redirect_output_signal_address).do_nothing
		end

feature {ANY} -- routine addresses

	print_help_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent print_help)
		end

	print_version_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent print_version)
		end

	redirect_output_signal_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent redirect_output_signal)
		end

end
