class
	PD_GEN_MD5_CONTEXT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create imp.make
		end

feature {ANY} -- fields

	imp: PD_MD5_CTX assign set_imp

feature {ANY} -- field setters

	set_imp (a_imp: PD_MD5_CTX)
		do
			imp := a_imp
			update_memory_field ("imp")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			imp := a_other.imp.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				imp.is_equal (a_other.imp)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("imp")
				>>)
			init_structure_info
		end

end
