class
	WGET_ASSEMBLER

feature {NONE}

	asm1 (op1: CE_ARRAY [INTEGER_32]; op2: CE_ARRAY [INTEGER_32]; op3: CE_ARRAY [SD_FD_SET])
		do
			c_asm1 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm1 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <wget.h>"
		alias
			"[
				int __d0 = *(int *)$op1;
				int __d1 = *(int *)$op2;
				fd_set fdset = *(fd_set *)$op3;

				__asm__ volatile ("cld; rep; stosl"
						: "=c" (__d0), "=D" (__d1)
						: "a" (0), "0" (sizeof(struct __anonstruct_fd_set_3) / sizeof(long)), "1" (&fdset.fds_bits[0])
						: "memory"
					);

				*(int *)$op1 = __d0;
				*(int *)$op2 = __d1;
				*(fd_set *)$op3 = fdset;
			]"
		end

	asm2 (op1: CE_ARRAY [SD_FD_SET]; op2: CE_ARRAY [INTEGER_32])
		do
			c_asm2 (op1.c_pointer, op2.c_pointer)
		end

	c_asm2 (op1: POINTER; op2: POINTER)
		external
			"C inline use <wget.h>"
		alias
			"[
				fd_set fdset = *(fd_set *)$op1;
				int fd = *(int *)$op2;

				__asm__ volatile ("btsl %1,%0"
						: "=m" (fdset.fds_bits[fd / (8 * (int)sizeof(long))])
						: "r" (fd % (8 * (int)sizeof(long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = fdset;
				*(int *)$op2 = fd;
			]"
		end

	asm3 (op1: CE_ARRAY [INTEGER_32]; op2: CE_ARRAY [INTEGER_32]; op3: CE_ARRAY [SD_FD_SET])
		do
			c_asm3 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm3 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <wget.h>"
		alias
			"[
				int __d0 = *(int *)$op1;
				int __d1 = *(int *)$op2;
				fd_set check_set = *(fd_set *)$op3;

				__asm__ volatile ("cld; rep; stosl"
						: "=c" (__d0), "=D" (__d1)
						: "a" (0), "0" (sizeof(struct __anonstruct_fd_set_3) / sizeof(long)), "1" (&check_set.fds_bits[0])
						: "memory"
					);

				*(int *)$op1 = __d0;
				*(int *)$op2 = __d1;
				*(fd_set *)$op3 = check_set;
			]"
		end

	asm4 (op1: CE_ARRAY [SD_FD_SET]; op2: CE_ARRAY [INTEGER_32])
		do
			c_asm4 (op1.c_pointer, op2.c_pointer)
		end

	c_asm4 (op1: POINTER; op2: POINTER)
		external
			"C inline use <wget.h>"
		alias
			"[
				fd_set check_set = *(fd_set *)$op1;
				int sock = *(int *)$op2;

				__asm__ volatile ("btsl %1,%0"
						: "=m" (check_set.fds_bits[sock / (8 * (int)sizeof(long))])
						: "r" (sock % (8 * (int)sizeof(long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = check_set;
				*(int *)$op2 = sock;
			]"
		end

end
