class
	P_MAILTO_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC

feature {ANY} -- public routines

	prog_func (a_term: CE_POINTER [PD_TERMINAL]; a_list: CE_POINTER [PD_LIST_HEAD]; a_param, a_name: CE_POINTER [NATURAL_8])
		require
			not a_list.is_void
		local
			l_prog: CE_POINTER [NATURAL_8]
			l_cmd: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_prog := a_list.item.get_prog
			if (not l_prog.is_void) then
				if not (l_prog.item).to_boolean then
					a_term.item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 295, 129, (create {P_LINKS_STATIC}).dummyarray.item + 296, ce_string (" "), a_name, ce_string ("."), create {CE_VOID_POINTER}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
					l_return := True
				end
			else
				a_term.item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 295, 129, (create {P_LINKS_STATIC}).dummyarray.item + 296, ce_string (" "), a_name, ce_string ("."), create {CE_VOID_POINTER}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
				l_return := True
			end
			if not l_return then
				l_cmd := (create {P_SESSION_STATIC}).subst_file (l_prog, a_param)
				if (not l_cmd.is_void) then
					(create {P_TERMINAL_STATIC}).exec_on_terminal (a_term, l_cmd, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 1);
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mailto.c")), 12, create {CE_VOID_POINTER}.make_cast (l_cmd))
				end
			end
		end

	mailto_func (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8])
		local
			l_user: CE_POINTER [NATURAL_8]
			l_host: CE_POINTER [NATURAL_8]
			l_m: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_f: INTEGER_32
			l_tmp: NATURAL_32
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_m.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_f := 1
					l_user := (create {P_URL_STATIC}).get_user_name (a_url)
					if l_user.is_void then
						l_pos := -1 + 4 -- goto fail
					end
				when 1 then
					l_host := (create {P_URL_STATIC}).get_host_name (a_url)
					if l_host.is_void then
						l_pos := -1 + 3 -- goto fail1
					end
				when 2 then
					l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_user))
					l_m.item := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mailto.c")), 22, (l_tmp + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_host)))) + {NATURAL_32} 2)))
					l_f := 0
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_m.item), create {CE_INTEGER_8_POINTER}.make_cast (l_user)).do_nothing
					strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_m.item), ce_string ("@")).do_nothing
					strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_m.item), create {CE_INTEGER_8_POINTER}.make_cast (l_host)).do_nothing;
					(create {P_OS_DEP_STATIC}).check_shell_security (l_m)
					prog_func (a_ses.item.term, (create {P_TYPES_STATIC}).mailto_prog.item, l_m.item, (create {P_LINKS_STATIC}).dummyarray.item + 297);
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mailto.c")), 29, create {CE_VOID_POINTER}.make_cast (l_m.item));
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mailto.c")), 30, create {CE_VOID_POINTER}.make_cast (l_host))
				when 3 then -- fail1:;
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mailto.c")), 32, create {CE_VOID_POINTER}.make_cast (l_user))
				when 4 then -- fail:
					if l_f.to_boolean then
						(a_ses.item.term).item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 138, 1, (create {P_LINKS_STATIC}).dummyarray.item + 301, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	tn_func (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8]; a_prog: CE_POINTER [PD_LIST_HEAD]; a_t1, a_t2: CE_POINTER [NATURAL_8])
		local
			l_m: CE_POINTER [NATURAL_8]
			l_h: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_hl: CE_ARRAY [INTEGER_32]
			l_pl: CE_ARRAY [INTEGER_32]
			l_hh: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_pp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_f: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___2: NATURAL_32
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_h.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_hl.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_pl.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_hh.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_pp.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_f := 1
					if ((create {P_URL_STATIC}).parse_url (a_url, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_h, l_hl, l_p, l_pl, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
						l_pos := -1 + 2 -- goto fail
					elseif not (l_hl.item).to_boolean then
						l_pos := -1 + 2 -- goto fail
					end
				when 1 then
					l_hh.item := (create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mailto.c")), 45, l_h.item, l_hl.item)
					if (l_pl.item).to_boolean then
						l_pp.item := (create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mailto.c")), 46, l_p.item, l_pl.item)
					end
					(create {P_OS_DEP_STATIC}).check_shell_security (l_hh)
					if (l_pl.item).to_boolean then
						(create {P_OS_DEP_STATIC}).check_shell_security (l_pp)
					end
					l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_hh.item))
					if (l_pl.item).to_boolean then
						l_tmp___2 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_pp.item)))
					else
						l_tmp___2 := (0).to_natural_32
					end
					l_m := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mailto.c")), 49, (l_tmp___0 + l_tmp___2) + {NATURAL_32} 2)))
					l_f := 0
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_m), create {CE_INTEGER_8_POINTER}.make_cast (l_hh.item)).do_nothing
					if (l_pl.item).to_boolean then
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_m), ce_string (" ")).do_nothing
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_m), create {CE_INTEGER_8_POINTER}.make_cast (l_pp.item)).do_nothing
						l_m[((l_hl.item + 1) + l_pl.item)] := (0).to_natural_8
					end
					prog_func (a_ses.item.term, a_prog, l_m, a_t1);
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mailto.c")), 58, create {CE_VOID_POINTER}.make_cast (l_m))
					if (l_pl.item).to_boolean then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mailto.c")), 59, create {CE_VOID_POINTER}.make_cast (l_pp.item))
					end
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mailto.c")), 60, create {CE_VOID_POINTER}.make_cast (l_hh.item))
				when 2 then -- fail:
					if l_f.to_boolean then
						(a_ses.item.term).item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 138, 1, a_t2, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
					end
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	telnet_func (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8])
		do
			tn_func (a_ses, a_url, (create {P_TYPES_STATIC}).telnet_prog.item, (create {P_LINKS_STATIC}).dummyarray.item + 298, (create {P_LINKS_STATIC}).dummyarray.item + 302)
		end

	tn3270_func (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8])
		do
			tn_func (a_ses, a_url, (create {P_TYPES_STATIC}).tn3270_prog.item, (create {P_LINKS_STATIC}).dummyarray.item + 299, (create {P_LINKS_STATIC}).dummyarray.item + 303)
		end

feature {ANY} -- routine addresses

	mailto_func_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent mailto_func)
		end

	telnet_func_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent telnet_func)
		end

	tn3270_func_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent tn3270_func)
		end

end
