class
	PD_DIRS

inherit
	PD_DIRS_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} s.make
			create {CE_NATURAL_8_POINTER} f.make
			Precursor
		end

feature {ANY} -- fields

	s: CE_POINTER [NATURAL_8] assign set_s

	f: CE_POINTER [NATURAL_8] assign set_f

feature {ANY} -- field setters

	set_s (a_s: CE_POINTER [NATURAL_8])
		do
			s := a_s
			update_memory_field ("s")
		end

	set_f (a_f: CE_POINTER [NATURAL_8])
		do
			f := a_f
			update_memory_field ("f")
		end

feature {ANY} -- public routines

	comp_de (a_d2: CE_POINTER [PD_DIRS]): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			if (f[0]).to_integer_32 = 46 then
				if (f[1]).to_integer_32 = 46 then
					if not (f[2]).to_boolean then
						Result := (-1)
						l_return := True
					end
				end
			end
			if not l_return and then ((a_d2.item.f[0]).to_integer_32 = 46) then
				if (a_d2.item.f[1]).to_integer_32 = 46 then
					if not (a_d2.item.f[2]).to_boolean then
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return and then ((s[0]).to_integer_32 = 100) then
				if (a_d2.item.s[0]).to_integer_32 /= 100 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return and then ((s[0]).to_integer_32 /= 100) then
				if (a_d2.item.s[0]).to_integer_32 = 100 then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				l_tmp := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (f), create {CE_INTEGER_8_POINTER}.make_cast (a_d2.item.f))
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			s := a_other.s
			f := a_other.f
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				s.is_equal (a_other.s) and
				f.is_equal (a_other.f)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("s"),
					create {CE_STRUCTURE_FIELD}.make ("f")
				>>)
			init_structure_info
		end

end
