class
	PD_DIGRAPH

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	char1: NATURAL_8 assign set_char1

	char2: NATURAL_8 assign set_char2

	result2: INTEGER_32 assign set_result2

feature {ANY} -- field setters

	set_char1 (a_char1: NATURAL_8)
		do
			char1 := a_char1
			update_memory_field ("char1")
		end

	set_char2 (a_char2: NATURAL_8)
		do
			char2 := a_char2
			update_memory_field ("char2")
		end

	set_result2 (a_result2: INTEGER_32)
		do
			result2 := a_result2
			update_memory_field ("result2")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			char1 := a_other.char1
			char2 := a_other.char2
			result2 := a_other.result2
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				char1 = a_other.char1 and
				char2 = a_other.char2 and
				result2 = a_other.result2
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("char1"),
					create {CE_STRUCTURE_FIELD}.make ("char2"),
					create {CE_STRUCTURE_FIELD}.make ("result2")
				>>)
			init_structure_info
		end

end
