class
	PD_GTKFORMCLASS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create parent_class.make
		end

feature {ANY} -- fields

	parent_class: SD_GTKCONTAINERCLASS assign set_parent_class

feature {ANY} -- field setters

	set_parent_class (a_parent_class: SD_GTKCONTAINERCLASS)
		do
			parent_class := a_parent_class
			update_memory_field ("parent_class")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_class := a_other.parent_class.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_class.is_equal (a_other.parent_class)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_class")
				>>)
			init_structure_info
		end

end
