class
	PD_MATCH_FOUND

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_ARRAY} match.make (<<1>>)
		end

feature {ANY} -- fields

	len: INTEGER_32 assign set_len

	match: CE_ARRAY [NATURAL_8]

feature {ANY} -- field setters

	set_len (a_len: INTEGER_32)
		do
			len := a_len
			update_memory_field ("len")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			len := a_other.len
			match := a_other.match.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				len = a_other.len and
				match.is_equal (a_other.match)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("len"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("match", <<1>>)
				>>)
			init_structure_info
		end

end
