class
	PD_ML_CHUNKSIZE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	mlcs_numlines: INTEGER_32 assign set_mlcs_numlines

	mlcs_totalsize: INTEGER_32 assign set_mlcs_totalsize

feature {ANY} -- field setters

	set_mlcs_numlines (a_mlcs_numlines: INTEGER_32)
		do
			mlcs_numlines := a_mlcs_numlines
			update_memory_field ("mlcs_numlines")
		end

	set_mlcs_totalsize (a_mlcs_totalsize: INTEGER_32)
		do
			mlcs_totalsize := a_mlcs_totalsize
			update_memory_field ("mlcs_totalsize")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mlcs_numlines := a_other.mlcs_numlines
			mlcs_totalsize := a_other.mlcs_totalsize
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mlcs_numlines = a_other.mlcs_numlines and
				mlcs_totalsize = a_other.mlcs_totalsize
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("mlcs_numlines"),
					create {CE_STRUCTURE_FIELD}.make ("mlcs_totalsize")
				>>)
			init_structure_info
		end

end
