class
	S_SYS_WAIT_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	wait (a___stat_loc: CE_POINTER [SD_WAIT]): INTEGER_32
		do
			Result := c_wait (a___stat_loc.c_pointer)
		end

	c_wait (a___stat_loc: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return wait($a___stat_loc);"
		end

	waitpid (a___pid: INTEGER_32; a___stat_loc: CE_POINTER [INTEGER_32]; a___options: INTEGER_32): INTEGER_32
		do
			Result := c_waitpid (a___pid, a___stat_loc.c_pointer, a___options)
		end

	c_waitpid (a___pid: INTEGER_32; a___stat_loc: POINTER; a___options: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return waitpid($a___pid, $a___stat_loc, $a___options);"
		end

end
