class
	S_X11_INTRINSIC_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	XtDispatchEvent (a_arg1: CE_POINTER [SD_XEVENT]): INTEGER_8
		do
			Result := c_XtDispatchEvent (a_arg1.c_pointer)
		end

	c_XtDispatchEvent (a_arg1: POINTER): INTEGER_8
		external
			"C inline use <vim.h>"
		alias
			"return XtDispatchEvent($a_arg1);"
		end

	XtAppNextEvent (a_arg1: CE_POINTER [ANY]; a_arg2: CE_POINTER [SD_XEVENT])
		do
			c_XtAppNextEvent (a_arg1.c_pointer, a_arg2.c_pointer)
		end

	c_XtAppNextEvent (a_arg1: POINTER; a_arg2: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"XtAppNextEvent($a_arg1, $a_arg2);"
		end

	XtAppPending (a_arg1: CE_POINTER [ANY]): NATURAL_32
		do
			Result := c_XtAppPending (a_arg1.c_pointer)
		end

	c_XtAppPending (a_arg1: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return XtAppPending($a_arg1);"
		end

	XtRealizeWidget (a_arg1: CE_POINTER [ANY])
		do
			c_XtRealizeWidget (a_arg1.c_pointer)
		end

	c_XtRealizeWidget (a_arg1: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"XtRealizeWidget($a_arg1);"
		end

	XtDestroyWidget (a_arg1: CE_POINTER [ANY])
		do
			c_XtDestroyWidget (a_arg1.c_pointer)
		end

	c_XtDestroyWidget (a_arg1: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"XtDestroyWidget($a_arg1);"
		end

	XtVaCreatePopupShell (a_args: TUPLE [a_arg1: CE_POINTER [INTEGER_8]; a_arg2, a_arg3: CE_POINTER [ANY]]): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared ((create {CE_ROUTINE}.make_shared (c_XtVaCreatePopupShell)).pointer_item (a_args).c_pointer)
		end

	c_XtVaCreatePopupShell: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)&XtVaCreatePopupShell;"
		end

	XtVaAppCreateShell (a_args: TUPLE [a_arg1, a_arg2: CE_POINTER [INTEGER_8]; a_arg3, a_arg4: CE_POINTER [ANY]]): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared ((create {CE_ROUTINE}.make_shared (c_XtVaAppCreateShell)).pointer_item (a_args).c_pointer)
		end

	c_XtVaAppCreateShell: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)&XtVaAppCreateShell;"
		end

	XtOpenDisplay (a_arg1: CE_POINTER [ANY]; a_arg2, a_arg3, a_arg4: CE_POINTER [INTEGER_8]; a_arg5: CE_POINTER [SD_XRMOPTIONDESCREC]; a_arg6: NATURAL_32; a_arg7: CE_POINTER [INTEGER_32]; a_arg8: CE_POINTER [CE_POINTER [INTEGER_8]]): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_XtOpenDisplay (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4.c_pointer, a_arg5.c_pointer, a_arg6, a_arg7.c_pointer, a_arg8.c_pointer))
		end

	c_XtOpenDisplay (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: POINTER; a_arg5: POINTER; a_arg6: NATURAL_32; a_arg7: POINTER; a_arg8: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)XtOpenDisplay($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7, $a_arg8);"
		end

	XtOwnSelection (a_arg1: CE_POINTER [ANY]; a_arg2, a_arg3: NATURAL_32; a_arg4, a_arg5, a_arg6: CE_ROUTINE): INTEGER_8
		do
			Result := c_XtOwnSelection (a_arg1.c_pointer, a_arg2, a_arg3, a_arg4.c_pointer, a_arg5.c_pointer, a_arg6.c_pointer)
		end

	c_XtOwnSelection (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: NATURAL_32; a_arg4: POINTER; a_arg5: POINTER; a_arg6: POINTER): INTEGER_8
		external
			"C inline use <vim.h>"
		alias
			"return XtOwnSelection($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6);"
		end

	XtAddEventHandler (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3: INTEGER_8; a_arg4: CE_ROUTINE; a_arg5: CE_POINTER [ANY])
		do
			c_XtAddEventHandler (a_arg1.c_pointer, a_arg2, a_arg3, a_arg4.c_pointer, a_arg5.c_pointer)
		end

	c_XtAddEventHandler (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: INTEGER_8; a_arg4: POINTER; a_arg5: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"XtAddEventHandler($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	XtDisplay (a_arg1: CE_POINTER [ANY]): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_XtDisplay (a_arg1.c_pointer))
		end

	c_XtDisplay (a_arg1: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)XtDisplay($a_arg1);"
		end

	XtWindow (a_arg1: CE_POINTER [ANY]): NATURAL_32
		do
			Result := c_XtWindow (a_arg1.c_pointer)
		end

	c_XtWindow (a_arg1: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return XtWindow($a_arg1);"
		end

	XtToolkitInitialize
		external
			"C inline use <vim.h>"
		alias
			"XtToolkitInitialize();"
		end

	XtCreateApplicationContext: CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_XtCreateApplicationContext)
		end

	c_XtCreateApplicationContext: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)XtCreateApplicationContext();"
		end

	XtMalloc (a_arg1: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_XtMalloc (a_arg1))
		end

	c_XtMalloc (a_arg1: NATURAL_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)XtMalloc($a_arg1);"
		end

	XtFree (a_arg1: CE_POINTER [INTEGER_8])
		do
			c_XtFree (a_arg1.c_pointer)
		end

	c_XtFree (a_arg1: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"XtFree($a_arg1);"
		end

	XtDisownSelection (a_arg1: CE_POINTER [ANY]; a_arg2, a_arg3: NATURAL_32)
		do
			c_XtDisownSelection (a_arg1.c_pointer, a_arg2, a_arg3)
		end

	c_XtDisownSelection (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"XtDisownSelection($a_arg1, $a_arg2, $a_arg3);"
		end

	XtGetSelectionValue (a_arg1: CE_POINTER [ANY]; a_arg2, a_arg3: NATURAL_32; a_arg4: CE_ROUTINE; a_arg5: CE_POINTER [ANY]; a_arg6: NATURAL_32)
		do
			c_XtGetSelectionValue (a_arg1.c_pointer, a_arg2, a_arg3, a_arg4.c_pointer, a_arg5.c_pointer, a_arg6)
		end

	c_XtGetSelectionValue (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: NATURAL_32; a_arg4: POINTER; a_arg5: POINTER; a_arg6: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"XtGetSelectionValue($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6);"
		end

end
