class
	SD_GCLOSURENOTIFYDATA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} data.make
			create notify.make
		end

feature {ANY} -- fields

	data: CE_POINTER [ANY] assign set_data

	notify: CE_ROUTINE assign set_notify

feature {ANY} -- field setters

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_notify (a_notify: CE_ROUTINE)
		do
			notify := a_notify
			update_memory_field ("notify")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			data := a_other.data
			notify := a_other.notify
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				data.is_equal (a_other.data) and
				notify.is_equal (a_other.notify)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("notify")
				>>)
			init_structure_info
		end

end
