class
	SD_GTKCHECKBUTTON

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create toggle_button.make
		end

feature {ANY} -- fields

	toggle_button: SD_GTKTOGGLEBUTTON assign set_toggle_button

feature {ANY} -- field setters

	set_toggle_button (a_toggle_button: SD_GTKTOGGLEBUTTON)
		do
			toggle_button := a_toggle_button
			update_memory_field ("toggle_button")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			toggle_button := a_other.toggle_button.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				toggle_button.is_equal (a_other.toggle_button)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("toggle_button")
				>>)
			init_structure_info
		end

end
