class
	SD_GTKREQUISITION

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	width: INTEGER_32 assign set_width

	height: INTEGER_32 assign set_height

feature {ANY} -- field setters

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_height (a_height: INTEGER_32)
		do
			height := a_height
			update_memory_field ("height")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			width := a_other.width
			height := a_other.height
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				width = a_other.width and
				height = a_other.height
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("height")
				>>)
			init_structure_info
		end

end
