class
	P_COOKIE_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_TIME_STATIC
	S_STDIO_STATIC
	S_STDLIB_STATIC

feature {ANY} -- public routines

	tailmatch (a_little, a_bigone: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_little.is_void
			not a_bigone.is_void
		local
			l_littlelen: NATURAL_32
			l_biglen: NATURAL_32
			l_return: BOOLEAN
		do
			l_littlelen := (strlen (a_little))
			l_biglen := (strlen (a_bigone))
			if l_littlelen > l_biglen then
				Result := (0).to_boolean
				l_return := True
			end
			if not l_return then
				Result := ((create {P_RAWSTR_STATIC}).Curl_raw_equal (a_little, (a_bigone + l_biglen.to_integer_32) - l_littlelen.to_integer_32)).to_boolean
			end
		end

	strstore (a_str: CE_POINTER [CE_POINTER [INTEGER_8]]; a_newstr: CE_POINTER [INTEGER_8])
		require
			not a_str.is_void
		do
			if (not (a_str.item).is_void) then
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_str.item)])
			end
			a_str.item := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([a_newstr]))
		end

	Curl_cookie_add (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_c: CE_POINTER [PD_COOKIEINFO]; a_httpheader: BOOLEAN; a_lineptr, a_domain, a_path: CE_POINTER [INTEGER_8]): CE_POINTER [PD_COOKIE]
		local
			l_lineptr: CE_POINTER [INTEGER_8]
			l_clist: CE_POINTER [PD_COOKIE]
			l_name: CE_ARRAY [INTEGER_8]
			l_co: CE_POINTER [PD_COOKIE]
			l_lastc: CE_POINTER [PD_COOKIE]
			l_now: CE_ARRAY [INTEGER_32]
			l_replace_old: BOOLEAN
			l_badcookie: BOOLEAN
			l_ptr: CE_POINTER [INTEGER_8]
			l_sep: CE_POINTER [INTEGER_8]
			l_semiptr: CE_POINTER [INTEGER_8]
			l_what: CE_POINTER [INTEGER_8]
			l_tmp___3: INTEGER_32
			l_tmp___5: INTEGER_8
			l_whatptr: CE_POINTER [INTEGER_8]
			l_len: NATURAL_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_domptr: CE_POINTER [INTEGER_8]
			l_dotcount: INTEGER_32
			l_tailptr: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___23: INTEGER_32
			l_queryp: CE_POINTER [INTEGER_8]
			l_endslash: CE_POINTER [INTEGER_8]
			l_pathlen: NATURAL_32
			l_ptr___0: CE_POINTER [INTEGER_8]
			l_firstptr: CE_POINTER [INTEGER_8]
			l_tok_buf: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_fields: INTEGER_32
			l_tmp___38: CE_POINTER [INTEGER_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_name.make (<<1_024>>)
			create {CE_INTEGER_32_ARRAY} l_now.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_tok_buf.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lineptr := a_lineptr
					l_lastc := create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer)
					l_now.item := (time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
					l_replace_old := (0).to_boolean
					l_badcookie := (0).to_boolean
					l_co := create {CE_CLASS_POINTER [PD_COOKIE]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, (create {PD_COOKIE}.make).structure_size.to_natural_32]))))
					if l_co.is_void then
						Result := (create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 51 -- skip if block
					end
				when 1 then -- if:
						if not a_httpheader then
							l_pos := -1 + 35 -- skip if block
						end
				when 2 then -- if:
						l_what := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(5_000).to_natural_32]))))
						if l_what.is_void then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_co)])
							Result := (create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer))
							l_return := True
						end
						if l_return then
							l_pos := -1 + 34 -- skip if block
						end
				when 3 then -- if:
						l_semiptr := (strchr (l_lineptr, (';').code))
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_lineptr[0]).to_boolean then
								if ((l_lineptr[0]).to_natural_8).to_integer_32 = 32 then
									l_tmp___3 := 1
								elseif ((l_lineptr[0]).to_natural_8).to_integer_32 = 9 then
									l_tmp___3 := 1
								else
									l_tmp___3 := 0
								end
								if not l_tmp___3.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_lineptr := l_lineptr + 1
							end
						end
						l_break := False
						l_ptr := l_lineptr
				when 4 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 33 -- skip loop
						end
				when 5 then -- loop body:
						l_break := False
						l_continue := False
						l_sep := (strchr (l_ptr, ('=').code))
						if l_sep.is_void then
							l_pos := -1 + 30 -- skip if block
						end
				when 6 then -- if:
						if (not l_semiptr.is_void) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___1
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 9 then -- else:
						if not ((l_semiptr.c_pointer.to_integer_32).to_natural_32 > (l_sep.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 28 -- skip if block
						end
				when 10 then -- if: | _L___1:
						l_tmp___5 := (0).to_integer_8
						l_what[0] := l_tmp___5
						l_name[0] := l_tmp___5
						if not (1 <= (sscanf ([l_ptr, ce_string ("%%1023[^;=]=%%4999[^;%R%N]"), l_name, l_what]))) then
							l_pos := -1 + 27 -- skip if block
						end
				when 11 then -- if:
						l_len := (strlen (l_what))
						from
						until
							(l_break)
						loop
							l_break := False
							if l_len.to_boolean then
								if ((l_what[(l_len - {NATURAL_32} 1).to_integer_32]).to_natural_8).to_integer_32 = 32 then
									l_tmp___7 := 1
								elseif ((l_what[(l_len - {NATURAL_32} 1).to_integer_32]).to_natural_8).to_integer_32 = 9 then
									l_tmp___7 := 1
								else
									l_tmp___7 := 0
								end
								if not l_tmp___7.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_what[(l_len - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
								l_len := l_len - 1
							end
						end
						l_break := False
						l_whatptr := l_what
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_whatptr[0]).to_boolean then
								if ((l_whatptr[0]).to_natural_8).to_integer_32 = 32 then
									l_tmp___8 := 1
								elseif ((l_whatptr[0]).to_natural_8).to_integer_32 = 9 then
									l_tmp___8 := 1
								else
									l_tmp___8 := 0
								end
								if not l_tmp___8.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_whatptr := l_whatptr + 1
							end
						end
						l_break := False
						if not (((create {P_RAWSTR_STATIC}).Curl_raw_equal (ce_string ("path"), l_name)).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						strstore (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (l_co.c_pointer + (create {PD_COOKIE}.make).offset_of ("path")), l_whatptr)
						if (l_co.item.path).is_void then
							l_badcookie := (1).to_boolean
							l_break := True
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 14 then -- else:
						if not (((create {P_RAWSTR_STATIC}).Curl_raw_equal (ce_string ("domain"), l_name)).to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 15 then -- if:
						l_domptr := l_whatptr
						l_dotcount := 1
						if 46 = (l_whatptr[0]).to_integer_32 then
							l_domptr := l_domptr + 1
						end
						from
						until
							(l_break)
						loop
							l_break := False
							l_domptr := (strchr (l_domptr, ('.').code))
							if (not l_domptr.is_void) then
								l_domptr := l_domptr + 1
								l_dotcount := l_dotcount + 1
							end
							if l_domptr.is_void then
								l_break := True
							end
						end
						l_break := False
						if not (l_dotcount < 2) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_badcookie := (1).to_boolean;
						(create {P_SENDF_STATIC}).Curl_infof ([a_data, ce_string ("skipped cookie with illegal dotcount domain: %%s%N"), l_whatptr])
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 18 then -- else:
						if 46 = (l_whatptr[0]).to_integer_32 then
							l_whatptr := l_whatptr + 1
						end
						if (not a_domain.is_void) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else:
						if not (tailmatch (l_whatptr, a_domain)) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if: | _L:
						l_tailptr := l_whatptr
						if (l_tailptr[0]).to_integer_32 = 46 then
							l_tailptr := l_tailptr + 1
						end
						strstore (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (l_co.c_pointer + (create {PD_COOKIE}.make).offset_of ("domain")), l_tailptr)
						if (l_co.item.domain).is_void then
							l_badcookie := (1).to_boolean
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_co.item.tailmatch := (1).to_boolean
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						l_badcookie := (1).to_boolean;
						(create {P_SENDF_STATIC}).Curl_infof ([a_data, ce_string ("skipped cookie with bad tailmatch domain: %%s%N"), l_whatptr])
				when 25 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						if ((create {P_RAWSTR_STATIC}).Curl_raw_equal (ce_string ("version"), l_name)).to_boolean then
							strstore (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (l_co.c_pointer + (create {PD_COOKIE}.make).offset_of ("version")), l_whatptr)
							if (l_co.item.version).is_void then
								l_badcookie := (1).to_boolean
								l_break := True
							end
						elseif ((create {P_RAWSTR_STATIC}).Curl_raw_equal (ce_string ("max-age"), l_name)).to_boolean then
							strstore (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (l_co.c_pointer + (create {PD_COOKIE}.make).offset_of ("maxage")), l_whatptr)
							if (l_co.item.maxage).is_void then
								l_badcookie := (1).to_boolean
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								if ((l_co.item.maxage).item).to_integer_32 = 34 then
									l_tmp___11 := l_co.item.maxage + 1
								else
									l_tmp___11 := l_co.item.maxage + 0
								end
								l_co.item.expires := ((atoi (l_tmp___11)).to_integer_32 + l_now.item).to_integer_64
							end
						elseif ((create {P_RAWSTR_STATIC}).Curl_raw_equal (ce_string ("expires"), l_name)).to_boolean then
							strstore (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (l_co.c_pointer + (create {PD_COOKIE}.make).offset_of ("expirestr")), l_whatptr)
							if (l_co.item.expirestr).is_void then
								l_badcookie := (1).to_boolean
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_co.item.expires := ((create {P_PARSEDATE_STATIC}).curl_getdate (l_what, l_now)).to_integer_64
								if l_co.item.expires = {INTEGER_64} 0 then
									l_co.item.expires := (1).to_integer_64
								elseif l_co.item.expires < {INTEGER_64} 0 then
									l_co.item.expires := (0).to_integer_64
								end
							end
						elseif (l_co.item.name).is_void then
							l_co.item.name := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_name]))
							l_co.item.value := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_whatptr]))
							if (l_co.item.name).is_void then
								l_badcookie := (1).to_boolean
								l_break := True
							elseif (l_co.item.value).is_void then
								l_badcookie := (1).to_boolean
								l_break := True
							end
						end
				when 27 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						l_pos := -1 + 30 -- goto _L___0
				when 29 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else: | _L___0:
						if (sscanf ([l_ptr, ce_string ("%%4999[^;%R%N]"), l_what])).to_boolean then
							if ((create {P_RAWSTR_STATIC}).Curl_raw_equal (ce_string ("secure"), l_what)).to_boolean then
								l_co.item.secure := (1).to_boolean
							elseif ((create {P_RAWSTR_STATIC}).Curl_raw_equal (ce_string ("httponly"), l_what)).to_boolean then
								l_co.item.httponly := (1).to_boolean
							end
						end
				when 31 then
						if not (l_return or l_break or l_continue) then
							if l_semiptr.is_void then
								l_semiptr := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								l_continue := True
							elseif not (l_semiptr[0]).to_boolean then
								l_semiptr := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							l_ptr := l_semiptr + 1
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_ptr[0]).to_boolean then
									if ((l_ptr[0]).to_natural_8).to_integer_32 = 32 then
										l_tmp___23 := 1
									elseif ((l_ptr[0]).to_natural_8).to_integer_32 = 9 then
										l_tmp___23 := 1
									else
										l_tmp___23 := 0
									end
									if not l_tmp___23.to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_ptr := l_ptr + 1
								end
							end
							l_break := False
							l_semiptr := (strchr (l_ptr, (';').code))
							if l_semiptr.is_void then
								if (l_ptr[0]).to_boolean then
									l_semiptr := (strchr (l_ptr, ('%/0/').code))
								end
							end
						end
						if (not l_return and not l_break) and then (l_semiptr.is_void) then
							l_pos := -1 + 33 -- break
						end
				when 32 then
						l_pos := -1 + 4 -- back to loop condition
				when 33 then -- loop done
						l_break := False
						l_continue := False
						if not l_badcookie then
							if (l_co.item.domain).is_void then
								if (not a_domain.is_void) then
									l_co.item.domain := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([a_domain]))
									if (l_co.item.domain).is_void then
										l_badcookie := (1).to_boolean
									end
								end
							end
						end
						if not l_badcookie then
							if (l_co.item.path).is_void then
								if (not a_path.is_void) then
									l_queryp := (strchr (a_path, ('?').code))
									if l_queryp.is_void then
										l_endslash := strrchr (a_path, ('/').code)
									else
										l_endslash := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_CURL_MEMRCHR_STATIC}).Curl_memrchr (create {CE_VOID_POINTER}.make_cast (a_path), ('/').code, (l_queryp.distance (a_path)).to_natural_32)))
									end
									if (not l_endslash.is_void) then
										l_pathlen := ((l_endslash.distance (a_path)) + 1).to_natural_32
										l_co.item.path := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([l_pathlen + {NATURAL_32} 1]))))
										if (not (l_co.item.path).is_void) then
											memcpy (create {CE_VOID_POINTER}.make_cast (l_co.item.path), create {CE_VOID_POINTER}.make_cast (a_path), l_pathlen).do_nothing
											l_co.item.path[l_pathlen.to_integer_32] := (0).to_integer_8
										else
											l_badcookie := (1).to_boolean
										end
									end
								end
							end
						end
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_what)])
						if l_badcookie then
							l_co.item.freecookie
							Result := (create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer))
							l_return := True
						elseif (l_co.item.name).is_void then
							l_co.item.freecookie
							Result := (create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer))
							l_return := True
						end
				when 34 then -- if done | if block done, skip else block:
						l_pos := -1 + 51
				when 35 then -- else:
						l_tok_buf.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						if (strncmp (l_lineptr, ce_string ("#HttpOnly_"), (10).to_natural_32)) = 0 then
							l_lineptr := l_lineptr + (10)
							l_co.item.httponly := (1).to_boolean
						end
						if (l_lineptr[0]).to_integer_32 = 35 then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_co)])
							Result := (create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer))
							l_return := True
						end
						if not l_return then
							l_ptr___0 := strchr (l_lineptr, ('%R').code)
							if (not l_ptr___0.is_void) then
								l_ptr___0[0] := (0).to_integer_8
							end
							l_ptr___0 := strchr (l_lineptr, ('%N').code)
							if (not l_ptr___0.is_void) then
								l_ptr___0[0] := (0).to_integer_8
							end
							l_firstptr := strtok_r (l_lineptr, ce_string ("%T"), l_tok_buf)
							if l_firstptr.is_void then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_co)])
								Result := (create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer))
								l_return := True
							elseif (not (strchr (l_firstptr, (':').code)).is_void) then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_co)])
								Result := (create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer))
								l_return := True
							end
						end
						if l_return then
							l_pos := -1 + 51 -- skip if block
						end
				when 36 then -- if:
						l_ptr___0 := l_firstptr
						l_fields := 0
				when 37 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 50 -- skip loop
						end
				when 38 then -- loop body:
						l_break := False
						if (not l_ptr___0.is_void) then
							if l_badcookie then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 49 -- skip if block
						end
				when 39 then -- if:
						inspect l_fields -- switch 1 head
						when 0 then l_pos := -1 + 40
						when 1 then l_pos := -1 + 41
						when 2 then l_pos := -1 + 42
						when 3 then l_pos := -1 + 44
						when 4 then l_pos := -1 + 45
						when 5 then l_pos := -1 + 46
						when 6 then l_pos := -1 + 47
						else l_pos := -1 + 48
						end
				when 40 then -- switch 1, case 0
						if (l_ptr___0[0]).to_integer_32 = 46 then
							l_ptr___0 := l_ptr___0 + 1
						end
						l_co.item.domain := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_ptr___0]))
						if (l_co.item.domain).is_void then
							l_badcookie := (1).to_boolean
						end
						l_pos := -1 + 48 -- switch 1; break
				when 41 then -- switch 1, case 1
						l_co.item.tailmatch := ((create {P_RAWSTR_STATIC}).Curl_raw_equal (l_ptr___0, ce_string ("TRUE"))).to_boolean
						l_pos := -1 + 48 -- switch 1; break
				when 42 then -- switch 1, case 2
						if (strcmp (ce_string ("TRUE"), l_ptr___0)).to_boolean then
							if (strcmp (ce_string ("FALSE"), l_ptr___0)).to_boolean then
								l_co.item.path := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_ptr___0]))
								if (l_co.item.path).is_void then
									l_badcookie := (1).to_boolean
								end
								l_pos := -1 + 48 -- switch 1; break
							end
						end
				when 43 then
						l_co.item.path := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([ce_string ("/")]))
						if (l_co.item.path).is_void then
							l_badcookie := (1).to_boolean
						end
						l_fields := l_fields + 1
				when 44 then -- switch 1, case 3
						l_co.item.secure := ((create {P_RAWSTR_STATIC}).Curl_raw_equal (l_ptr___0, ce_string ("TRUE"))).to_boolean
						l_pos := -1 + 48 -- switch 1; break
				when 45 then -- switch 1, case 4
						l_co.item.expires := strtoll (l_ptr___0, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10)
						l_pos := -1 + 48 -- switch 1; break
				when 46 then -- switch 1, case 5
						l_co.item.name := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_ptr___0]))
						if (l_co.item.name).is_void then
							l_badcookie := (1).to_boolean
						end
						l_pos := -1 + 48 -- switch 1; break
				when 47 then -- switch 1, case 6
						l_co.item.value := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_ptr___0]))
						if (l_co.item.value).is_void then
							l_badcookie := (1).to_boolean
						end
						l_pos := -1 + 48 -- switch 1; break
				when 48 then -- switch 1, done:
						l_ptr___0 := strtok_r (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string ("%T"), l_tok_buf)
						l_fields := l_fields + 1
				when 49 then -- if done
						l_pos := -1 + 37 -- back to loop condition
				when 50 then -- loop done
						l_break := False
						if 6 = l_fields then
							l_co.item.value := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([ce_string ("")]))
							if (l_co.item.value).is_void then
								l_badcookie := (1).to_boolean
							else
								l_fields := l_fields + 1
							end
						end
						if not l_badcookie then
							if 7 /= l_fields then
								l_badcookie := (1).to_boolean
							end
						end
						if l_badcookie then
							l_co.item.freecookie
							Result := (create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer))
							l_return := True
						end
				when 51 then -- if done | if done | if done
					if not l_return and then (not a_c.item.running) then
						if a_c.item.newsession then
							if not (l_co.item.expires).to_boolean then
								l_co.item.freecookie
								Result := (create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer))
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 66 -- skip if block
					end
				when 52 then -- if:
						l_co.item.livecookie := a_c.item.running
						l_clist := a_c.item.cookies
						l_replace_old := (0).to_boolean
				when 53 then -- loop condition:
						if not (not (l_return or l_break) and then (not l_clist.is_void)) then
							l_pos := -1 + 66 -- skip loop
						end
				when 54 then -- loop body:
						l_break := False
						if not (((create {P_RAWSTR_STATIC}).Curl_raw_equal (l_clist.item.name, l_co.item.name)).to_boolean) then
							l_pos := -1 + 65 -- skip if block
						end
				when 55 then -- if:
						if (l_clist.item.domain).is_void then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						if (not (l_co.item.domain).is_void) then
							if ((create {P_RAWSTR_STATIC}).Curl_raw_equal (l_clist.item.domain, l_co.item.domain)).to_boolean then
								l_replace_old := (1).to_boolean
							end
						else
							l_pos := -1 + 58 -- goto _L___2
						end
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 59
				when 58 then -- else: | _L___2:
						if (l_clist.item.domain).is_void then
							if (l_co.item.domain).is_void then
								l_replace_old := (1).to_boolean
							end
						end
				when 59 then
						if not l_replace_old then
							l_pos := -1 + 64 -- skip if block
						end
				when 60 then -- if:
						if (l_clist.item.path).is_void then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						if (not (l_co.item.path).is_void) then
							if ((create {P_RAWSTR_STATIC}).Curl_raw_equal (l_clist.item.path, l_co.item.path)).to_boolean then
								l_replace_old := (1).to_boolean
							else
								l_replace_old := (0).to_boolean
							end
						else
							l_pos := -1 + 63 -- goto _L___3
						end
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 64
				when 63 then -- else: | _L___3:
						if (l_clist.item.path).is_void then
							if (l_co.item.path).is_void then
								l_replace_old := (1).to_boolean
							else
								l_replace_old := (0).to_boolean
							end
						else
							l_replace_old := (0).to_boolean
						end
				when 64 then -- if done
						if l_replace_old then
							if not l_co.item.livecookie then
								if l_clist.item.livecookie then
									l_co.item.freecookie
									Result := (create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer))
									l_return := True
								end
							end
						end
						if not l_return and then l_replace_old then
							l_co.item.next := l_clist.item.next;
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_clist.item.name)])
							if (not (l_clist.item.value).is_void) then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_clist.item.value)])
							end
							if (not (l_clist.item.domain).is_void) then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_clist.item.domain)])
							end
							if (not (l_clist.item.path).is_void) then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_clist.item.path)])
							end
							if (not (l_clist.item.expirestr).is_void) then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_clist.item.expirestr)])
							end
							if (not (l_clist.item.version).is_void) then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_clist.item.version)])
							end
							if (not (l_clist.item.maxage).is_void) then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_clist.item.maxage)])
							end
							l_clist.item := (l_co.item).twin;
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_co)])
							l_co := l_clist
							from
							until
								(l_break)
							loop
								l_break := False
								l_lastc := l_clist
								l_clist := l_clist.item.next
								if l_clist.is_void then
									l_break := True
								end
							end
							l_break := False
							l_break := True
						end
				when 65 then -- if done
						if not (l_return or l_break or l_continue) then
							l_lastc := l_clist
							l_clist := l_clist.item.next
						end
						l_pos := -1 + 53 -- back to loop condition
				when 66 then -- loop done | if done
					if not l_return then
						l_break := False
						if a_c.item.running then
							if l_replace_old then
								l_tmp___38 := ce_string ("Replaced")
							else
								l_tmp___38 := ce_string ("Added")
							end
							(create {P_SENDF_STATIC}).Curl_infof ([a_data, ce_string ("%%s cookie %%s=%"%%s%" for domain %%s, path %%s, expire %%lld%N"), l_tmp___38, l_co.item.name, l_co.item.value, l_co.item.domain, l_co.item.path, l_co.item.expires])
						end
						if not l_replace_old then
							if (not l_lastc.is_void) then
								l_lastc.item.next := l_co
							else
								a_c.item.cookies := l_co
							end
						end
						a_c.item.numcookies := (a_c.item.numcookies) + 1
						Result := l_co
					end
				when 67 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_cookie_init (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_file: CE_POINTER [INTEGER_8]; a_inc: CE_POINTER [PD_COOKIEINFO]; a_newsession: BOOLEAN): CE_POINTER [PD_COOKIEINFO]
		local
			l_c: CE_POINTER [PD_COOKIEINFO]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_fromfile: BOOLEAN
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_lineptr: CE_POINTER [INTEGER_8]
			l_headerline: BOOLEAN
			l_line: CE_POINTER [INTEGER_8]
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fromfile := (1).to_boolean
					if a_inc.is_void then
						l_c := create {CE_CLASS_POINTER [PD_COOKIEINFO]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, (create {PD_COOKIEINFO}.make).structure_size.to_natural_32]))))
						if l_c.is_void then
							Result := (create {CE_CLASS_POINTER [PD_COOKIEINFO]}.make_shared (default_pointer))
							l_return := True
						end
						if not l_return then
							if (not a_file.is_void) then
								l_tmp___0 := a_file
							else
								l_tmp___0 := ce_string ("none")
							end
							l_c.item.filename := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_tmp___0]))
						end
					else
						l_c := a_inc
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_c.item.running := (0).to_boolean
						if a_file.is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if ((create {P_STREQUAL_STATIC}).curl_strequal (a_file, ce_string ("-"))).to_boolean then
							l_fp := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer))
							l_fromfile := (0).to_boolean
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_file.is_void then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not (a_file[0]).to_boolean then
							l_fp := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if (not a_file.is_void) then
							l_fp := (fopen (a_file, ce_string ("r")))
						else
							l_fp := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
						end
				when 8 then -- if done
						l_c.item.newsession := a_newsession
						if (not l_fp.is_void) then
							l_line := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(5_000).to_natural_32]))))
							if (not l_line.is_void) then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (fgets (l_line, 5_000, l_fp)).is_void then
										l_break := True
									end
									if not (l_return or l_break) then
										if ((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Set-Cookie:"), l_line, (strlen (ce_string ("Set-Cookie:"))))).to_boolean then
											l_lineptr := l_line + 11
											l_headerline := (1).to_boolean
										else
											l_lineptr := l_line
											l_headerline := (0).to_boolean
										end
										from
										until
											(l_break)
										loop
											l_break := False
											if (l_lineptr[0]).to_boolean then
												if ((l_lineptr[0]).to_natural_8).to_integer_32 = 32 then
													l_tmp___6 := 1
												elseif ((l_lineptr[0]).to_natural_8).to_integer_32 = 9 then
													l_tmp___6 := 1
												else
													l_tmp___6 := 0
												end
												if not l_tmp___6.to_boolean then
													l_break := True
												end
											else
												l_break := True
											end
											if not (l_break) then
												l_lineptr := l_lineptr + 1
											end
										end
										l_break := False
										Curl_cookie_add (a_data, l_c, l_headerline, l_lineptr, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)).do_nothing
									end
								end
								l_break := False;
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_line)])
							end
							if l_fromfile then
								fclose (l_fp).do_nothing
							end
						end
						l_c.item.running := (1).to_boolean
						Result := l_c
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cookie_sort (a_p1, a_p2: CE_POINTER [ANY]): INTEGER_32
		local
			l_c1: CE_POINTER [PD_COOKIE]
			l_c2: CE_POINTER [PD_COOKIE]
			l_l1: NATURAL_32
			l_tmp___0: NATURAL_32
			l_l2: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
		do
			l_c1 := (create {CE_POINTER_POINTER [PD_COOKIE]}.make_cast (a_p1)).item
			l_c2 := (create {CE_POINTER_POINTER [PD_COOKIE]}.make_cast (a_p2)).item
			if (not (l_c1.item.path).is_void) then
				l_tmp___0 := (strlen (l_c1.item.path))
			else
				l_tmp___0 := (0).to_natural_32
			end
			l_l1 := l_tmp___0
			if (not (l_c2.item.path).is_void) then
				l_tmp___2 := (strlen (l_c2.item.path))
			else
				l_tmp___2 := (0).to_natural_32
			end
			l_l2 := l_tmp___2
			if l_l2 > l_l1 then
				l_tmp___4 := 1
			else
				if l_l2 < l_l1 then
					l_tmp___3 := -1
				else
					l_tmp___3 := 0
				end
				l_tmp___4 := l_tmp___3
			end
			Result := l_tmp___4
		end

	Curl_cookie_clearall (a_cookies: CE_POINTER [PD_COOKIEINFO])
		do
			if (not a_cookies.is_void) then
				Curl_cookie_freelist (a_cookies.item.cookies, (1).to_boolean)
				a_cookies.item.cookies := create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer)
				a_cookies.item.numcookies := 0
			end
		end

	Curl_cookie_freelist (a_co: CE_POINTER [PD_COOKIE]; a_cookiestoo: BOOLEAN)
		local
			l_co: CE_POINTER [PD_COOKIE]
			l_next: CE_POINTER [PD_COOKIE]
		do
			l_co := a_co
			if (not l_co.is_void) then
				from
				until
					l_co.is_void
				loop
					l_next := l_co.item.next
					if a_cookiestoo then
						l_co.item.freecookie
					else
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_co)])
					end
					l_co := l_next
				end
			end
		end

	Curl_cookie_clearsess (a_cookies: CE_POINTER [PD_COOKIEINFO])
		local
			l_first: CE_POINTER [PD_COOKIE]
			l_curr: CE_POINTER [PD_COOKIE]
			l_next: CE_POINTER [PD_COOKIE]
			l_prev: CE_POINTER [PD_COOKIE]
			l_return: BOOLEAN
		do
			l_prev := create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer)
			if a_cookies.is_void then
				l_return := True
			elseif (a_cookies.item.cookies).is_void then
				l_return := True
			end
			if not l_return then
				l_prev := a_cookies.item.cookies
				l_curr := l_prev
				l_first := l_curr
				from
				until
					l_curr.is_void
				loop
					l_next := l_curr.item.next
					if not (l_curr.item.expires).to_boolean then
						if l_first.is_equal (l_curr) then
							l_first := l_next
						end
						if l_prev.is_equal (l_curr) then
							l_prev := l_next
						else
							l_prev.item.next := l_next
						end
						l_curr.item.freecookie
						a_cookies.item.numcookies := (a_cookies.item.numcookies) - 1
					else
						l_prev := l_curr
					end
					l_curr := l_next
				end
				a_cookies.item.cookies := l_first
			end
		end

	Curl_cookie_cleanup (a_c: CE_POINTER [PD_COOKIEINFO])
		local
			l_co: CE_POINTER [PD_COOKIE]
			l_next: CE_POINTER [PD_COOKIE]
		do
			if (not a_c.is_void) then
				if (not (a_c.item.filename).is_void) then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_c.item.filename)])
				end
				l_co := a_c.item.cookies
				from
				until
					l_co.is_void
				loop
					l_next := l_co.item.next
					l_co.item.freecookie
					l_co := l_next
				end
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_c)])
			end
		end

feature {ANY} -- routine addresses

	cookie_sort_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent cookie_sort)
		end

end
