class
	P_LLIST_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	Curl_llist_alloc (a_dtor: CE_ROUTINE): CE_POINTER [PD_CURL_LLIST]
		local
			l_list: CE_POINTER [PD_CURL_LLIST]
			l_return: BOOLEAN
		do
			l_list := create {CE_CLASS_POINTER [PD_CURL_LLIST]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(create {PD_CURL_LLIST}.make).structure_size.to_natural_32]))))
			if l_list.is_void then
				Result := (create {CE_CLASS_POINTER [PD_CURL_LLIST]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_list.item.llist_init (a_dtor)
				Result := l_list
			end
		end

	Curl_llist_insert_next (a_list: CE_POINTER [PD_CURL_LLIST]; a_e: CE_POINTER [PD_CURL_LLIST_ELEMENT]; a_p: CE_POINTER [ANY]): INTEGER_32
		local
			l_ne: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_return: BOOLEAN
		do
			l_ne := create {CE_CLASS_POINTER [PD_CURL_LLIST_ELEMENT]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(create {PD_CURL_LLIST_ELEMENT}.make).structure_size.to_natural_32]))))
			if l_ne.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_ne.item.ptr := a_p
				if a_list.item.size = {NATURAL_32} 0 then
					a_list.item.head := l_ne;
					(a_list.item.head).item.prev := create {CE_CLASS_POINTER [PD_CURL_LLIST_ELEMENT]}.make_shared (default_pointer);
					(a_list.item.head).item.next := create {CE_CLASS_POINTER [PD_CURL_LLIST_ELEMENT]}.make_shared (default_pointer)
					a_list.item.tail := l_ne
				else
					if (not a_e.is_void) then
						l_ne.item.next := a_e.item.next
					else
						l_ne.item.next := a_list.item.head
					end
					l_ne.item.prev := a_e
					if a_e.is_void then
						(a_list.item.head).item.prev := l_ne
						a_list.item.head := l_ne
					elseif (not (a_e.item.next).is_void) then
						(a_e.item.next).item.prev := l_ne
					else
						a_list.item.tail := l_ne
					end
					if (not a_e.is_void) then
						a_e.item.next := l_ne
					end
				end
				a_list.item.size := (a_list.item.size) + 1
				Result := 1
			end
		end

	Curl_llist_destroy (a_list: CE_POINTER [PD_CURL_LLIST]; a_user: CE_POINTER [ANY])
		do
			if (not a_list.is_void) then
				from
				until
					not (a_list.item.size > {NATURAL_32} 0)
				loop
					a_list.item.Curl_llist_remove (a_list.item.tail, a_user).do_nothing
				end
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_list)])
			end
		end

end
