class
	PD_CURL_SOCKADDR_STORAGE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create buffer.make
		end

feature {ANY} -- fields

	buffer: SD_SOCKADDR_STORAGE assign set_buffer

feature {ANY} -- field setters

	set_buffer (a_buffer: SD_SOCKADDR_STORAGE)
		do
			buffer := a_buffer
			update_memory_field ("buffer")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			buffer := a_other.buffer.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				buffer.is_equal (a_other.buffer)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("buffer")
				>>)
			init_structure_info
		end

end
