class
	S_ARPA_INET_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	inet_ntop (a___af: INTEGER_32; a___cp: CE_POINTER [ANY]; a___buf: CE_POINTER [INTEGER_8]; a___len: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_inet_ntop (a___af, a___cp.c_pointer, a___buf.c_pointer, a___len))
		end

	c_inet_ntop (a___af: INTEGER_32; a___cp: POINTER; a___buf: POINTER; a___len: NATURAL_32): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return (EIF_POINTER)inet_ntop($a___af, $a___cp, $a___buf, $a___len);"
		end

	inet_pton (a___af: INTEGER_32; a___cp: CE_POINTER [INTEGER_8]; a___buf: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_inet_pton (a___af, a___cp.c_pointer, a___buf.c_pointer)
		end

	c_inet_pton (a___af: INTEGER_32; a___cp: POINTER; a___buf: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return inet_pton($a___af, $a___cp, $a___buf);"
		end

end
