class
	SD_IN6_ADDR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create in6_u.make
		end

feature {ANY} -- fields

	in6_u: SD_IN6_U assign set_in6_u

feature {ANY} -- field setters

	set_in6_u (a_in6_u: SD_IN6_U)
		do
			in6_u := a_in6_u
			update_memory_field ("in6_u")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			in6_u := a_other.in6_u.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				in6_u.is_equal (a_other.in6_u)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("in6_u")
				>>)
			init_structure_info
		end

end
