class
	P_ADD_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpf_add (a_r, a_u, a_v: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_u.is_void
			not a_v.is_void
		local
			l_u: CE_POINTER [PD_MPF_STRUCT]
			l_v: CE_POINTER [PD_MPF_STRUCT]
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_rsize: INTEGER_32
			l_prec: INTEGER_32
			l_uexp: INTEGER_32
			l_ediff: INTEGER_32
			l_cy: NATURAL_32
			l_negate: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_v_negated: CE_ARRAY [PD_MPF_STRUCT]
			l_t: CE_POINTER [PD_MPF_STRUCT]
			l_tmp___2: CE_POINTER [ANY]
			l_size: INTEGER_32
			l_size___0: INTEGER_32
			l_size___1: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPF_STRUCT]} l_v_negated.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_u := a_u
					l_v := a_v
					l_usize := (l_u.item.mp_size).to_integer_32
					l_vsize := (l_v.item.mp_size).to_integer_32
					if l_usize /= 0 then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | set_r_v_maybe:
						if not a_r.is_equal (l_v) then
							a_r.item.gmpf_set (l_v)
						end
						l_return := True
				when 2 then -- if done
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 3 then -- if:
						if l_vsize = 0 then
							l_v := l_u
							l_pos := -1 + 1 -- goto set_r_v_maybe
						end
				when 4 then
						if ((l_usize).bit_xor (l_vsize)) < 0 then
							l_v_negated.item.mp_size := (-l_vsize).to_integer_32
							l_v_negated.item.mp_exp := l_v.item.mp_exp
							l_v_negated.item.mp_d := l_v.item.mp_d;
							(create {P_SUB_STATIC}).gmpf_sub (a_r, l_u, l_v_negated)
							l_return := True
						end
				when 5 then -- if done
					if not l_return then
						l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						l_negate := (l_usize < 0).to_integer
						if l_u.item.mp_exp < l_v.item.mp_exp then
							l_t := l_u
							l_u := l_v
							l_v := l_t
							l_usize := (l_u.item.mp_size).to_integer_32
							l_vsize := (l_v.item.mp_size).to_integer_32
						end
						if l_usize >= 0 then
							l_usize := l_usize
						else
							l_usize := -l_usize
						end
						if l_vsize >= 0 then
							l_vsize := l_vsize
						else
							l_vsize := -l_vsize
						end
						l_up := l_u.item.mp_d
						l_vp := l_v.item.mp_d
						l_rp := a_r.item.mp_d
						l_prec := (a_r.item.mp_prec).to_integer_32
						l_uexp := l_u.item.mp_exp
						l_ediff := (l_u.item.mp_exp - l_v.item.mp_exp)
						if l_usize > l_prec then
							l_up := l_up + (l_usize - l_prec)
							l_usize := l_prec
						end
						if l_vsize + l_ediff > l_prec then
							l_vp := l_vp + ((l_vsize + l_ediff) - l_prec)
							l_vsize := l_prec - l_ediff
						end
						if (builtin_expect ((l_prec.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___2 := (l_aaf.new ((l_prec.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___2 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_prec.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
						if l_ediff >= l_prec then
							if not l_rp.is_equal (l_up) then
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_up, l_usize)
									l_break := True
								end
								l_break := False
							end
							l_rsize := l_usize
						else
							if l_usize > l_ediff then
								if l_vsize + l_ediff <= l_usize then
									l_size := (l_usize - l_ediff) - l_vsize
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											(l_return or l_break)
										loop
											l_break := False;
											(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_up, l_size)
											l_break := True
										end
										l_break := False
										l_break := True
									end
									l_break := False
									l_cy := (create {P_GMP_STATIC}).gmpn_add (l_tp + l_size, l_up + l_size, l_usize - l_size, l_vp, l_vsize)
									l_rsize := l_usize
								else
									l_size___0 := (l_vsize + l_ediff) - l_usize
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											(l_return or l_break)
										loop
											l_break := False;
											(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_vp, l_size___0)
											l_break := True
										end
										l_break := False
										l_break := True
									end
									l_break := False
									l_cy := (create {P_GMP_STATIC}).gmpn_add (l_tp + l_size___0, l_up, l_usize, l_vp + l_size___0, l_usize - l_ediff)
									l_rsize := l_vsize + l_ediff
								end
							else
								l_size___1 := (l_vsize + l_ediff) - l_usize
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_vp, l_vsize)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if l_ediff - l_usize /= 0 then
										l___dst := l_tp + l_vsize
										l___n := l_ediff - l_usize
										from
										until
											(l_break)
										loop
											l_break := False
											l_tmp___4 := l___dst
											l___dst := l___dst + 1
											l_tmp___4.item := (0).to_natural_32
											l___n := l___n - 1
											if not l___n.to_boolean then
												l_break := True
											end
										end
										l_break := False
									end
									l_break := True
								end
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_tp + l_size___1, l_up, l_usize)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								l_cy := (0).to_natural_32
								l_rsize := l_size___1 + l_usize
							end
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_tp, l_rsize)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							l_rp[l_rsize] := l_cy
							l_rsize := (l_rsize.to_natural_32 + l_cy).to_integer_32
							l_uexp := (l_uexp.to_natural_32 + l_cy).to_integer_32
						end
						if l_negate.to_boolean then
							a_r.item.mp_size := (-l_rsize).to_integer_32
						else
							a_r.item.mp_size := l_rsize.to_integer_32
						end
						a_r.item.mp_exp := l_uexp
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
