class
	P_DCPI1_BDIV_Q_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_dcpi1_bdiv_q_n_itch (a_n: INTEGER_32): INTEGER_32
		do
			Result := a_n
		end

	gmpn_dcpi1_bdiv_q_n (a_qp, a_np, a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_dinv: NATURAL_32; a_tp: CE_POINTER [NATURAL_32])
		require
			not a_qp.is_void
			not a_np.is_void
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_lo: INTEGER_32
			l_hi: INTEGER_32
			l_cy: NATURAL_32
			l_break: BOOLEAN
		do
			l_qp := a_qp
			l_np := a_np
			l_n := a_n
			from
			until
				(l_break)
			loop
				l_break := False
				if 132 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (l_n >= 132) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_lo := (l_n).bit_shift_right (1)
					l_hi := l_n - l_lo
					l_cy := (create {P_DCPI1_BDIV_QR_STATIC}).gmpn_dcpi1_bdiv_qr_n (l_qp, l_np, a_dp, l_lo, a_dinv, a_tp);
					(create {P_MULLO_N_STATIC}).gmpn_mullo_n (a_tp, l_qp, a_dp + l_hi, l_lo);
					(create {P_GMP_STATIC}).gmpn_sub_n (l_np + l_hi, (l_np + l_hi), a_tp, l_lo).do_nothing
					if l_lo < l_hi then
						l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_submul_1 (l_np + l_lo, l_qp, l_lo, a_dp[l_lo]))
						l_np[(l_n - 1)] := l_np[(l_n - 1)] - l_cy
					end
					l_qp := l_qp + l_lo
					l_np := l_np + l_lo
					l_n := l_n - l_lo
				end
			end
			l_break := False;
			(create {P_SBPI1_BDIV_Q_STATIC}).gmpn_sbpi1_bdiv_q (l_qp, l_np, l_n, a_dp, l_n, a_dinv)
		end

	gmpn_dcpi1_bdiv_q (a_qp, a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_dinv: NATURAL_32)
		require
			not a_qp.is_void
			not a_np.is_void
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_qn: CE_ARRAY [INTEGER_32]
			l_cy: CE_ARRAY [NATURAL_32]
			l_tp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_INTEGER_32_ARRAY} l_qn.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_tp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)

			l_qp := a_qp
			l_np := a_np
			l___tmp_marker := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			l_tp.item := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new ((a_dn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_qn.item := a_nn
			if l_qn.item > a_dn then
				from
				until
					(l_break)
				loop
					l_break := False
					l_qn.item := l_qn.item - a_dn
					if not (l_qn.item > a_dn) then
						l_break := True
					end
				end
				l_break := False
				if 60 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_qn.item >= 60 then
						l_cy.item := (create {P_DCPI1_BDIV_QR_STATIC}).gmpn_dcpi1_bdiv_qr_n (l_qp, l_np, a_dp, l_qn.item, a_dinv, l_tp.item)
					else
						l_cy.item := (create {P_SBPI1_BDIV_QR_STATIC}).gmpn_sbpi1_bdiv_qr (l_qp, l_np, 2 * l_qn.item, a_dp, l_qn.item, a_dinv)
					end
				else
					l_cy.item := (create {P_SBPI1_BDIV_QR_STATIC}).gmpn_sbpi1_bdiv_qr (l_qp, l_np, 2 * l_qn.item, a_dp, l_qn.item, a_dinv)
				end
				if l_qn.item /= a_dn then
					if l_qn.item > a_dn - l_qn.item then
						(create {P_MUL_STATIC}).gmpn_mul (l_tp.item, l_qp, l_qn.item, a_dp + l_qn.item, a_dn - l_qn.item).do_nothing
					else
						(create {P_MUL_STATIC}).gmpn_mul (l_tp.item, a_dp + l_qn.item, a_dn - l_qn.item, l_qp, l_qn.item).do_nothing
					end
					from
					until
						(l_break)
					loop
						l_break := False
						asm322 (l___ptr_dummy, l_tp, l_qn, l_cy)
						l_break := True
					end
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_sub (l_np + l_qn.item, (l_np + l_qn.item), a_nn - l_qn.item, l_tp.item, a_dn).do_nothing
					l_cy.item := (0).to_natural_32
				end
				l_np := l_np + (l_qn.item)
				l_qp := l_qp + (l_qn.item)
				l_qn.item := a_nn - l_qn.item
				from
				until
					not (l_qn.item > a_dn)
				loop
					(create {P_GMP_STATIC}).gmpn_sub_1 (l_np + a_dn, (l_np + a_dn), l_qn.item, l_cy.item).do_nothing
					l_cy.item := (create {P_DCPI1_BDIV_QR_STATIC}).gmpn_dcpi1_bdiv_qr_n (l_qp, l_np, a_dp, a_dn, a_dinv, l_tp.item)
					l_qp := l_qp + a_dn
					l_np := l_np + a_dn
					l_qn.item := l_qn.item - a_dn
				end
				gmpn_dcpi1_bdiv_q_n (l_qp, l_np, a_dp, a_dn, a_dinv, l_tp.item)
			elseif 132 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_qn.item >= 132 then
					gmpn_dcpi1_bdiv_q_n (l_qp, l_np, a_dp, l_qn.item, a_dinv, l_tp.item)
				else
					(create {P_SBPI1_BDIV_Q_STATIC}).gmpn_sbpi1_bdiv_q (l_qp, l_np, l_qn.item, a_dp, l_qn.item, a_dinv)
				end
			else
				(create {P_SBPI1_BDIV_Q_STATIC}).gmpn_sbpi1_bdiv_q (l_qp, l_np, l_qn.item, a_dp, l_qn.item, a_dinv)
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect ((not l___tmp_marker.is_void).to_integer, 0)).to_boolean then
					(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker)
				end
				l_break := True
			end
			l_break := False
		end

end
