class
	P_FDIV_QR_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_fdiv_qr (a_quot, a_rem, a_dividend, a_divisor: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_dividend.is_void
			not a_divisor.is_void
		local
			l_divisor: CE_POINTER [PD_MPZ_STRUCT]
			l_divisor_size: INTEGER_32
			l_xsize: INTEGER_32
			l_temp_divisor: CE_ARRAY [PD_MPZ_STRUCT]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_temp_divisor.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_divisor := a_divisor
					l_divisor_size := (l_divisor.item.mp_size).to_integer_32
					l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
					if not (a_quot.is_equal (l_divisor)) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (a_rem.is_equal (l_divisor)) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___x := l_temp_divisor
							if l_divisor_size >= 0 then
								l___x.item.mp_alloc := l_divisor_size.to_integer_32
							else
								l___x.item.mp_alloc := (-l_divisor_size).to_integer_32
							end
							if l_divisor_size >= 0 then
								l_tmp___6 := l_divisor_size
							else
								l_tmp___6 := -l_divisor_size
							end
							if (builtin_expect ((l_tmp___6.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								if l_divisor_size >= 0 then
									l_tmp___1 := l_divisor_size
								else
									l_tmp___1 := -l_divisor_size
								end
								l_tmp___5 := (l_aaf.new ((l_tmp___1.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								if l_divisor_size >= 0 then
									l_tmp___3 := l_divisor_size
								else
									l_tmp___3 := -l_divisor_size
								end
								l_tmp___5 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_tmp___3.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l___x.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___5)
							l_break := True
						end
						l_break := False
						l_temp_divisor.item.gmpz_set (l_divisor)
						l_divisor := create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_temp_divisor)
				when 5 then -- if done
					l_xsize := ((a_dividend.item.mp_size).to_integer_32).bit_xor (l_divisor_size);
					(create {P_TDIV_QR_STATIC}).gmpz_tdiv_qr (a_quot, a_rem, a_dividend, l_divisor)
					if l_xsize < 0 then
						if a_rem.item.mp_size /= 0 then
							a_quot.item.gmpz_sub_ui (a_quot, {NATURAL_32} 1)
							a_rem.item.gmpz_add (a_rem, l_divisor)
						end
					end
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
							(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						end
						l_break := True
					end
					l_break := False
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
