class
	P_GET_D_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpn_get_d (a_up: CE_POINTER [NATURAL_32]; a_size, a_sign, a_exp: INTEGER_32): REAL_64
		local
			l_up: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_exp: INTEGER_32
			l_lshift: INTEGER_32
			l_nbits: INTEGER_32
			l_u: PD_IEEE_DOUBLE_EXTRACT
			l_x___2: NATURAL_32
			l_mhi: NATURAL_32
			l_mlo: NATURAL_32
			l_rshift: INTEGER_32
			l_tmp___1: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create l_u.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_up := a_up
					l_size := a_size
					l_exp := a_exp
					if l_size = 0 then
						Result := (0.0)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if not ((builtin_expect (((32 * l_size).to_natural_32 > (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) - l_exp).to_natural_32).to_integer, 0)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 9 -- goto ieee_infinity
				when 3 then
						l_exp := -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else:
						l_exp := l_exp + (32 * l_size)
				when 6 then -- if done
						l_up := l_up + l_size
						l_up := l_up - 1
						l_x___2 := l_up.item
						l_size := l_size - 1
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_lshift := builtin_clzl (l_x___2)
							l_break := True
						end
						l_break := False
						l_exp := l_exp - (l_lshift + 1).to_integer_32
						l_x___2 := (l_x___2).bit_shift_left (l_lshift)
						l_mhi := (l_x___2).bit_shift_right (11)
						if l_lshift < 11 then
							l_mlo := (l_x___2).bit_shift_left (21)
							l_nbits := (32 - l_lshift) - 21
						elseif l_size /= 0 then
							l_nbits := 32 - l_lshift
							l_up := l_up - 1
							l_x___2 := l_up.item
							l_size := l_size - 1
							l_x___2 := l_x___2
							l_mhi := (l_mhi).bit_or (((((l_x___2).bit_shift_right (l_nbits))).bit_shift_right (11)))
							l_mlo := (l_x___2).bit_shift_left (((32 - l_nbits) - 11))
							l_nbits := l_nbits + (11)
						else
							l_mlo := (0).to_natural_32
							l_pos := -1 + 8 -- goto done
						end
				when 7 then
						if l_nbits < 32 then
							if l_size /= 0 then
								l_up := l_up - 1
								l_x___2 := l_up.item
								l_size := l_size - 1
								l_x___2 := l_x___2
								l_x___2 := (l_x___2).bit_shift_right (l_nbits)
								l_mlo := (l_mlo).bit_or (l_x___2)
								l_nbits := l_nbits + (32)
								if l_nbits < 32 then
									if l_size /= 0 then
										l_up := l_up - 1
										l_x___2 := l_up.item
										l_size := l_size - 1
										l_x___2 := l_x___2
										l_x___2 := (l_x___2).bit_shift_right (l_nbits)
										l_mlo := (l_mlo).bit_or (l_x___2)
										l_nbits := l_nbits + (32)
									end
								end
							end
						end
				when 8 then -- done:
						if not ((builtin_expect ((l_exp >= 1_024).to_integer, 0)).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | ieee_infinity:
						l_mhi := (0).to_natural_32
						l_mlo := (0).to_natural_32
						l_exp := 1_024
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						if (builtin_expect ((l_exp <= -1_023).to_integer, 0)).to_boolean then
							if (builtin_expect ((l_exp <= -1_075).to_integer, 1)).to_boolean then
								Result := (0.0)
								l_return := True
							end
							if not l_return then
								l_rshift := (-1_022 - l_exp).to_integer_32
								if l_rshift >= 32 then
									l_mlo := l_mhi
									l_mhi := (0).to_natural_32
									l_rshift := l_rshift - (32)
								end
								l_lshift := 32 - l_rshift
								if l_rshift = 0 then
									l_tmp___1 := (0).to_natural_32
								else
									l_tmp___1 := (l_mhi).bit_shift_left (l_lshift)
								end
								l_mlo := (((l_mlo).bit_shift_right (l_rshift))).bit_or (l_tmp___1)
								l_mhi := (l_mhi).bit_shift_right (l_rshift)
								l_exp := -1_023
							end
						end
				when 12 then -- if done | if done
					if not l_return then
						l_u.s.manh := l_mhi.to_natural_32
						l_u.update_class_fields -- synchronize union
						l_u.s.manl := l_mlo.to_natural_32
						l_u.update_class_fields -- synchronize union
						l_u.s.exp := (l_exp + 1_023).to_natural_32
						l_u.update_class_fields -- synchronize union
						l_u.s.sig := (a_sign < 0).to_integer.to_natural_32
						l_u.update_class_fields -- synchronize union
						Result := (l_u.d)
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
