class
	P_MU_BDIV_QR_STATIC

inherit
	CE_UTILITIES
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_mu_bdiv_qr (a_qp, a_rp, a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32]): NATURAL_32
		require
			not a_dp.is_void
		local
			l_scratch: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_dn: CE_ARRAY [INTEGER_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_qn: INTEGER_32
			l_in: CE_ARRAY [INTEGER_32]
			l_cy: NATURAL_32
			l_c0: CE_ARRAY [NATURAL_32]
			l_tn: INTEGER_32
			l_wn: CE_ARRAY [INTEGER_32]
			l_b: INTEGER_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___4: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___5: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_scratch.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_dn.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_in.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_c0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_wn.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___2.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___3.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___4.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___5.make (<<1>>)

			l_scratch.item := a_scratch
			l_dn.item := a_dn
			l_qp := a_qp
			l_np := a_np
			l_qn := a_nn - l_dn.item
			if l_qn > l_dn.item then
				l_b := (l_qn - 1) // l_dn.item + 1
				l_in.item := (l_qn - 1) // l_b + 1;
				(create {P_BINVERT_STATIC}).gmpn_binvert (l_scratch.item, a_dp, l_in.item, l_scratch.item + l_in.item)
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (a_rp, l_np, l_dn.item)
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				l_np := l_np + (l_dn.item)
				l_cy := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_qn > l_in.item))
				loop
					(create {P_MULLO_N_STATIC}).gmpn_mullo_n (l_qp, a_rp, l_scratch.item, l_in.item)
					if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if l_in.item >= 58 then
							l_tn := (create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1_next_size (l_dn.item);
							(create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1 (l_scratch.item + l_in.item, l_tn, a_dp, l_dn.item, l_qp, l_in.item, (l_scratch.item + l_in.item) + l_tn)
							l_wn.item := (l_dn.item + l_in.item) - l_tn
							if l_wn.item > 0 then
								l_c0.item := (create {P_GMP_STATIC}).gmpn_sub_n ((l_scratch.item + l_in.item) + l_tn, (l_scratch.item + l_in.item), a_rp, l_wn.item)
								from
								until
									(l_break)
								loop
									l_break := False
									asm332 (l___ptr_dummy, l_scratch, l_in, l_wn, l_c0)
									l_break := True
								end
								l_break := False
							end
						else
							(create {P_MUL_STATIC}).gmpn_mul (l_scratch.item + l_in.item, a_dp, l_dn.item, l_qp, l_in.item).do_nothing
						end
					else
						(create {P_MUL_STATIC}).gmpn_mul (l_scratch.item + l_in.item, a_dp, l_dn.item, l_qp, l_in.item).do_nothing
					end
					l_qp := l_qp + (l_in.item)
					l_qn := l_qn - (l_in.item)
					if l_dn.item /= l_in.item then
						l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_sub_n (a_rp, (a_rp + l_in.item), ((l_scratch.item + l_in.item) + l_in.item), l_dn.item - l_in.item))
						if l_cy = {NATURAL_32} 2 then
							from
							until
								(l_break)
							loop
								l_break := False
								asm333 (l___ptr_dummy___0, l_scratch, l_in, l_dn)
								l_break := True
							end
							l_break := False
							l_cy := (1).to_natural_32
						end
					end
					l_cy := (create {P_GMP_IMPL_STATIC}).gmpn_sub_nc ((a_rp + l_dn.item) - l_in.item, l_np, ((l_scratch.item + l_in.item) + l_dn.item), l_in.item, l_cy)
					l_np := l_np + (l_in.item)
				end
				(create {P_MULLO_N_STATIC}).gmpn_mullo_n (l_qp, a_rp, l_scratch.item, l_qn)
				if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_qn >= 58 then
						l_tn := (create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1_next_size (l_dn.item);
						(create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1 (l_scratch.item + l_in.item, l_tn, a_dp, l_dn.item, l_qp, l_qn, (l_scratch.item + l_in.item) + l_tn)
						l_wn.item := (l_dn.item + l_qn) - l_tn
						if l_wn.item > 0 then
							l_c0.item := (create {P_GMP_STATIC}).gmpn_sub_n ((l_scratch.item + l_in.item) + l_tn, (l_scratch.item + l_in.item), a_rp, l_wn.item)
							from
							until
								(l_break)
							loop
								l_break := False
								asm334 (l___ptr_dummy___1, l_scratch, l_in, l_wn, l_c0)
								l_break := True
							end
							l_break := False
						end
					else
						(create {P_MUL_STATIC}).gmpn_mul (l_scratch.item + l_in.item, a_dp, l_dn.item, l_qp, l_qn).do_nothing
					end
				else
					(create {P_MUL_STATIC}).gmpn_mul (l_scratch.item + l_in.item, a_dp, l_dn.item, l_qp, l_qn).do_nothing
				end
				if l_dn.item /= l_qn then
					l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_sub_n (a_rp, (a_rp + l_qn), ((l_scratch.item + l_in.item) + l_qn), l_dn.item - l_qn))
					if l_cy = {NATURAL_32} 2 then
						from
						until
							(l_break)
						loop
							l_break := False
							asm335 (l___ptr_dummy___2, l_scratch, l_in, l_dn)
							l_break := True
						end
						l_break := False
						l_cy := (1).to_natural_32
					end
				end
				Result := ((create {P_GMP_IMPL_STATIC}).gmpn_sub_nc ((a_rp + l_dn.item) - l_qn, l_np, ((l_scratch.item + l_in.item) + l_dn.item), l_qn, l_cy))
			else
				l_in.item := l_qn - ((l_qn).bit_shift_right (1));
				(create {P_BINVERT_STATIC}).gmpn_binvert (l_scratch.item, a_dp, l_in.item, l_scratch.item + l_in.item);
				(create {P_MULLO_N_STATIC}).gmpn_mullo_n (l_qp, l_np, l_scratch.item, l_in.item)
				if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_in.item >= 58 then
						l_tn := (create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1_next_size (l_dn.item);
						(create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1 (l_scratch.item + l_in.item, l_tn, a_dp, l_dn.item, l_qp, l_in.item, (l_scratch.item + l_in.item) + l_tn)
						l_wn.item := (l_dn.item + l_in.item) - l_tn
						if l_wn.item > 0 then
							l_c0.item := (create {P_GMP_STATIC}).gmpn_sub_n ((l_scratch.item + l_in.item) + l_tn, (l_scratch.item + l_in.item), l_np, l_wn.item)
							from
							until
								(l_break)
							loop
								l_break := False
								asm336 (l___ptr_dummy___3, l_scratch, l_in, l_wn, l_c0)
								l_break := True
							end
							l_break := False
						end
					else
						(create {P_MUL_STATIC}).gmpn_mul (l_scratch.item + l_in.item, a_dp, l_dn.item, l_qp, l_in.item).do_nothing
					end
				else
					(create {P_MUL_STATIC}).gmpn_mul (l_scratch.item + l_in.item, a_dp, l_dn.item, l_qp, l_in.item).do_nothing
				end
				l_qp := l_qp + (l_in.item)
				l_qn := l_qn - (l_in.item)
				l_cy := (create {P_GMP_STATIC}).gmpn_sub_n (a_rp, l_np + l_in.item, ((l_scratch.item + l_in.item) + l_in.item), l_dn.item);
				(create {P_MULLO_N_STATIC}).gmpn_mullo_n (l_qp, a_rp, l_scratch.item, l_qn)
				if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_qn >= 58 then
						l_tn := (create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1_next_size (l_dn.item);
						(create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1 (l_scratch.item + l_in.item, l_tn, a_dp, l_dn.item, l_qp, l_qn, (l_scratch.item + l_in.item) + l_tn)
						l_wn.item := (l_dn.item + l_qn) - l_tn
						if l_wn.item > 0 then
							l_c0.item := (create {P_GMP_STATIC}).gmpn_sub_n ((l_scratch.item + l_in.item) + l_tn, (l_scratch.item + l_in.item), a_rp, l_wn.item)
							from
							until
								(l_break)
							loop
								l_break := False
								asm337 (l___ptr_dummy___4, l_scratch, l_in, l_wn, l_c0)
								l_break := True
							end
							l_break := False
						end
					else
						(create {P_MUL_STATIC}).gmpn_mul (l_scratch.item + l_in.item, a_dp, l_dn.item, l_qp, l_qn).do_nothing
					end
				else
					(create {P_MUL_STATIC}).gmpn_mul (l_scratch.item + l_in.item, a_dp, l_dn.item, l_qp, l_qn).do_nothing
				end
				l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_sub_n (a_rp, (a_rp + l_qn), ((l_scratch.item + l_in.item) + l_qn), l_dn.item - l_qn))
				if l_cy = {NATURAL_32} 2 then
					from
					until
						(l_break)
					loop
						l_break := False
						asm338 (l___ptr_dummy___5, l_scratch, l_in, l_dn)
						l_break := True
					end
					l_break := False
					l_cy := (1).to_natural_32
				end
				Result := ((create {P_GMP_IMPL_STATIC}).gmpn_sub_nc ((a_rp + l_dn.item) - l_qn, (l_np + l_dn.item) + l_in.item, ((l_scratch.item + l_in.item) + l_dn.item), l_qn, l_cy))
			end
		end

	gmpn_mu_bdiv_qr_itch (a_nn, a_dn: INTEGER_32): INTEGER_32
		local
			l_qn: INTEGER_32
			l_in: INTEGER_32
			l_tn: INTEGER_32
			l_itch_binvert: INTEGER_32
			l_itch_out: INTEGER_32
			l_itches: INTEGER_32
			l_b: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_qn := a_nn - a_dn
			if l_qn > a_dn then
				l_b := (l_qn - 1) // a_dn + 1
				l_in := (l_qn - 1) // l_b + 1
				if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_in >= 58 then
						l_tn := (create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1_next_size (a_dn)
						l_itch_out := (create {P_GMP_IMPL_STATIC}).mpn_mulmod_bnm1_itch (l_tn, a_dn, l_in)
					else
						l_tn := a_dn + l_in
						l_itch_out := (0).to_integer_32
					end
				else
					l_tn := a_dn + l_in
					l_itch_out := (0).to_integer_32
				end
				l_itch_binvert := (create {P_BINVERT_STATIC}).gmpn_binvert_itch (l_in)
				l_itches := l_tn + l_itch_out
				if l_itches > l_itch_binvert then
					l_tmp := l_itches
				else
					l_tmp := l_itch_binvert
				end
				Result := (l_in + l_tmp)
				l_return := True
			else
				l_in := l_qn - ((l_qn).bit_shift_right (1))
				if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_in >= 58 then
						l_tn := (create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1_next_size (a_dn)
						l_itch_out := (create {P_GMP_IMPL_STATIC}).mpn_mulmod_bnm1_itch (l_tn, a_dn, l_in)
					else
						l_tn := a_dn + l_in
						l_itch_out := (0).to_integer_32
					end
				else
					l_tn := a_dn + l_in
					l_itch_out := (0).to_integer_32
				end
			end
			if not l_return then
				l_itch_binvert := (create {P_BINVERT_STATIC}).gmpn_binvert_itch (l_in)
				l_itches := l_tn + l_itch_out
				if l_itches > l_itch_binvert then
					l_tmp___0 := l_itches
				else
					l_tmp___0 := l_itch_binvert
				end
				Result := (l_in + l_tmp___0)
			end
		end

end
