class
	P_MULLO_BASECASE_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpn_mullo_basecase (a_rp, a_up, a_vp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32)
		require
			not a_vp.is_void
		local
			l_i: INTEGER_32
		do
			(create {P_GMP_STATIC}).gmpn_mul_1 (a_rp, a_up, a_n, a_vp[0]).do_nothing
			l_i := (1).to_integer_32
			from
			until
				not (l_i < a_n)
			loop
				(create {P_GMP_STATIC}).gmpn_addmul_1 (a_rp + l_i, a_up, a_n - l_i, a_vp[l_i]).do_nothing
				l_i := l_i + 1
			end
		end

end
