class
	P_NUSSBAUMER_MUL_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpn_nussbaumer_mul (a_pp, a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32)
		local
			l_rn: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___14: CE_POINTER [ANY]
			l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
					if not (a_ap.is_equal (a_bp)) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_an = a_bn then
							l_rn := (create {P_SQRMOD_BNM1_STATIC}).gmpn_sqrmod_bnm1_next_size (2 * a_an)
							if (builtin_expect ((((create {P_GMP_IMPL_STATIC}).mpn_sqrmod_bnm1_itch (l_rn, a_an)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___5 := (l_aaf.new ((((create {P_GMP_IMPL_STATIC}).mpn_sqrmod_bnm1_itch (l_rn, a_an)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___5 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (((create {P_GMP_IMPL_STATIC}).mpn_sqrmod_bnm1_itch (l_rn, a_an)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___5);
							(create {P_SQRMOD_BNM1_STATIC}).gmpn_sqrmod_bnm1 (a_pp, l_rn, a_ap, a_an, l_tp)
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_rn := (create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1_next_size (a_an + a_bn)
						if (builtin_expect ((((create {P_GMP_IMPL_STATIC}).mpn_mulmod_bnm1_itch (l_rn, a_an, a_bn)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___14 := (l_aaf.new ((((create {P_GMP_IMPL_STATIC}).mpn_mulmod_bnm1_itch (l_rn, a_an, a_bn)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___14 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (((create {P_GMP_IMPL_STATIC}).mpn_mulmod_bnm1_itch (l_rn, a_an, a_bn)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___14);
						(create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1 (a_pp, l_rn, a_ap, a_an, a_bp, a_bn, l_tp)
				when 4 then
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
							(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						end
						l_break := True
					end
					l_break := False
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
