class
	P_TOOM_INTERPOLATE_6PTS_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_toom_interpolate_6pts (a_pp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_flags: NATURAL_32; a_w4, a_w2, a_w1: CE_POINTER [NATURAL_32]; a_w0n: INTEGER_32)
		local
			l_w0n: CE_ARRAY [INTEGER_32]
			l_w1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_w2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_n: CE_ARRAY [INTEGER_32]
			l_pp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_cy: CE_ARRAY [NATURAL_32]
			l_cy4: CE_ARRAY [NATURAL_32]
			l_cy6: CE_ARRAY [NATURAL_32]
			l_embankment: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___2: NATURAL_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___4: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___5: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___6: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___7: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___8: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_w0n.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_w1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_w2.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_n.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_pp.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy4.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy6.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___2.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___3.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___4.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___5.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___6.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___7.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___8.make (<<1>>)

			l_w0n.item := a_w0n
			l_w1.item := a_w1
			l_w2.item := a_w2
			l_n.item := a_n
			l_pp.item := a_pp
			if ((a_flags).bit_and ({NATURAL_32} 2)).to_boolean then
				(create {P_GMP_STATIC}).gmpn_add_n (l_w2.item, l_w1.item, l_w2.item, 2 * l_n.item + 1).do_nothing
			else
				(create {P_GMP_STATIC}).gmpn_sub_n (l_w2.item, l_w1.item, l_w2.item, 2 * l_n.item + 1).do_nothing
			end
			(create {P_GMP_STATIC}).gmpn_rshift (l_w2.item, l_w2.item, 2 * l_n.item + 1, {NATURAL_32} 2).do_nothing
			l_w1.item[2 * l_n.item] := l_w1.item[2 * l_n.item] - ((create {P_GMP_STATIC}).gmpn_sub_n (l_w1.item, l_w1.item, l_pp.item, 2 * l_n.item));
			(create {P_GMP_STATIC}).gmpn_rshift (l_w1.item, l_w1.item, 2 * l_n.item + 1, {NATURAL_32} 1).do_nothing;
			(create {P_GMP_STATIC}).gmpn_sub_n (l_w1.item, l_w1.item, l_w2.item, 2 * l_n.item + 1).do_nothing;
			(create {P_GMP_STATIC}).gmpn_rshift (l_w1.item, l_w1.item, 2 * l_n.item + 1, {NATURAL_32} 1).do_nothing
			if ((a_flags).bit_and ({NATURAL_32} 1)).to_boolean then
				(create {P_GMP_STATIC}).gmpn_add_n (a_w4, (l_pp.item + 2 * l_n.item), a_w4, 2 * l_n.item + 1).do_nothing;
				(create {P_GMP_STATIC}).gmpn_rshift (a_w4, a_w4, 2 * l_n.item + 1, {NATURAL_32} 1).do_nothing
			else
				(create {P_GMP_STATIC}).gmpn_sub_n (a_w4, (l_pp.item + 2 * l_n.item), a_w4, 2 * l_n.item + 1).do_nothing;
				(create {P_GMP_STATIC}).gmpn_rshift (a_w4, a_w4, 2 * l_n.item + 1, {NATURAL_32} 1).do_nothing
			end
			(create {P_GMP_STATIC}).gmpn_sub_n (l_w2.item, l_w2.item, a_w4, 2 * l_n.item + 1).do_nothing
			l_tmp___0 := (create {P_GMP_IMPL_STATIC}).gmpn_bdiv_dbm1c (l_w2.item, l_w2.item, 2 * l_n.item + 1, {NATURAL_32} 1_431_655_765, (0).to_natural_32);
			(create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + 2 * l_n.item, (l_pp.item + 2 * l_n.item), a_w4, 2 * l_n.item + 1).do_nothing;
			(l_pp.item + 2 * l_n.item)[2 * l_n.item] := (l_pp.item + 2 * l_n.item)[2 * l_n.item] - ((create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + 2 * l_n.item, (l_pp.item + 2 * l_n.item), l_pp.item, 2 * l_n.item));
			(create {P_GMP_STATIC}).gmpn_sub_n (l_w1.item, l_w1.item, (l_pp.item + 2 * l_n.item), 2 * l_n.item + 1).do_nothing
			l_tmp___2 := (create {P_GMP_IMPL_STATIC}).gmpn_bdiv_dbm1c (l_w1.item, l_w1.item, 2 * l_n.item + 1, {NATURAL_32} 1_431_655_765, (0).to_natural_32)
			l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + l_n.item, (l_pp.item + l_n.item), a_w4, 2 * l_n.item + 1)
			from
			until
				(l_break)
			loop
				l_break := False
				asm149 (l___ptr_dummy, l_pp, l_n, l_cy)
				l_break := True
			end
			l_break := False
			l_cy.item := (create {P_GMP_STATIC}).gmpn_lshift (a_w4, (l_pp.item + 5 * l_n.item), l_w0n.item, {NATURAL_32} 2)
			l_cy.item := l_cy.item + ((create {P_GMP_STATIC}).gmpn_sub_n (l_w2.item, l_w2.item, a_w4, l_w0n.item))
			from
			until
				(l_break)
			loop
				l_break := False
				asm150 (l___ptr_dummy___0, l_w2, l_w0n, l_cy)
				l_break := True
			end
			l_break := False
			l_cy.item := (create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + l_n.item, (l_pp.item + l_n.item), l_w2.item, l_n.item)
			from
			until
				(l_break)
			loop
				l_break := False
				asm151 (l___ptr_dummy___1, l_pp, l_n, l_cy)
				l_break := True
			end
			l_break := False
			l_cy4.item := (l_pp.item + 2 * l_n.item)[2 * l_n.item] + ((create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + 3 * l_n.item, (l_pp.item + 3 * l_n.item), l_w2.item, l_n.item))
			l_cy.item := l_w2.item[2 * l_n.item] + ((create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + 4 * l_n.item, l_w1.item, (l_w2.item + l_n.item), l_n.item))
			from
			until
				(l_break)
			loop
				l_break := False
				asm152 (l___ptr_dummy___2, l_w1, l_n, l_cy)
				l_break := True
			end
			l_break := False
			if (builtin_expect ((l_w0n.item > l_n.item).to_integer, 1)).to_boolean then
				l_cy6.item := l_w1.item[2 * l_n.item] + ((create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + 5 * l_n.item, (l_pp.item + 5 * l_n.item), (l_w1.item + l_n.item), l_n.item))
			else
				l_cy6.item := (create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + 5 * l_n.item, (l_pp.item + 5 * l_n.item), (l_w1.item + l_n.item), l_w0n.item)
			end
			l_cy.item := (create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + 2 * l_n.item, (l_pp.item + 2 * l_n.item), (l_pp.item + 4 * l_n.item), l_n.item + l_w0n.item)
			l_embankment := (l_pp.item + 5 * l_n.item)[(l_w0n.item - 1)] - {NATURAL_32} 1;
			(l_pp.item + 5 * l_n.item)[(l_w0n.item - 1)] := (1).to_natural_32
			if (builtin_expect ((l_w0n.item > l_n.item).to_integer, 1)).to_boolean then
				if (builtin_expect ((l_cy4.item > l_cy6.item).to_integer, 1)).to_boolean then
					from
					until
						(l_break)
					loop
						l_break := False
						asm153 (l___ptr_dummy___3, l_pp, l_n, l_cy4, l_cy6)
						l_break := True
					end
					l_break := False
				else
					from
					until
						(l_break)
					loop
						l_break := False
						asm154 (l___ptr_dummy___4, l_pp, l_n, l_cy6, l_cy4)
						l_break := True
					end
					l_break := False
				end
				from
				until
					(l_break)
				loop
					l_break := False
					asm155 (l___ptr_dummy___5, l_pp, l_n, l_w0n, l_cy)
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					asm156 (l___ptr_dummy___6, l_pp, l_n, l_cy6)
					l_break := True
				end
				l_break := False
			else
				from
				until
					(l_break)
				loop
					l_break := False
					asm157 (l___ptr_dummy___7, l_pp, l_n, l_cy4)
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					asm158 (l___ptr_dummy___8, l_pp, l_n, l_w0n, l_cy, l_cy6)
					l_break := True
				end
				l_break := False
			end
			(l_pp.item + 5 * l_n.item)[(l_w0n.item - 1)] := (l_pp.item + 5 * l_n.item)[(l_w0n.item - 1)] + l_embankment
		end

end
