class
	PD_GMP_PRIMES_DTAB

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	binv: NATURAL_32 assign set_binv

	lim: NATURAL_32 assign set_lim

feature {ANY} -- field setters

	set_binv (a_binv: NATURAL_32)
		do
			binv := a_binv
			update_memory_field ("binv")
		end

	set_lim (a_lim: NATURAL_32)
		do
			lim := a_lim
			update_memory_field ("lim")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			binv := a_other.binv
			lim := a_other.lim
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				binv = a_other.binv and
				lim = a_other.lim
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("binv"),
					create {CE_STRUCTURE_FIELD}.make ("lim")
				>>)
			init_structure_info
		end

end
