class
	P_INIT_SOURCE_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_block_complex_long_double_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]
		local
			l_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("block length n must be positive integer"), ce_string ("init_source.c"), 28, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_b___0 := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_cast ((malloc ((create {PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT}.make).structure_size.to_natural_32)))
				if l_b___0.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block struct"), ce_string ("init_source.c"), 36, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.data := create {CE_REAL_96_POINTER}.make_cast ((malloc (({NATURAL_32} 2 * a_n) * {CE_UTILITIES}.Real_96_bytes.to_natural_32)))
				if (l_b___0.item.data).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_b___0))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block data"), ce_string ("init_source.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.size := a_n
				Result := l_b___0
			end
		end

	gsl_block_complex_long_double_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]
		local
			l_i: NATURAL_32
			l_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]
			l_return: BOOLEAN
		do
			l_b___0 := (gsl_block_complex_long_double_alloc (a_n))
			if l_b___0.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < {NATURAL_32} 2 * a_n)
				loop
					l_b___0.item.data[l_i.to_integer_32] := real_96_from_integer_32 (0)
					l_i := l_i + 1
				end
				Result := l_b___0
			end
		end

	gsl_block_complex_long_double_free (a_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_b___0.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_b___0.item.data))
				free (create {CE_VOID_POINTER}.make_cast (a_b___0))
			end
		end

	gsl_block_complex_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]
		local
			l_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("block length n must be positive integer"), ce_string ("init_source.c"), 28, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_b___0 := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_cast ((malloc ((create {PD_GSL_BLOCK_COMPLEX_STRUCT}.make).structure_size.to_natural_32)))
				if l_b___0.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block struct"), ce_string ("init_source.c"), 36, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.data := create {CE_REAL_64_POINTER}.make_cast ((malloc (({NATURAL_32} 2 * a_n) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_b___0.item.data).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_b___0))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block data"), ce_string ("init_source.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.size := a_n
				Result := l_b___0
			end
		end

	gsl_block_complex_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]
		local
			l_i: NATURAL_32
			l_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]
			l_return: BOOLEAN
		do
			l_b___0 := (gsl_block_complex_alloc (a_n))
			if l_b___0.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < {NATURAL_32} 2 * a_n)
				loop
					l_b___0.item.data[l_i.to_integer_32] := (0).to_double
					l_i := l_i + 1
				end
				Result := l_b___0
			end
		end

	gsl_block_complex_free (a_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_b___0.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_b___0.item.data))
				free (create {CE_VOID_POINTER}.make_cast (a_b___0))
			end
		end

	gsl_block_complex_float_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]
		local
			l_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("block length n must be positive integer"), ce_string ("init_source.c"), 28, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_b___0 := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_cast ((malloc ((create {PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT}.make).structure_size.to_natural_32)))
				if l_b___0.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block struct"), ce_string ("init_source.c"), 36, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.data := create {CE_REAL_32_POINTER}.make_cast ((malloc (({NATURAL_32} 2 * a_n) * {PLATFORM}.Real_32_bytes.to_natural_32)))
				if (l_b___0.item.data).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_b___0))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block data"), ce_string ("init_source.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.size := a_n
				Result := l_b___0
			end
		end

	gsl_block_complex_float_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]
		local
			l_i: NATURAL_32
			l_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]
			l_return: BOOLEAN
		do
			l_b___0 := (gsl_block_complex_float_alloc (a_n))
			if l_b___0.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < {NATURAL_32} 2 * a_n)
				loop
					l_b___0.item.data[l_i.to_integer_32] := (0).to_real
					l_i := l_i + 1
				end
				Result := l_b___0
			end
		end

	gsl_block_complex_float_free (a_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_b___0.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_b___0.item.data))
				free (create {CE_VOID_POINTER}.make_cast (a_b___0))
			end
		end

	gsl_block_long_double_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]
		local
			l_b___0: CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("block length n must be positive integer"), ce_string ("init_source.c"), 28, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_b___0 := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_cast ((malloc ((create {PD_GSL_BLOCK_LONG_DOUBLE_STRUCT}.make).structure_size.to_natural_32)))
				if l_b___0.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block struct"), ce_string ("init_source.c"), 36, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.data := create {CE_REAL_96_POINTER}.make_cast ((malloc (a_n * {CE_UTILITIES}.Real_96_bytes.to_natural_32)))
				if (l_b___0.item.data).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_b___0))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block data"), ce_string ("init_source.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.size := a_n
				Result := l_b___0
			end
		end

	gsl_block_long_double_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]
		local
			l_i: NATURAL_32
			l_b___0: CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]
			l_return: BOOLEAN
		do
			l_b___0 := (gsl_block_long_double_alloc (a_n))
			if l_b___0.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_b___0.item.data[l_i.to_integer_32] := real_96_from_integer_32 (0)
					l_i := l_i + 1
				end
				Result := l_b___0
			end
		end

	gsl_block_long_double_free (a_b___0: CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_b___0.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_b___0.item.data))
				free (create {CE_VOID_POINTER}.make_cast (a_b___0))
			end
		end

	gsl_block_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_STRUCT]
		local
			l_b___0: CE_POINTER [PD_GSL_BLOCK_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("block length n must be positive integer"), ce_string ("init_source.c"), 28, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_b___0 := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_cast ((malloc ((create {PD_GSL_BLOCK_STRUCT}.make).structure_size.to_natural_32)))
				if l_b___0.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block struct"), ce_string ("init_source.c"), 36, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.data := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_b___0.item.data).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_b___0))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block data"), ce_string ("init_source.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.size := a_n
				Result := l_b___0
			end
		end

	gsl_block_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_STRUCT]
		local
			l_i: NATURAL_32
			l_b___0: CE_POINTER [PD_GSL_BLOCK_STRUCT]
			l_return: BOOLEAN
		do
			l_b___0 := (gsl_block_alloc (a_n))
			if l_b___0.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_b___0.item.data[l_i.to_integer_32] := (0).to_double
					l_i := l_i + 1
				end
				Result := l_b___0
			end
		end

	gsl_block_free (a_b___0: CE_POINTER [PD_GSL_BLOCK_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_b___0.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_b___0.item.data))
				free (create {CE_VOID_POINTER}.make_cast (a_b___0))
			end
		end

	gsl_block_float_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]
		local
			l_b___0: CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("block length n must be positive integer"), ce_string ("init_source.c"), 28, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_b___0 := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_cast ((malloc ((create {PD_GSL_BLOCK_FLOAT_STRUCT}.make).structure_size.to_natural_32)))
				if l_b___0.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block struct"), ce_string ("init_source.c"), 36, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.data := create {CE_REAL_32_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Real_32_bytes.to_natural_32)))
				if (l_b___0.item.data).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_b___0))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block data"), ce_string ("init_source.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.size := a_n
				Result := l_b___0
			end
		end

	gsl_block_float_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]
		local
			l_i: NATURAL_32
			l_b___0: CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]
			l_return: BOOLEAN
		do
			l_b___0 := (gsl_block_float_alloc (a_n))
			if l_b___0.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_b___0.item.data[l_i.to_integer_32] := (0).to_real
					l_i := l_i + 1
				end
				Result := l_b___0
			end
		end

	gsl_block_float_free (a_b___0: CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_b___0.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_b___0.item.data))
				free (create {CE_VOID_POINTER}.make_cast (a_b___0))
			end
		end

	gsl_block_ulong_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]
		local
			l_b___0: CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("block length n must be positive integer"), ce_string ("init_source.c"), 28, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_b___0 := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_cast ((malloc ((create {PD_GSL_BLOCK_ULONG_STRUCT}.make).structure_size.to_natural_32)))
				if l_b___0.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block struct"), ce_string ("init_source.c"), 36, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.data := create {CE_NATURAL_32_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Natural_32_bytes.to_natural_32)))
				if (l_b___0.item.data).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_b___0))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block data"), ce_string ("init_source.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.size := a_n
				Result := l_b___0
			end
		end

	gsl_block_ulong_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]
		local
			l_i: NATURAL_32
			l_b___0: CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]
			l_return: BOOLEAN
		do
			l_b___0 := (gsl_block_ulong_alloc (a_n))
			if l_b___0.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_b___0.item.data[l_i.to_integer_32] := {NATURAL_32} 0
					l_i := l_i + 1
				end
				Result := l_b___0
			end
		end

	gsl_block_ulong_free (a_b___0: CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_b___0.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_b___0.item.data))
				free (create {CE_VOID_POINTER}.make_cast (a_b___0))
			end
		end

	gsl_block_long_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]
		local
			l_b___0: CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("block length n must be positive integer"), ce_string ("init_source.c"), 28, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_b___0 := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_cast ((malloc ((create {PD_GSL_BLOCK_LONG_STRUCT}.make).structure_size.to_natural_32)))
				if l_b___0.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block struct"), ce_string ("init_source.c"), 36, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.data := create {CE_INTEGER_32_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Integer_32_bytes.to_natural_32)))
				if (l_b___0.item.data).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_b___0))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block data"), ce_string ("init_source.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.size := a_n
				Result := l_b___0
			end
		end

	gsl_block_long_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]
		local
			l_i: NATURAL_32
			l_b___0: CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]
			l_return: BOOLEAN
		do
			l_b___0 := (gsl_block_long_alloc (a_n))
			if l_b___0.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_b___0.item.data[l_i.to_integer_32] := 0
					l_i := l_i + 1
				end
				Result := l_b___0
			end
		end

	gsl_block_long_free (a_b___0: CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_b___0.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_b___0.item.data))
				free (create {CE_VOID_POINTER}.make_cast (a_b___0))
			end
		end

	gsl_block_uint_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]
		local
			l_b___0: CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("block length n must be positive integer"), ce_string ("init_source.c"), 28, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_b___0 := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_cast ((malloc ((create {PD_GSL_BLOCK_UINT_STRUCT}.make).structure_size.to_natural_32)))
				if l_b___0.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block struct"), ce_string ("init_source.c"), 36, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.data := create {CE_NATURAL_32_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Natural_32_bytes.to_natural_32)))
				if (l_b___0.item.data).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_b___0))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block data"), ce_string ("init_source.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.size := a_n
				Result := l_b___0
			end
		end

	gsl_block_uint_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]
		local
			l_i: NATURAL_32
			l_b___0: CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]
			l_return: BOOLEAN
		do
			l_b___0 := (gsl_block_uint_alloc (a_n))
			if l_b___0.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_b___0.item.data[l_i.to_integer_32] := {NATURAL_32} 0
					l_i := l_i + 1
				end
				Result := l_b___0
			end
		end

	gsl_block_uint_free (a_b___0: CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_b___0.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_b___0.item.data))
				free (create {CE_VOID_POINTER}.make_cast (a_b___0))
			end
		end

	gsl_block_int_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]
		local
			l_b___0: CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("block length n must be positive integer"), ce_string ("init_source.c"), 28, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_b___0 := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_cast ((malloc ((create {PD_GSL_BLOCK_INT_STRUCT}.make).structure_size.to_natural_32)))
				if l_b___0.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block struct"), ce_string ("init_source.c"), 36, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.data := create {CE_INTEGER_32_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Integer_32_bytes.to_natural_32)))
				if (l_b___0.item.data).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_b___0))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block data"), ce_string ("init_source.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.size := a_n
				Result := l_b___0
			end
		end

	gsl_block_int_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]
		local
			l_i: NATURAL_32
			l_b___0: CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]
			l_return: BOOLEAN
		do
			l_b___0 := (gsl_block_int_alloc (a_n))
			if l_b___0.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_b___0.item.data[l_i.to_integer_32] := 0
					l_i := l_i + 1
				end
				Result := l_b___0
			end
		end

	gsl_block_int_free (a_b___0: CE_POINTER [PD_GSL_BLOCK_INT_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_b___0.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_b___0.item.data))
				free (create {CE_VOID_POINTER}.make_cast (a_b___0))
			end
		end

	gsl_block_ushort_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]
		local
			l_b___0: CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("block length n must be positive integer"), ce_string ("init_source.c"), 28, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_b___0 := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_cast ((malloc ((create {PD_GSL_BLOCK_USHORT_STRUCT}.make).structure_size.to_natural_32)))
				if l_b___0.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block struct"), ce_string ("init_source.c"), 36, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.data := create {CE_NATURAL_16_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Natural_16_bytes.to_natural_32)))
				if (l_b___0.item.data).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_b___0))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block data"), ce_string ("init_source.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.size := a_n
				Result := l_b___0
			end
		end

	gsl_block_ushort_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]
		local
			l_i: NATURAL_32
			l_b___0: CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]
			l_return: BOOLEAN
		do
			l_b___0 := (gsl_block_ushort_alloc (a_n))
			if l_b___0.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_b___0.item.data[l_i.to_integer_32] := (0).to_natural_16
					l_i := l_i + 1
				end
				Result := l_b___0
			end
		end

	gsl_block_ushort_free (a_b___0: CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_b___0.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_b___0.item.data))
				free (create {CE_VOID_POINTER}.make_cast (a_b___0))
			end
		end

	gsl_block_short_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]
		local
			l_b___0: CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("block length n must be positive integer"), ce_string ("init_source.c"), 28, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_b___0 := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_cast ((malloc ((create {PD_GSL_BLOCK_SHORT_STRUCT}.make).structure_size.to_natural_32)))
				if l_b___0.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block struct"), ce_string ("init_source.c"), 36, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.data := create {CE_INTEGER_16_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Integer_16_bytes.to_natural_32)))
				if (l_b___0.item.data).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_b___0))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block data"), ce_string ("init_source.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.size := a_n
				Result := l_b___0
			end
		end

	gsl_block_short_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]
		local
			l_i: NATURAL_32
			l_b___0: CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]
			l_return: BOOLEAN
		do
			l_b___0 := (gsl_block_short_alloc (a_n))
			if l_b___0.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_b___0.item.data[l_i.to_integer_32] := (0).to_integer_16
					l_i := l_i + 1
				end
				Result := l_b___0
			end
		end

	gsl_block_short_free (a_b___0: CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_b___0.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_b___0.item.data))
				free (create {CE_VOID_POINTER}.make_cast (a_b___0))
			end
		end

	gsl_block_uchar_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]
		local
			l_b___0: CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("block length n must be positive integer"), ce_string ("init_source.c"), 28, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_b___0 := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_cast ((malloc ((create {PD_GSL_BLOCK_UCHAR_STRUCT}.make).structure_size.to_natural_32)))
				if l_b___0.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block struct"), ce_string ("init_source.c"), 36, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.data := create {CE_NATURAL_8_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Natural_8_bytes.to_natural_32)))
				if (l_b___0.item.data).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_b___0))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block data"), ce_string ("init_source.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.size := a_n
				Result := l_b___0
			end
		end

	gsl_block_uchar_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]
		local
			l_i: NATURAL_32
			l_b___0: CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]
			l_return: BOOLEAN
		do
			l_b___0 := (gsl_block_uchar_alloc (a_n))
			if l_b___0.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_b___0.item.data[l_i.to_integer_32] := (0).to_natural_8
					l_i := l_i + 1
				end
				Result := l_b___0
			end
		end

	gsl_block_uchar_free (a_b___0: CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_b___0.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_b___0.item.data))
				free (create {CE_VOID_POINTER}.make_cast (a_b___0))
			end
		end

	gsl_block_char_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]
		local
			l_b___0: CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("block length n must be positive integer"), ce_string ("init_source.c"), 28, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_b___0 := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_cast ((malloc ((create {PD_GSL_BLOCK_CHAR_STRUCT}.make).structure_size.to_natural_32)))
				if l_b___0.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block struct"), ce_string ("init_source.c"), 36, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.data := create {CE_INTEGER_8_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Integer_8_bytes.to_natural_32)))
				if (l_b___0.item.data).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_b___0))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block data"), ce_string ("init_source.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_b___0.item.size := a_n
				Result := l_b___0
			end
		end

	gsl_block_char_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]
		local
			l_i: NATURAL_32
			l_b___0: CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]
			l_return: BOOLEAN
		do
			l_b___0 := (gsl_block_char_alloc (a_n))
			if l_b___0.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_b___0.item.data[l_i.to_integer_32] := (0).to_integer_8
					l_i := l_i + 1
				end
				Result := l_b___0
			end
		end

	gsl_block_char_free (a_b___0: CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_b___0.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_b___0.item.data))
				free (create {CE_VOID_POINTER}.make_cast (a_b___0))
			end
		end

	gsl_matrix_complex_long_double_alloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]
			l_return, l_break: BOOLEAN
		do
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("init_source.c"), 34, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4 := create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]}.make_cast ((malloc ((create {PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE}.make).structure_size.to_natural_32)))
				if l_m___4.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for matrix struct"), ce_string ("init_source.c"), 42, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_complex_long_double_alloc (a_n1 * a_n2)
				if l_block.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 52, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_m___4.item.data := l_block.item.data
				l_m___4.item.size1 := a_n1
				l_m___4.item.size2 := a_n2
				l_m___4.item.tda := a_n2
				l_m___4.item.block := l_block
				l_m___4.item.owner := 1
				Result := l_m___4
			end
		end

	gsl_matrix_complex_long_double_calloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]
		local
			l_i: NATURAL_32
			l_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]
			l_return: BOOLEAN
		do
			l_m___4 := (gsl_matrix_complex_long_double_alloc (a_n1, a_n2))
			if l_m___4.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < ({NATURAL_32} 2 * a_n1) * a_n2)
				loop
					l_m___4.item.data[l_i.to_integer_32] := real_96_from_integer_32 (0)
					l_i := l_i + 1
				end
				Result := l_m___4
			end
		end

	gsl_matrix_complex_long_double_free (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE])
		local
			l_return: BOOLEAN
		do
			if a_m___4.is_void then
				l_return := True
			end
			if not l_return then
				if (a_m___4.item.owner).to_boolean then
					gsl_block_complex_long_double_free (a_m___4.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_m___4))
			end
		end

	gsl_matrix_complex_alloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_COMPLEX]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]
			l_return, l_break: BOOLEAN
		do
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("init_source.c"), 34, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4 := create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX]}.make_cast ((malloc ((create {PD_GSL_MATRIX_COMPLEX}.make).structure_size.to_natural_32)))
				if l_m___4.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for matrix struct"), ce_string ("init_source.c"), 42, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_complex_alloc (a_n1 * a_n2)
				if l_block.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 52, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_m___4.item.data := l_block.item.data
				l_m___4.item.size1 := a_n1
				l_m___4.item.size2 := a_n2
				l_m___4.item.tda := a_n2
				l_m___4.item.block := l_block
				l_m___4.item.owner := 1
				Result := l_m___4
			end
		end

	gsl_matrix_complex_calloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_COMPLEX]
		local
			l_i: NATURAL_32
			l_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]
			l_return: BOOLEAN
		do
			l_m___4 := (gsl_matrix_complex_alloc (a_n1, a_n2))
			if l_m___4.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < ({NATURAL_32} 2 * a_n1) * a_n2)
				loop
					l_m___4.item.data[l_i.to_integer_32] := (0).to_double
					l_i := l_i + 1
				end
				Result := l_m___4
			end
		end

	gsl_matrix_complex_free (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX])
		local
			l_return: BOOLEAN
		do
			if a_m___4.is_void then
				l_return := True
			end
			if not l_return then
				if (a_m___4.item.owner).to_boolean then
					gsl_block_complex_free (a_m___4.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_m___4))
			end
		end

	gsl_matrix_complex_float_alloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]
			l_return, l_break: BOOLEAN
		do
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("init_source.c"), 34, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4 := create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]}.make_cast ((malloc ((create {PD_GSL_MATRIX_COMPLEX_FLOAT}.make).structure_size.to_natural_32)))
				if l_m___4.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for matrix struct"), ce_string ("init_source.c"), 42, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_complex_float_alloc (a_n1 * a_n2)
				if l_block.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 52, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_m___4.item.data := l_block.item.data
				l_m___4.item.size1 := a_n1
				l_m___4.item.size2 := a_n2
				l_m___4.item.tda := a_n2
				l_m___4.item.block := l_block
				l_m___4.item.owner := 1
				Result := l_m___4
			end
		end

	gsl_matrix_complex_float_calloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]
		local
			l_i: NATURAL_32
			l_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]
			l_return: BOOLEAN
		do
			l_m___4 := (gsl_matrix_complex_float_alloc (a_n1, a_n2))
			if l_m___4.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < ({NATURAL_32} 2 * a_n1) * a_n2)
				loop
					l_m___4.item.data[l_i.to_integer_32] := (0).to_real
					l_i := l_i + 1
				end
				Result := l_m___4
			end
		end

	gsl_matrix_complex_float_free (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT])
		local
			l_return: BOOLEAN
		do
			if a_m___4.is_void then
				l_return := True
			end
			if not l_return then
				if (a_m___4.item.owner).to_boolean then
					gsl_block_complex_float_free (a_m___4.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_m___4))
			end
		end

	gsl_matrix_long_double_alloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]
			l_return, l_break: BOOLEAN
		do
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("init_source.c"), 34, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4 := create {CE_CLASS_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]}.make_cast ((malloc ((create {PD_GSL_MATRIX_LONG_DOUBLE}.make).structure_size.to_natural_32)))
				if l_m___4.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for matrix struct"), ce_string ("init_source.c"), 42, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_long_double_alloc (a_n1 * a_n2)
				if l_block.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 52, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_m___4.item.data := l_block.item.data
				l_m___4.item.size1 := a_n1
				l_m___4.item.size2 := a_n2
				l_m___4.item.tda := a_n2
				l_m___4.item.block := l_block
				l_m___4.item.owner := 1
				Result := l_m___4
			end
		end

	gsl_matrix_long_double_calloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]
		local
			l_i: NATURAL_32
			l_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]
			l_return: BOOLEAN
		do
			l_m___4 := (gsl_matrix_long_double_alloc (a_n1, a_n2))
			if l_m___4.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n1 * a_n2)
				loop
					l_m___4.item.data[l_i.to_integer_32] := real_96_from_integer_32 (0)
					l_i := l_i + 1
				end
				Result := l_m___4
			end
		end

	gsl_matrix_long_double_free (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE])
		local
			l_return: BOOLEAN
		do
			if a_m___4.is_void then
				l_return := True
			end
			if not l_return then
				if (a_m___4.item.owner).to_boolean then
					gsl_block_long_double_free (a_m___4.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_m___4))
			end
		end

	gsl_matrix_alloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX]
			l_return, l_break: BOOLEAN
		do
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("init_source.c"), 34, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4 := create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_cast ((malloc ((create {PD_GSL_MATRIX}.make).structure_size.to_natural_32)))
				if l_m___4.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for matrix struct"), ce_string ("init_source.c"), 42, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_alloc (a_n1 * a_n2)
				if l_block.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 52, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_m___4.item.data := l_block.item.data
				l_m___4.item.size1 := a_n1
				l_m___4.item.size2 := a_n2
				l_m___4.item.tda := a_n2
				l_m___4.item.block := l_block
				l_m___4.item.owner := 1
				Result := l_m___4
			end
		end

	gsl_matrix_calloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX]
		local
			l_i: NATURAL_32
			l_m___4: CE_POINTER [PD_GSL_MATRIX]
			l_return: BOOLEAN
		do
			l_m___4 := (gsl_matrix_alloc (a_n1, a_n2))
			if l_m___4.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n1 * a_n2)
				loop
					l_m___4.item.data[l_i.to_integer_32] := (0).to_double
					l_i := l_i + 1
				end
				Result := l_m___4
			end
		end

	gsl_matrix_free (a_m___4: CE_POINTER [PD_GSL_MATRIX])
		local
			l_return: BOOLEAN
		do
			if a_m___4.is_void then
				l_return := True
			end
			if not l_return then
				if (a_m___4.item.owner).to_boolean then
					gsl_block_free (a_m___4.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_m___4))
			end
		end

	gsl_matrix_float_alloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_FLOAT]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]
			l_return, l_break: BOOLEAN
		do
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_FLOAT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("init_source.c"), 34, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_FLOAT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4 := create {CE_CLASS_POINTER [PD_GSL_MATRIX_FLOAT]}.make_cast ((malloc ((create {PD_GSL_MATRIX_FLOAT}.make).structure_size.to_natural_32)))
				if l_m___4.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for matrix struct"), ce_string ("init_source.c"), 42, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_FLOAT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_float_alloc (a_n1 * a_n2)
				if l_block.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 52, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_FLOAT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_m___4.item.data := l_block.item.data
				l_m___4.item.size1 := a_n1
				l_m___4.item.size2 := a_n2
				l_m___4.item.tda := a_n2
				l_m___4.item.block := l_block
				l_m___4.item.owner := 1
				Result := l_m___4
			end
		end

	gsl_matrix_float_calloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_FLOAT]
		local
			l_i: NATURAL_32
			l_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]
			l_return: BOOLEAN
		do
			l_m___4 := (gsl_matrix_float_alloc (a_n1, a_n2))
			if l_m___4.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_FLOAT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n1 * a_n2)
				loop
					l_m___4.item.data[l_i.to_integer_32] := (0).to_real
					l_i := l_i + 1
				end
				Result := l_m___4
			end
		end

	gsl_matrix_float_free (a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT])
		local
			l_return: BOOLEAN
		do
			if a_m___4.is_void then
				l_return := True
			end
			if not l_return then
				if (a_m___4.item.owner).to_boolean then
					gsl_block_float_free (a_m___4.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_m___4))
			end
		end

	gsl_matrix_ulong_alloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_ULONG]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]
			l_return, l_break: BOOLEAN
		do
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_ULONG]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("init_source.c"), 34, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_ULONG]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4 := create {CE_CLASS_POINTER [PD_GSL_MATRIX_ULONG]}.make_cast ((malloc ((create {PD_GSL_MATRIX_ULONG}.make).structure_size.to_natural_32)))
				if l_m___4.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for matrix struct"), ce_string ("init_source.c"), 42, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_ULONG]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_ulong_alloc (a_n1 * a_n2)
				if l_block.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 52, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_ULONG]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_m___4.item.data := l_block.item.data
				l_m___4.item.size1 := a_n1
				l_m___4.item.size2 := a_n2
				l_m___4.item.tda := a_n2
				l_m___4.item.block := l_block
				l_m___4.item.owner := 1
				Result := l_m___4
			end
		end

	gsl_matrix_ulong_calloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_ULONG]
		local
			l_i: NATURAL_32
			l_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]
			l_return: BOOLEAN
		do
			l_m___4 := (gsl_matrix_ulong_alloc (a_n1, a_n2))
			if l_m___4.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_ULONG]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n1 * a_n2)
				loop
					l_m___4.item.data[l_i.to_integer_32] := {NATURAL_32} 0
					l_i := l_i + 1
				end
				Result := l_m___4
			end
		end

	gsl_matrix_ulong_free (a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG])
		local
			l_return: BOOLEAN
		do
			if a_m___4.is_void then
				l_return := True
			end
			if not l_return then
				if (a_m___4.item.owner).to_boolean then
					gsl_block_ulong_free (a_m___4.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_m___4))
			end
		end

	gsl_matrix_long_alloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_LONG]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]
			l_return, l_break: BOOLEAN
		do
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_LONG]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("init_source.c"), 34, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_LONG]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4 := create {CE_CLASS_POINTER [PD_GSL_MATRIX_LONG]}.make_cast ((malloc ((create {PD_GSL_MATRIX_LONG}.make).structure_size.to_natural_32)))
				if l_m___4.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for matrix struct"), ce_string ("init_source.c"), 42, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_LONG]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_long_alloc (a_n1 * a_n2)
				if l_block.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 52, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_LONG]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_m___4.item.data := l_block.item.data
				l_m___4.item.size1 := a_n1
				l_m___4.item.size2 := a_n2
				l_m___4.item.tda := a_n2
				l_m___4.item.block := l_block
				l_m___4.item.owner := 1
				Result := l_m___4
			end
		end

	gsl_matrix_long_calloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_LONG]
		local
			l_i: NATURAL_32
			l_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]
			l_return: BOOLEAN
		do
			l_m___4 := (gsl_matrix_long_alloc (a_n1, a_n2))
			if l_m___4.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_LONG]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n1 * a_n2)
				loop
					l_m___4.item.data[l_i.to_integer_32] := 0
					l_i := l_i + 1
				end
				Result := l_m___4
			end
		end

	gsl_matrix_long_free (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG])
		local
			l_return: BOOLEAN
		do
			if a_m___4.is_void then
				l_return := True
			end
			if not l_return then
				if (a_m___4.item.owner).to_boolean then
					gsl_block_long_free (a_m___4.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_m___4))
			end
		end

	gsl_matrix_uint_alloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_UINT]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]
			l_return, l_break: BOOLEAN
		do
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_UINT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("init_source.c"), 34, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_UINT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4 := create {CE_CLASS_POINTER [PD_GSL_MATRIX_UINT]}.make_cast ((malloc ((create {PD_GSL_MATRIX_UINT}.make).structure_size.to_natural_32)))
				if l_m___4.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for matrix struct"), ce_string ("init_source.c"), 42, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_UINT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_uint_alloc (a_n1 * a_n2)
				if l_block.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 52, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_UINT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_m___4.item.data := l_block.item.data
				l_m___4.item.size1 := a_n1
				l_m___4.item.size2 := a_n2
				l_m___4.item.tda := a_n2
				l_m___4.item.block := l_block
				l_m___4.item.owner := 1
				Result := l_m___4
			end
		end

	gsl_matrix_uint_calloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_UINT]
		local
			l_i: NATURAL_32
			l_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]
			l_return: BOOLEAN
		do
			l_m___4 := (gsl_matrix_uint_alloc (a_n1, a_n2))
			if l_m___4.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_UINT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n1 * a_n2)
				loop
					l_m___4.item.data[l_i.to_integer_32] := {NATURAL_32} 0
					l_i := l_i + 1
				end
				Result := l_m___4
			end
		end

	gsl_matrix_uint_free (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT])
		local
			l_return: BOOLEAN
		do
			if a_m___4.is_void then
				l_return := True
			end
			if not l_return then
				if (a_m___4.item.owner).to_boolean then
					gsl_block_uint_free (a_m___4.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_m___4))
			end
		end

	gsl_matrix_int_alloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_INT]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX_INT]
			l_return, l_break: BOOLEAN
		do
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_INT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("init_source.c"), 34, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_INT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4 := create {CE_CLASS_POINTER [PD_GSL_MATRIX_INT]}.make_cast ((malloc ((create {PD_GSL_MATRIX_INT}.make).structure_size.to_natural_32)))
				if l_m___4.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for matrix struct"), ce_string ("init_source.c"), 42, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_INT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_int_alloc (a_n1 * a_n2)
				if l_block.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 52, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_INT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_m___4.item.data := l_block.item.data
				l_m___4.item.size1 := a_n1
				l_m___4.item.size2 := a_n2
				l_m___4.item.tda := a_n2
				l_m___4.item.block := l_block
				l_m___4.item.owner := 1
				Result := l_m___4
			end
		end

	gsl_matrix_int_calloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_INT]
		local
			l_i: NATURAL_32
			l_m___4: CE_POINTER [PD_GSL_MATRIX_INT]
			l_return: BOOLEAN
		do
			l_m___4 := (gsl_matrix_int_alloc (a_n1, a_n2))
			if l_m___4.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_INT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n1 * a_n2)
				loop
					l_m___4.item.data[l_i.to_integer_32] := 0
					l_i := l_i + 1
				end
				Result := l_m___4
			end
		end

	gsl_matrix_int_free (a_m___4: CE_POINTER [PD_GSL_MATRIX_INT])
		local
			l_return: BOOLEAN
		do
			if a_m___4.is_void then
				l_return := True
			end
			if not l_return then
				if (a_m___4.item.owner).to_boolean then
					gsl_block_int_free (a_m___4.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_m___4))
			end
		end

	gsl_matrix_ushort_alloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_USHORT]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]
			l_return, l_break: BOOLEAN
		do
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_USHORT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("init_source.c"), 34, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_USHORT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4 := create {CE_CLASS_POINTER [PD_GSL_MATRIX_USHORT]}.make_cast ((malloc ((create {PD_GSL_MATRIX_USHORT}.make).structure_size.to_natural_32)))
				if l_m___4.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for matrix struct"), ce_string ("init_source.c"), 42, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_USHORT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_ushort_alloc (a_n1 * a_n2)
				if l_block.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 52, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_USHORT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_m___4.item.data := l_block.item.data
				l_m___4.item.size1 := a_n1
				l_m___4.item.size2 := a_n2
				l_m___4.item.tda := a_n2
				l_m___4.item.block := l_block
				l_m___4.item.owner := 1
				Result := l_m___4
			end
		end

	gsl_matrix_ushort_calloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_USHORT]
		local
			l_i: NATURAL_32
			l_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]
			l_return: BOOLEAN
		do
			l_m___4 := (gsl_matrix_ushort_alloc (a_n1, a_n2))
			if l_m___4.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_USHORT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n1 * a_n2)
				loop
					l_m___4.item.data[l_i.to_integer_32] := (0).to_natural_16
					l_i := l_i + 1
				end
				Result := l_m___4
			end
		end

	gsl_matrix_ushort_free (a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT])
		local
			l_return: BOOLEAN
		do
			if a_m___4.is_void then
				l_return := True
			end
			if not l_return then
				if (a_m___4.item.owner).to_boolean then
					gsl_block_ushort_free (a_m___4.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_m___4))
			end
		end

	gsl_matrix_short_alloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_SHORT]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]
			l_return, l_break: BOOLEAN
		do
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_SHORT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("init_source.c"), 34, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_SHORT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4 := create {CE_CLASS_POINTER [PD_GSL_MATRIX_SHORT]}.make_cast ((malloc ((create {PD_GSL_MATRIX_SHORT}.make).structure_size.to_natural_32)))
				if l_m___4.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for matrix struct"), ce_string ("init_source.c"), 42, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_SHORT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_short_alloc (a_n1 * a_n2)
				if l_block.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 52, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_SHORT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_m___4.item.data := l_block.item.data
				l_m___4.item.size1 := a_n1
				l_m___4.item.size2 := a_n2
				l_m___4.item.tda := a_n2
				l_m___4.item.block := l_block
				l_m___4.item.owner := 1
				Result := l_m___4
			end
		end

	gsl_matrix_short_calloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_SHORT]
		local
			l_i: NATURAL_32
			l_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]
			l_return: BOOLEAN
		do
			l_m___4 := (gsl_matrix_short_alloc (a_n1, a_n2))
			if l_m___4.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_SHORT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n1 * a_n2)
				loop
					l_m___4.item.data[l_i.to_integer_32] := (0).to_integer_16
					l_i := l_i + 1
				end
				Result := l_m___4
			end
		end

	gsl_matrix_short_free (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT])
		local
			l_return: BOOLEAN
		do
			if a_m___4.is_void then
				l_return := True
			end
			if not l_return then
				if (a_m___4.item.owner).to_boolean then
					gsl_block_short_free (a_m___4.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_m___4))
			end
		end

	gsl_matrix_uchar_alloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_UCHAR]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]
			l_return, l_break: BOOLEAN
		do
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_UCHAR]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("init_source.c"), 34, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_UCHAR]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4 := create {CE_CLASS_POINTER [PD_GSL_MATRIX_UCHAR]}.make_cast ((malloc ((create {PD_GSL_MATRIX_UCHAR}.make).structure_size.to_natural_32)))
				if l_m___4.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for matrix struct"), ce_string ("init_source.c"), 42, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_UCHAR]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_uchar_alloc (a_n1 * a_n2)
				if l_block.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 52, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_UCHAR]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_m___4.item.data := l_block.item.data
				l_m___4.item.size1 := a_n1
				l_m___4.item.size2 := a_n2
				l_m___4.item.tda := a_n2
				l_m___4.item.block := l_block
				l_m___4.item.owner := 1
				Result := l_m___4
			end
		end

	gsl_matrix_uchar_calloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_UCHAR]
		local
			l_i: NATURAL_32
			l_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]
			l_return: BOOLEAN
		do
			l_m___4 := (gsl_matrix_uchar_alloc (a_n1, a_n2))
			if l_m___4.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_UCHAR]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n1 * a_n2)
				loop
					l_m___4.item.data[l_i.to_integer_32] := (0).to_natural_8
					l_i := l_i + 1
				end
				Result := l_m___4
			end
		end

	gsl_matrix_uchar_free (a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR])
		local
			l_return: BOOLEAN
		do
			if a_m___4.is_void then
				l_return := True
			end
			if not l_return then
				if (a_m___4.item.owner).to_boolean then
					gsl_block_uchar_free (a_m___4.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_m___4))
			end
		end

	gsl_matrix_char_alloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_CHAR]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]
			l_return, l_break: BOOLEAN
		do
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_CHAR]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("init_source.c"), 34, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_CHAR]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4 := create {CE_CLASS_POINTER [PD_GSL_MATRIX_CHAR]}.make_cast ((malloc ((create {PD_GSL_MATRIX_CHAR}.make).structure_size.to_natural_32)))
				if l_m___4.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for matrix struct"), ce_string ("init_source.c"), 42, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_CHAR]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_char_alloc (a_n1 * a_n2)
				if l_block.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 52, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_CHAR]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_m___4.item.data := l_block.item.data
				l_m___4.item.size1 := a_n1
				l_m___4.item.size2 := a_n2
				l_m___4.item.tda := a_n2
				l_m___4.item.block := l_block
				l_m___4.item.owner := 1
				Result := l_m___4
			end
		end

	gsl_matrix_char_calloc (a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_CHAR]
		local
			l_i: NATURAL_32
			l_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]
			l_return: BOOLEAN
		do
			l_m___4 := (gsl_matrix_char_alloc (a_n1, a_n2))
			if l_m___4.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_CHAR]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n1 * a_n2)
				loop
					l_m___4.item.data[l_i.to_integer_32] := (0).to_integer_8
					l_i := l_i + 1
				end
				Result := l_m___4
			end
		end

	gsl_matrix_char_free (a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR])
		local
			l_return: BOOLEAN
		do
			if a_m___4.is_void then
				l_return := True
			end
			if not l_return then
				if (a_m___4.item.owner).to_boolean then
					gsl_block_char_free (a_m___4.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_m___4))
			end
		end

	gsl_vector_complex_long_double_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]
			l_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]}.make_cast ((malloc ((create {PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE}.make).structure_size.to_natural_32)))
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("init_source.c"), 37, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_complex_long_double_alloc (a_n)
				if l_block.is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_v))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 47, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := l_block.item.data
				l_v.item.size := a_n
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := l_block
				l_v.item.owner := 1
				Result := l_v
			end
		end

	gsl_vector_complex_long_double_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]
		local
			l_i: NATURAL_32
			l_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]
			l_return: BOOLEAN
		do
			l_v := (gsl_vector_complex_long_double_alloc (a_n))
			if l_v.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < {NATURAL_32} 2 * a_n)
				loop
					l_v.item.data[l_i.to_integer_32] := real_96_from_integer_32 (0)
					l_i := l_i + 1
				end
				Result := l_v
			end
		end

	gsl_vector_complex_long_double_free (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE])
		local
			l_return: BOOLEAN
		do
			if a_v.is_void then
				l_return := True
			end
			if not l_return then
				if (a_v.item.owner).to_boolean then
					gsl_block_complex_long_double_free (a_v.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_v))
			end
		end

	gsl_vector_complex_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_COMPLEX]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]
			l_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_cast ((malloc ((create {PD_GSL_VECTOR_COMPLEX}.make).structure_size.to_natural_32)))
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("init_source.c"), 37, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_complex_alloc (a_n)
				if l_block.is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_v))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 47, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := l_block.item.data
				l_v.item.size := a_n
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := l_block
				l_v.item.owner := 1
				Result := l_v
			end
		end

	gsl_vector_complex_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_COMPLEX]
		local
			l_i: NATURAL_32
			l_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]
			l_return: BOOLEAN
		do
			l_v := (gsl_vector_complex_alloc (a_n))
			if l_v.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < {NATURAL_32} 2 * a_n)
				loop
					l_v.item.data[l_i.to_integer_32] := (0).to_double
					l_i := l_i + 1
				end
				Result := l_v
			end
		end

	gsl_vector_complex_free (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX])
		local
			l_return: BOOLEAN
		do
			if a_v.is_void then
				l_return := True
			end
			if not l_return then
				if (a_v.item.owner).to_boolean then
					gsl_block_complex_free (a_v.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_v))
			end
		end

	gsl_vector_complex_float_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]
			l_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]}.make_cast ((malloc ((create {PD_GSL_VECTOR_COMPLEX_FLOAT}.make).structure_size.to_natural_32)))
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("init_source.c"), 37, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_complex_float_alloc (a_n)
				if l_block.is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_v))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 47, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := l_block.item.data
				l_v.item.size := a_n
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := l_block
				l_v.item.owner := 1
				Result := l_v
			end
		end

	gsl_vector_complex_float_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]
		local
			l_i: NATURAL_32
			l_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]
			l_return: BOOLEAN
		do
			l_v := (gsl_vector_complex_float_alloc (a_n))
			if l_v.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < {NATURAL_32} 2 * a_n)
				loop
					l_v.item.data[l_i.to_integer_32] := (0).to_real
					l_i := l_i + 1
				end
				Result := l_v
			end
		end

	gsl_vector_complex_float_free (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT])
		local
			l_return: BOOLEAN
		do
			if a_v.is_void then
				l_return := True
			end
			if not l_return then
				if (a_v.item.owner).to_boolean then
					gsl_block_complex_float_free (a_v.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_v))
			end
		end

	gsl_vector_long_double_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]
			l_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]}.make_cast ((malloc ((create {PD_GSL_VECTOR_LONG_DOUBLE}.make).structure_size.to_natural_32)))
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("init_source.c"), 37, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_long_double_alloc (a_n)
				if l_block.is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_v))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 47, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := l_block.item.data
				l_v.item.size := a_n
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := l_block
				l_v.item.owner := 1
				Result := l_v
			end
		end

	gsl_vector_long_double_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]
		local
			l_i: NATURAL_32
			l_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]
			l_return: BOOLEAN
		do
			l_v := (gsl_vector_long_double_alloc (a_n))
			if l_v.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_v.item.data[l_i.to_integer_32] := real_96_from_integer_32 (0)
					l_i := l_i + 1
				end
				Result := l_v
			end
		end

	gsl_vector_long_double_free (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE])
		local
			l_return: BOOLEAN
		do
			if a_v.is_void then
				l_return := True
			end
			if not l_return then
				if (a_v.item.owner).to_boolean then
					gsl_block_long_double_free (a_v.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_v))
			end
		end

	gsl_vector_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_STRUCT]
			l_v: CE_POINTER [PD_GSL_VECTOR]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_cast ((malloc ((create {PD_GSL_VECTOR}.make).structure_size.to_natural_32)))
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("init_source.c"), 37, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_alloc (a_n)
				if l_block.is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_v))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 47, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := l_block.item.data
				l_v.item.size := a_n
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := l_block
				l_v.item.owner := 1
				Result := l_v
			end
		end

	gsl_vector_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR]
		local
			l_i: NATURAL_32
			l_v: CE_POINTER [PD_GSL_VECTOR]
			l_return: BOOLEAN
		do
			l_v := (gsl_vector_alloc (a_n))
			if l_v.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_v.item.data[l_i.to_integer_32] := (0).to_double
					l_i := l_i + 1
				end
				Result := l_v
			end
		end

	gsl_vector_free (a_v: CE_POINTER [PD_GSL_VECTOR])
		local
			l_return: BOOLEAN
		do
			if a_v.is_void then
				l_return := True
			end
			if not l_return then
				if (a_v.item.owner).to_boolean then
					gsl_block_free (a_v.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_v))
			end
		end

	gsl_vector_float_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_FLOAT]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]
			l_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_FLOAT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_FLOAT]}.make_cast ((malloc ((create {PD_GSL_VECTOR_FLOAT}.make).structure_size.to_natural_32)))
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("init_source.c"), 37, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_FLOAT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_float_alloc (a_n)
				if l_block.is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_v))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 47, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_FLOAT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := l_block.item.data
				l_v.item.size := a_n
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := l_block
				l_v.item.owner := 1
				Result := l_v
			end
		end

	gsl_vector_float_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_FLOAT]
		local
			l_i: NATURAL_32
			l_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]
			l_return: BOOLEAN
		do
			l_v := (gsl_vector_float_alloc (a_n))
			if l_v.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_FLOAT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_v.item.data[l_i.to_integer_32] := (0).to_real
					l_i := l_i + 1
				end
				Result := l_v
			end
		end

	gsl_vector_float_free (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT])
		local
			l_return: BOOLEAN
		do
			if a_v.is_void then
				l_return := True
			end
			if not l_return then
				if (a_v.item.owner).to_boolean then
					gsl_block_float_free (a_v.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_v))
			end
		end

	gsl_vector_ulong_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_ULONG]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]
			l_v: CE_POINTER [PD_GSL_VECTOR_ULONG]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_ULONG]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_ULONG]}.make_cast ((malloc ((create {PD_GSL_VECTOR_ULONG}.make).structure_size.to_natural_32)))
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("init_source.c"), 37, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_ULONG]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_ulong_alloc (a_n)
				if l_block.is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_v))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 47, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_ULONG]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := l_block.item.data
				l_v.item.size := a_n
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := l_block
				l_v.item.owner := 1
				Result := l_v
			end
		end

	gsl_vector_ulong_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_ULONG]
		local
			l_i: NATURAL_32
			l_v: CE_POINTER [PD_GSL_VECTOR_ULONG]
			l_return: BOOLEAN
		do
			l_v := (gsl_vector_ulong_alloc (a_n))
			if l_v.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_ULONG]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_v.item.data[l_i.to_integer_32] := {NATURAL_32} 0
					l_i := l_i + 1
				end
				Result := l_v
			end
		end

	gsl_vector_ulong_free (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG])
		local
			l_return: BOOLEAN
		do
			if a_v.is_void then
				l_return := True
			end
			if not l_return then
				if (a_v.item.owner).to_boolean then
					gsl_block_ulong_free (a_v.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_v))
			end
		end

	gsl_vector_long_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_LONG]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]
			l_v: CE_POINTER [PD_GSL_VECTOR_LONG]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_LONG]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_LONG]}.make_cast ((malloc ((create {PD_GSL_VECTOR_LONG}.make).structure_size.to_natural_32)))
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("init_source.c"), 37, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_LONG]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_long_alloc (a_n)
				if l_block.is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_v))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 47, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_LONG]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := l_block.item.data
				l_v.item.size := a_n
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := l_block
				l_v.item.owner := 1
				Result := l_v
			end
		end

	gsl_vector_long_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_LONG]
		local
			l_i: NATURAL_32
			l_v: CE_POINTER [PD_GSL_VECTOR_LONG]
			l_return: BOOLEAN
		do
			l_v := (gsl_vector_long_alloc (a_n))
			if l_v.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_LONG]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_v.item.data[l_i.to_integer_32] := 0
					l_i := l_i + 1
				end
				Result := l_v
			end
		end

	gsl_vector_long_free (a_v: CE_POINTER [PD_GSL_VECTOR_LONG])
		local
			l_return: BOOLEAN
		do
			if a_v.is_void then
				l_return := True
			end
			if not l_return then
				if (a_v.item.owner).to_boolean then
					gsl_block_long_free (a_v.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_v))
			end
		end

	gsl_vector_uint_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_UINT]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]
			l_v: CE_POINTER [PD_GSL_VECTOR_UINT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_UINT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_UINT]}.make_cast ((malloc ((create {PD_GSL_VECTOR_UINT}.make).structure_size.to_natural_32)))
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("init_source.c"), 37, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_UINT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_uint_alloc (a_n)
				if l_block.is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_v))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 47, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_UINT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := l_block.item.data
				l_v.item.size := a_n
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := l_block
				l_v.item.owner := 1
				Result := l_v
			end
		end

	gsl_vector_uint_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_UINT]
		local
			l_i: NATURAL_32
			l_v: CE_POINTER [PD_GSL_VECTOR_UINT]
			l_return: BOOLEAN
		do
			l_v := (gsl_vector_uint_alloc (a_n))
			if l_v.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_UINT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_v.item.data[l_i.to_integer_32] := {NATURAL_32} 0
					l_i := l_i + 1
				end
				Result := l_v
			end
		end

	gsl_vector_uint_free (a_v: CE_POINTER [PD_GSL_VECTOR_UINT])
		local
			l_return: BOOLEAN
		do
			if a_v.is_void then
				l_return := True
			end
			if not l_return then
				if (a_v.item.owner).to_boolean then
					gsl_block_uint_free (a_v.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_v))
			end
		end

	gsl_vector_int_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_INT]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]
			l_v: CE_POINTER [PD_GSL_VECTOR_INT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_INT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_INT]}.make_cast ((malloc ((create {PD_GSL_VECTOR_INT}.make).structure_size.to_natural_32)))
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("init_source.c"), 37, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_INT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_int_alloc (a_n)
				if l_block.is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_v))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 47, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_INT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := l_block.item.data
				l_v.item.size := a_n
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := l_block
				l_v.item.owner := 1
				Result := l_v
			end
		end

	gsl_vector_int_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_INT]
		local
			l_i: NATURAL_32
			l_v: CE_POINTER [PD_GSL_VECTOR_INT]
			l_return: BOOLEAN
		do
			l_v := (gsl_vector_int_alloc (a_n))
			if l_v.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_INT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_v.item.data[l_i.to_integer_32] := 0
					l_i := l_i + 1
				end
				Result := l_v
			end
		end

	gsl_vector_int_free (a_v: CE_POINTER [PD_GSL_VECTOR_INT])
		local
			l_return: BOOLEAN
		do
			if a_v.is_void then
				l_return := True
			end
			if not l_return then
				if (a_v.item.owner).to_boolean then
					gsl_block_int_free (a_v.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_v))
			end
		end

	gsl_vector_ushort_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_USHORT]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]
			l_v: CE_POINTER [PD_GSL_VECTOR_USHORT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_USHORT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_USHORT]}.make_cast ((malloc ((create {PD_GSL_VECTOR_USHORT}.make).structure_size.to_natural_32)))
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("init_source.c"), 37, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_USHORT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_ushort_alloc (a_n)
				if l_block.is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_v))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 47, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_USHORT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := l_block.item.data
				l_v.item.size := a_n
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := l_block
				l_v.item.owner := 1
				Result := l_v
			end
		end

	gsl_vector_ushort_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_USHORT]
		local
			l_i: NATURAL_32
			l_v: CE_POINTER [PD_GSL_VECTOR_USHORT]
			l_return: BOOLEAN
		do
			l_v := (gsl_vector_ushort_alloc (a_n))
			if l_v.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_USHORT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_v.item.data[l_i.to_integer_32] := (0).to_natural_16
					l_i := l_i + 1
				end
				Result := l_v
			end
		end

	gsl_vector_ushort_free (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT])
		local
			l_return: BOOLEAN
		do
			if a_v.is_void then
				l_return := True
			end
			if not l_return then
				if (a_v.item.owner).to_boolean then
					gsl_block_ushort_free (a_v.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_v))
			end
		end

	gsl_vector_short_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_SHORT]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]
			l_v: CE_POINTER [PD_GSL_VECTOR_SHORT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_SHORT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_SHORT]}.make_cast ((malloc ((create {PD_GSL_VECTOR_SHORT}.make).structure_size.to_natural_32)))
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("init_source.c"), 37, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_SHORT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_short_alloc (a_n)
				if l_block.is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_v))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 47, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_SHORT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := l_block.item.data
				l_v.item.size := a_n
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := l_block
				l_v.item.owner := 1
				Result := l_v
			end
		end

	gsl_vector_short_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_SHORT]
		local
			l_i: NATURAL_32
			l_v: CE_POINTER [PD_GSL_VECTOR_SHORT]
			l_return: BOOLEAN
		do
			l_v := (gsl_vector_short_alloc (a_n))
			if l_v.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_SHORT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_v.item.data[l_i.to_integer_32] := (0).to_integer_16
					l_i := l_i + 1
				end
				Result := l_v
			end
		end

	gsl_vector_short_free (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT])
		local
			l_return: BOOLEAN
		do
			if a_v.is_void then
				l_return := True
			end
			if not l_return then
				if (a_v.item.owner).to_boolean then
					gsl_block_short_free (a_v.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_v))
			end
		end

	gsl_vector_uchar_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_UCHAR]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]
			l_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_UCHAR]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_UCHAR]}.make_cast ((malloc ((create {PD_GSL_VECTOR_UCHAR}.make).structure_size.to_natural_32)))
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("init_source.c"), 37, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_UCHAR]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_uchar_alloc (a_n)
				if l_block.is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_v))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 47, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_UCHAR]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := l_block.item.data
				l_v.item.size := a_n
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := l_block
				l_v.item.owner := 1
				Result := l_v
			end
		end

	gsl_vector_uchar_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_UCHAR]
		local
			l_i: NATURAL_32
			l_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]
			l_return: BOOLEAN
		do
			l_v := (gsl_vector_uchar_alloc (a_n))
			if l_v.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_UCHAR]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_v.item.data[l_i.to_integer_32] := (0).to_natural_8
					l_i := l_i + 1
				end
				Result := l_v
			end
		end

	gsl_vector_uchar_free (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR])
		local
			l_return: BOOLEAN
		do
			if a_v.is_void then
				l_return := True
			end
			if not l_return then
				if (a_v.item.owner).to_boolean then
					gsl_block_uchar_free (a_v.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_v))
			end
		end

	gsl_vector_char_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_CHAR]
		local
			l_block: CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]
			l_v: CE_POINTER [PD_GSL_VECTOR_CHAR]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("init_source.c"), 29, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_CHAR]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_CHAR]}.make_cast ((malloc ((create {PD_GSL_VECTOR_CHAR}.make).structure_size.to_natural_32)))
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("init_source.c"), 37, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_CHAR]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_block := gsl_block_char_alloc (a_n)
				if l_block.is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_v))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for block"), ce_string ("init_source.c"), 47, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_CHAR]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := l_block.item.data
				l_v.item.size := a_n
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := l_block
				l_v.item.owner := 1
				Result := l_v
			end
		end

	gsl_vector_char_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_CHAR]
		local
			l_i: NATURAL_32
			l_v: CE_POINTER [PD_GSL_VECTOR_CHAR]
			l_return: BOOLEAN
		do
			l_v := (gsl_vector_char_alloc (a_n))
			if l_v.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_CHAR]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_v.item.data[l_i.to_integer_32] := (0).to_integer_8
					l_i := l_i + 1
				end
				Result := l_v
			end
		end

	gsl_vector_char_free (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR])
		local
			l_return: BOOLEAN
		do
			if a_v.is_void then
				l_return := True
			end
			if not l_return then
				if (a_v.item.owner).to_boolean then
					gsl_block_char_free (a_v.item.block)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_v))
			end
		end

end
