class
	P_KNUTHRAN2002_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	ran_type___6: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("knuthran2002"), {NATURAL_32} 1_073_741_823, {NATURAL_32} 0, (create {PD_RAN_STATE_T_26__4}.make).structure_size.to_natural_32, ran_set___6_address, ran_get___6_address, ran_get_double___6_address])
				>>)
		end

	gsl_rng_knuthran2002: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ran_type___6.item
		end

feature {ANY} -- public routines

	ran_array___0 (a_aa: CE_POINTER [INTEGER_32]; a_n: NATURAL_32; a_ran_x: CE_POINTER [INTEGER_32])
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
		do
			l_j := {NATURAL_32} 0
			from
			until
				not (l_j < {NATURAL_32} 100)
			loop
				a_aa[l_j.to_integer_32] := a_ran_x[l_j.to_integer_32]
				l_j := l_j + 1
			end
			from
			until
				not (l_j < a_n)
			loop
				a_aa[l_j.to_integer_32] := ((a_aa[(l_j - {NATURAL_32} 100).to_integer_32] - a_aa[(l_j - {NATURAL_32} 37).to_integer_32])).bit_and ((((1).bit_shift_left (30)) - 1))
				l_j := l_j + 1
			end
			l_i := {NATURAL_32} 0
			from
			until
				not (l_i < {NATURAL_32} 37)
			loop
				a_ran_x[l_i.to_integer_32] := ((a_aa[(l_j - {NATURAL_32} 100).to_integer_32] - a_aa[(l_j - {NATURAL_32} 37).to_integer_32])).bit_and ((((1).bit_shift_left (30)) - 1))
				l_i := l_i + 1
				l_j := l_j + 1
			end
			from
			until
				not (l_i < {NATURAL_32} 100)
			loop
				a_ran_x[l_i.to_integer_32] := ((a_aa[(l_j - {NATURAL_32} 100).to_integer_32] - a_ran_x[(l_i - {NATURAL_32} 37).to_integer_32])).bit_and ((((1).bit_shift_left (30)) - 1))
				l_i := l_i + 1
				l_j := l_j + 1
			end
		end

	ran_get___6 (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN_STATE_T_26__4]
			l_i: NATURAL_32
			l_v: NATURAL_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T_26__4]}.make_cast (a_vstate)
			l_i := l_state.item.i
			if l_i = {NATURAL_32} 0 then
				ran_array___0 (l_state.item.aa, {NATURAL_32} 1_009, l_state.item.ran_x)
			end
			l_v := (l_state.item.aa[l_i.to_integer_32]).to_natural_32
			l_state.item.i := (l_i + {NATURAL_32} 1) \\ {NATURAL_32} 100
			Result := l_v
		end

	ran_get_double___6 (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RAN_STATE_T_26__4]
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T_26__4]}.make_cast (a_vstate)
			Result := ((ran_get___6 (create {CE_VOID_POINTER}.make_cast (l_state))).to_real_64 / 1073741824.0)
		end

	ran_set___6 (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RAN_STATE_T_26__4]
			l_x: CE_ARRAY [INTEGER_32]
			l_j: INTEGER_32
			l_t: INTEGER_32
			l_ss: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_x.make (<<199>>)

			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T_26__4]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 314_159
			end
			l_ss := (((l_s + {NATURAL_32} 2)).bit_and ((((1).bit_shift_left (30)) - 2).to_natural_32)).to_integer_32
			l_j := 0
			from
			until
				not (l_j < 100)
			loop
				l_x[l_j] := l_ss
				l_ss := (l_ss).bit_shift_left ((1))
				if l_ss >= (1).bit_shift_left (30) then
					l_ss := l_ss - (((1).bit_shift_left (30)) - 2)
				end
				l_j := l_j + 1
			end
			l_x[1] := (l_x[1]) + 1
			l_ss := ((l_s).bit_and ((((1).bit_shift_left (30)) - 1).to_natural_32)).to_integer_32
			l_t := 69
			from
			until
				not (not (l_return) and then (l_t.to_boolean))
			loop
				l_j := 99
				from
				until
					not (l_j > 0)
				loop
					l_x[l_j + l_j] := l_x[l_j]
					l_x[(l_j + l_j) - 1] := 0
					l_j := l_j - 1
				end
				l_j := 198
				from
				until
					not (l_j >= 100)
				loop
					l_x[l_j - 63] := ((l_x[l_j - 63] - l_x[l_j])).bit_and ((((1).bit_shift_left (30)) - 1))
					l_x[l_j - 100] := ((l_x[l_j - 100] - l_x[l_j])).bit_and ((((1).bit_shift_left (30)) - 1))
					l_j := l_j - 1
				end
				if ((l_ss).bit_and (1)).to_boolean then
					l_j := 100
					from
					until
						not (l_j > 0)
					loop
						l_x[l_j] := l_x[l_j - 1]
						l_j := l_j - 1
					end
					l_x[0] := l_x[100]
					l_x[37] := ((l_x[37] - l_x[100])).bit_and ((((1).bit_shift_left (30)) - 1))
				end
				if l_ss.to_boolean then
					l_ss := (l_ss).bit_shift_right ((1))
				else
					l_t := l_t - 1
				end
			end
			l_j := 0
			from
			until
				not (l_j < 37)
			loop
				l_state.item.ran_x[(l_j + 100) - 37] := l_x[l_j]
				l_j := l_j + 1
			end
			from
			until
				not (l_j < 100)
			loop
				l_state.item.ran_x[l_j - 37] := l_x[l_j]
				l_j := l_j + 1
			end
			l_j := 0
			from
			until
				not (l_j < 10)
			loop
				ran_array___0 (l_x, {NATURAL_32} 199, l_state.item.ran_x)
				l_j := l_j + 1
			end
			l_state.item.i := {NATURAL_32} 0
		end

feature {ANY} -- routine addresses

	ran_get___6_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_get___6)
		end

	ran_get_double___6_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_get_double___6)
		end

	ran_set___6_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_set___6)
		end

end
