class
	P_WORK_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_multifit_linear_alloc (a_n, a_p: NATURAL_32): CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]
			l_return, l_break: BOOLEAN
		do
			l_w := create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_cast ((malloc ((create {PD_GSL_MULTIFIT_LINEAR_WORKSPACE}.make).structure_size.to_natural_32)))
			if l_w.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for multifit_linear struct"), ce_string ("work.c"), 35, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_w.item.n := a_n
				l_w.item.p := a_p
				l_w.item.A := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_alloc (a_n, a_p)
				if (l_w.item.A).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for A"), ce_string ("work.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.Q := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_alloc (a_p, a_p)
				if (l_w.item.Q).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_w.item.A)
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for Q"), ce_string ("work.c"), 55, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.QSI := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_alloc (a_p, a_p)
				if (l_w.item.QSI).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_w.item.Q);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_w.item.A)
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for QSI"), ce_string ("work.c"), 65, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.S := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (a_p)
				if (l_w.item.S).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_w.item.QSI);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_w.item.Q);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_w.item.A)
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for S"), ce_string ("work.c"), 76, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.t := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (a_n)
				if (l_w.item.t).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_w.item.S);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_w.item.QSI);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_w.item.Q);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_w.item.A)
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for t"), ce_string ("work.c"), 88, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.xt := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_p)
				if (l_w.item.xt).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_w.item.t);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_w.item.S);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_w.item.QSI);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_w.item.Q);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_w.item.A)
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for xt"), ce_string ("work.c"), 101, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.D := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_p)
				if (l_w.item.D).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_w.item.D);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_w.item.t);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_w.item.S);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_w.item.QSI);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_w.item.Q);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_w.item.A)
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for xt"), ce_string ("work.c"), 115, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := l_w
			end
		end

	gsl_multifit_linear_free (a_work: CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE])
		local
			l_return: BOOLEAN
		do
			if a_work.is_void then
				l_return := True
			end
			if not l_return then
				(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (a_work.item.A);
				(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (a_work.item.Q);
				(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (a_work.item.QSI);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_work.item.S);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_work.item.t);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_work.item.xt);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_work.item.D)
				free (create {CE_VOID_POINTER}.make_cast (a_work))
			end
		end

end
