class
	P_ZTPMV_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	cblas_ztpmv (a_order, a_Uplo, a_TransA, a_Diag: NATURAL_32; a_N: INTEGER_32; a_Ap, a_X: CE_POINTER [ANY]; a_incX: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_conj: INTEGER_32
			l_tmp: INTEGER_32
			l_Trans: INTEGER_32
			l_tmp___0: NATURAL_32
			l_nonunit: INTEGER_32
			l_ix: INTEGER_32
			l_tmp___1: INTEGER_32
			l_Aii_real: REAL_64
			l_Aii_imag: REAL_64
			l_temp_r: REAL_64
			l_temp_i: REAL_64
			l_x_real: REAL_64
			l_x_imag: REAL_64
			l_jx: INTEGER_32
			l_tmp___2: INTEGER_32
			l_Aij_real: REAL_64
			l_Aij_imag: REAL_64
			l_x_real___0: REAL_64
			l_x_imag___0: REAL_64
			l_ix___0: INTEGER_32
			l_tmp___3: INTEGER_32
			l_Aii_real___0: REAL_64
			l_Aii_imag___0: REAL_64
			l_temp_r___0: REAL_64
			l_temp_i___0: REAL_64
			l_x_real___1: REAL_64
			l_x_imag___1: REAL_64
			l_jx___0: INTEGER_32
			l_tmp___4: INTEGER_32
			l_Aij_real___0: REAL_64
			l_Aij_imag___0: REAL_64
			l_x_real___2: REAL_64
			l_x_imag___2: REAL_64
			l_tmp___5: INTEGER_32
			l_ix___1: INTEGER_32
			l_tmp___6: INTEGER_32
			l_Aii_real___1: REAL_64
			l_Aii_imag___1: REAL_64
			l_temp_r___1: REAL_64
			l_temp_i___1: REAL_64
			l_x_real___3: REAL_64
			l_x_imag___3: REAL_64
			l_jx___1: INTEGER_32
			l_tmp___7: INTEGER_32
			l_x_real___4: REAL_64
			l_x_imag___4: REAL_64
			l_Aji_real: REAL_64
			l_Aji_imag: REAL_64
			l_tmp___8: INTEGER_32
			l_ix___2: INTEGER_32
			l_tmp___9: INTEGER_32
			l_Aii_real___2: REAL_64
			l_Aii_imag___2: REAL_64
			l_temp_r___2: REAL_64
			l_temp_i___2: REAL_64
			l_x_real___5: REAL_64
			l_x_imag___5: REAL_64
			l_jx___2: INTEGER_32
			l_tmp___10: INTEGER_32
			l_x_real___6: REAL_64
			l_x_imag___6: REAL_64
			l_Aji_real___0: REAL_64
			l_Aji_imag___0: REAL_64
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_TransA = {NATURAL_32} 113 then
						l_tmp := -1
					else
						l_tmp := 1
					end
					l_conj := l_tmp
					if a_TransA /= {NATURAL_32} 113 then
						l_tmp___0 := a_TransA
					else
						l_tmp___0 := {NATURAL_32} 112
					end
					l_Trans := l_tmp___0.to_integer_32
					l_nonunit := (a_Diag = {NATURAL_32} 131).to_integer
					if a_order /= {NATURAL_32} 101 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_Trans = 111 then
							if a_Uplo = {NATURAL_32} 121 then
								l_pos := -1 + 6 -- goto _L___12
							else
								l_pos := -1 + 3 -- goto _L___16
							end
						else
							l_pos := -1 + 3 -- goto _L___16
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 3 then -- else: | _L___16:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L___12:
						if a_incX > 0 then
							l_tmp___1 := 0
						else
							l_tmp___1 := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp___1
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_Aii_real := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i)]
							l_Aii_imag := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i) + 1)])
							if l_nonunit.to_boolean then
								l_x_real := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix]
								l_x_imag := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
								l_temp_r := l_Aii_real * l_x_real - l_Aii_imag * l_x_imag
								l_temp_i := l_Aii_real * l_x_imag + l_Aii_imag * l_x_real
							else
								l_temp_r := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix]
								l_temp_i := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
							end
							if a_incX > 0 then
								l_tmp___2 := 0
							else
								l_tmp___2 := (a_N - 1) * -a_incX
							end
							l_jx := l_tmp___2 + (l_i + 1) * a_incX
							l_j := l_i + 1
							from
							until
								not (l_j < a_N)
							loop
								l_Aij_real := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i)]
								l_Aij_imag := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i) + 1)])
								l_x_real___0 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_jx]
								l_x_imag___0 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_jx + 1)]
								l_temp_r := l_temp_r + (l_Aij_real * l_x_real___0 - l_Aij_imag * l_x_imag___0)
								l_temp_i := l_temp_i + (l_Aij_real * l_x_imag___0 + l_Aij_imag * l_x_real___0)
								l_jx := l_jx + a_incX
								l_j := l_j + 1
							end
							create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix] := l_temp_r
							create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := l_temp_i
							l_ix := l_ix + a_incX
							l_i := l_i + 1
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 12 -- goto _L___14
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___14
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 49
				when 12 then -- else: | _L___14:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_Trans = 111 then
							if a_Uplo = {NATURAL_32} 122 then
								l_pos := -1 + 18 -- goto _L___7
							else
								l_pos := -1 + 15 -- goto _L___11
							end
						else
							l_pos := -1 + 15 -- goto _L___11
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 15 then -- else: | _L___11:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 24 -- skip if block
						end
				when 16 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 22 -- skip if block
						end
				when 17 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if: | _L___7:
						if a_incX > 0 then
							l_tmp___3 := 0
						else
							l_tmp___3 := (a_N - 1) * -a_incX
						end
						l_ix___0 := l_tmp___3 + a_incX * (a_N - 1)
						l_i := a_N
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_i > 0 then
								l_tmp___5 := l_i
								l_i := l_i - 1
								if not l_tmp___5.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_Aii_real___0 := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * ((l_i * (l_i + 1)) // 2 + l_i)]
								l_Aii_imag___0 := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * ((l_i * (l_i + 1)) // 2 + l_i) + 1)])
								if l_nonunit.to_boolean then
									l_x_real___1 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___0]
									l_x_imag___1 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)]
									l_temp_r___0 := l_Aii_real___0 * l_x_real___1 - l_Aii_imag___0 * l_x_imag___1
									l_temp_i___0 := l_Aii_real___0 * l_x_imag___1 + l_Aii_imag___0 * l_x_real___1
								else
									l_temp_r___0 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___0]
									l_temp_i___0 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)]
								end
								if a_incX > 0 then
									l_tmp___4 := 0
								else
									l_tmp___4 := (a_N - 1) * -a_incX
								end
								l_jx___0 := l_tmp___4
								l_j := 0
								from
								until
									not (l_j < l_i)
								loop
									l_Aij_real___0 := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * ((l_i * (l_i + 1)) // 2 + l_j)]
									l_Aij_imag___0 := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * ((l_i * (l_i + 1)) // 2 + l_j) + 1)])
									l_x_real___2 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_jx___0]
									l_x_imag___2 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_jx___0 + 1)]
									l_temp_r___0 := l_temp_r___0 + (l_Aij_real___0 * l_x_real___2 - l_Aij_imag___0 * l_x_imag___2)
									l_temp_i___0 := l_temp_i___0 + (l_Aij_real___0 * l_x_imag___2 + l_Aij_imag___0 * l_x_real___2)
									l_jx___0 := l_jx___0 + a_incX
									l_j := l_j + 1
								end
								create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___0] := l_temp_r___0
								create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)] := l_temp_i___0
								l_ix___0 := l_ix___0 - a_incX
							end
						end
						l_break := False
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						l_pos := -1 + 24 -- goto _L___9
				when 21 then -- if done | if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_pos := -1 + 24 -- goto _L___9
				when 23 then -- if done | if block done, skip else block:
						l_pos := -1 + 49
				when 24 then -- else: | _L___9:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						if l_Trans = 112 then
							if a_Uplo = {NATURAL_32} 121 then
								l_pos := -1 + 30 -- goto _L___2
							else
								l_pos := -1 + 27 -- goto _L___6
							end
						else
							l_pos := -1 + 27 -- goto _L___6
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 27 then -- else: | _L___6:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 36 -- skip if block
						end
				when 28 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 34 -- skip if block
						end
				when 29 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if: | _L___2:
						if a_incX > 0 then
							l_tmp___6 := 0
						else
							l_tmp___6 := (a_N - 1) * -a_incX
						end
						l_ix___1 := l_tmp___6 + a_incX * (a_N - 1)
						l_i := a_N
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_i > 0 then
								l_tmp___8 := l_i
								l_i := l_i - 1
								if not l_tmp___8.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_Aii_real___1 := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i)]
								l_Aii_imag___1 := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i) + 1)])
								if l_nonunit.to_boolean then
									l_x_real___3 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___1]
									l_x_imag___3 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___1 + 1)]
									l_temp_r___1 := l_Aii_real___1 * l_x_real___3 - l_Aii_imag___1 * l_x_imag___3
									l_temp_i___1 := l_Aii_real___1 * l_x_imag___3 + l_Aii_imag___1 * l_x_real___3
								else
									l_temp_r___1 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___1]
									l_temp_i___1 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___1 + 1)]
								end
								if a_incX > 0 then
									l_tmp___7 := 0
								else
									l_tmp___7 := (a_N - 1) * -a_incX
								end
								l_jx___1 := l_tmp___7
								l_j := 0
								from
								until
									not (l_j < l_i)
								loop
									l_x_real___4 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_jx___1]
									l_x_imag___4 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_jx___1 + 1)]
									l_Aji_real := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * (((((l_j - 1) + 1) * (2 * a_N - (l_j - 1))) // 2 + l_i) - l_j)]
									l_Aji_imag := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * (((((l_j - 1) + 1) * (2 * a_N - (l_j - 1))) // 2 + l_i) - l_j) + 1)])
									l_temp_r___1 := l_temp_r___1 + (l_Aji_real * l_x_real___4 - l_Aji_imag * l_x_imag___4)
									l_temp_i___1 := l_temp_i___1 + (l_Aji_real * l_x_imag___4 + l_Aji_imag * l_x_real___4)
									l_jx___1 := l_jx___1 + a_incX
									l_j := l_j + 1
								end
								create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___1] := l_temp_r___1
								create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___1 + 1)] := l_temp_i___1
								l_ix___1 := l_ix___1 - a_incX
							end
						end
						l_break := False
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else:
						l_pos := -1 + 36 -- goto _L___4
				when 33 then -- if done | if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else:
						l_pos := -1 + 36 -- goto _L___4
				when 35 then -- if done | if block done, skip else block:
						l_pos := -1 + 49
				when 36 then -- else: | _L___4:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if l_Trans = 112 then
							if a_Uplo = {NATURAL_32} 122 then
								l_pos := -1 + 42 -- goto _L
							else
								l_pos := -1 + 39 -- goto _L___1
							end
						else
							l_pos := -1 + 39 -- goto _L___1
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 39 then -- else: | _L___1:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 48 -- skip if block
						end
				when 40 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 46 -- skip if block
						end
				when 41 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if: | _L:
						if a_incX > 0 then
							l_tmp___9 := 0
						else
							l_tmp___9 := (a_N - 1) * -a_incX
						end
						l_ix___2 := l_tmp___9
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_Aii_real___2 := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * ((l_i * (l_i + 1)) // 2 + l_i)]
							l_Aii_imag___2 := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * ((l_i * (l_i + 1)) // 2 + l_i) + 1)])
							if l_nonunit.to_boolean then
								l_x_real___5 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___2]
								l_x_imag___5 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___2 + 1)]
								l_temp_r___2 := l_Aii_real___2 * l_x_real___5 - l_Aii_imag___2 * l_x_imag___5
								l_temp_i___2 := l_Aii_real___2 * l_x_imag___5 + l_Aii_imag___2 * l_x_real___5
							else
								l_temp_r___2 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___2]
								l_temp_i___2 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___2 + 1)]
							end
							if a_incX > 0 then
								l_tmp___10 := 0
							else
								l_tmp___10 := (a_N - 1) * -a_incX
							end
							l_jx___2 := l_tmp___10 + (l_i + 1) * a_incX
							l_j := l_i + 1
							from
							until
								not (l_j < a_N)
							loop
								l_x_real___6 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_jx___2]
								l_x_imag___6 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_jx___2 + 1)]
								l_Aji_real___0 := create {CE_REAL_64_POINTER}.make_cast (a_Ap)[2 * ((l_j * (l_j + 1)) // 2 + l_i)]
								l_Aji_imag___0 := (l_conj.to_double * create {CE_REAL_64_POINTER}.make_cast (a_Ap)[(2 * ((l_j * (l_j + 1)) // 2 + l_i) + 1)])
								l_temp_r___2 := l_temp_r___2 + (l_Aji_real___0 * l_x_real___6 - l_Aji_imag___0 * l_x_imag___6)
								l_temp_i___2 := l_temp_i___2 + (l_Aji_real___0 * l_x_imag___6 + l_Aji_imag___0 * l_x_real___6)
								l_jx___2 := l_jx___2 + a_incX
								l_j := l_j + 1
							end
							create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___2] := l_temp_r___2
							create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___2 + 1)] := l_temp_i___2
							l_ix___2 := l_ix___2 + a_incX
							l_i := l_i + 1
						end
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_tpmv_c.h"), ce_string ("unrecognized operation")])
				when 45 then -- if done | if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_tpmv_c.h"), ce_string ("unrecognized operation")])
				when 47 then -- if done | if block done, skip else block:
						l_pos := -1 + 49
				when 48 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_tpmv_c.h"), ce_string ("unrecognized operation")])
				when 49 then -- if done | if done | if done | if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
