class
	PD_FALSEPOS_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	f_lower: REAL_64 assign set_f_lower

	f_upper: REAL_64 assign set_f_upper

feature {ANY} -- field setters

	set_f_lower (a_f_lower: REAL_64)
		do
			f_lower := a_f_lower
			update_memory_field ("f_lower")
		end

	set_f_upper (a_f_upper: REAL_64)
		do
			f_upper := a_f_upper
			update_memory_field ("f_upper")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			f_lower := a_other.f_lower
			f_upper := a_other.f_upper
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				f_lower = a_other.f_lower and
				f_upper = a_other.f_upper
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("f_lower"),
					create {CE_STRUCTURE_FIELD}.make ("f_upper")
				>>)
			init_structure_info
		end

end
