class
	PD_GSL_MULTIROOT_FUNCTION_STRUCT_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- routine addresses

	dnewton_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_function: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x, a_f, a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
				do
					Result := a_function.item.dnewton_set (a_vstate, a_x, a_f, a_dx)
				end)
		end

	dnewton_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_function: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x, a_f, a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
				do
					Result := a_function.item.dnewton_iterate (a_vstate, a_x, a_f, a_dx)
				end)
		end

	broyden_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_function: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x, a_f, a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
				do
					Result := a_function.item.broyden_set (a_vstate, a_x, a_f, a_dx)
				end)
		end

	broyden_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_function: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x, a_f, a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
				do
					Result := a_function.item.broyden_iterate (a_vstate, a_x, a_f, a_dx)
				end)
		end

	hybrid_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_func: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x, a_f, a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
				do
					Result := a_func.item.hybrid_set (a_vstate, a_x, a_f, a_dx)
				end)
		end

	hybrids_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_func: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x, a_f, a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
				do
					Result := a_func.item.hybrids_set (a_vstate, a_x, a_f, a_dx)
				end)
		end

	hybrid_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_func: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x, a_f, a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
				do
					Result := a_func.item.hybrid_iterate (a_vstate, a_x, a_f, a_dx)
				end)
		end

	hybrids_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_func: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x, a_f, a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
				do
					Result := a_func.item.hybrids_iterate (a_vstate, a_x, a_f, a_dx)
				end)
		end

end
