class
	PD_MT_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_32_ARRAY} mt.make (<<624>>)
		end

feature {ANY} -- fields

	mt: CE_ARRAY [NATURAL_32]

	mti: INTEGER_32 assign set_mti

feature {ANY} -- field setters

	set_mti (a_mti: INTEGER_32)
		do
			mti := a_mti
			update_memory_field ("mti")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mt := a_other.mt.twin
			mti := a_other.mti
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mt.is_equal (a_other.mt) and
				mti = a_other.mti
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mt", <<624>>),
					create {CE_STRUCTURE_FIELD}.make ("mti")
				>>)
			init_structure_info
		end

end
