class
	PD_RAN_STATE_T_26__3

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_32_ARRAY} aa.make (<<2_009>>)
			create {CE_NATURAL_32_ARRAY} ran_x.make (<<100>>)
		end

feature {ANY} -- fields

	i: NATURAL_32 assign set_i

	aa: CE_ARRAY [NATURAL_32]

	ran_x: CE_ARRAY [NATURAL_32]

feature {ANY} -- field setters

	set_i (a_i: NATURAL_32)
		do
			i := a_i
			update_memory_field ("i")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			i := a_other.i
			aa := a_other.aa.twin
			ran_x := a_other.ran_x.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				i = a_other.i and
				aa.is_equal (a_other.aa) and
				ran_x.is_equal (a_other.ran_x)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("i"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("aa", <<2_009>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ran_x", <<100>>)
				>>)
			init_structure_info
		end

end
